// chrome/browser/media/history/media_history_store.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/browser/media/history/media_history_store.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/browser/media/history/media_history_store.mojom-params-data.h"
#include "chrome/browser/media/history/media_history_store.mojom-shared-message-ids.h"

#include "chrome/browser/media/history/media_history_store.mojom-import-headers.h"


#ifndef CHROME_BROWSER_MEDIA_HISTORY_MEDIA_HISTORY_STORE_MOJOM_JUMBO_H_
#define CHROME_BROWSER_MEDIA_HISTORY_MEDIA_HISTORY_STORE_MOJOM_JUMBO_H_
#endif
namespace media_history {
namespace mojom {
MediaHistoryStats::MediaHistoryStats()
    : table_row_counts() {}

MediaHistoryStats::MediaHistoryStats(
    const base::flat_map<std::string, int32_t>& table_row_counts_in)
    : table_row_counts(std::move(table_row_counts_in)) {}

MediaHistoryStats::~MediaHistoryStats() = default;

bool MediaHistoryStats::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char MediaHistoryStore::Name_[] = "media_history.mojom.MediaHistoryStore";

class MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback(
      MediaHistoryStore::GetMediaHistoryStatsCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MediaHistoryStore::GetMediaHistoryStatsCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback);
};

MediaHistoryStoreProxy::MediaHistoryStoreProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void MediaHistoryStoreProxy::GetMediaHistoryStats(
    GetMediaHistoryStatsCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryStats");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryStats_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryStats");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder {
 public:
  static MediaHistoryStore::GetMediaHistoryStatsCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder> proxy(
        new MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MediaHistoryStore::GetMediaHistoryStatsCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      MediaHistoryStatsPtr in_stats);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder);
};

bool MediaHistoryStore_GetMediaHistoryStats_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "media_history::mojom::MediaHistoryStore::GetMediaHistoryStatsCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  MediaHistoryStatsPtr p_stats{};
  MediaHistoryStore_GetMediaHistoryStats_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadStats(&p_stats))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MediaHistoryStore::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_stats));
  return true;
}

void MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder::Run(
    MediaHistoryStatsPtr in_stats) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaHistoryStore_GetMediaHistoryStats_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_history::mojom::internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->stats)::BaseType::BufferWriter
      stats_writer;
  mojo::internal::Serialize<::media_history::mojom::MediaHistoryStatsDataView>(
      in_stats, buffer, &stats_writer, &serialization_context);
  params->stats.Set(
      stats_writer.is_null() ? nullptr : stats_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->stats.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null stats in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryStatsCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaHistoryStore::Name_);
  message.set_method_name("GetMediaHistoryStats");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool MediaHistoryStoreStubDispatch::Accept(
    MediaHistoryStore* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kMediaHistoryStore_GetMediaHistoryStats_Name: {
      break;
    }
  }
  return false;
}

// static
bool MediaHistoryStoreStubDispatch::AcceptWithResponder(
    MediaHistoryStore* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kMediaHistoryStore_GetMediaHistoryStats_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryStats",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_history::mojom::MediaHistoryStore::GetMediaHistoryStats");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data* params =
          reinterpret_cast<
              internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      MediaHistoryStore_GetMediaHistoryStats_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaHistoryStore::Name_, 0, false);
        return false;
      }
      MediaHistoryStore::GetMediaHistoryStatsCallback callback =
          MediaHistoryStore_GetMediaHistoryStats_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetMediaHistoryStats(std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kMediaHistoryStoreValidationInfo[] = {
    {internal::kMediaHistoryStore_GetMediaHistoryStats_Name,
     {&internal::MediaHistoryStore_GetMediaHistoryStats_Params_Data::Validate,
      &internal::MediaHistoryStore_GetMediaHistoryStats_ResponseParams_Data::Validate}},
};

bool MediaHistoryStoreRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::media_history::mojom::MediaHistoryStore::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kMediaHistoryStoreValidationInfo);
}

bool MediaHistoryStoreResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::media_history::mojom::MediaHistoryStore::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kMediaHistoryStoreValidationInfo);

}
}  // namespace mojom
}  // namespace media_history

namespace mojo {


// static
bool StructTraits<::media_history::mojom::MediaHistoryStats::DataView, ::media_history::mojom::MediaHistoryStatsPtr>::Read(
    ::media_history::mojom::MediaHistoryStats::DataView input,
    ::media_history::mojom::MediaHistoryStatsPtr* output) {
  bool success = true;
  ::media_history::mojom::MediaHistoryStatsPtr result(::media_history::mojom::MediaHistoryStats::New());
  
      if (success && !input.ReadTableRowCounts(&result->table_row_counts))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif