// chrome/browser/media/history/media_history_store.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_MEDIA_HISTORY_MEDIA_HISTORY_STORE_MOJOM_H_
#define CHROME_BROWSER_MEDIA_HISTORY_MEDIA_HISTORY_STORE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/browser/media/history/media_history_store.mojom-shared.h"
#include "chrome/browser/media/history/media_history_store.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace media_history {
namespace mojom {

class MediaHistoryStoreProxy;

template <typename ImplRefTraits>
class MediaHistoryStoreStub;

class MediaHistoryStoreRequestValidator;
class MediaHistoryStoreResponseValidator;


class  MediaHistoryStore
    : public MediaHistoryStoreInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = MediaHistoryStoreInterfaceBase;
  using Proxy_ = MediaHistoryStoreProxy;

  template <typename ImplRefTraits>
  using Stub_ = MediaHistoryStoreStub<ImplRefTraits>;

  using RequestValidator_ = MediaHistoryStoreRequestValidator;
  using ResponseValidator_ = MediaHistoryStoreResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetMediaHistoryStatsMinVersion = 0,
  };
  virtual ~MediaHistoryStore() {}


  using GetMediaHistoryStatsCallback = base::OnceCallback<void(MediaHistoryStatsPtr)>;
  
  virtual void GetMediaHistoryStats(GetMediaHistoryStatsCallback callback) = 0;
};



class  MediaHistoryStoreProxy
    : public MediaHistoryStore {
 public:
  using InterfaceType = MediaHistoryStore;

  explicit MediaHistoryStoreProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetMediaHistoryStats(GetMediaHistoryStatsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  MediaHistoryStoreStubDispatch {
 public:
  static bool Accept(MediaHistoryStore* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MediaHistoryStore* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MediaHistoryStore>>
class MediaHistoryStoreStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MediaHistoryStoreStub() {}
  ~MediaHistoryStoreStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaHistoryStoreStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MediaHistoryStoreStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MediaHistoryStoreRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  MediaHistoryStoreResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  MediaHistoryStats {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MediaHistoryStats, T>::value>;
  using DataView = MediaHistoryStatsDataView;
  using Data_ = internal::MediaHistoryStats_Data;

  template <typename... Args>
  static MediaHistoryStatsPtr New(Args&&... args) {
    return MediaHistoryStatsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MediaHistoryStatsPtr From(const U& u) {
    return mojo::TypeConverter<MediaHistoryStatsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MediaHistoryStats>::Convert(*this);
  }


  MediaHistoryStats();

  explicit MediaHistoryStats(
      const base::flat_map<std::string, int32_t>& table_row_counts);

  ~MediaHistoryStats();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MediaHistoryStatsPtr>
  MediaHistoryStatsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MediaHistoryStats::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MediaHistoryStats::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MediaHistoryStats::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MediaHistoryStats_UnserializedMessageContext<
            UserType, MediaHistoryStats::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<MediaHistoryStats::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return MediaHistoryStats::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MediaHistoryStats_UnserializedMessageContext<
            UserType, MediaHistoryStats::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MediaHistoryStats::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  base::flat_map<std::string, int32_t> table_row_counts;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MediaHistoryStats::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MediaHistoryStats::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MediaHistoryStats::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MediaHistoryStats::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
MediaHistoryStatsPtr MediaHistoryStats::Clone() const {
  return New(
      mojo::Clone(table_row_counts)
  );
}

template <typename T, MediaHistoryStats::EnableIfSame<T>*>
bool MediaHistoryStats::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->table_row_counts, other_struct.table_row_counts))
    return false;
  return true;
}

template <typename T, MediaHistoryStats::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.table_row_counts < rhs.table_row_counts)
    return true;
  if (rhs.table_row_counts < lhs.table_row_counts)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace media_history

namespace mojo {


template <>
struct  StructTraits<::media_history::mojom::MediaHistoryStats::DataView,
                                         ::media_history::mojom::MediaHistoryStatsPtr> {
  static bool IsNull(const ::media_history::mojom::MediaHistoryStatsPtr& input) { return !input; }
  static void SetToNull(::media_history::mojom::MediaHistoryStatsPtr* output) { output->reset(); }

  static const decltype(::media_history::mojom::MediaHistoryStats::table_row_counts)& table_row_counts(
      const ::media_history::mojom::MediaHistoryStatsPtr& input) {
    return input->table_row_counts;
  }

  static bool Read(::media_history::mojom::MediaHistoryStats::DataView input, ::media_history::mojom::MediaHistoryStatsPtr* output);
};

}  // namespace mojo

#endif  // CHROME_BROWSER_MEDIA_HISTORY_MEDIA_HISTORY_STORE_MOJOM_H_