// Copyright (c) 2020 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "chrome/common/apps/platform_apps/api/generated_schemas.h"

namespace {
const char kBrowser[] = "{\"functions\":[{\"parameters\":[{\"$ref\":\"browser.OpenTabOptions\",\"name\":\"options\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"openTab\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"browser\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"browser.OpenTabOptions\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"}}}]}";
const char kMediaGalleries[] = "{\"functions\":[{\"parameters\":[{\"optional\":true,\"name\":\"details\",\"$ref\":\"mediaGalleries.MediaFileSystemsDetails\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"},\"isInstanceOf\":\"DOMFileSystem\"},\"type\":\"array\",\"name\":\"mediaFileSystems\"}]}],\"name\":\"getMediaFileSystems\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"},\"isInstanceOf\":\"DOMFileSystem\"},\"type\":\"array\",\"name\":\"mediaFileSystems\"},{\"type\":\"string\",\"name\":\"selectedFileSystemName\"}]}],\"name\":\"addUserSelectedFolder\",\"type\":\"function\"},{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"mediaFileSystem\",\"isInstanceOf\":\"DOMFileSystem\"}],\"returns\":{\"optional\":true,\"name\":\"getMediaFileSystemMetadata\",\"$ref\":\"mediaGalleries.MediaFileSystemMetadata\"},\"name\":\"getMediaFileSystemMetadata\",\"type\":\"function\"},{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"mediaFile\",\"isInstanceOf\":\"Blob\"},{\"optional\":true,\"name\":\"options\",\"$ref\":\"mediaGalleries.MediaMetadataOptions\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"metadata\",\"$ref\":\"mediaGalleries.MediaMetadata\"}]}],\"name\":\"getMetadata\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"galleryId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"mediaGalleries.AddGalleryWatchResult\"}]}],\"name\":\"addGalleryWatch\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"galleryId\"}],\"name\":\"removeGalleryWatch\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"name\":\"details\",\"$ref\":\"mediaGalleries.GalleryChangeDetails\"}],\"name\":\"onGalleryChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"mediaGalleries\",\"properties\":{},\"types\":[{\"inline_doc\":\"True\",\"enum\":[{\"name\":\"contents_changed\"},{\"name\":\"watch_dropped\"}],\"type\":\"string\",\"id\":\"mediaGalleries.GalleryChangeType\"},{\"inline_doc\":\"True\",\"enum\":[{\"name\":\"no\"},{\"name\":\"yes\"},{\"name\":\"if_needed\"}],\"type\":\"string\",\"id\":\"mediaGalleries.GetMediaFileSystemsInteractivity\"},{\"inline_doc\":\"True\",\"enum\":[{\"name\":\"all\"},{\"name\":\"mimeTypeAndTags\"},{\"name\":\"mimeTypeOnly\"}],\"type\":\"string\",\"id\":\"mediaGalleries.GetMetadataType\"},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"mediaGalleries.GalleryChangeDetails\",\"properties\":{\"type\":{\"name\":\"type\",\"$ref\":\"mediaGalleries.GalleryChangeType\"},\"galleryId\":{\"name\":\"galleryId\",\"type\":\"string\"}}},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"mediaGalleries.MediaFileSystemsDetails\",\"properties\":{\"interactive\":{\"optional\":true,\"name\":\"interactive\",\"$ref\":\"mediaGalleries.GetMediaFileSystemsInteractivity\"}}},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"mediaGalleries.MediaMetadataOptions\",\"properties\":{\"metadataType\":{\"optional\":true,\"name\":\"metadataType\",\"$ref\":\"mediaGalleries.GetMetadataType\"}}},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"mediaGalleries.MediaFileSystemMetadata\",\"properties\":{\"name\":{\"name\":\"name\",\"type\":\"string\"},\"galleryId\":{\"name\":\"galleryId\",\"type\":\"string\"},\"deviceId\":{\"optional\":true,\"name\":\"deviceId\",\"type\":\"string\"},\"isRemovable\":{\"name\":\"isRemovable\",\"type\":\"boolean\"},\"isMediaDevice\":{\"name\":\"isMediaDevice\",\"type\":\"boolean\"},\"isAvailable\":{\"name\":\"isAvailable\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"mediaGalleries.StreamInfo\",\"properties\":{\"type\":{\"name\":\"type\",\"type\":\"string\"},\"tags\":{\"name\":\"tags\",\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}}},{\"type\":\"object\",\"id\":\"mediaGalleries.MediaMetadata\",\"properties\":{\"mimeType\":{\"name\":\"mimeType\",\"type\":\"string\"},\"height\":{\"optional\":true,\"name\":\"height\",\"type\":\"integer\"},\"width\":{\"optional\":true,\"name\":\"width\",\"type\":\"integer\"},\"duration\":{\"optional\":true,\"name\":\"duration\",\"type\":\"number\"},\"rotation\":{\"optional\":true,\"name\":\"rotation\",\"type\":\"integer\"},\"album\":{\"optional\":true,\"name\":\"album\",\"type\":\"string\"},\"artist\":{\"optional\":true,\"name\":\"artist\",\"type\":\"string\"},\"comment\":{\"optional\":true,\"name\":\"comment\",\"type\":\"string\"},\"copyright\":{\"optional\":true,\"name\":\"copyright\",\"type\":\"string\"},\"disc\":{\"optional\":true,\"name\":\"disc\",\"type\":\"integer\"},\"genre\":{\"optional\":true,\"name\":\"genre\",\"type\":\"string\"},\"language\":{\"optional\":true,\"name\":\"language\",\"type\":\"string\"},\"title\":{\"optional\":true,\"name\":\"title\",\"type\":\"string\"},\"track\":{\"optional\":true,\"name\":\"track\",\"type\":\"integer\"},\"rawTags\":{\"name\":\"rawTags\",\"type\":\"array\",\"items\":{\"$ref\":\"mediaGalleries.StreamInfo\"}},\"attachedImages\":{\"name\":\"attachedImages\",\"type\":\"array\",\"items\":{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"},\"isInstanceOf\":\"Blob\"}}}},{\"type\":\"object\",\"id\":\"mediaGalleries.AddGalleryWatchResult\",\"properties\":{\"galleryId\":{\"name\":\"galleryId\",\"type\":\"string\"},\"success\":{\"name\":\"success\",\"type\":\"boolean\"}}}]}";
const char kSyncFileSystem[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"fileSystem\",\"isInstanceOf\":\"DOMFileSystem\"}]}],\"name\":\"requestFileSystem\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"policy\",\"$ref\":\"syncFileSystem.ConflictResolutionPolicy\"},{\"name\":\"callback\",\"parameters\":[],\"type\":\"function\",\"optional\":true}],\"name\":\"setConflictResolutionPolicy\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"policy\",\"$ref\":\"syncFileSystem.ConflictResolutionPolicy\"}]}],\"name\":\"getConflictResolutionPolicy\",\"type\":\"function\"},{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"fileSystem\",\"isInstanceOf\":\"DOMFileSystem\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"syncFileSystem.StorageInfo\"}]}],\"name\":\"getUsageAndQuota\",\"type\":\"function\"},{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"fileEntry\",\"isInstanceOf\":\"Entry\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"status\",\"$ref\":\"syncFileSystem.FileStatus\"}]}],\"name\":\"getFileStatus\",\"type\":\"function\"},{\"parameters\":[{\"items\":{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}},\"type\":\"array\",\"name\":\"fileEntries\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"syncFileSystem.FileStatusInfo\"},\"type\":\"array\",\"name\":\"status\"}]}],\"name\":\"getFileStatuses\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"status\",\"$ref\":\"syncFileSystem.ServiceStatus\"}]}],\"name\":\"getServiceStatus\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"name\":\"detail\",\"$ref\":\"syncFileSystem.ServiceInfo\"}],\"name\":\"onServiceStatusChanged\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"detail\",\"$ref\":\"syncFileSystem.FileInfo\"}],\"name\":\"onFileStatusChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"syncFileSystem\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"added\"},{\"name\":\"updated\"},{\"name\":\"deleted\"}],\"type\":\"string\",\"id\":\"syncFileSystem.SyncAction\"},{\"enum\":[{\"name\":\"initializing\"},{\"name\":\"running\"},{\"name\":\"authentication_required\"},{\"name\":\"temporary_unavailable\"},{\"name\":\"disabled\"}],\"type\":\"string\",\"id\":\"syncFileSystem.ServiceStatus\"},{\"enum\":[{\"name\":\"synced\"},{\"name\":\"pending\"},{\"name\":\"conflicting\"}],\"type\":\"string\",\"id\":\"syncFileSystem.FileStatus\"},{\"enum\":[{\"name\":\"local_to_remote\"},{\"name\":\"remote_to_local\"}],\"type\":\"string\",\"id\":\"syncFileSystem.SyncDirection\"},{\"enum\":[{\"name\":\"last_write_win\"},{\"name\":\"manual\"}],\"type\":\"string\",\"id\":\"syncFileSystem.ConflictResolutionPolicy\"},{\"type\":\"object\",\"id\":\"syncFileSystem.FileInfo\",\"properties\":{\"fileEntry\":{\"name\":\"fileEntry\",\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"},\"isInstanceOf\":\"Entry\"},\"status\":{\"name\":\"status\",\"$ref\":\"syncFileSystem.FileStatus\"},\"action\":{\"optional\":true,\"name\":\"action\",\"$ref\":\"syncFileSystem.SyncAction\"},\"direction\":{\"optional\":true,\"name\":\"direction\",\"$ref\":\"syncFileSystem.SyncDirection\"}}},{\"type\":\"object\",\"id\":\"syncFileSystem.FileStatusInfo\",\"properties\":{\"fileEntry\":{\"name\":\"fileEntry\",\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"},\"isInstanceOf\":\"Entry\"},\"status\":{\"name\":\"status\",\"$ref\":\"syncFileSystem.FileStatus\"},\"error\":{\"optional\":true,\"name\":\"error\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"syncFileSystem.StorageInfo\",\"properties\":{\"usageBytes\":{\"name\":\"usageBytes\",\"type\":\"integer\"},\"quotaBytes\":{\"name\":\"quotaBytes\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"syncFileSystem.ServiceInfo\",\"properties\":{\"state\":{\"name\":\"state\",\"$ref\":\"syncFileSystem.ServiceStatus\"},\"description\":{\"name\":\"description\",\"type\":\"string\"}}}]}";
const char kWebstoreWidgetPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"string\",\"name\":\"itemId\"},{\"type\":\"boolean\",\"name\":\"silentInstallation\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"installWebstoreItem\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":[\"chromeos\"],\"internal\":false,\"namespace\":\"webstoreWidgetPrivate\",\"properties\":{},\"types\":[]}";
const char kMusicManagerPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"device_id\"}]}],\"name\":\"getDeviceId\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"musicManagerPrivate\",\"properties\":{},\"types\":[]}";
}  // namespace

namespace chrome_apps {
namespace api {

// static
bool ChromeAppsGeneratedSchemas::IsGenerated(base::StringPiece name) {
  return !Get(name).empty();
}

// static
base::StringPiece ChromeAppsGeneratedSchemas::Get(base::StringPiece name) {
  static const struct {
    base::StringPiece name;
    base::StringPiece schema;
  } kSchemas[] = {
    {{"browser", 7}, {kBrowser, sizeof(kBrowser) - 1}},
    {{"mediaGalleries", 14}, {kMediaGalleries, sizeof(kMediaGalleries) - 1}},
    {{"musicManagerPrivate", 19}, {kMusicManagerPrivate, sizeof(kMusicManagerPrivate) - 1}},
    {{"syncFileSystem", 14}, {kSyncFileSystem, sizeof(kSyncFileSystem) - 1}},
    {{"webstoreWidgetPrivate", 21}, {kWebstoreWidgetPrivate, sizeof(kWebstoreWidgetPrivate) - 1}},
  };
  for (const auto& schema : kSchemas) {
    if (schema.name == name)
      return schema.schema;
  }
  return base::StringPiece();
}

}  // namespace api
}  // namespace chrome_apps
