// chrome/common/content_settings_manager.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CONTENT_SETTINGS_MANAGER_MOJOM_H_
#define CHROME_COMMON_CONTENT_SETTINGS_MANAGER_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/common/content_settings_manager.mojom-shared.h"
#include "chrome/common/content_settings_manager.mojom-forward.h"
#include "components/content_settings/core/common/content_settings.mojom-forward.h"
#include "url/mojom/origin.mojom-forward.h"
#include "url/mojom/url.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace chrome {
namespace mojom {

class ContentSettingsManagerProxy;

template <typename ImplRefTraits>
class ContentSettingsManagerStub;

class ContentSettingsManagerRequestValidator;
class ContentSettingsManagerResponseValidator;


class  ContentSettingsManager
    : public ContentSettingsManagerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = true;

  using Base_ = ContentSettingsManagerInterfaceBase;
  using Proxy_ = ContentSettingsManagerProxy;

  template <typename ImplRefTraits>
  using Stub_ = ContentSettingsManagerStub<ImplRefTraits>;

  using RequestValidator_ = ContentSettingsManagerRequestValidator;
  using ResponseValidator_ = ContentSettingsManagerResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCloneMinVersion = 0,
    kAllowStorageAccessMinVersion = 0,
    kOnContentBlockedMinVersion = 0,
  };
  
  using StorageType = ContentSettingsManager_StorageType;
  virtual ~ContentSettingsManager() {}

  
  virtual void Clone(mojo::PendingReceiver<ContentSettingsManager> clone) = 0;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool AllowStorageAccess(int32_t render_frame_id, ContentSettingsManager::StorageType storage_type, const ::url::Origin& origin, const ::GURL& site_for_cookies, const ::url::Origin& top_frame_origin, bool* out_allowed);

  using AllowStorageAccessCallback = base::OnceCallback<void(bool)>;
  
  virtual void AllowStorageAccess(int32_t render_frame_id, ContentSettingsManager::StorageType storage_type, const ::url::Origin& origin, const ::GURL& site_for_cookies, const ::url::Origin& top_frame_origin, AllowStorageAccessCallback callback) = 0;

  
  virtual void OnContentBlocked(int32_t render_frame_id, ::ContentSettingsType type) = 0;
};



class  ContentSettingsManagerProxy
    : public ContentSettingsManager {
 public:
  using InterfaceType = ContentSettingsManager;

  explicit ContentSettingsManagerProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Clone(mojo::PendingReceiver<ContentSettingsManager> clone) final;
  
  bool AllowStorageAccess(int32_t render_frame_id, ContentSettingsManager::StorageType storage_type, const ::url::Origin& origin, const ::GURL& site_for_cookies, const ::url::Origin& top_frame_origin, bool* out_allowed) final;
  
  void AllowStorageAccess(int32_t render_frame_id, ContentSettingsManager::StorageType storage_type, const ::url::Origin& origin, const ::GURL& site_for_cookies, const ::url::Origin& top_frame_origin, AllowStorageAccessCallback callback) final;
  
  void OnContentBlocked(int32_t render_frame_id, ::ContentSettingsType type) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  ContentSettingsManagerStubDispatch {
 public:
  static bool Accept(ContentSettingsManager* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ContentSettingsManager* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ContentSettingsManager>>
class ContentSettingsManagerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ContentSettingsManagerStub() {}
  ~ContentSettingsManagerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContentSettingsManagerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ContentSettingsManagerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  ContentSettingsManagerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  ContentSettingsManagerResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace chrome

namespace mojo {

}  // namespace mojo

#endif  // CHROME_COMMON_CONTENT_SETTINGS_MANAGER_MOJOM_H_