// chrome/common/importer/profile_import.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_IMPORTER_PROFILE_IMPORT_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_IMPORTER_PROFILE_IMPORT_MOJOM_TEST_UTILS_H_

#include "chrome/common/importer/profile_import.mojom.h"


namespace chrome {
namespace mojom {


class  ProfileImportObserverInterceptorForTesting : public ProfileImportObserver {
  virtual ProfileImportObserver* GetForwardingInterface() = 0;
  void OnImportStart() override;
  void OnImportFinished(bool succeeded, const std::string& error_msg) override;
  void OnImportItemStart(::importer::ImportItem item) override;
  void OnImportItemFinished(::importer::ImportItem item) override;
  void OnHistoryImportStart(uint32_t total_history_rows_count) override;
  void OnHistoryImportGroup(const std::vector<::ImporterURLRow>& history_rows_group, int32_t visit_source) override;
  void OnHomePageImportReady(const ::GURL& home_page) override;
  void OnBookmarksImportStart(const ::base::string16& first_folder_name, uint32_t total_bookmarks_count) override;
  void OnBookmarksImportGroup(const std::vector<::ImportedBookmarkEntry>& bookmarks_group) override;
  void OnFaviconsImportStart(uint32_t total_favicons_count) override;
  void OnFaviconsImportGroup(const ::favicon_base::FaviconUsageDataList& favicons_group) override;
  void OnPasswordFormImportReady(const ::autofill::PasswordForm& form) override;
  void OnKeywordsImportReady(const std::vector<::importer::SearchEngineInfo>& search_engines, bool unique_on_host_and_path) override;
  void OnFirefoxSearchEngineDataReceived(const std::vector<std::string>& search_engine_data) override;
  void OnAutofillFormDataImportStart(uint32_t total_autofill_form_data_entry_count) override;
  void OnAutofillFormDataImportGroup(const std::vector<::ImporterAutofillFormDataEntry>& autofill_form_data_entry_group) override;
};
class  ProfileImportObserverAsyncWaiter {
 public:
  explicit ProfileImportObserverAsyncWaiter(ProfileImportObserver* proxy);
  ~ProfileImportObserverAsyncWaiter();

 private:
  ProfileImportObserver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ProfileImportObserverAsyncWaiter);
};


class  ProfileImportInterceptorForTesting : public ProfileImport {
  virtual ProfileImport* GetForwardingInterface() = 0;
  void StartImport(const ::importer::SourceProfile& source_profile, uint16_t items, const base::flat_map<uint32_t, std::string>& localized_strings, mojo::PendingRemote<ProfileImportObserver> observer) override;
  void CancelImport() override;
  void ReportImportItemFinished(::importer::ImportItem item) override;
};
class  ProfileImportAsyncWaiter {
 public:
  explicit ProfileImportAsyncWaiter(ProfileImport* proxy);
  ~ProfileImportAsyncWaiter();

 private:
  ProfileImport* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ProfileImportAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_IMPORTER_PROFILE_IMPORT_MOJOM_TEST_UTILS_H_