// chrome/common/media_router/mojom/media_router.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_ROUTER_MOJOM_SHARED_H_
#define CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_ROUTER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/common/media_router/mojom/media_router.mojom-shared-internal.h"
#include "chrome/common/media_router/mojom/media_controller.mojom-shared.h"
#include "chrome/common/media_router/mojom/media_status.mojom-shared.h"
#include "components/mirroring/mojom/mirroring_service_host.mojom-shared.h"
#include "media/mojo/mojom/mirror_service_remoting.mojom-shared.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "services/network/public/mojom/ip_address.mojom-shared.h"
#include "services/network/public/mojom/ip_endpoint.mojom-shared.h"
#include "third_party/blink/public/mojom/presentation/presentation.mojom-shared.h"
#include "url/mojom/origin.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"






namespace media_router {
namespace mojom {
class MediaSinkDataView;

class DialMediaSinkDataView;

class CastMediaSinkDataView;

class MediaRouteDataView;

class IssueDataView;

class RouteMessageDataView;

class SinkSearchCriteriaDataView;

class MediaRouteProviderConfigDataView;

class RoutePresentationConnectionDataView;

class MediaSinkExtraDataDataView;


}  // namespace mojom
}  // namespace media_router

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::media_router::mojom::MediaSinkDataView> {
  using Data = ::media_router::mojom::internal::MediaSink_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::DialMediaSinkDataView> {
  using Data = ::media_router::mojom::internal::DialMediaSink_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::CastMediaSinkDataView> {
  using Data = ::media_router::mojom::internal::CastMediaSink_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::MediaRouteDataView> {
  using Data = ::media_router::mojom::internal::MediaRoute_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::IssueDataView> {
  using Data = ::media_router::mojom::internal::Issue_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::RouteMessageDataView> {
  using Data = ::media_router::mojom::internal::RouteMessage_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::SinkSearchCriteriaDataView> {
  using Data = ::media_router::mojom::internal::SinkSearchCriteria_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::MediaRouteProviderConfigDataView> {
  using Data = ::media_router::mojom::internal::MediaRouteProviderConfig_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::RoutePresentationConnectionDataView> {
  using Data = ::media_router::mojom::internal::RoutePresentationConnection_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::media_router::mojom::MediaSinkExtraDataDataView> {
  using Data = ::media_router::mojom::internal::MediaSinkExtraData_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace media_router {
namespace mojom {


enum class SinkIconType : int32_t {
  
  CAST,
  
  CAST_AUDIO_GROUP,
  
  CAST_AUDIO,
  
  MEETING,
  
  HANGOUT,
  
  EDUCATION,
  
  WIRED_DISPLAY,
  
  GENERIC,
  kMinValue = 0,
  kMaxValue = 7,
};

 std::ostream& operator<<(std::ostream& os, SinkIconType value);
inline bool IsKnownEnumValue(SinkIconType value) {
  return internal::SinkIconType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class RouteControllerType : int32_t {
  
  kNone,
  
  kGeneric,
  
  kMirroring,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, RouteControllerType value);
inline bool IsKnownEnumValue(RouteControllerType value) {
  return internal::RouteControllerType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class RouteRequestResultCode : int32_t {
  
  UNKNOWN_ERROR,
  
  OK,
  
  TIMED_OUT,
  
  ROUTE_NOT_FOUND,
  
  SINK_NOT_FOUND,
  
  INVALID_ORIGIN,
  
  INCOGNITO_MISMATCH,
  
  NO_SUPPORTED_PROVIDER,
  
  CANCELLED,
  
  ROUTE_ALREADY_EXISTS,
  
  DESKTOP_PICKER_FAILED,
  kMinValue = 0,
  kMaxValue = 10,
};

 std::ostream& operator<<(std::ostream& os, RouteRequestResultCode value);
inline bool IsKnownEnumValue(RouteRequestResultCode value) {
  return internal::RouteRequestResultCode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class Issue_Severity : int32_t {
  
  FATAL,
  
  WARNING,
  
  NOTIFICATION,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, Issue_Severity value);
inline bool IsKnownEnumValue(Issue_Severity value) {
  return internal::Issue_Severity_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class Issue_ActionType : int32_t {
  
  DISMISS,
  
  LEARN_MORE,
  kMinValue = 0,
  kMaxValue = 1,
};

 std::ostream& operator<<(std::ostream& os, Issue_ActionType value);
inline bool IsKnownEnumValue(Issue_ActionType value) {
  return internal::Issue_ActionType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class RouteMessage_Type : int32_t {
  
  TEXT,
  
  BINARY,
  kMinValue = 0,
  kMaxValue = 1,
};

 std::ostream& operator<<(std::ostream& os, RouteMessage_Type value);
inline bool IsKnownEnumValue(RouteMessage_Type value) {
  return internal::RouteMessage_Type_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class MediaRouteProvider_Id : int32_t {
  
  EXTENSION,
  
  WIRED_DISPLAY,
  
  CAST,
  
  DIAL,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, MediaRouteProvider_Id value);
inline bool IsKnownEnumValue(MediaRouteProvider_Id value) {
  return internal::MediaRouteProvider_Id_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class MediaRouter_SinkAvailability : int32_t {
  
  UNAVAILABLE,
  
  PER_SOURCE,
  
  AVAILABLE,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, MediaRouter_SinkAvailability value);
inline bool IsKnownEnumValue(MediaRouter_SinkAvailability value) {
  return internal::MediaRouter_SinkAvailability_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class MediaRouter_PresentationConnectionState : int32_t {
  
  CONNECTING,
  
  CONNECTED,
  
  CLOSED,
  
  TERMINATED,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, MediaRouter_PresentationConnectionState value);
inline bool IsKnownEnumValue(MediaRouter_PresentationConnectionState value) {
  return internal::MediaRouter_PresentationConnectionState_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class MediaRouter_PresentationConnectionCloseReason : int32_t {
  
  CONNECTION_ERROR,
  
  CLOSED,
  
  WENT_AWAY,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, MediaRouter_PresentationConnectionCloseReason value);
inline bool IsKnownEnumValue(MediaRouter_PresentationConnectionCloseReason value) {
  return internal::MediaRouter_PresentationConnectionCloseReason_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class MediaRouteProviderInterfaceBase {};

using MediaRouteProviderPtrDataView =
    mojo::InterfacePtrDataView<MediaRouteProviderInterfaceBase>;
using MediaRouteProviderRequestDataView =
    mojo::InterfaceRequestDataView<MediaRouteProviderInterfaceBase>;
using MediaRouteProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaRouteProviderInterfaceBase>;
using MediaRouteProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaRouteProviderInterfaceBase>;
class MediaRouterInterfaceBase {};

using MediaRouterPtrDataView =
    mojo::InterfacePtrDataView<MediaRouterInterfaceBase>;
using MediaRouterRequestDataView =
    mojo::InterfaceRequestDataView<MediaRouterInterfaceBase>;
using MediaRouterAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaRouterInterfaceBase>;
using MediaRouterAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaRouterInterfaceBase>;
class MediaSinkDataView {
 public:
  MediaSinkDataView() {}

  MediaSinkDataView(
      internal::MediaSink_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSinkIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSinkId(UserType* output) {
    auto* pointer = data_->sink_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadName(UserType* output) {
    auto* pointer = data_->name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDescriptionDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDescription(UserType* output) {
    auto* pointer = data_->description.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDomainDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDomain(UserType* output) {
    auto* pointer = data_->domain.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIconType(UserType* output) const {
    auto data_value = data_->icon_type;
    return mojo::internal::Deserialize<::media_router::mojom::SinkIconType>(
        data_value, output);
  }

  SinkIconType icon_type() const {
    return static_cast<SinkIconType>(data_->icon_type);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProviderId(UserType* output) const {
    auto data_value = data_->provider_id;
    return mojo::internal::Deserialize<::media_router::mojom::MediaRouteProvider_Id>(
        data_value, output);
  }

  MediaRouteProvider_Id provider_id() const {
    return static_cast<MediaRouteProvider_Id>(data_->provider_id);
  }
  inline void GetExtraDataDataView(
      MediaSinkExtraDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadExtraData(UserType* output) {
    auto* pointer = !data_->extra_data.is_null() ? &data_->extra_data : nullptr;
    return mojo::internal::Deserialize<::media_router::mojom::MediaSinkExtraDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::MediaSink_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DialMediaSinkDataView {
 public:
  DialMediaSinkDataView() {}

  DialMediaSinkDataView(
      internal::DialMediaSink_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIpAddressDataView(
      ::network::mojom::IPAddressDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIpAddress(UserType* output) {
    auto* pointer = data_->ip_address.Get();
    return mojo::internal::Deserialize<::network::mojom::IPAddressDataView>(
        pointer, output, context_);
  }
  inline void GetModelNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadModelName(UserType* output) {
    auto* pointer = data_->model_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetAppUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppUrl(UserType* output) {
    auto* pointer = data_->app_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::DialMediaSink_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class CastMediaSinkDataView {
 public:
  CastMediaSinkDataView() {}

  CastMediaSinkDataView(
      internal::CastMediaSink_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIpEndpointDataView(
      ::network::mojom::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadIpEndpoint(UserType* output) {
    auto* pointer = data_->ip_endpoint.Get();
    return mojo::internal::Deserialize<::network::mojom::IPEndPointDataView>(
        pointer, output, context_);
  }
  inline void GetModelNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadModelName(UserType* output) {
    auto* pointer = data_->model_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  uint8_t capabilities() const {
    return data_->capabilities;
  }
  int32_t cast_channel_id() const {
    return data_->cast_channel_id;
  }
 private:
  internal::CastMediaSink_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaRouteDataView {
 public:
  MediaRouteDataView() {}

  MediaRouteDataView(
      internal::MediaRoute_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMediaRouteIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMediaRouteId(UserType* output) {
    auto* pointer = data_->media_route_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetPresentationIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPresentationId(UserType* output) {
    auto* pointer = data_->presentation_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMediaSourceDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMediaSource(UserType* output) {
    auto* pointer = data_->media_source.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMediaSinkIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMediaSinkId(UserType* output) {
    auto* pointer = data_->media_sink_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMediaSinkNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMediaSinkName(UserType* output) {
    auto* pointer = data_->media_sink_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDescriptionDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDescription(UserType* output) {
    auto* pointer = data_->description.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool is_local() const {
    return data_->is_local;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadControllerType(UserType* output) const {
    auto data_value = data_->controller_type;
    return mojo::internal::Deserialize<::media_router::mojom::RouteControllerType>(
        data_value, output);
  }

  RouteControllerType controller_type() const {
    return static_cast<RouteControllerType>(data_->controller_type);
  }
  bool for_display() const {
    return data_->for_display;
  }
  bool is_incognito() const {
    return data_->is_incognito;
  }
  bool is_local_presentation() const {
    return data_->is_local_presentation;
  }
 private:
  internal::MediaRoute_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IssueDataView {
 public:
  IssueDataView() {}

  IssueDataView(
      internal::Issue_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRouteIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRouteId(UserType* output) {
    auto* pointer = data_->route_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetSinkIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSinkId(UserType* output) {
    auto* pointer = data_->sink_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSeverity(UserType* output) const {
    auto data_value = data_->severity;
    return mojo::internal::Deserialize<::media_router::mojom::Issue_Severity>(
        data_value, output);
  }

  Issue_Severity severity() const {
    return static_cast<Issue_Severity>(data_->severity);
  }
  bool is_blocking() const {
    return data_->is_blocking;
  }
  inline void GetTitleDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTitle(UserType* output) {
    auto* pointer = data_->title.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDefaultAction(UserType* output) const {
    auto data_value = data_->default_action;
    return mojo::internal::Deserialize<::media_router::mojom::Issue_ActionType>(
        data_value, output);
  }

  Issue_ActionType default_action() const {
    return static_cast<Issue_ActionType>(data_->default_action);
  }
  inline void GetSecondaryActionsDataView(
      mojo::ArrayDataView<Issue_ActionType>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSecondaryActions(UserType* output) {
    auto* pointer = data_->secondary_actions.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::media_router::mojom::Issue_ActionType>>(
        pointer, output, context_);
  }
  int32_t help_page_id() const {
    return data_->help_page_id;
  }
 private:
  internal::Issue_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RouteMessageDataView {
 public:
  RouteMessageDataView() {}

  RouteMessageDataView(
      internal::RouteMessage_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::media_router::mojom::RouteMessage_Type>(
        data_value, output);
  }

  RouteMessage_Type type() const {
    return static_cast<RouteMessage_Type>(data_->type);
  }
  inline void GetMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDataDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::RouteMessage_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SinkSearchCriteriaDataView {
 public:
  SinkSearchCriteriaDataView() {}

  SinkSearchCriteriaDataView(
      internal::SinkSearchCriteria_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInputDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInput(UserType* output) {
    auto* pointer = data_->input.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDomainDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDomain(UserType* output) {
    auto* pointer = data_->domain.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::SinkSearchCriteria_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaRouteProviderConfigDataView {
 public:
  MediaRouteProviderConfigDataView() {}

  MediaRouteProviderConfigDataView(
      internal::MediaRouteProviderConfig_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool enable_dial_discovery() const {
    return data_->enable_dial_discovery;
  }
  bool enable_cast_discovery() const {
    return data_->enable_cast_discovery;
  }
  bool enable_dial_sink_query() const {
    return data_->enable_dial_sink_query;
  }
  bool enable_cast_sink_query() const {
    return data_->enable_cast_sink_query;
  }
  bool use_mirroring_service() const {
    return data_->use_mirroring_service;
  }
 private:
  internal::MediaRouteProviderConfig_Data* data_ = nullptr;
};

class RoutePresentationConnectionDataView {
 public:
  RoutePresentationConnectionDataView() {}

  RoutePresentationConnectionDataView(
      internal::RoutePresentationConnection_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeConnectionRemote() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::blink::mojom::PresentationConnectionInterfaceBase>>(
            &data_->connection_remote, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeConnectionReceiver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfaceRequestDataView<::blink::mojom::PresentationConnectionInterfaceBase>>(
            &data_->connection_receiver, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::RoutePresentationConnection_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaSinkExtraDataDataView {
 public:
  using Tag = internal::MediaSinkExtraData_Data::MediaSinkExtraData_Tag;

  MediaSinkExtraDataDataView() {}

  MediaSinkExtraDataDataView(
      internal::MediaSinkExtraData_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_dial_media_sink() const { return data_->tag == Tag::DIAL_MEDIA_SINK; }
  inline void GetDialMediaSinkDataView(
      DialMediaSinkDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDialMediaSink(UserType* output) {
    DCHECK(is_dial_media_sink());
    return mojo::internal::Deserialize<::media_router::mojom::DialMediaSinkDataView>(
        data_->data.f_dial_media_sink.Get(), output, context_);
  }
  bool is_cast_media_sink() const { return data_->tag == Tag::CAST_MEDIA_SINK; }
  inline void GetCastMediaSinkDataView(
      CastMediaSinkDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCastMediaSink(UserType* output) {
    DCHECK(is_cast_media_sink());
    return mojo::internal::Deserialize<::media_router::mojom::CastMediaSinkDataView>(
        data_->data.f_cast_media_sink.Get(), output, context_);
  }

 private:
  internal::MediaSinkExtraData_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace media_router

namespace std {

template <>
struct hash<::media_router::mojom::SinkIconType>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::SinkIconType> {};

template <>
struct hash<::media_router::mojom::RouteControllerType>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::RouteControllerType> {};

template <>
struct hash<::media_router::mojom::RouteRequestResultCode>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::RouteRequestResultCode> {};

template <>
struct hash<::media_router::mojom::Issue_Severity>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::Issue_Severity> {};

template <>
struct hash<::media_router::mojom::Issue_ActionType>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::Issue_ActionType> {};

template <>
struct hash<::media_router::mojom::RouteMessage_Type>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::RouteMessage_Type> {};

template <>
struct hash<::media_router::mojom::MediaRouteProvider_Id>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::MediaRouteProvider_Id> {};

template <>
struct hash<::media_router::mojom::MediaRouter_SinkAvailability>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::MediaRouter_SinkAvailability> {};

template <>
struct hash<::media_router::mojom::MediaRouter_PresentationConnectionState>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::MediaRouter_PresentationConnectionState> {};

template <>
struct hash<::media_router::mojom::MediaRouter_PresentationConnectionCloseReason>
    : public mojo::internal::EnumHashImpl<::media_router::mojom::MediaRouter_PresentationConnectionCloseReason> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::media_router::mojom::SinkIconType, ::media_router::mojom::SinkIconType> {
  static ::media_router::mojom::SinkIconType ToMojom(::media_router::mojom::SinkIconType input) { return input; }
  static bool FromMojom(::media_router::mojom::SinkIconType input, ::media_router::mojom::SinkIconType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::SinkIconType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::SinkIconType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::SinkIconType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::RouteControllerType, ::media_router::mojom::RouteControllerType> {
  static ::media_router::mojom::RouteControllerType ToMojom(::media_router::mojom::RouteControllerType input) { return input; }
  static bool FromMojom(::media_router::mojom::RouteControllerType input, ::media_router::mojom::RouteControllerType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::RouteControllerType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::RouteControllerType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::RouteControllerType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::RouteRequestResultCode, ::media_router::mojom::RouteRequestResultCode> {
  static ::media_router::mojom::RouteRequestResultCode ToMojom(::media_router::mojom::RouteRequestResultCode input) { return input; }
  static bool FromMojom(::media_router::mojom::RouteRequestResultCode input, ::media_router::mojom::RouteRequestResultCode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::RouteRequestResultCode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::RouteRequestResultCode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::RouteRequestResultCode>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::Issue_Severity, ::media_router::mojom::Issue_Severity> {
  static ::media_router::mojom::Issue_Severity ToMojom(::media_router::mojom::Issue_Severity input) { return input; }
  static bool FromMojom(::media_router::mojom::Issue_Severity input, ::media_router::mojom::Issue_Severity* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::Issue_Severity, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::Issue_Severity, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::Issue_Severity>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::Issue_ActionType, ::media_router::mojom::Issue_ActionType> {
  static ::media_router::mojom::Issue_ActionType ToMojom(::media_router::mojom::Issue_ActionType input) { return input; }
  static bool FromMojom(::media_router::mojom::Issue_ActionType input, ::media_router::mojom::Issue_ActionType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::Issue_ActionType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::Issue_ActionType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::Issue_ActionType>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::RouteMessage_Type, ::media_router::mojom::RouteMessage_Type> {
  static ::media_router::mojom::RouteMessage_Type ToMojom(::media_router::mojom::RouteMessage_Type input) { return input; }
  static bool FromMojom(::media_router::mojom::RouteMessage_Type input, ::media_router::mojom::RouteMessage_Type* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::RouteMessage_Type, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::RouteMessage_Type, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::RouteMessage_Type>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::MediaRouteProvider_Id, ::media_router::mojom::MediaRouteProvider_Id> {
  static ::media_router::mojom::MediaRouteProvider_Id ToMojom(::media_router::mojom::MediaRouteProvider_Id input) { return input; }
  static bool FromMojom(::media_router::mojom::MediaRouteProvider_Id input, ::media_router::mojom::MediaRouteProvider_Id* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaRouteProvider_Id, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::MediaRouteProvider_Id, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::MediaRouteProvider_Id>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::MediaRouter_SinkAvailability, ::media_router::mojom::MediaRouter_SinkAvailability> {
  static ::media_router::mojom::MediaRouter_SinkAvailability ToMojom(::media_router::mojom::MediaRouter_SinkAvailability input) { return input; }
  static bool FromMojom(::media_router::mojom::MediaRouter_SinkAvailability input, ::media_router::mojom::MediaRouter_SinkAvailability* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaRouter_SinkAvailability, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::MediaRouter_SinkAvailability, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::MediaRouter_SinkAvailability>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::MediaRouter_PresentationConnectionState, ::media_router::mojom::MediaRouter_PresentationConnectionState> {
  static ::media_router::mojom::MediaRouter_PresentationConnectionState ToMojom(::media_router::mojom::MediaRouter_PresentationConnectionState input) { return input; }
  static bool FromMojom(::media_router::mojom::MediaRouter_PresentationConnectionState input, ::media_router::mojom::MediaRouter_PresentationConnectionState* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaRouter_PresentationConnectionState, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::MediaRouter_PresentationConnectionState, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::MediaRouter_PresentationConnectionState>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::media_router::mojom::MediaRouter_PresentationConnectionCloseReason, ::media_router::mojom::MediaRouter_PresentationConnectionCloseReason> {
  static ::media_router::mojom::MediaRouter_PresentationConnectionCloseReason ToMojom(::media_router::mojom::MediaRouter_PresentationConnectionCloseReason input) { return input; }
  static bool FromMojom(::media_router::mojom::MediaRouter_PresentationConnectionCloseReason input, ::media_router::mojom::MediaRouter_PresentationConnectionCloseReason* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaRouter_PresentationConnectionCloseReason, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::media_router::mojom::MediaRouter_PresentationConnectionCloseReason, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::media_router::mojom::MediaRouter_PresentationConnectionCloseReason>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaSinkDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::MediaSinkDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::MediaSink_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::sink_id(input)) in_sink_id = Traits::sink_id(input);
    typename decltype((*output)->sink_id)::BaseType::BufferWriter
        sink_id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_sink_id, buffer, &sink_id_writer, context);
    (*output)->sink_id.Set(
        sink_id_writer.is_null() ? nullptr : sink_id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->sink_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null sink_id in MediaSink struct");
    decltype(Traits::name(input)) in_name = Traits::name(input);
    typename decltype((*output)->name)::BaseType::BufferWriter
        name_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name, buffer, &name_writer, context);
    (*output)->name.Set(
        name_writer.is_null() ? nullptr : name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name in MediaSink struct");
    decltype(Traits::description(input)) in_description = Traits::description(input);
    typename decltype((*output)->description)::BaseType::BufferWriter
        description_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_description, buffer, &description_writer, context);
    (*output)->description.Set(
        description_writer.is_null() ? nullptr : description_writer.data());
    decltype(Traits::domain(input)) in_domain = Traits::domain(input);
    typename decltype((*output)->domain)::BaseType::BufferWriter
        domain_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_domain, buffer, &domain_writer, context);
    (*output)->domain.Set(
        domain_writer.is_null() ? nullptr : domain_writer.data());
    mojo::internal::Serialize<::media_router::mojom::SinkIconType>(
        Traits::icon_type(input), &(*output)->icon_type);
    mojo::internal::Serialize<::media_router::mojom::MediaRouteProvider_Id>(
        Traits::provider_id(input), &(*output)->provider_id);
    decltype(Traits::extra_data(input)) in_extra_data = Traits::extra_data(input);
    typename decltype((*output)->extra_data)::BufferWriter extra_data_writer;
    extra_data_writer.AllocateInline(buffer, &(*output)->extra_data);
    mojo::internal::Serialize<::media_router::mojom::MediaSinkExtraDataDataView>(
        in_extra_data, buffer, &extra_data_writer, true, context);
  }

  static bool Deserialize(::media_router::mojom::internal::MediaSink_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::MediaSinkDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::DialMediaSinkDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::DialMediaSinkDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::DialMediaSink_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::ip_address(input)) in_ip_address = Traits::ip_address(input);
    typename decltype((*output)->ip_address)::BaseType::BufferWriter
        ip_address_writer;
    mojo::internal::Serialize<::network::mojom::IPAddressDataView>(
        in_ip_address, buffer, &ip_address_writer, context);
    (*output)->ip_address.Set(
        ip_address_writer.is_null() ? nullptr : ip_address_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->ip_address.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null ip_address in DialMediaSink struct");
    decltype(Traits::model_name(input)) in_model_name = Traits::model_name(input);
    typename decltype((*output)->model_name)::BaseType::BufferWriter
        model_name_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_model_name, buffer, &model_name_writer, context);
    (*output)->model_name.Set(
        model_name_writer.is_null() ? nullptr : model_name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->model_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null model_name in DialMediaSink struct");
    decltype(Traits::app_url(input)) in_app_url = Traits::app_url(input);
    typename decltype((*output)->app_url)::BaseType::BufferWriter
        app_url_writer;
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_app_url, buffer, &app_url_writer, context);
    (*output)->app_url.Set(
        app_url_writer.is_null() ? nullptr : app_url_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->app_url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null app_url in DialMediaSink struct");
  }

  static bool Deserialize(::media_router::mojom::internal::DialMediaSink_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::DialMediaSinkDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::CastMediaSinkDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::CastMediaSinkDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::CastMediaSink_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::ip_endpoint(input)) in_ip_endpoint = Traits::ip_endpoint(input);
    typename decltype((*output)->ip_endpoint)::BaseType::BufferWriter
        ip_endpoint_writer;
    mojo::internal::Serialize<::network::mojom::IPEndPointDataView>(
        in_ip_endpoint, buffer, &ip_endpoint_writer, context);
    (*output)->ip_endpoint.Set(
        ip_endpoint_writer.is_null() ? nullptr : ip_endpoint_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->ip_endpoint.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null ip_endpoint in CastMediaSink struct");
    decltype(Traits::model_name(input)) in_model_name = Traits::model_name(input);
    typename decltype((*output)->model_name)::BaseType::BufferWriter
        model_name_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_model_name, buffer, &model_name_writer, context);
    (*output)->model_name.Set(
        model_name_writer.is_null() ? nullptr : model_name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->model_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null model_name in CastMediaSink struct");
    (*output)->capabilities = Traits::capabilities(input);
    (*output)->cast_channel_id = Traits::cast_channel_id(input);
  }

  static bool Deserialize(::media_router::mojom::internal::CastMediaSink_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::CastMediaSinkDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaRouteDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::MediaRouteDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::MediaRoute_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::media_route_id(input)) in_media_route_id = Traits::media_route_id(input);
    typename decltype((*output)->media_route_id)::BaseType::BufferWriter
        media_route_id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_media_route_id, buffer, &media_route_id_writer, context);
    (*output)->media_route_id.Set(
        media_route_id_writer.is_null() ? nullptr : media_route_id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->media_route_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null media_route_id in MediaRoute struct");
    decltype(Traits::presentation_id(input)) in_presentation_id = Traits::presentation_id(input);
    typename decltype((*output)->presentation_id)::BaseType::BufferWriter
        presentation_id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_presentation_id, buffer, &presentation_id_writer, context);
    (*output)->presentation_id.Set(
        presentation_id_writer.is_null() ? nullptr : presentation_id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->presentation_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_id in MediaRoute struct");
    decltype(Traits::media_source(input)) in_media_source = Traits::media_source(input);
    typename decltype((*output)->media_source)::BaseType::BufferWriter
        media_source_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_media_source, buffer, &media_source_writer, context);
    (*output)->media_source.Set(
        media_source_writer.is_null() ? nullptr : media_source_writer.data());
    decltype(Traits::media_sink_id(input)) in_media_sink_id = Traits::media_sink_id(input);
    typename decltype((*output)->media_sink_id)::BaseType::BufferWriter
        media_sink_id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_media_sink_id, buffer, &media_sink_id_writer, context);
    (*output)->media_sink_id.Set(
        media_sink_id_writer.is_null() ? nullptr : media_sink_id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->media_sink_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null media_sink_id in MediaRoute struct");
    decltype(Traits::media_sink_name(input)) in_media_sink_name = Traits::media_sink_name(input);
    typename decltype((*output)->media_sink_name)::BaseType::BufferWriter
        media_sink_name_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_media_sink_name, buffer, &media_sink_name_writer, context);
    (*output)->media_sink_name.Set(
        media_sink_name_writer.is_null() ? nullptr : media_sink_name_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->media_sink_name.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null media_sink_name in MediaRoute struct");
    decltype(Traits::description(input)) in_description = Traits::description(input);
    typename decltype((*output)->description)::BaseType::BufferWriter
        description_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_description, buffer, &description_writer, context);
    (*output)->description.Set(
        description_writer.is_null() ? nullptr : description_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->description.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null description in MediaRoute struct");
    (*output)->is_local = Traits::is_local(input);
    mojo::internal::Serialize<::media_router::mojom::RouteControllerType>(
        Traits::controller_type(input), &(*output)->controller_type);
    (*output)->for_display = Traits::for_display(input);
    (*output)->is_incognito = Traits::is_incognito(input);
    (*output)->is_local_presentation = Traits::is_local_presentation(input);
  }

  static bool Deserialize(::media_router::mojom::internal::MediaRoute_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::MediaRouteDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::IssueDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::IssueDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::Issue_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::route_id(input)) in_route_id = Traits::route_id(input);
    typename decltype((*output)->route_id)::BaseType::BufferWriter
        route_id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_route_id, buffer, &route_id_writer, context);
    (*output)->route_id.Set(
        route_id_writer.is_null() ? nullptr : route_id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->route_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null route_id in Issue struct");
    decltype(Traits::sink_id(input)) in_sink_id = Traits::sink_id(input);
    typename decltype((*output)->sink_id)::BaseType::BufferWriter
        sink_id_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_sink_id, buffer, &sink_id_writer, context);
    (*output)->sink_id.Set(
        sink_id_writer.is_null() ? nullptr : sink_id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->sink_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null sink_id in Issue struct");
    mojo::internal::Serialize<::media_router::mojom::Issue_Severity>(
        Traits::severity(input), &(*output)->severity);
    (*output)->is_blocking = Traits::is_blocking(input);
    decltype(Traits::title(input)) in_title = Traits::title(input);
    typename decltype((*output)->title)::BaseType::BufferWriter
        title_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_title, buffer, &title_writer, context);
    (*output)->title.Set(
        title_writer.is_null() ? nullptr : title_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->title.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null title in Issue struct");
    decltype(Traits::message(input)) in_message = Traits::message(input);
    typename decltype((*output)->message)::BaseType::BufferWriter
        message_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_message, buffer, &message_writer, context);
    (*output)->message.Set(
        message_writer.is_null() ? nullptr : message_writer.data());
    mojo::internal::Serialize<::media_router::mojom::Issue_ActionType>(
        Traits::default_action(input), &(*output)->default_action);
    decltype(Traits::secondary_actions(input)) in_secondary_actions = Traits::secondary_actions(input);
    typename decltype((*output)->secondary_actions)::BaseType::BufferWriter
        secondary_actions_writer;
    const mojo::internal::ContainerValidateParams secondary_actions_validate_params(
        0, ::media_router::mojom::internal::Issue_ActionType_Data::Validate);
    mojo::internal::Serialize<mojo::ArrayDataView<::media_router::mojom::Issue_ActionType>>(
        in_secondary_actions, buffer, &secondary_actions_writer, &secondary_actions_validate_params,
        context);
    (*output)->secondary_actions.Set(
        secondary_actions_writer.is_null() ? nullptr : secondary_actions_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->secondary_actions.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null secondary_actions in Issue struct");
    (*output)->help_page_id = Traits::help_page_id(input);
  }

  static bool Deserialize(::media_router::mojom::internal::Issue_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::IssueDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::RouteMessageDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::RouteMessageDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::RouteMessage_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    mojo::internal::Serialize<::media_router::mojom::RouteMessage_Type>(
        Traits::type(input), &(*output)->type);
    decltype(Traits::message(input)) in_message = Traits::message(input);
    typename decltype((*output)->message)::BaseType::BufferWriter
        message_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_message, buffer, &message_writer, context);
    (*output)->message.Set(
        message_writer.is_null() ? nullptr : message_writer.data());
    decltype(Traits::data(input)) in_data = Traits::data(input);
    typename decltype((*output)->data)::BaseType::BufferWriter
        data_writer;
    const mojo::internal::ContainerValidateParams data_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
        in_data, buffer, &data_writer, &data_validate_params,
        context);
    (*output)->data.Set(
        data_writer.is_null() ? nullptr : data_writer.data());
  }

  static bool Deserialize(::media_router::mojom::internal::RouteMessage_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::RouteMessageDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::SinkSearchCriteriaDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::SinkSearchCriteriaDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::SinkSearchCriteria_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::input(input)) in_input = Traits::input(input);
    typename decltype((*output)->input)::BaseType::BufferWriter
        input_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_input, buffer, &input_writer, context);
    (*output)->input.Set(
        input_writer.is_null() ? nullptr : input_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->input.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null input in SinkSearchCriteria struct");
    decltype(Traits::domain(input)) in_domain = Traits::domain(input);
    typename decltype((*output)->domain)::BaseType::BufferWriter
        domain_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_domain, buffer, &domain_writer, context);
    (*output)->domain.Set(
        domain_writer.is_null() ? nullptr : domain_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->domain.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null domain in SinkSearchCriteria struct");
  }

  static bool Deserialize(::media_router::mojom::internal::SinkSearchCriteria_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::SinkSearchCriteriaDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaRouteProviderConfigDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::MediaRouteProviderConfigDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::MediaRouteProviderConfig_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->enable_dial_discovery = Traits::enable_dial_discovery(input);
    (*output)->enable_cast_discovery = Traits::enable_cast_discovery(input);
    (*output)->enable_dial_sink_query = Traits::enable_dial_sink_query(input);
    (*output)->enable_cast_sink_query = Traits::enable_cast_sink_query(input);
    (*output)->use_mirroring_service = Traits::use_mirroring_service(input);
  }

  static bool Deserialize(::media_router::mojom::internal::MediaRouteProviderConfig_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::MediaRouteProviderConfigDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::RoutePresentationConnectionDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::media_router::mojom::RoutePresentationConnectionDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::RoutePresentationConnection_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::connection_remote(input)) in_connection_remote = Traits::connection_remote(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::blink::mojom::PresentationConnectionInterfaceBase>>(
        in_connection_remote, &(*output)->connection_remote, context);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid((*output)->connection_remote),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid connection_remote in RoutePresentationConnection struct");
    decltype(Traits::connection_receiver(input)) in_connection_receiver = Traits::connection_receiver(input);
    mojo::internal::Serialize<mojo::InterfaceRequestDataView<::blink::mojom::PresentationConnectionInterfaceBase>>(
        in_connection_receiver, &(*output)->connection_receiver, context);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid((*output)->connection_receiver),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid connection_receiver in RoutePresentationConnection struct");
  }

  static bool Deserialize(::media_router::mojom::internal::RoutePresentationConnection_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::RoutePresentationConnectionDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::media_router::mojom::MediaSinkExtraDataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::media_router::mojom::MediaSinkExtraDataDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::media_router::mojom::internal::MediaSinkExtraData_Data::BufferWriter* writer,
                        bool inlined,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
         writer->data()->set_null();
      return;
    }
    if (!inlined)
      writer->Allocate(buffer);

    ::media_router::mojom::internal::MediaSinkExtraData_Data::BufferWriter& result = *writer;
    ALLOW_UNUSED_LOCAL(result);
    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    result->size = kUnionDataSize;
    result->tag = Traits::GetTag(input);
    switch (result->tag) {
      case ::media_router::mojom::MediaSinkExtraDataDataView::Tag::DIAL_MEDIA_SINK: {
        decltype(Traits::dial_media_sink(input))
            in_dial_media_sink = Traits::dial_media_sink(input);
        typename decltype(result->data.f_dial_media_sink)::BaseType::BufferWriter
            value_writer;
        mojo::internal::Serialize<::media_router::mojom::DialMediaSinkDataView>(
            in_dial_media_sink, buffer, &value_writer, context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null dial_media_sink in MediaSinkExtraData union");
        result->data.f_dial_media_sink.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
      case ::media_router::mojom::MediaSinkExtraDataDataView::Tag::CAST_MEDIA_SINK: {
        decltype(Traits::cast_media_sink(input))
            in_cast_media_sink = Traits::cast_media_sink(input);
        typename decltype(result->data.f_cast_media_sink)::BaseType::BufferWriter
            value_writer;
        mojo::internal::Serialize<::media_router::mojom::CastMediaSinkDataView>(
            in_cast_media_sink, buffer, &value_writer, context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_writer.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null cast_media_sink in MediaSinkExtraData union");
        result->data.f_cast_media_sink.Set(
            value_writer.is_null() ? nullptr : value_writer.data());
        break;
      }
    }
  }

  static bool Deserialize(::media_router::mojom::internal::MediaSinkExtraData_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::media_router::mojom::MediaSinkExtraDataDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace media_router {
namespace mojom {

inline void MediaSinkDataView::GetSinkIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->sink_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaSinkDataView::GetNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaSinkDataView::GetDescriptionDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->description.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaSinkDataView::GetDomainDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->domain.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaSinkDataView::GetExtraDataDataView(
    MediaSinkExtraDataDataView* output) {
  auto pointer = &data_->extra_data;
  *output = MediaSinkExtraDataDataView(pointer, context_);
}


inline void DialMediaSinkDataView::GetIpAddressDataView(
    ::network::mojom::IPAddressDataView* output) {
  auto pointer = data_->ip_address.Get();
  *output = ::network::mojom::IPAddressDataView(pointer, context_);
}
inline void DialMediaSinkDataView::GetModelNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->model_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void DialMediaSinkDataView::GetAppUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->app_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void CastMediaSinkDataView::GetIpEndpointDataView(
    ::network::mojom::IPEndPointDataView* output) {
  auto pointer = data_->ip_endpoint.Get();
  *output = ::network::mojom::IPEndPointDataView(pointer, context_);
}
inline void CastMediaSinkDataView::GetModelNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->model_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void MediaRouteDataView::GetMediaRouteIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->media_route_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaRouteDataView::GetPresentationIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->presentation_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaRouteDataView::GetMediaSourceDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->media_source.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaRouteDataView::GetMediaSinkIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->media_sink_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaRouteDataView::GetMediaSinkNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->media_sink_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void MediaRouteDataView::GetDescriptionDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->description.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void IssueDataView::GetRouteIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->route_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void IssueDataView::GetSinkIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->sink_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void IssueDataView::GetTitleDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->title.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void IssueDataView::GetMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->message.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void IssueDataView::GetSecondaryActionsDataView(
    mojo::ArrayDataView<Issue_ActionType>* output) {
  auto pointer = data_->secondary_actions.Get();
  *output = mojo::ArrayDataView<Issue_ActionType>(pointer, context_);
}


inline void RouteMessageDataView::GetMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->message.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void RouteMessageDataView::GetDataDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->data.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void SinkSearchCriteriaDataView::GetInputDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->input.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void SinkSearchCriteriaDataView::GetDomainDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->domain.Get();
  *output = mojo::StringDataView(pointer, context_);
}






inline void MediaSinkExtraDataDataView::GetDialMediaSinkDataView(
    DialMediaSinkDataView* output) {
  DCHECK(is_dial_media_sink());
  *output = DialMediaSinkDataView(data_->data.f_dial_media_sink.Get(), context_);
}
inline void MediaSinkExtraDataDataView::GetCastMediaSinkDataView(
    CastMediaSinkDataView* output) {
  DCHECK(is_cast_media_sink());
  *output = CastMediaSinkDataView(data_->data.f_cast_media_sink.Get(), context_);
}


}  // namespace mojom
}  // namespace media_router

#endif  // CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_ROUTER_MOJOM_SHARED_H_