// chrome/common/media_router/mojom/media_router.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_ROUTER_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_ROUTER_MOJOM_TEST_UTILS_H_

#include "chrome/common/media_router/mojom/media_router.mojom.h"


namespace media_router {
namespace mojom {


class  MediaRouteProviderInterceptorForTesting : public MediaRouteProvider {
  virtual MediaRouteProvider* GetForwardingInterface() = 0;
  void CreateRoute(const std::string& media_source, const std::string& sink_id, const std::string& original_presentation_id, const ::url::Origin& origin, int32_t tab_id, ::base::TimeDelta timeout, bool incognito, CreateRouteCallback callback) override;
  void JoinRoute(const std::string& media_source, const std::string& presentation_id, const ::url::Origin& origin, int32_t tab_id, ::base::TimeDelta timeout, bool incognito, JoinRouteCallback callback) override;
  void ConnectRouteByRouteId(const std::string& media_source, const std::string& route_id, const std::string& presentation_id, const ::url::Origin& origin, int32_t tab_id, ::base::TimeDelta timeout, bool incognito, ConnectRouteByRouteIdCallback callback) override;
  void TerminateRoute(const std::string& route_id, TerminateRouteCallback callback) override;
  void SendRouteMessage(const std::string& media_route_id, const std::string& message) override;
  void SendRouteBinaryMessage(const std::string& media_route_id, const std::vector<uint8_t>& data) override;
  void StartObservingMediaSinks(const std::string& media_source) override;
  void StopObservingMediaSinks(const std::string& media_source) override;
  void StartObservingMediaRoutes(const std::string& media_source) override;
  void StopObservingMediaRoutes(const std::string& media_source) override;
  void StartListeningForRouteMessages(const std::string& route_id) override;
  void StopListeningForRouteMessages(const std::string& route_id) override;
  void DetachRoute(const std::string& route_id) override;
  void EnableMdnsDiscovery() override;
  void UpdateMediaSinks(const std::string& media_source) override;
  void SearchSinks(const std::string& sink_id, const std::string& media_source, SinkSearchCriteriaPtr search_criteria, SearchSinksCallback callback) override;
  void ProvideSinks(const std::string& provider_name, const std::vector<::media_router::MediaSinkInternal>& sinks) override;
  void CreateMediaRouteController(const std::string& route_id, mojo::PendingReceiver<::media_router::mojom::MediaController> media_controller, mojo::PendingRemote<::media_router::mojom::MediaStatusObserver> observer, CreateMediaRouteControllerCallback callback) override;
};
class  MediaRouteProviderAsyncWaiter {
 public:
  explicit MediaRouteProviderAsyncWaiter(MediaRouteProvider* proxy);
  ~MediaRouteProviderAsyncWaiter();
  void CreateRoute(
      const std::string& media_source, const std::string& sink_id, const std::string& original_presentation_id, const ::url::Origin& origin, int32_t tab_id, ::base::TimeDelta timeout, bool incognito, base::Optional<::media_router::MediaRoute>* out_route, RoutePresentationConnectionPtr* out_connection, base::Optional<std::string>* out_error_text, ::media_router::RouteRequestResult::ResultCode* out_result_code);
  void JoinRoute(
      const std::string& media_source, const std::string& presentation_id, const ::url::Origin& origin, int32_t tab_id, ::base::TimeDelta timeout, bool incognito, base::Optional<::media_router::MediaRoute>* out_route, RoutePresentationConnectionPtr* out_connection, base::Optional<std::string>* out_error_text, ::media_router::RouteRequestResult::ResultCode* out_result_code);
  void ConnectRouteByRouteId(
      const std::string& media_source, const std::string& route_id, const std::string& presentation_id, const ::url::Origin& origin, int32_t tab_id, ::base::TimeDelta timeout, bool incognito, base::Optional<::media_router::MediaRoute>* out_route, RoutePresentationConnectionPtr* out_connection, base::Optional<std::string>* out_error_text, ::media_router::RouteRequestResult::ResultCode* out_result_code);
  void TerminateRoute(
      const std::string& route_id, base::Optional<std::string>* out_error_text, ::media_router::RouteRequestResult::ResultCode* out_result_code);
  void SearchSinks(
      const std::string& sink_id, const std::string& media_source, SinkSearchCriteriaPtr search_criteria, std::string* out_sink_id);
  void CreateMediaRouteController(
      const std::string& route_id, mojo::PendingReceiver<::media_router::mojom::MediaController> media_controller, mojo::PendingRemote<::media_router::mojom::MediaStatusObserver> observer, bool* out_success);

 private:
  MediaRouteProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MediaRouteProviderAsyncWaiter);
};


class  MediaRouterInterceptorForTesting : public MediaRouter {
  virtual MediaRouter* GetForwardingInterface() = 0;
  void RegisterMediaRouteProvider(::media_router::MediaRouteProviderId provider_id, mojo::PendingRemote<MediaRouteProvider> media_router_provider, RegisterMediaRouteProviderCallback callback) override;
  void OnSinksReceived(::media_router::MediaRouteProviderId provider_id, const std::string& media_source, const std::vector<::media_router::MediaSinkInternal>& sinks, const std::vector<::url::Origin>& origins) override;
  void OnIssue(const ::media_router::IssueInfo& issue) override;
  void OnRoutesUpdated(::media_router::MediaRouteProviderId provider_id, const std::vector<::media_router::MediaRoute>& routes, const std::string& media_source, const std::vector<std::string>& joinable_route_ids) override;
  void OnSinkAvailabilityUpdated(::media_router::MediaRouteProviderId provider_id, MediaRouter::SinkAvailability availability) override;
  void OnPresentationConnectionStateChanged(const std::string& route_id, MediaRouter::PresentationConnectionState state) override;
  void OnPresentationConnectionClosed(const std::string& route_id, MediaRouter::PresentationConnectionCloseReason reason, const std::string& message) override;
  void OnRouteMessagesReceived(const std::string& route_id, std::vector<RouteMessagePtr> messages) override;
  void OnMediaRemoterCreated(int32_t tab_id, mojo::PendingRemote<::media::mojom::MirrorServiceRemoter> remoter, mojo::PendingReceiver<::media::mojom::MirrorServiceRemotingSource> remoting_source) override;
  void GetMediaSinkServiceStatus(GetMediaSinkServiceStatusCallback callback) override;
  void GetMirroringServiceHostForTab(int32_t target_tab_id, mojo::PendingReceiver<::mirroring::mojom::MirroringServiceHost> receiver) override;
  void GetMirroringServiceHostForDesktop(int32_t initiator_tab_id, const std::string& desktop_stream_id, mojo::PendingReceiver<::mirroring::mojom::MirroringServiceHost> receiver) override;
  void GetMirroringServiceHostForOffscreenTab(const ::GURL& presentation_url, const std::string& presentation_id, mojo::PendingReceiver<::mirroring::mojom::MirroringServiceHost> receiver) override;
};
class  MediaRouterAsyncWaiter {
 public:
  explicit MediaRouterAsyncWaiter(MediaRouter* proxy);
  ~MediaRouterAsyncWaiter();
  void RegisterMediaRouteProvider(
      ::media_router::MediaRouteProviderId provider_id, mojo::PendingRemote<MediaRouteProvider> media_router_provider, std::string* out_instance_id, MediaRouteProviderConfigPtr* out_config);
  void GetMediaSinkServiceStatus(
      std::string* out_status);

 private:
  MediaRouter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MediaRouterAsyncWaiter);
};




}  // namespace mojom
}  // namespace media_router

#endif  // CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_ROUTER_MOJOM_TEST_UTILS_H_