// chrome/common/media_router/mojom/media_status.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/common/media_router/mojom/media_status.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/common/media_router/mojom/media_status.mojom-params-data.h"
#include "chrome/common/media_router/mojom/media_status.mojom-shared-message-ids.h"

#include "chrome/common/media_router/mojom/media_status.mojom-import-headers.h"


#ifndef CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_STATUS_MOJOM_JUMBO_H_
#define CHROME_COMMON_MEDIA_ROUTER_MOJOM_MEDIA_STATUS_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "ui/gfx/geometry/mojom/geometry_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif
namespace media_router {
namespace mojom {
MediaImage::MediaImage()
    : url(),
      size() {}

MediaImage::MediaImage(
    const ::GURL& url_in,
    const base::Optional<::gfx::Size>& size_in)
    : url(std::move(url_in)),
      size(std::move(size_in)) {}

MediaImage::~MediaImage() = default;

bool MediaImage::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MediaStatus::MediaStatus()
    : title(),
      secondary_title(),
      can_play_pause(),
      can_mute(),
      can_set_volume(),
      can_seek(),
      can_skip_to_next_track(),
      can_skip_to_previous_track(),
      play_state(),
      is_muted(),
      volume(),
      duration(),
      current_time(),
      images() {}

MediaStatus::MediaStatus(
    const std::string& title_in,
    const std::string& secondary_title_in,
    bool can_play_pause_in,
    bool can_mute_in,
    bool can_set_volume_in,
    bool can_seek_in,
    bool can_skip_to_next_track_in,
    bool can_skip_to_previous_track_in,
    MediaStatus::PlayState play_state_in,
    bool is_muted_in,
    float volume_in,
    ::base::TimeDelta duration_in,
    ::base::TimeDelta current_time_in,
    std::vector<MediaImagePtr> images_in)
    : title(std::move(title_in)),
      secondary_title(std::move(secondary_title_in)),
      can_play_pause(std::move(can_play_pause_in)),
      can_mute(std::move(can_mute_in)),
      can_set_volume(std::move(can_set_volume_in)),
      can_seek(std::move(can_seek_in)),
      can_skip_to_next_track(std::move(can_skip_to_next_track_in)),
      can_skip_to_previous_track(std::move(can_skip_to_previous_track_in)),
      play_state(std::move(play_state_in)),
      is_muted(std::move(is_muted_in)),
      volume(std::move(volume_in)),
      duration(std::move(duration_in)),
      current_time(std::move(current_time_in)),
      images(std::move(images_in)) {}

MediaStatus::~MediaStatus() = default;

bool MediaStatus::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char MediaStatusObserver::Name_[] = "media_router.mojom.MediaStatusObserver";

MediaStatusObserverProxy::MediaStatusObserverProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void MediaStatusObserverProxy::OnMediaStatusUpdated(
    MediaStatusPtr in_status) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "media_router::mojom::MediaStatusObserver::OnMediaStatusUpdated");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMediaStatusObserver_OnMediaStatusUpdated_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::media_router::mojom::internal::MediaStatusObserver_OnMediaStatusUpdated_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->status)::BaseType::BufferWriter
      status_writer;
  mojo::internal::Serialize<::media_router::mojom::MediaStatusDataView>(
      in_status, buffer, &status_writer, &serialization_context);
  params->status.Set(
      status_writer.is_null() ? nullptr : status_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->status.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null status in MediaStatusObserver.OnMediaStatusUpdated request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MediaStatusObserver::Name_);
  message.set_method_name("OnMediaStatusUpdated");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool MediaStatusObserverStubDispatch::Accept(
    MediaStatusObserver* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kMediaStatusObserver_OnMediaStatusUpdated_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)media_router::mojom::MediaStatusObserver::OnMediaStatusUpdated",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)media_router::mojom::MediaStatusObserver::OnMediaStatusUpdated");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      DCHECK(message->is_serialized());
      internal::MediaStatusObserver_OnMediaStatusUpdated_Params_Data* params =
          reinterpret_cast<internal::MediaStatusObserver_OnMediaStatusUpdated_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      MediaStatusPtr p_status{};
      MediaStatusObserver_OnMediaStatusUpdated_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadStatus(&p_status))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MediaStatusObserver::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnMediaStatusUpdated(
std::move(p_status));
      return true;
    }
  }
  return false;
}

// static
bool MediaStatusObserverStubDispatch::AcceptWithResponder(
    MediaStatusObserver* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kMediaStatusObserver_OnMediaStatusUpdated_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kMediaStatusObserverValidationInfo[] = {
    {internal::kMediaStatusObserver_OnMediaStatusUpdated_Name,
     {&internal::MediaStatusObserver_OnMediaStatusUpdated_Params_Data::Validate,
      nullptr /* no response */}},
};

bool MediaStatusObserverRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::media_router::mojom::MediaStatusObserver::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kMediaStatusObserverValidationInfo);
}

}  // namespace mojom
}  // namespace media_router

namespace mojo {


// static
bool StructTraits<::media_router::mojom::MediaImage::DataView, ::media_router::mojom::MediaImagePtr>::Read(
    ::media_router::mojom::MediaImage::DataView input,
    ::media_router::mojom::MediaImagePtr* output) {
  bool success = true;
  ::media_router::mojom::MediaImagePtr result(::media_router::mojom::MediaImage::New());
  
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success && !input.ReadSize(&result->size))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media_router::mojom::MediaStatus::DataView, ::media_router::mojom::MediaStatusPtr>::Read(
    ::media_router::mojom::MediaStatus::DataView input,
    ::media_router::mojom::MediaStatusPtr* output) {
  bool success = true;
  ::media_router::mojom::MediaStatusPtr result(::media_router::mojom::MediaStatus::New());
  
      if (success && !input.ReadTitle(&result->title))
        success = false;
      if (success && !input.ReadSecondaryTitle(&result->secondary_title))
        success = false;
      if (success)
        result->can_play_pause = input.can_play_pause();
      if (success)
        result->can_mute = input.can_mute();
      if (success)
        result->can_set_volume = input.can_set_volume();
      if (success)
        result->can_seek = input.can_seek();
      if (success)
        result->can_skip_to_next_track = input.can_skip_to_next_track();
      if (success)
        result->can_skip_to_previous_track = input.can_skip_to_previous_track();
      if (success && !input.ReadPlayState(&result->play_state))
        success = false;
      if (success)
        result->is_muted = input.is_muted();
      if (success)
        result->volume = input.volume();
      if (success && !input.ReadDuration(&result->duration))
        success = false;
      if (success && !input.ReadCurrentTime(&result->current_time))
        success = false;
      if (success && !input.ReadImages(&result->images))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif