// chrome/common/metrics.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_METRICS_MOJOM_H_
#define CHROME_COMMON_METRICS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/common/metrics.mojom-shared.h"
#include "chrome/common/metrics.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace chrome {
namespace mojom {

class MetricsServiceProxy;

template <typename ImplRefTraits>
class MetricsServiceStub;

class MetricsServiceRequestValidator;
class MetricsServiceResponseValidator;


class  MetricsService
    : public MetricsServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = true;

  using Base_ = MetricsServiceInterfaceBase;
  using Proxy_ = MetricsServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = MetricsServiceStub<ImplRefTraits>;

  using RequestValidator_ = MetricsServiceRequestValidator;
  using ResponseValidator_ = MetricsServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kIsMetricsAndCrashReportingEnabledMinVersion = 0,
  };
  virtual ~MetricsService() {}

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool IsMetricsAndCrashReportingEnabled(bool* out_result);

  using IsMetricsAndCrashReportingEnabledCallback = base::OnceCallback<void(bool)>;
  
  virtual void IsMetricsAndCrashReportingEnabled(IsMetricsAndCrashReportingEnabledCallback callback) = 0;
};



class  MetricsServiceProxy
    : public MetricsService {
 public:
  using InterfaceType = MetricsService;

  explicit MetricsServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool IsMetricsAndCrashReportingEnabled(bool* out_result) final;
  
  void IsMetricsAndCrashReportingEnabled(IsMetricsAndCrashReportingEnabledCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  MetricsServiceStubDispatch {
 public:
  static bool Accept(MetricsService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MetricsService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MetricsService>>
class MetricsServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MetricsServiceStub() {}
  ~MetricsServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MetricsServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MetricsServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MetricsServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  MetricsServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace chrome

namespace mojo {

}  // namespace mojo

#endif  // CHROME_COMMON_METRICS_MOJOM_H_