// chrome/common/sync_encryption_keys_extension.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_SYNC_ENCRYPTION_KEYS_EXTENSION_MOJOM_H_
#define CHROME_COMMON_SYNC_ENCRYPTION_KEYS_EXTENSION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/common/sync_encryption_keys_extension.mojom-shared.h"
#include "chrome/common/sync_encryption_keys_extension.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace chrome {
namespace mojom {

class SyncEncryptionKeysExtensionProxy;

template <typename ImplRefTraits>
class SyncEncryptionKeysExtensionStub;

class SyncEncryptionKeysExtensionRequestValidator;
class SyncEncryptionKeysExtensionResponseValidator;


class  SyncEncryptionKeysExtension
    : public SyncEncryptionKeysExtensionInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SyncEncryptionKeysExtensionInterfaceBase;
  using Proxy_ = SyncEncryptionKeysExtensionProxy;

  template <typename ImplRefTraits>
  using Stub_ = SyncEncryptionKeysExtensionStub<ImplRefTraits>;

  using RequestValidator_ = SyncEncryptionKeysExtensionRequestValidator;
  using ResponseValidator_ = SyncEncryptionKeysExtensionResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSetEncryptionKeysMinVersion = 0,
  };
  virtual ~SyncEncryptionKeysExtension() {}


  using SetEncryptionKeysCallback = base::OnceCallback<void()>;
  
  virtual void SetEncryptionKeys(const std::string& gaia_id, const std::vector<std::vector<uint8_t>>& encryption_keys, int32_t last_key_version, SetEncryptionKeysCallback callback) = 0;
};



class  SyncEncryptionKeysExtensionProxy
    : public SyncEncryptionKeysExtension {
 public:
  using InterfaceType = SyncEncryptionKeysExtension;

  explicit SyncEncryptionKeysExtensionProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void SetEncryptionKeys(const std::string& gaia_id, const std::vector<std::vector<uint8_t>>& encryption_keys, int32_t last_key_version, SetEncryptionKeysCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  SyncEncryptionKeysExtensionStubDispatch {
 public:
  static bool Accept(SyncEncryptionKeysExtension* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      SyncEncryptionKeysExtension* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<SyncEncryptionKeysExtension>>
class SyncEncryptionKeysExtensionStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SyncEncryptionKeysExtensionStub() {}
  ~SyncEncryptionKeysExtensionStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SyncEncryptionKeysExtensionStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SyncEncryptionKeysExtensionStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SyncEncryptionKeysExtensionRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  SyncEncryptionKeysExtensionResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace chrome

namespace mojo {

}  // namespace mojo

#endif  // CHROME_COMMON_SYNC_ENCRYPTION_KEYS_EXTENSION_MOJOM_H_