// chrome/services/local_search_service/public/mojom/local_search_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_LOCAL_SEARCH_SERVICE_MOJOM_H_
#define CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_LOCAL_SEARCH_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/local_search_service/public/mojom/local_search_service.mojom-shared.h"
#include "chrome/services/local_search_service/public/mojom/local_search_service.mojom-forward.h"
#include "chrome/services/local_search_service/public/mojom/types.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace local_search_service {
namespace mojom {

class LocalSearchServiceProxy;

template <typename ImplRefTraits>
class LocalSearchServiceStub;

class LocalSearchServiceRequestValidator;


class  LocalSearchService
    : public LocalSearchServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = LocalSearchServiceInterfaceBase;
  using Proxy_ = LocalSearchServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = LocalSearchServiceStub<ImplRefTraits>;

  using RequestValidator_ = LocalSearchServiceRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kGetIndexMinVersion = 0,
  };
  
  using IndexId = LocalSearchService_IndexId;
  virtual ~LocalSearchService() {}

  
  virtual void GetIndex(LocalSearchService::IndexId index_id, mojo::PendingReceiver<Index> index) = 0;
};

class IndexProxy;

template <typename ImplRefTraits>
class IndexStub;

class IndexRequestValidator;
class IndexResponseValidator;


class  Index
    : public IndexInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = IndexInterfaceBase;
  using Proxy_ = IndexProxy;

  template <typename ImplRefTraits>
  using Stub_ = IndexStub<ImplRefTraits>;

  using RequestValidator_ = IndexRequestValidator;
  using ResponseValidator_ = IndexResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetSizeMinVersion = 0,
    kAddOrUpdateMinVersion = 0,
    kDeleteMinVersion = 0,
    kFindMinVersion = 0,
    kSetSearchParamsMinVersion = 0,
  };
  virtual ~Index() {}


  using GetSizeCallback = base::OnceCallback<void(uint64_t)>;
  
  virtual void GetSize(GetSizeCallback callback) = 0;


  using AddOrUpdateCallback = base::OnceCallback<void()>;
  
  virtual void AddOrUpdate(std::vector<::local_search_service::mojom::DataPtr> data, AddOrUpdateCallback callback) = 0;


  using DeleteCallback = base::OnceCallback<void(uint32_t)>;
  
  virtual void Delete(const std::vector<std::string>& ids, DeleteCallback callback) = 0;


  using FindCallback = base::OnceCallback<void(::local_search_service::mojom::ResponseStatus, base::Optional<std::vector<::local_search_service::mojom::ResultPtr>>)>;
  
  virtual void Find(const std::string& query, int32_t max_latency_in_ms, int32_t max_results, FindCallback callback) = 0;


  using SetSearchParamsCallback = base::OnceCallback<void()>;
  
  virtual void SetSearchParams(::local_search_service::mojom::SearchParamsPtr search_params, SetSearchParamsCallback callback) = 0;
};



class  LocalSearchServiceProxy
    : public LocalSearchService {
 public:
  using InterfaceType = LocalSearchService;

  explicit LocalSearchServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetIndex(LocalSearchService::IndexId index_id, mojo::PendingReceiver<Index> index) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  IndexProxy
    : public Index {
 public:
  using InterfaceType = Index;

  explicit IndexProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetSize(GetSizeCallback callback) final;
  
  void AddOrUpdate(std::vector<::local_search_service::mojom::DataPtr> data, AddOrUpdateCallback callback) final;
  
  void Delete(const std::vector<std::string>& ids, DeleteCallback callback) final;
  
  void Find(const std::string& query, int32_t max_latency_in_ms, int32_t max_results, FindCallback callback) final;
  
  void SetSearchParams(::local_search_service::mojom::SearchParamsPtr search_params, SetSearchParamsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  LocalSearchServiceStubDispatch {
 public:
  static bool Accept(LocalSearchService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      LocalSearchService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<LocalSearchService>>
class LocalSearchServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  LocalSearchServiceStub() {}
  ~LocalSearchServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LocalSearchServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LocalSearchServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  IndexStubDispatch {
 public:
  static bool Accept(Index* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      Index* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Index>>
class IndexStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  IndexStub() {}
  ~IndexStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  LocalSearchServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  IndexRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  IndexResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace local_search_service

namespace mojo {

}  // namespace mojo

#endif  // CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_LOCAL_SEARCH_SERVICE_MOJOM_H_