// chrome/services/local_search_service/public/mojom/types.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/services/local_search_service/public/mojom/types.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/local_search_service/public/mojom/types.mojom-params-data.h"
#include "chrome/services/local_search_service/public/mojom/types.mojom-shared-message-ids.h"

#include "chrome/services/local_search_service/public/mojom/types.mojom-import-headers.h"


#ifndef CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_JUMBO_H_
#define CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_JUMBO_H_
#endif
namespace local_search_service {
namespace mojom {
Range::Range()
    : start(),
      end() {}

Range::Range(
    uint32_t start_in,
    uint32_t end_in)
    : start(std::move(start_in)),
      end(std::move(end_in)) {}

Range::~Range() = default;
size_t Range::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->start);
  seed = mojo::internal::Hash(seed, this->end);
  return seed;
}

bool Range::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Data::Data()
    : id(),
      search_tags() {}

Data::Data(
    const std::string& id_in,
    std::vector<std::string> search_tags_in)
    : id(std::move(id_in)),
      search_tags(std::move(search_tags_in)) {}

Data::~Data() = default;

bool Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Result::Result()
    : id(),
      score(),
      hits() {}

Result::Result(
    const std::string& id_in,
    double score_in,
    std::vector<RangePtr> hits_in)
    : id(std::move(id_in)),
      score(std::move(score_in)),
      hits(std::move(hits_in)) {}

Result::~Result() = default;

bool Result::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SearchParams::SearchParams()
    : relevance_threshold(0.3),
      partial_match_penalty_rate(0.9),
      use_prefix_only(false),
      use_weighted_ratio(true),
      use_edit_distance(false) {}

SearchParams::SearchParams(
    double relevance_threshold_in,
    double partial_match_penalty_rate_in,
    bool use_prefix_only_in,
    bool use_weighted_ratio_in,
    bool use_edit_distance_in)
    : relevance_threshold(std::move(relevance_threshold_in)),
      partial_match_penalty_rate(std::move(partial_match_penalty_rate_in)),
      use_prefix_only(std::move(use_prefix_only_in)),
      use_weighted_ratio(std::move(use_weighted_ratio_in)),
      use_edit_distance(std::move(use_edit_distance_in)) {}

SearchParams::~SearchParams() = default;
size_t SearchParams::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->relevance_threshold);
  seed = mojo::internal::Hash(seed, this->partial_match_penalty_rate);
  seed = mojo::internal::Hash(seed, this->use_prefix_only);
  seed = mojo::internal::Hash(seed, this->use_weighted_ratio);
  seed = mojo::internal::Hash(seed, this->use_edit_distance);
  return seed;
}

bool SearchParams::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace local_search_service

namespace mojo {


// static
bool StructTraits<::local_search_service::mojom::Range::DataView, ::local_search_service::mojom::RangePtr>::Read(
    ::local_search_service::mojom::Range::DataView input,
    ::local_search_service::mojom::RangePtr* output) {
  bool success = true;
  ::local_search_service::mojom::RangePtr result(::local_search_service::mojom::Range::New());
  
      if (success)
        result->start = input.start();
      if (success)
        result->end = input.end();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::local_search_service::mojom::Data::DataView, ::local_search_service::mojom::DataPtr>::Read(
    ::local_search_service::mojom::Data::DataView input,
    ::local_search_service::mojom::DataPtr* output) {
  bool success = true;
  ::local_search_service::mojom::DataPtr result(::local_search_service::mojom::Data::New());
  
      if (success && !input.ReadId(&result->id))
        success = false;
      if (success && !input.ReadSearchTags(&result->search_tags))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::local_search_service::mojom::Result::DataView, ::local_search_service::mojom::ResultPtr>::Read(
    ::local_search_service::mojom::Result::DataView input,
    ::local_search_service::mojom::ResultPtr* output) {
  bool success = true;
  ::local_search_service::mojom::ResultPtr result(::local_search_service::mojom::Result::New());
  
      if (success && !input.ReadId(&result->id))
        success = false;
      if (success)
        result->score = input.score();
      if (success && !input.ReadHits(&result->hits))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::local_search_service::mojom::SearchParams::DataView, ::local_search_service::mojom::SearchParamsPtr>::Read(
    ::local_search_service::mojom::SearchParams::DataView input,
    ::local_search_service::mojom::SearchParamsPtr* output) {
  bool success = true;
  ::local_search_service::mojom::SearchParamsPtr result(::local_search_service::mojom::SearchParams::New());
  
      if (success)
        result->relevance_threshold = input.relevance_threshold();
      if (success)
        result->partial_match_penalty_rate = input.partial_match_penalty_rate();
      if (success)
        result->use_prefix_only = input.use_prefix_only();
      if (success)
        result->use_weighted_ratio = input.use_weighted_ratio();
      if (success)
        result->use_edit_distance = input.use_edit_distance();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif