// chrome/services/local_search_service/public/mojom/types.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_H_
#define CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/local_search_service/public/mojom/types.mojom-shared.h"
#include "chrome/services/local_search_service/public/mojom/types.mojom-forward.h"
#include "mojo/public/mojom/base/values.mojom.h"
#include <string>
#include <vector>








namespace local_search_service {
namespace mojom {





class  Range {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Range, T>::value>;
  using DataView = RangeDataView;
  using Data_ = internal::Range_Data;

  template <typename... Args>
  static RangePtr New(Args&&... args) {
    return RangePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static RangePtr From(const U& u) {
    return mojo::TypeConverter<RangePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Range>::Convert(*this);
  }


  Range();

  Range(
      uint32_t start,
      uint32_t end);

  ~Range();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = RangePtr>
  RangePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Range::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Range::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Range::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Range_UnserializedMessageContext<
            UserType, Range::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Range::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Range::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Range_UnserializedMessageContext<
            UserType, Range::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Range::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  uint32_t start;
  
  uint32_t end;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Range::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Range::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Range::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Range::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}











class  Data {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Data, T>::value>;
  using DataView = DataDataView;
  using Data_ = internal::Data_Data;

  template <typename... Args>
  static DataPtr New(Args&&... args) {
    return DataPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DataPtr From(const U& u) {
    return mojo::TypeConverter<DataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Data>::Convert(*this);
  }


  Data();

  Data(
      const std::string& id,
      std::vector<std::string> search_tags);

  ~Data();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DataPtr>
  DataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Data::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Data::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Data::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Data_UnserializedMessageContext<
            UserType, Data::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Data::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Data::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Data_UnserializedMessageContext<
            UserType, Data::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Data::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string id;
  
  std::vector<std::string> search_tags;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Data::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Data::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Data::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Data::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  Result {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<Result, T>::value>;
  using DataView = ResultDataView;
  using Data_ = internal::Result_Data;

  template <typename... Args>
  static ResultPtr New(Args&&... args) {
    return ResultPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ResultPtr From(const U& u) {
    return mojo::TypeConverter<ResultPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, Result>::Convert(*this);
  }


  Result();

  Result(
      const std::string& id,
      double score,
      std::vector<RangePtr> hits);

  ~Result();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ResultPtr>
  ResultPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, Result::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        Result::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        Result::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::Result_UnserializedMessageContext<
            UserType, Result::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<Result::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return Result::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::Result_UnserializedMessageContext<
            UserType, Result::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<Result::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  std::string id;
  
  double score;
  
  std::vector<RangePtr> hits;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(Result);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, Result::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, Result::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, Result::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, Result::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  SearchParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SearchParams, T>::value>;
  using DataView = SearchParamsDataView;
  using Data_ = internal::SearchParams_Data;

  template <typename... Args>
  static SearchParamsPtr New(Args&&... args) {
    return SearchParamsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SearchParamsPtr From(const U& u) {
    return mojo::TypeConverter<SearchParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SearchParams>::Convert(*this);
  }


  SearchParams();

  SearchParams(
      double relevance_threshold,
      double partial_match_penalty_rate,
      bool use_prefix_only,
      bool use_weighted_ratio,
      bool use_edit_distance);

  ~SearchParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SearchParamsPtr>
  SearchParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SearchParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SearchParams::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SearchParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SearchParams_UnserializedMessageContext<
            UserType, SearchParams::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<SearchParams::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SearchParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SearchParams_UnserializedMessageContext<
            UserType, SearchParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SearchParams::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  double relevance_threshold;
  
  double partial_match_penalty_rate;
  
  bool use_prefix_only;
  
  bool use_weighted_ratio;
  
  bool use_edit_distance;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SearchParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SearchParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SearchParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SearchParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
RangePtr Range::Clone() const {
  return New(
      mojo::Clone(start),
      mojo::Clone(end)
  );
}

template <typename T, Range::EnableIfSame<T>*>
bool Range::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->start, other_struct.start))
    return false;
  if (!mojo::Equals(this->end, other_struct.end))
    return false;
  return true;
}

template <typename T, Range::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.start < rhs.start)
    return true;
  if (rhs.start < lhs.start)
    return false;
  if (lhs.end < rhs.end)
    return true;
  if (rhs.end < lhs.end)
    return false;
  return false;
}
template <typename StructPtrType>
DataPtr Data::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(search_tags)
  );
}

template <typename T, Data::EnableIfSame<T>*>
bool Data::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->search_tags, other_struct.search_tags))
    return false;
  return true;
}

template <typename T, Data::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.search_tags < rhs.search_tags)
    return true;
  if (rhs.search_tags < lhs.search_tags)
    return false;
  return false;
}
template <typename StructPtrType>
ResultPtr Result::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(score),
      mojo::Clone(hits)
  );
}

template <typename T, Result::EnableIfSame<T>*>
bool Result::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->score, other_struct.score))
    return false;
  if (!mojo::Equals(this->hits, other_struct.hits))
    return false;
  return true;
}

template <typename T, Result::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.score < rhs.score)
    return true;
  if (rhs.score < lhs.score)
    return false;
  if (lhs.hits < rhs.hits)
    return true;
  if (rhs.hits < lhs.hits)
    return false;
  return false;
}
template <typename StructPtrType>
SearchParamsPtr SearchParams::Clone() const {
  return New(
      mojo::Clone(relevance_threshold),
      mojo::Clone(partial_match_penalty_rate),
      mojo::Clone(use_prefix_only),
      mojo::Clone(use_weighted_ratio),
      mojo::Clone(use_edit_distance)
  );
}

template <typename T, SearchParams::EnableIfSame<T>*>
bool SearchParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->relevance_threshold, other_struct.relevance_threshold))
    return false;
  if (!mojo::Equals(this->partial_match_penalty_rate, other_struct.partial_match_penalty_rate))
    return false;
  if (!mojo::Equals(this->use_prefix_only, other_struct.use_prefix_only))
    return false;
  if (!mojo::Equals(this->use_weighted_ratio, other_struct.use_weighted_ratio))
    return false;
  if (!mojo::Equals(this->use_edit_distance, other_struct.use_edit_distance))
    return false;
  return true;
}

template <typename T, SearchParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.relevance_threshold < rhs.relevance_threshold)
    return true;
  if (rhs.relevance_threshold < lhs.relevance_threshold)
    return false;
  if (lhs.partial_match_penalty_rate < rhs.partial_match_penalty_rate)
    return true;
  if (rhs.partial_match_penalty_rate < lhs.partial_match_penalty_rate)
    return false;
  if (lhs.use_prefix_only < rhs.use_prefix_only)
    return true;
  if (rhs.use_prefix_only < lhs.use_prefix_only)
    return false;
  if (lhs.use_weighted_ratio < rhs.use_weighted_ratio)
    return true;
  if (rhs.use_weighted_ratio < lhs.use_weighted_ratio)
    return false;
  if (lhs.use_edit_distance < rhs.use_edit_distance)
    return true;
  if (rhs.use_edit_distance < lhs.use_edit_distance)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace local_search_service

namespace mojo {


template <>
struct  StructTraits<::local_search_service::mojom::Range::DataView,
                                         ::local_search_service::mojom::RangePtr> {
  static bool IsNull(const ::local_search_service::mojom::RangePtr& input) { return !input; }
  static void SetToNull(::local_search_service::mojom::RangePtr* output) { output->reset(); }

  static decltype(::local_search_service::mojom::Range::start) start(
      const ::local_search_service::mojom::RangePtr& input) {
    return input->start;
  }

  static decltype(::local_search_service::mojom::Range::end) end(
      const ::local_search_service::mojom::RangePtr& input) {
    return input->end;
  }

  static bool Read(::local_search_service::mojom::Range::DataView input, ::local_search_service::mojom::RangePtr* output);
};


template <>
struct  StructTraits<::local_search_service::mojom::Data::DataView,
                                         ::local_search_service::mojom::DataPtr> {
  static bool IsNull(const ::local_search_service::mojom::DataPtr& input) { return !input; }
  static void SetToNull(::local_search_service::mojom::DataPtr* output) { output->reset(); }

  static const decltype(::local_search_service::mojom::Data::id)& id(
      const ::local_search_service::mojom::DataPtr& input) {
    return input->id;
  }

  static const decltype(::local_search_service::mojom::Data::search_tags)& search_tags(
      const ::local_search_service::mojom::DataPtr& input) {
    return input->search_tags;
  }

  static bool Read(::local_search_service::mojom::Data::DataView input, ::local_search_service::mojom::DataPtr* output);
};


template <>
struct  StructTraits<::local_search_service::mojom::Result::DataView,
                                         ::local_search_service::mojom::ResultPtr> {
  static bool IsNull(const ::local_search_service::mojom::ResultPtr& input) { return !input; }
  static void SetToNull(::local_search_service::mojom::ResultPtr* output) { output->reset(); }

  static const decltype(::local_search_service::mojom::Result::id)& id(
      const ::local_search_service::mojom::ResultPtr& input) {
    return input->id;
  }

  static decltype(::local_search_service::mojom::Result::score) score(
      const ::local_search_service::mojom::ResultPtr& input) {
    return input->score;
  }

  static const decltype(::local_search_service::mojom::Result::hits)& hits(
      const ::local_search_service::mojom::ResultPtr& input) {
    return input->hits;
  }

  static bool Read(::local_search_service::mojom::Result::DataView input, ::local_search_service::mojom::ResultPtr* output);
};


template <>
struct  StructTraits<::local_search_service::mojom::SearchParams::DataView,
                                         ::local_search_service::mojom::SearchParamsPtr> {
  static bool IsNull(const ::local_search_service::mojom::SearchParamsPtr& input) { return !input; }
  static void SetToNull(::local_search_service::mojom::SearchParamsPtr* output) { output->reset(); }

  static decltype(::local_search_service::mojom::SearchParams::relevance_threshold) relevance_threshold(
      const ::local_search_service::mojom::SearchParamsPtr& input) {
    return input->relevance_threshold;
  }

  static decltype(::local_search_service::mojom::SearchParams::partial_match_penalty_rate) partial_match_penalty_rate(
      const ::local_search_service::mojom::SearchParamsPtr& input) {
    return input->partial_match_penalty_rate;
  }

  static decltype(::local_search_service::mojom::SearchParams::use_prefix_only) use_prefix_only(
      const ::local_search_service::mojom::SearchParamsPtr& input) {
    return input->use_prefix_only;
  }

  static decltype(::local_search_service::mojom::SearchParams::use_weighted_ratio) use_weighted_ratio(
      const ::local_search_service::mojom::SearchParamsPtr& input) {
    return input->use_weighted_ratio;
  }

  static decltype(::local_search_service::mojom::SearchParams::use_edit_distance) use_edit_distance(
      const ::local_search_service::mojom::SearchParamsPtr& input) {
    return input->use_edit_distance;
  }

  static bool Read(::local_search_service::mojom::SearchParams::DataView input, ::local_search_service::mojom::SearchParamsPtr* output);
};

}  // namespace mojo

#endif  // CHROME_SERVICES_LOCAL_SEARCH_SERVICE_PUBLIC_MOJOM_TYPES_MOJOM_H_