// chrome/services/printing/public/mojom/pdf_to_pwg_raster_converter.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "chrome/services/printing/public/mojom/pdf_to_pwg_raster_converter.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"

#include "chrome/services/printing/public/mojom/pdf_to_pwg_raster_converter.mojom-params-data.h"
namespace printing {
namespace mojom {

std::ostream& operator<<(std::ostream& os, PwgRasterSettings_TransformType value) {
  switch(value) {
    case PwgRasterSettings_TransformType::TRANSFORM_NORMAL:
      return os << "PwgRasterSettings_TransformType::TRANSFORM_NORMAL";
    case PwgRasterSettings_TransformType::TRANSFORM_ROTATE_180:
      return os << "PwgRasterSettings_TransformType::TRANSFORM_ROTATE_180";
    case PwgRasterSettings_TransformType::TRANSFORM_FLIP_HORIZONTAL:
      return os << "PwgRasterSettings_TransformType::TRANSFORM_FLIP_HORIZONTAL";
    case PwgRasterSettings_TransformType::TRANSFORM_FLIP_VERTICAL:
      return os << "PwgRasterSettings_TransformType::TRANSFORM_FLIP_VERTICAL";
    default:
      return os << "Unknown PwgRasterSettings_TransformType value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, PwgRasterSettings_DuplexMode value) {
  switch(value) {
    case PwgRasterSettings_DuplexMode::SIMPLEX:
      return os << "PwgRasterSettings_DuplexMode::SIMPLEX";
    case PwgRasterSettings_DuplexMode::LONG_EDGE:
      return os << "PwgRasterSettings_DuplexMode::LONG_EDGE";
    case PwgRasterSettings_DuplexMode::SHORT_EDGE:
      return os << "PwgRasterSettings_DuplexMode::SHORT_EDGE";
    default:
      return os << "Unknown PwgRasterSettings_DuplexMode value: " << static_cast<int32_t>(value);
  }
}

namespace internal {


// static
bool PwgRasterSettings_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PwgRasterSettings_Data* object = static_cast<const PwgRasterSettings_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }


  if (!::printing::mojom::internal::PwgRasterSettings_DuplexMode_Data
        ::Validate(object->duplex_mode, validation_context))
    return false;


  if (!::printing::mojom::internal::PwgRasterSettings_TransformType_Data
        ::Validate(object->odd_page_transform, validation_context))
    return false;

  return true;
}

PwgRasterSettings_Data::PwgRasterSettings_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PdfToPwgRasterConverter_Convert_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PdfToPwgRasterConverter_Convert_Params_Data* object = static_cast<const PdfToPwgRasterConverter_Convert_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 32 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->pdf_region, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->pdf_region, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->pdf_settings, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->pdf_settings, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->pwg_raster_settings, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->pwg_raster_settings, validation_context))
    return false;

  return true;
}

PdfToPwgRasterConverter_Convert_Params_Data::PdfToPwgRasterConverter_Convert_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PdfToPwgRasterConverter_Convert_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PdfToPwgRasterConverter_Convert_ResponseParams_Data* object = static_cast<const PdfToPwgRasterConverter_Convert_ResponseParams_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->pwg_raster_region, validation_context))
    return false;

  return true;
}

PdfToPwgRasterConverter_Convert_ResponseParams_Data::PdfToPwgRasterConverter_Convert_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace printing

#if defined(_MSC_VER)
#pragma warning(pop)
#endif