// chrome/services/sharing/public/mojom/sharing.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_SHARING_MOJOM_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_SHARING_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/services/sharing/public/mojom/sharing.mojom-shared.h"
#include "chrome/services/sharing/public/mojom/sharing.mojom-forward.h"
#include "chrome/services/sharing/public/mojom/webrtc.mojom-forward.h"
#include "services/network/public/mojom/p2p.mojom-forward.h"
#include "services/network/public/mojom/mdns_responder.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace sharing {
namespace mojom {

class SharingProxy;

template <typename ImplRefTraits>
class SharingStub;

class SharingRequestValidator;


class  Sharing
    : public SharingInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = SharingInterfaceBase;
  using Proxy_ = SharingProxy;

  template <typename ImplRefTraits>
  using Stub_ = SharingStub<ImplRefTraits>;

  using RequestValidator_ = SharingRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateSharingWebRtcConnectionMinVersion = 0,
  };
  virtual ~Sharing() {}

  
  virtual void CreateSharingWebRtcConnection(mojo::PendingRemote<::sharing::mojom::SignallingSender> signalling_sender, mojo::PendingReceiver<::sharing::mojom::SignallingReceiver> signalling_receiver, mojo::PendingRemote<::sharing::mojom::SharingWebRtcConnectionDelegate> delegate, mojo::PendingReceiver<::sharing::mojom::SharingWebRtcConnection> connection, mojo::PendingRemote<::network::mojom::P2PSocketManager> socket_manager, mojo::PendingRemote<::network::mojom::MdnsResponder> mdns_responder, std::vector<::sharing::mojom::IceServerPtr> ice_servers) = 0;
};



class  SharingProxy
    : public Sharing {
 public:
  using InterfaceType = Sharing;

  explicit SharingProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateSharingWebRtcConnection(mojo::PendingRemote<::sharing::mojom::SignallingSender> signalling_sender, mojo::PendingReceiver<::sharing::mojom::SignallingReceiver> signalling_receiver, mojo::PendingRemote<::sharing::mojom::SharingWebRtcConnectionDelegate> delegate, mojo::PendingReceiver<::sharing::mojom::SharingWebRtcConnection> connection, mojo::PendingRemote<::network::mojom::P2PSocketManager> socket_manager, mojo::PendingRemote<::network::mojom::MdnsResponder> mdns_responder, std::vector<::sharing::mojom::IceServerPtr> ice_servers) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  SharingStubDispatch {
 public:
  static bool Accept(Sharing* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      Sharing* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<Sharing>>
class SharingStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  SharingStub() {}
  ~SharingStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharingStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return SharingStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  SharingRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace sharing

namespace mojo {

}  // namespace mojo

#endif  // CHROME_SERVICES_SHARING_PUBLIC_MOJOM_SHARING_MOJOM_H_