// chrome/services/sharing/public/mojom/webrtc.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/services/sharing/public/mojom/webrtc.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/sharing/public/mojom/webrtc.mojom-params-data.h"
#include "chrome/services/sharing/public/mojom/webrtc.mojom-shared-message-ids.h"

#include "chrome/services/sharing/public/mojom/webrtc.mojom-import-headers.h"


#ifndef CHROME_SERVICES_SHARING_PUBLIC_MOJOM_WEBRTC_MOJOM_JUMBO_H_
#define CHROME_SERVICES_SHARING_PUBLIC_MOJOM_WEBRTC_MOJOM_JUMBO_H_
#include "url/mojom/url_gurl_mojom_traits.h"
#endif
namespace sharing {
namespace mojom {
IceCandidate::IceCandidate()
    : candidate(),
      sdp_mid(),
      sdp_mline_index() {}

IceCandidate::IceCandidate(
    const std::string& candidate_in,
    const std::string& sdp_mid_in,
    int32_t sdp_mline_index_in)
    : candidate(std::move(candidate_in)),
      sdp_mid(std::move(sdp_mid_in)),
      sdp_mline_index(std::move(sdp_mline_index_in)) {}

IceCandidate::~IceCandidate() = default;
size_t IceCandidate::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->candidate);
  seed = mojo::internal::Hash(seed, this->sdp_mid);
  seed = mojo::internal::Hash(seed, this->sdp_mline_index);
  return seed;
}

bool IceCandidate::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
IceServer::IceServer()
    : urls(),
      username(),
      credential() {}

IceServer::IceServer(
    std::vector<::GURL> urls_in,
    const base::Optional<std::string>& username_in,
    const base::Optional<std::string>& credential_in)
    : urls(std::move(urls_in)),
      username(std::move(username_in)),
      credential(std::move(credential_in)) {}

IceServer::~IceServer() = default;

bool IceServer::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char SignallingSender::Name_[] = "sharing.mojom.SignallingSender";

class SignallingSender_SendOffer_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  SignallingSender_SendOffer_ForwardToCallback(
      SignallingSender::SendOfferCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  SignallingSender::SendOfferCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(SignallingSender_SendOffer_ForwardToCallback);
};

SignallingSenderProxy::SignallingSenderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SignallingSenderProxy::SendOffer(
    const std::string& in_offer, SendOfferCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "sharing::mojom::SignallingSender::SendOffer");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSignallingSender_SendOffer_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SignallingSender_SendOffer_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->offer)::BaseType::BufferWriter
      offer_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_offer, buffer, &offer_writer, &serialization_context);
  params->offer.Set(
      offer_writer.is_null() ? nullptr : offer_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->offer.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null offer in SignallingSender.SendOffer request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SignallingSender::Name_);
  message.set_method_name("SendOffer");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new SignallingSender_SendOffer_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void SignallingSenderProxy::SendIceCandidates(
    std::vector<IceCandidatePtr> in_ice_candidates) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "sharing::mojom::SignallingSender::SendIceCandidates");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSignallingSender_SendIceCandidates_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SignallingSender_SendIceCandidates_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->ice_candidates)::BaseType::BufferWriter
      ice_candidates_writer;
  const mojo::internal::ContainerValidateParams ice_candidates_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::sharing::mojom::IceCandidateDataView>>(
      in_ice_candidates, buffer, &ice_candidates_writer, &ice_candidates_validate_params,
      &serialization_context);
  params->ice_candidates.Set(
      ice_candidates_writer.is_null() ? nullptr : ice_candidates_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->ice_candidates.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null ice_candidates in SignallingSender.SendIceCandidates request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SignallingSender::Name_);
  message.set_method_name("SendIceCandidates");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class SignallingSender_SendOffer_ProxyToResponder {
 public:
  static SignallingSender::SendOfferCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<SignallingSender_SendOffer_ProxyToResponder> proxy(
        new SignallingSender_SendOffer_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&SignallingSender_SendOffer_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~SignallingSender_SendOffer_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  SignallingSender_SendOffer_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "SignallingSender::SendOfferCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      const std::string& in_answer);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(SignallingSender_SendOffer_ProxyToResponder);
};

bool SignallingSender_SendOffer_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "sharing::mojom::SignallingSender::SendOfferCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::SignallingSender_SendOffer_ResponseParams_Data* params =
      reinterpret_cast<
          internal::SignallingSender_SendOffer_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::string p_answer{};
  SignallingSender_SendOffer_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadAnswer(&p_answer))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        SignallingSender::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_answer));
  return true;
}

void SignallingSender_SendOffer_ProxyToResponder::Run(
    const std::string& in_answer) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSignallingSender_SendOffer_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SignallingSender_SendOffer_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->answer)::BaseType::BufferWriter
      answer_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_answer, buffer, &answer_writer, &serialization_context);
  params->answer.Set(
      answer_writer.is_null() ? nullptr : answer_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->answer.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null answer in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)sharing::mojom::SignallingSender::SendOfferCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SignallingSender::Name_);
  message.set_method_name("SendOffer");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool SignallingSenderStubDispatch::Accept(
    SignallingSender* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSignallingSender_SendOffer_Name: {
      break;
    }
    case internal::kSignallingSender_SendIceCandidates_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)sharing::mojom::SignallingSender::SendIceCandidates",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)sharing::mojom::SignallingSender::SendIceCandidates");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      DCHECK(message->is_serialized());
      internal::SignallingSender_SendIceCandidates_Params_Data* params =
          reinterpret_cast<internal::SignallingSender_SendIceCandidates_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<IceCandidatePtr> p_ice_candidates{};
      SignallingSender_SendIceCandidates_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadIceCandidates(&p_ice_candidates))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            SignallingSender::Name_, 1739166848, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SendIceCandidates(
std::move(p_ice_candidates));
      return true;
    }
  }
  return false;
}

// static
bool SignallingSenderStubDispatch::AcceptWithResponder(
    SignallingSender* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSignallingSender_SendOffer_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)sharing::mojom::SignallingSender::SendOffer",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)sharing::mojom::SignallingSender::SendOffer");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      internal::SignallingSender_SendOffer_Params_Data* params =
          reinterpret_cast<
              internal::SignallingSender_SendOffer_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_offer{};
      SignallingSender_SendOffer_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadOffer(&p_offer))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            SignallingSender::Name_, 0, false);
        return false;
      }
      SignallingSender::SendOfferCallback callback =
          SignallingSender_SendOffer_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SendOffer(
std::move(p_offer), std::move(callback));
      return true;
    }
    case internal::kSignallingSender_SendIceCandidates_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kSignallingSenderValidationInfo[] = {
    {internal::kSignallingSender_SendOffer_Name,
     {&internal::SignallingSender_SendOffer_Params_Data::Validate,
      &internal::SignallingSender_SendOffer_ResponseParams_Data::Validate}},
    {internal::kSignallingSender_SendIceCandidates_Name,
     {&internal::SignallingSender_SendIceCandidates_Params_Data::Validate,
      nullptr /* no response */}},
};

bool SignallingSenderRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::sharing::mojom::SignallingSender::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kSignallingSenderValidationInfo);
}

bool SignallingSenderResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::sharing::mojom::SignallingSender::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kSignallingSenderValidationInfo);

}
const char SignallingReceiver::Name_[] = "sharing.mojom.SignallingReceiver";

class SignallingReceiver_OnOfferReceived_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  SignallingReceiver_OnOfferReceived_ForwardToCallback(
      SignallingReceiver::OnOfferReceivedCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  SignallingReceiver::OnOfferReceivedCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(SignallingReceiver_OnOfferReceived_ForwardToCallback);
};

SignallingReceiverProxy::SignallingReceiverProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SignallingReceiverProxy::OnOfferReceived(
    const std::string& in_offer, OnOfferReceivedCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "sharing::mojom::SignallingReceiver::OnOfferReceived");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSignallingReceiver_OnOfferReceived_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SignallingReceiver_OnOfferReceived_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->offer)::BaseType::BufferWriter
      offer_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_offer, buffer, &offer_writer, &serialization_context);
  params->offer.Set(
      offer_writer.is_null() ? nullptr : offer_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->offer.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null offer in SignallingReceiver.OnOfferReceived request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SignallingReceiver::Name_);
  message.set_method_name("OnOfferReceived");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new SignallingReceiver_OnOfferReceived_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void SignallingReceiverProxy::OnIceCandidatesReceived(
    std::vector<IceCandidatePtr> in_ice_candidates) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "sharing::mojom::SignallingReceiver::OnIceCandidatesReceived");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSignallingReceiver_OnIceCandidatesReceived_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SignallingReceiver_OnIceCandidatesReceived_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->ice_candidates)::BaseType::BufferWriter
      ice_candidates_writer;
  const mojo::internal::ContainerValidateParams ice_candidates_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::sharing::mojom::IceCandidateDataView>>(
      in_ice_candidates, buffer, &ice_candidates_writer, &ice_candidates_validate_params,
      &serialization_context);
  params->ice_candidates.Set(
      ice_candidates_writer.is_null() ? nullptr : ice_candidates_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->ice_candidates.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null ice_candidates in SignallingReceiver.OnIceCandidatesReceived request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SignallingReceiver::Name_);
  message.set_method_name("OnIceCandidatesReceived");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class SignallingReceiver_OnOfferReceived_ProxyToResponder {
 public:
  static SignallingReceiver::OnOfferReceivedCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<SignallingReceiver_OnOfferReceived_ProxyToResponder> proxy(
        new SignallingReceiver_OnOfferReceived_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&SignallingReceiver_OnOfferReceived_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~SignallingReceiver_OnOfferReceived_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  SignallingReceiver_OnOfferReceived_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "SignallingReceiver::OnOfferReceivedCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      const std::string& in_answer);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(SignallingReceiver_OnOfferReceived_ProxyToResponder);
};

bool SignallingReceiver_OnOfferReceived_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "sharing::mojom::SignallingReceiver::OnOfferReceivedCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::SignallingReceiver_OnOfferReceived_ResponseParams_Data* params =
      reinterpret_cast<
          internal::SignallingReceiver_OnOfferReceived_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::string p_answer{};
  SignallingReceiver_OnOfferReceived_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadAnswer(&p_answer))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        SignallingReceiver::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_answer));
  return true;
}

void SignallingReceiver_OnOfferReceived_ProxyToResponder::Run(
    const std::string& in_answer) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSignallingReceiver_OnOfferReceived_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SignallingReceiver_OnOfferReceived_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->answer)::BaseType::BufferWriter
      answer_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_answer, buffer, &answer_writer, &serialization_context);
  params->answer.Set(
      answer_writer.is_null() ? nullptr : answer_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->answer.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null answer in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)sharing::mojom::SignallingReceiver::OnOfferReceivedCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SignallingReceiver::Name_);
  message.set_method_name("OnOfferReceived");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool SignallingReceiverStubDispatch::Accept(
    SignallingReceiver* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSignallingReceiver_OnOfferReceived_Name: {
      break;
    }
    case internal::kSignallingReceiver_OnIceCandidatesReceived_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)sharing::mojom::SignallingReceiver::OnIceCandidatesReceived",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)sharing::mojom::SignallingReceiver::OnIceCandidatesReceived");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      DCHECK(message->is_serialized());
      internal::SignallingReceiver_OnIceCandidatesReceived_Params_Data* params =
          reinterpret_cast<internal::SignallingReceiver_OnIceCandidatesReceived_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<IceCandidatePtr> p_ice_candidates{};
      SignallingReceiver_OnIceCandidatesReceived_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadIceCandidates(&p_ice_candidates))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            SignallingReceiver::Name_, 1481846331, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnIceCandidatesReceived(
std::move(p_ice_candidates));
      return true;
    }
  }
  return false;
}

// static
bool SignallingReceiverStubDispatch::AcceptWithResponder(
    SignallingReceiver* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSignallingReceiver_OnOfferReceived_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)sharing::mojom::SignallingReceiver::OnOfferReceived",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)sharing::mojom::SignallingReceiver::OnOfferReceived");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      internal::SignallingReceiver_OnOfferReceived_Params_Data* params =
          reinterpret_cast<
              internal::SignallingReceiver_OnOfferReceived_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_offer{};
      SignallingReceiver_OnOfferReceived_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadOffer(&p_offer))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            SignallingReceiver::Name_, 0, false);
        return false;
      }
      SignallingReceiver::OnOfferReceivedCallback callback =
          SignallingReceiver_OnOfferReceived_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnOfferReceived(
std::move(p_offer), std::move(callback));
      return true;
    }
    case internal::kSignallingReceiver_OnIceCandidatesReceived_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kSignallingReceiverValidationInfo[] = {
    {internal::kSignallingReceiver_OnOfferReceived_Name,
     {&internal::SignallingReceiver_OnOfferReceived_Params_Data::Validate,
      &internal::SignallingReceiver_OnOfferReceived_ResponseParams_Data::Validate}},
    {internal::kSignallingReceiver_OnIceCandidatesReceived_Name,
     {&internal::SignallingReceiver_OnIceCandidatesReceived_Params_Data::Validate,
      nullptr /* no response */}},
};

bool SignallingReceiverRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::sharing::mojom::SignallingReceiver::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kSignallingReceiverValidationInfo);
}

bool SignallingReceiverResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::sharing::mojom::SignallingReceiver::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kSignallingReceiverValidationInfo);

}
const char SharingWebRtcConnectionDelegate::Name_[] = "sharing.mojom.SharingWebRtcConnectionDelegate";

SharingWebRtcConnectionDelegateProxy::SharingWebRtcConnectionDelegateProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SharingWebRtcConnectionDelegateProxy::OnMessageReceived(
    const std::vector<uint8_t>& in_message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "sharing::mojom::SharingWebRtcConnectionDelegate::OnMessageReceived");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSharingWebRtcConnectionDelegate_OnMessageReceived_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SharingWebRtcConnectionDelegate_OnMessageReceived_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->message)::BaseType::BufferWriter
      message_writer;
  const mojo::internal::ContainerValidateParams message_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
      in_message, buffer, &message_writer, &message_validate_params,
      &serialization_context);
  params->message.Set(
      message_writer.is_null() ? nullptr : message_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->message.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null message in SharingWebRtcConnectionDelegate.OnMessageReceived request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SharingWebRtcConnectionDelegate::Name_);
  message.set_method_name("OnMessageReceived");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool SharingWebRtcConnectionDelegateStubDispatch::Accept(
    SharingWebRtcConnectionDelegate* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSharingWebRtcConnectionDelegate_OnMessageReceived_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)sharing::mojom::SharingWebRtcConnectionDelegate::OnMessageReceived",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)sharing::mojom::SharingWebRtcConnectionDelegate::OnMessageReceived");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      DCHECK(message->is_serialized());
      internal::SharingWebRtcConnectionDelegate_OnMessageReceived_Params_Data* params =
          reinterpret_cast<internal::SharingWebRtcConnectionDelegate_OnMessageReceived_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<uint8_t> p_message{};
      SharingWebRtcConnectionDelegate_OnMessageReceived_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadMessage(&p_message))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            SharingWebRtcConnectionDelegate::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnMessageReceived(
std::move(p_message));
      return true;
    }
  }
  return false;
}

// static
bool SharingWebRtcConnectionDelegateStubDispatch::AcceptWithResponder(
    SharingWebRtcConnectionDelegate* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSharingWebRtcConnectionDelegate_OnMessageReceived_Name: {
      break;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kSharingWebRtcConnectionDelegateValidationInfo[] = {
    {internal::kSharingWebRtcConnectionDelegate_OnMessageReceived_Name,
     {&internal::SharingWebRtcConnectionDelegate_OnMessageReceived_Params_Data::Validate,
      nullptr /* no response */}},
};

bool SharingWebRtcConnectionDelegateRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::sharing::mojom::SharingWebRtcConnectionDelegate::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kSharingWebRtcConnectionDelegateValidationInfo);
}

const char SharingWebRtcConnection::Name_[] = "sharing.mojom.SharingWebRtcConnection";

class SharingWebRtcConnection_SendMessage_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  SharingWebRtcConnection_SendMessage_ForwardToCallback(
      SharingWebRtcConnection::SendMessageCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  SharingWebRtcConnection::SendMessageCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(SharingWebRtcConnection_SendMessage_ForwardToCallback);
};

SharingWebRtcConnectionProxy::SharingWebRtcConnectionProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SharingWebRtcConnectionProxy::SendMessage(
    const std::vector<uint8_t>& in_message, SendMessageCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "sharing::mojom::SharingWebRtcConnection::SendMessage");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSharingWebRtcConnection_SendMessage_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SharingWebRtcConnection_SendMessage_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->message)::BaseType::BufferWriter
      message_writer;
  const mojo::internal::ContainerValidateParams message_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
      in_message, buffer, &message_writer, &message_validate_params,
      &serialization_context);
  params->message.Set(
      message_writer.is_null() ? nullptr : message_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->message.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null message in SharingWebRtcConnection.SendMessage request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SharingWebRtcConnection::Name_);
  message.set_method_name("SendMessage");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new SharingWebRtcConnection_SendMessage_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class SharingWebRtcConnection_SendMessage_ProxyToResponder {
 public:
  static SharingWebRtcConnection::SendMessageCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<SharingWebRtcConnection_SendMessage_ProxyToResponder> proxy(
        new SharingWebRtcConnection_SendMessage_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&SharingWebRtcConnection_SendMessage_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~SharingWebRtcConnection_SendMessage_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  SharingWebRtcConnection_SendMessage_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "SharingWebRtcConnection::SendMessageCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      SendMessageResult in_result);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(SharingWebRtcConnection_SendMessage_ProxyToResponder);
};

bool SharingWebRtcConnection_SendMessage_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "sharing::mojom::SharingWebRtcConnection::SendMessageCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::SharingWebRtcConnection_SendMessage_ResponseParams_Data* params =
      reinterpret_cast<
          internal::SharingWebRtcConnection_SendMessage_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  SendMessageResult p_result{};
  SharingWebRtcConnection_SendMessage_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        SharingWebRtcConnection::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void SharingWebRtcConnection_SendMessage_ProxyToResponder::Run(
    SendMessageResult in_result) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSharingWebRtcConnection_SendMessage_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::sharing::mojom::internal::SharingWebRtcConnection_SendMessage_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::sharing::mojom::SendMessageResult>(
      in_result, &params->result);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)sharing::mojom::SharingWebRtcConnection::SendMessageCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SharingWebRtcConnection::Name_);
  message.set_method_name("SendMessage");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool SharingWebRtcConnectionStubDispatch::Accept(
    SharingWebRtcConnection* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSharingWebRtcConnection_SendMessage_Name: {
      break;
    }
  }
  return false;
}

// static
bool SharingWebRtcConnectionStubDispatch::AcceptWithResponder(
    SharingWebRtcConnection* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSharingWebRtcConnection_SendMessage_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)sharing::mojom::SharingWebRtcConnection::SendMessage",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)sharing::mojom::SharingWebRtcConnection::SendMessage");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext dispatch_context(message);

      internal::SharingWebRtcConnection_SendMessage_Params_Data* params =
          reinterpret_cast<
              internal::SharingWebRtcConnection_SendMessage_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<uint8_t> p_message{};
      SharingWebRtcConnection_SendMessage_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadMessage(&p_message))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            SharingWebRtcConnection::Name_, 0, false);
        return false;
      }
      SharingWebRtcConnection::SendMessageCallback callback =
          SharingWebRtcConnection_SendMessage_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SendMessage(
std::move(p_message), std::move(callback));
      return true;
    }
  }
  return false;
}


static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kSharingWebRtcConnectionValidationInfo[] = {
    {internal::kSharingWebRtcConnection_SendMessage_Name,
     {&internal::SharingWebRtcConnection_SendMessage_Params_Data::Validate,
      &internal::SharingWebRtcConnection_SendMessage_ResponseParams_Data::Validate}},
};

bool SharingWebRtcConnectionRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::sharing::mojom::SharingWebRtcConnection::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kSharingWebRtcConnectionValidationInfo);
}

bool SharingWebRtcConnectionResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::sharing::mojom::SharingWebRtcConnection::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kSharingWebRtcConnectionValidationInfo);

}
}  // namespace mojom
}  // namespace sharing

namespace mojo {


// static
bool StructTraits<::sharing::mojom::IceCandidate::DataView, ::sharing::mojom::IceCandidatePtr>::Read(
    ::sharing::mojom::IceCandidate::DataView input,
    ::sharing::mojom::IceCandidatePtr* output) {
  bool success = true;
  ::sharing::mojom::IceCandidatePtr result(::sharing::mojom::IceCandidate::New());
  
      if (success && !input.ReadCandidate(&result->candidate))
        success = false;
      if (success && !input.ReadSdpMid(&result->sdp_mid))
        success = false;
      if (success)
        result->sdp_mline_index = input.sdp_mline_index();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::sharing::mojom::IceServer::DataView, ::sharing::mojom::IceServerPtr>::Read(
    ::sharing::mojom::IceServer::DataView input,
    ::sharing::mojom::IceServerPtr* output) {
  bool success = true;
  ::sharing::mojom::IceServerPtr result(::sharing::mojom::IceServer::New());
  
      if (success && !input.ReadUrls(&result->urls))
        success = false;
      if (success && !input.ReadUsername(&result->username))
        success = false;
      if (success && !input.ReadCredential(&result->credential))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif