// components/mirroring/mojom/session_parameters.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_MIRRORING_MOJOM_SESSION_PARAMETERS_MOJOM_H_
#define COMPONENTS_MIRRORING_MOJOM_SESSION_PARAMETERS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/mirroring/mojom/session_parameters.mojom-shared.h"
#include "components/mirroring/mojom/session_parameters.mojom-forward.h"
#include "services/network/public/mojom/ip_address.mojom.h"
#include <string>
#include <vector>








namespace mirroring {
namespace mojom {








class  SessionParameters {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SessionParameters, T>::value>;
  using DataView = SessionParametersDataView;
  using Data_ = internal::SessionParameters_Data;

  template <typename... Args>
  static SessionParametersPtr New(Args&&... args) {
    return SessionParametersPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SessionParametersPtr From(const U& u) {
    return mojo::TypeConverter<SessionParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SessionParameters>::Convert(*this);
  }


  SessionParameters();

  SessionParameters(
      SessionType type,
      const ::net::IPAddress& receiver_address,
      const std::string& receiver_model_name);

  ~SessionParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SessionParametersPtr>
  SessionParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SessionParameters::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SessionParameters::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SessionParameters::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SessionParameters_UnserializedMessageContext<
            UserType, SessionParameters::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<SessionParameters::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SessionParameters::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SessionParameters_UnserializedMessageContext<
            UserType, SessionParameters::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SessionParameters::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  SessionType type;
  
  ::net::IPAddress receiver_address;
  
  std::string receiver_model_name;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SessionParameters::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SessionParameters::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SessionParameters::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SessionParameters::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
SessionParametersPtr SessionParameters::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(receiver_address),
      mojo::Clone(receiver_model_name)
  );
}

template <typename T, SessionParameters::EnableIfSame<T>*>
bool SessionParameters::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->receiver_address, other_struct.receiver_address))
    return false;
  if (!mojo::Equals(this->receiver_model_name, other_struct.receiver_model_name))
    return false;
  return true;
}

template <typename T, SessionParameters::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.type < rhs.type)
    return true;
  if (rhs.type < lhs.type)
    return false;
  if (lhs.receiver_address < rhs.receiver_address)
    return true;
  if (rhs.receiver_address < lhs.receiver_address)
    return false;
  if (lhs.receiver_model_name < rhs.receiver_model_name)
    return true;
  if (rhs.receiver_model_name < lhs.receiver_model_name)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace mirroring

namespace mojo {


template <>
struct  StructTraits<::mirroring::mojom::SessionParameters::DataView,
                                         ::mirroring::mojom::SessionParametersPtr> {
  static bool IsNull(const ::mirroring::mojom::SessionParametersPtr& input) { return !input; }
  static void SetToNull(::mirroring::mojom::SessionParametersPtr* output) { output->reset(); }

  static decltype(::mirroring::mojom::SessionParameters::type) type(
      const ::mirroring::mojom::SessionParametersPtr& input) {
    return input->type;
  }

  static const decltype(::mirroring::mojom::SessionParameters::receiver_address)& receiver_address(
      const ::mirroring::mojom::SessionParametersPtr& input) {
    return input->receiver_address;
  }

  static const decltype(::mirroring::mojom::SessionParameters::receiver_model_name)& receiver_model_name(
      const ::mirroring::mojom::SessionParametersPtr& input) {
    return input->receiver_model_name;
  }

  static bool Read(::mirroring::mojom::SessionParameters::DataView input, ::mirroring::mojom::SessionParametersPtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_MIRRORING_MOJOM_SESSION_PARAMETERS_MOJOM_H_