// components/services/storage/public/mojom/indexed_db_control.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_INDEXED_DB_CONTROL_MOJOM_H_
#define COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_INDEXED_DB_CONTROL_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "components/services/storage/public/mojom/indexed_db_control.mojom-shared.h"
#include "components/services/storage/public/mojom/indexed_db_control.mojom-forward.h"
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "mojo/public/mojom/base/values.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"






namespace storage {
namespace mojom {

class IndexedDBControlProxy;

template <typename ImplRefTraits>
class IndexedDBControlStub;

class IndexedDBControlRequestValidator;
class IndexedDBControlResponseValidator;


class  IndexedDBControl
    : public IndexedDBControlInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = IndexedDBControlInterfaceBase;
  using Proxy_ = IndexedDBControlProxy;

  template <typename ImplRefTraits>
  using Stub_ = IndexedDBControlStub<ImplRefTraits>;

  using RequestValidator_ = IndexedDBControlRequestValidator;
  using ResponseValidator_ = IndexedDBControlResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetUsageMinVersion = 0,
    kDeleteForOriginMinVersion = 0,
    kForceCloseMinVersion = 0,
    kGetConnectionCountMinVersion = 0,
    kDownloadOriginDataMinVersion = 0,
    kGetAllOriginsDetailsMinVersion = 0,
  };
  virtual ~IndexedDBControl() {}


  using GetUsageCallback = base::OnceCallback<void(std::vector<IndexedDBStorageUsageInfoPtr>)>;
  
  virtual void GetUsage(GetUsageCallback callback) = 0;


  using DeleteForOriginCallback = base::OnceCallback<void(bool)>;
  
  virtual void DeleteForOrigin(const ::url::Origin& origin, DeleteForOriginCallback callback) = 0;


  using ForceCloseCallback = base::OnceCallback<void()>;
  
  virtual void ForceClose(const ::url::Origin& origin, ForceCloseReason reason, ForceCloseCallback callback) = 0;


  using GetConnectionCountCallback = base::OnceCallback<void(uint64_t)>;
  
  virtual void GetConnectionCount(const ::url::Origin& origin, GetConnectionCountCallback callback) = 0;


  using DownloadOriginDataCallback = base::OnceCallback<void(bool, const ::base::FilePath&, const ::base::FilePath&)>;
  
  virtual void DownloadOriginData(const ::url::Origin& origin, DownloadOriginDataCallback callback) = 0;


  using GetAllOriginsDetailsCallback = base::OnceCallback<void(bool, ::base::Value)>;
  
  virtual void GetAllOriginsDetails(GetAllOriginsDetailsCallback callback) = 0;
};



class  IndexedDBControlProxy
    : public IndexedDBControl {
 public:
  using InterfaceType = IndexedDBControl;

  explicit IndexedDBControlProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetUsage(GetUsageCallback callback) final;
  
  void DeleteForOrigin(const ::url::Origin& origin, DeleteForOriginCallback callback) final;
  
  void ForceClose(const ::url::Origin& origin, ForceCloseReason reason, ForceCloseCallback callback) final;
  
  void GetConnectionCount(const ::url::Origin& origin, GetConnectionCountCallback callback) final;
  
  void DownloadOriginData(const ::url::Origin& origin, DownloadOriginDataCallback callback) final;
  
  void GetAllOriginsDetails(GetAllOriginsDetailsCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  IndexedDBControlStubDispatch {
 public:
  static bool Accept(IndexedDBControl* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      IndexedDBControl* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<IndexedDBControl>>
class IndexedDBControlStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  IndexedDBControlStub() {}
  ~IndexedDBControlStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexedDBControlStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return IndexedDBControlStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  IndexedDBControlRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  IndexedDBControlResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class  IndexedDBStorageUsageInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<IndexedDBStorageUsageInfo, T>::value>;
  using DataView = IndexedDBStorageUsageInfoDataView;
  using Data_ = internal::IndexedDBStorageUsageInfo_Data;

  template <typename... Args>
  static IndexedDBStorageUsageInfoPtr New(Args&&... args) {
    return IndexedDBStorageUsageInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static IndexedDBStorageUsageInfoPtr From(const U& u) {
    return mojo::TypeConverter<IndexedDBStorageUsageInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, IndexedDBStorageUsageInfo>::Convert(*this);
  }


  IndexedDBStorageUsageInfo();

  IndexedDBStorageUsageInfo(
      const ::url::Origin& origin,
      uint64_t size_in_bytes,
      ::base::Time last_modified_time);

  ~IndexedDBStorageUsageInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = IndexedDBStorageUsageInfoPtr>
  IndexedDBStorageUsageInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, IndexedDBStorageUsageInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        IndexedDBStorageUsageInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        IndexedDBStorageUsageInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::IndexedDBStorageUsageInfo_UnserializedMessageContext<
            UserType, IndexedDBStorageUsageInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<IndexedDBStorageUsageInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return IndexedDBStorageUsageInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::IndexedDBStorageUsageInfo_UnserializedMessageContext<
            UserType, IndexedDBStorageUsageInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<IndexedDBStorageUsageInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::url::Origin origin;
  
  uint64_t size_in_bytes;
  
  ::base::Time last_modified_time;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, IndexedDBStorageUsageInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, IndexedDBStorageUsageInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, IndexedDBStorageUsageInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, IndexedDBStorageUsageInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
IndexedDBStorageUsageInfoPtr IndexedDBStorageUsageInfo::Clone() const {
  return New(
      mojo::Clone(origin),
      mojo::Clone(size_in_bytes),
      mojo::Clone(last_modified_time)
  );
}

template <typename T, IndexedDBStorageUsageInfo::EnableIfSame<T>*>
bool IndexedDBStorageUsageInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->origin, other_struct.origin))
    return false;
  if (!mojo::Equals(this->size_in_bytes, other_struct.size_in_bytes))
    return false;
  if (!mojo::Equals(this->last_modified_time, other_struct.last_modified_time))
    return false;
  return true;
}

template <typename T, IndexedDBStorageUsageInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.origin < rhs.origin)
    return true;
  if (rhs.origin < lhs.origin)
    return false;
  if (lhs.size_in_bytes < rhs.size_in_bytes)
    return true;
  if (rhs.size_in_bytes < lhs.size_in_bytes)
    return false;
  if (lhs.last_modified_time < rhs.last_modified_time)
    return true;
  if (rhs.last_modified_time < lhs.last_modified_time)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace storage

namespace mojo {


template <>
struct  StructTraits<::storage::mojom::IndexedDBStorageUsageInfo::DataView,
                                         ::storage::mojom::IndexedDBStorageUsageInfoPtr> {
  static bool IsNull(const ::storage::mojom::IndexedDBStorageUsageInfoPtr& input) { return !input; }
  static void SetToNull(::storage::mojom::IndexedDBStorageUsageInfoPtr* output) { output->reset(); }

  static const decltype(::storage::mojom::IndexedDBStorageUsageInfo::origin)& origin(
      const ::storage::mojom::IndexedDBStorageUsageInfoPtr& input) {
    return input->origin;
  }

  static decltype(::storage::mojom::IndexedDBStorageUsageInfo::size_in_bytes) size_in_bytes(
      const ::storage::mojom::IndexedDBStorageUsageInfoPtr& input) {
    return input->size_in_bytes;
  }

  static const decltype(::storage::mojom::IndexedDBStorageUsageInfo::last_modified_time)& last_modified_time(
      const ::storage::mojom::IndexedDBStorageUsageInfoPtr& input) {
    return input->last_modified_time;
  }

  static bool Read(::storage::mojom::IndexedDBStorageUsageInfo::DataView input, ::storage::mojom::IndexedDBStorageUsageInfoPtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_STORAGE_PUBLIC_MOJOM_INDEXED_DB_CONTROL_MOJOM_H_