// media/mojo/mojom/interface_factory.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_INTERFACE_FACTORY_MOJOM_BLINK_H_
#define MEDIA_MOJO_MOJOM_INTERFACE_FACTORY_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "media/mojo/mojom/interface_factory.mojom-shared.h"
#include "media/mojo/mojom/interface_factory.mojom-blink-forward.h"
#include "media/mojo/mojom/audio_decoder.mojom-blink-forward.h"
#include "media/mojo/mojom/decryptor.mojom-blink-forward.h"
#include "media/mojo/mojom/content_decryption_module.mojom-blink-forward.h"
#include "media/mojo/mojom/renderer.mojom-blink-forward.h"
#include "media/mojo/mojom/renderer_extensions.mojom-blink-forward.h"
#include "media/mojo/mojom/video_decoder.mojom-blink-forward.h"
#include "mojo/public/mojom/base/token.mojom-blink-forward.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/public/platform/web_common.h"




namespace media {
namespace mojom {
namespace blink {

class InterfaceFactoryProxy;

template <typename ImplRefTraits>
class InterfaceFactoryStub;

class InterfaceFactoryRequestValidator;


class BLINK_PLATFORM_EXPORT InterfaceFactory
    : public InterfaceFactoryInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = InterfaceFactoryInterfaceBase;
  using Proxy_ = InterfaceFactoryProxy;

  template <typename ImplRefTraits>
  using Stub_ = InterfaceFactoryStub<ImplRefTraits>;

  using RequestValidator_ = InterfaceFactoryRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateAudioDecoderMinVersion = 0,
    kCreateVideoDecoderMinVersion = 0,
    kCreateDefaultRendererMinVersion = 0,
    kCreateCdmMinVersion = 0,
    kCreateDecryptorMinVersion = 0,
  };
  virtual ~InterfaceFactory() {}

  
  virtual void CreateAudioDecoder(mojo::PendingReceiver<::media::mojom::blink::AudioDecoder> audio_decoder) = 0;

  
  virtual void CreateVideoDecoder(mojo::PendingReceiver<::media::mojom::blink::VideoDecoder> video_decoder) = 0;

  
  virtual void CreateDefaultRenderer(const WTF::String& audio_device_id, mojo::PendingReceiver<::media::mojom::blink::Renderer> renderer) = 0;

  
  virtual void CreateCdm(const WTF::String& key_system, mojo::PendingReceiver<::media::mojom::blink::ContentDecryptionModule> cdm) = 0;

  
  virtual void CreateDecryptor(int32_t cdm_id, mojo::PendingReceiver<::media::mojom::blink::Decryptor> decryptor) = 0;
};



class BLINK_PLATFORM_EXPORT InterfaceFactoryProxy
    : public InterfaceFactory {
 public:
  using InterfaceType = InterfaceFactory;

  explicit InterfaceFactoryProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateAudioDecoder(mojo::PendingReceiver<::media::mojom::blink::AudioDecoder> audio_decoder) final;
  
  void CreateVideoDecoder(mojo::PendingReceiver<::media::mojom::blink::VideoDecoder> video_decoder) final;
  
  void CreateDefaultRenderer(const WTF::String& audio_device_id, mojo::PendingReceiver<::media::mojom::blink::Renderer> renderer) final;
  
  void CreateCdm(const WTF::String& key_system, mojo::PendingReceiver<::media::mojom::blink::ContentDecryptionModule> cdm) final;
  
  void CreateDecryptor(int32_t cdm_id, mojo::PendingReceiver<::media::mojom::blink::Decryptor> decryptor) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT InterfaceFactoryStubDispatch {
 public:
  static bool Accept(InterfaceFactory* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      InterfaceFactory* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<InterfaceFactory>>
class InterfaceFactoryStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  InterfaceFactoryStub() {}
  ~InterfaceFactoryStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return InterfaceFactoryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return InterfaceFactoryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT InterfaceFactoryRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace media

namespace mojo {

}  // namespace mojo

#endif  // MEDIA_MOJO_MOJOM_INTERFACE_FACTORY_MOJOM_BLINK_H_