// media/mojo/mojom/media_types.mojom-blink.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "media/mojo/mojom/media_types.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "media/mojo/mojom/media_types.mojom-params-data.h"
#include "media/mojo/mojom/media_types.mojom-shared-message-ids.h"

#include "media/mojo/mojom/media_types.mojom-blink-import-headers.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef MEDIA_MOJO_MOJOM_MEDIA_TYPES_MOJOM_BLINK_JUMBO_H_
#define MEDIA_MOJO_MOJOM_MEDIA_TYPES_MOJOM_BLINK_JUMBO_H_
#include "gpu/ipc/common/mailbox_holder_mojom_traits.h"
#include "gpu/ipc/common/sync_token_mojom_traits.h"
#include "mojo/public/cpp/base/shared_memory_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "mojo/public/cpp/base/values_mojom_traits.h"
#include "third_party/blink/renderer/platform/mojo/geometry_mojom_traits.h"
#include "ui/gfx/geometry/mojom/geometry_mojom_traits.h"
#include "ui/gfx/mojom/buffer_types_mojom_traits.h"
#include "ui/gfx/mojom/color_space_mojom_traits.h"
#endif
namespace media {
namespace mojom {
namespace blink {
VideoTransformation::VideoTransformation()
    : rotation(),
      mirrored() {}

VideoTransformation::VideoTransformation(
    VideoRotation rotation_in,
    bool mirrored_in)
    : rotation(std::move(rotation_in)),
      mirrored(std::move(mirrored_in)) {}

VideoTransformation::~VideoTransformation() = default;
size_t VideoTransformation::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->rotation);
  seed = mojo::internal::WTFHash(seed, this->mirrored);
  return seed;
}

bool VideoTransformation::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
EncryptionPattern::EncryptionPattern()
    : crypt_byte_block(),
      skip_byte_block() {}

EncryptionPattern::EncryptionPattern(
    uint32_t crypt_byte_block_in,
    uint32_t skip_byte_block_in)
    : crypt_byte_block(std::move(crypt_byte_block_in)),
      skip_byte_block(std::move(skip_byte_block_in)) {}

EncryptionPattern::~EncryptionPattern() = default;
size_t EncryptionPattern::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->crypt_byte_block);
  seed = mojo::internal::WTFHash(seed, this->skip_byte_block);
  return seed;
}

bool EncryptionPattern::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
VideoColorSpace::VideoColorSpace()
    : primaries(),
      transfer(),
      matrix(),
      range() {}

VideoColorSpace::VideoColorSpace(
    VideoColorSpace::PrimaryID primaries_in,
    VideoColorSpace::TransferID transfer_in,
    VideoColorSpace::MatrixID matrix_in,
    VideoColorSpace::RangeID range_in)
    : primaries(std::move(primaries_in)),
      transfer(std::move(transfer_in)),
      matrix(std::move(matrix_in)),
      range(std::move(range_in)) {}

VideoColorSpace::~VideoColorSpace() = default;
size_t VideoColorSpace::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->primaries);
  seed = mojo::internal::WTFHash(seed, this->transfer);
  seed = mojo::internal::WTFHash(seed, this->matrix);
  seed = mojo::internal::WTFHash(seed, this->range);
  return seed;
}

bool VideoColorSpace::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MasteringMetadata::MasteringMetadata()
    : primary_r(),
      primary_g(),
      primary_b(),
      white_point(),
      luminance_max(),
      luminance_min() {}

MasteringMetadata::MasteringMetadata(
    const ::gfx::PointF& primary_r_in,
    const ::gfx::PointF& primary_g_in,
    const ::gfx::PointF& primary_b_in,
    const ::gfx::PointF& white_point_in,
    float luminance_max_in,
    float luminance_min_in)
    : primary_r(std::move(primary_r_in)),
      primary_g(std::move(primary_g_in)),
      primary_b(std::move(primary_b_in)),
      white_point(std::move(white_point_in)),
      luminance_max(std::move(luminance_max_in)),
      luminance_min(std::move(luminance_min_in)) {}

MasteringMetadata::~MasteringMetadata() = default;

bool MasteringMetadata::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
HDRMetadata::HDRMetadata()
    : mastering_metadata(),
      max_content_light_level(),
      max_frame_average_light_level() {}

HDRMetadata::HDRMetadata(
    MasteringMetadataPtr mastering_metadata_in,
    uint32_t max_content_light_level_in,
    uint32_t max_frame_average_light_level_in)
    : mastering_metadata(std::move(mastering_metadata_in)),
      max_content_light_level(std::move(max_content_light_level_in)),
      max_frame_average_light_level(std::move(max_frame_average_light_level_in)) {}

HDRMetadata::~HDRMetadata() = default;

bool HDRMetadata::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
AudioDecoderConfig::AudioDecoderConfig()
    : codec(),
      profile(),
      sample_format(),
      channel_layout(),
      samples_per_second(),
      extra_data(),
      seek_preroll(),
      codec_delay(),
      encryption_scheme() {}

AudioDecoderConfig::AudioDecoderConfig(
    AudioCodec codec_in,
    AudioCodecProfile profile_in,
    SampleFormat sample_format_in,
    ChannelLayout channel_layout_in,
    int32_t samples_per_second_in,
    WTF::Vector<uint8_t> extra_data_in,
    ::base::TimeDelta seek_preroll_in,
    int32_t codec_delay_in,
    EncryptionScheme encryption_scheme_in)
    : codec(std::move(codec_in)),
      profile(std::move(profile_in)),
      sample_format(std::move(sample_format_in)),
      channel_layout(std::move(channel_layout_in)),
      samples_per_second(std::move(samples_per_second_in)),
      extra_data(std::move(extra_data_in)),
      seek_preroll(std::move(seek_preroll_in)),
      codec_delay(std::move(codec_delay_in)),
      encryption_scheme(std::move(encryption_scheme_in)) {}

AudioDecoderConfig::~AudioDecoderConfig() = default;

bool AudioDecoderConfig::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
VideoDecoderConfig::VideoDecoderConfig()
    : codec(),
      profile(),
      level(),
      has_alpha(),
      transformation(),
      coded_size(),
      visible_rect(),
      natural_size(),
      extra_data(),
      encryption_scheme(),
      color_space_info(),
      hdr_metadata() {}

VideoDecoderConfig::VideoDecoderConfig(
    VideoCodec codec_in,
    VideoCodecProfile profile_in,
    uint32_t level_in,
    bool has_alpha_in,
    VideoTransformationPtr transformation_in,
    const ::blink::WebSize& coded_size_in,
    const ::blink::WebRect& visible_rect_in,
    const ::blink::WebSize& natural_size_in,
    WTF::Vector<uint8_t> extra_data_in,
    EncryptionScheme encryption_scheme_in,
    VideoColorSpacePtr color_space_info_in,
    HDRMetadataPtr hdr_metadata_in)
    : codec(std::move(codec_in)),
      profile(std::move(profile_in)),
      level(std::move(level_in)),
      has_alpha(std::move(has_alpha_in)),
      transformation(std::move(transformation_in)),
      coded_size(std::move(coded_size_in)),
      visible_rect(std::move(visible_rect_in)),
      natural_size(std::move(natural_size_in)),
      extra_data(std::move(extra_data_in)),
      encryption_scheme(std::move(encryption_scheme_in)),
      color_space_info(std::move(color_space_info_in)),
      hdr_metadata(std::move(hdr_metadata_in)) {}

VideoDecoderConfig::~VideoDecoderConfig() = default;

bool VideoDecoderConfig::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
DecryptConfig::DecryptConfig()
    : encryption_scheme(),
      key_id(),
      iv(),
      subsamples(),
      encryption_pattern() {}

DecryptConfig::DecryptConfig(
    EncryptionScheme encryption_scheme_in,
    const WTF::String& key_id_in,
    const WTF::String& iv_in,
    WTF::Vector<SubsampleEntryPtr> subsamples_in,
    EncryptionPatternPtr encryption_pattern_in)
    : encryption_scheme(std::move(encryption_scheme_in)),
      key_id(std::move(key_id_in)),
      iv(std::move(iv_in)),
      subsamples(std::move(subsamples_in)),
      encryption_pattern(std::move(encryption_pattern_in)) {}

DecryptConfig::~DecryptConfig() = default;

bool DecryptConfig::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
DecoderBuffer::DecoderBuffer()
    : timestamp(),
      duration(),
      is_end_of_stream(),
      data_size(),
      is_key_frame(),
      side_data(),
      decrypt_config(),
      front_discard(),
      back_discard() {}

DecoderBuffer::DecoderBuffer(
    ::base::TimeDelta timestamp_in,
    ::base::TimeDelta duration_in,
    bool is_end_of_stream_in,
    uint32_t data_size_in,
    bool is_key_frame_in,
    WTF::Vector<uint8_t> side_data_in,
    DecryptConfigPtr decrypt_config_in,
    ::base::TimeDelta front_discard_in,
    ::base::TimeDelta back_discard_in)
    : timestamp(std::move(timestamp_in)),
      duration(std::move(duration_in)),
      is_end_of_stream(std::move(is_end_of_stream_in)),
      data_size(std::move(data_size_in)),
      is_key_frame(std::move(is_key_frame_in)),
      side_data(std::move(side_data_in)),
      decrypt_config(std::move(decrypt_config_in)),
      front_discard(std::move(front_discard_in)),
      back_discard(std::move(back_discard_in)) {}

DecoderBuffer::~DecoderBuffer() = default;

bool DecoderBuffer::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
AudioBuffer::AudioBuffer()
    : sample_format(),
      channel_layout(),
      channel_count(),
      sample_rate(),
      frame_count(),
      end_of_stream(),
      timestamp(),
      data() {}

AudioBuffer::AudioBuffer(
    SampleFormat sample_format_in,
    ChannelLayout channel_layout_in,
    int32_t channel_count_in,
    int32_t sample_rate_in,
    int32_t frame_count_in,
    bool end_of_stream_in,
    ::base::TimeDelta timestamp_in,
    WTF::Vector<uint8_t> data_in)
    : sample_format(std::move(sample_format_in)),
      channel_layout(std::move(channel_layout_in)),
      channel_count(std::move(channel_count_in)),
      sample_rate(std::move(sample_rate_in)),
      frame_count(std::move(frame_count_in)),
      end_of_stream(std::move(end_of_stream_in)),
      timestamp(std::move(timestamp_in)),
      data(std::move(data_in)) {}

AudioBuffer::~AudioBuffer() = default;

bool AudioBuffer::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
VideoFrame::VideoFrame()
    : format(),
      coded_size(),
      visible_rect(),
      natural_size(),
      timestamp(),
      data(),
      metadata(),
      color_space() {}

VideoFrame::VideoFrame(
    VideoPixelFormat format_in,
    const ::blink::WebSize& coded_size_in,
    const ::blink::WebRect& visible_rect_in,
    const ::blink::WebSize& natural_size_in,
    ::base::TimeDelta timestamp_in,
    VideoFrameDataPtr data_in,
    ::base::Value metadata_in,
    const ::gfx::ColorSpace& color_space_in)
    : format(std::move(format_in)),
      coded_size(std::move(coded_size_in)),
      visible_rect(std::move(visible_rect_in)),
      natural_size(std::move(natural_size_in)),
      timestamp(std::move(timestamp_in)),
      data(std::move(data_in)),
      metadata(std::move(metadata_in)),
      color_space(std::move(color_space_in)) {}

VideoFrame::~VideoFrame() = default;

bool VideoFrame::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
EosVideoFrameData::EosVideoFrameData() {}

EosVideoFrameData::~EosVideoFrameData() = default;
size_t EosVideoFrameData::Hash(size_t seed) const {
  return seed;
}

bool EosVideoFrameData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SharedBufferVideoFrameData::SharedBufferVideoFrameData()
    : frame_data(),
      frame_data_size(),
      y_stride(),
      u_stride(),
      v_stride(),
      y_offset(),
      u_offset(),
      v_offset() {}

SharedBufferVideoFrameData::SharedBufferVideoFrameData(
    mojo::ScopedSharedBufferHandle frame_data_in,
    uint64_t frame_data_size_in,
    int32_t y_stride_in,
    int32_t u_stride_in,
    int32_t v_stride_in,
    uint64_t y_offset_in,
    uint64_t u_offset_in,
    uint64_t v_offset_in)
    : frame_data(std::move(frame_data_in)),
      frame_data_size(std::move(frame_data_size_in)),
      y_stride(std::move(y_stride_in)),
      u_stride(std::move(u_stride_in)),
      v_stride(std::move(v_stride_in)),
      y_offset(std::move(y_offset_in)),
      u_offset(std::move(u_offset_in)),
      v_offset(std::move(v_offset_in)) {}

SharedBufferVideoFrameData::~SharedBufferVideoFrameData() = default;

bool SharedBufferVideoFrameData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
DmabufVideoFrameData::DmabufVideoFrameData()
    : dmabuf_fds() {}

DmabufVideoFrameData::DmabufVideoFrameData(
    WTF::Vector<mojo::ScopedHandle> dmabuf_fds_in)
    : dmabuf_fds(std::move(dmabuf_fds_in)) {}

DmabufVideoFrameData::~DmabufVideoFrameData() = default;

bool DmabufVideoFrameData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
GpuMemoryBufferVideoFrameData::GpuMemoryBufferVideoFrameData()
    : gpu_memory_buffer_handle(),
      mailbox_holder() {}

GpuMemoryBufferVideoFrameData::GpuMemoryBufferVideoFrameData(
    gfx::GpuMemoryBufferHandle gpu_memory_buffer_handle_in,
    WTF::Vector<::gpu::MailboxHolder> mailbox_holder_in)
    : gpu_memory_buffer_handle(std::move(gpu_memory_buffer_handle_in)),
      mailbox_holder(std::move(mailbox_holder_in)) {}

GpuMemoryBufferVideoFrameData::~GpuMemoryBufferVideoFrameData() = default;

bool GpuMemoryBufferVideoFrameData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
MailboxVideoFrameData::MailboxVideoFrameData()
    : mailbox_holder(),
      ycbcr_data() {}

MailboxVideoFrameData::MailboxVideoFrameData(
    WTF::Vector<::gpu::MailboxHolder> mailbox_holder_in,
    ::gpu::mojom::blink::VulkanYCbCrInfoPtr ycbcr_data_in)
    : mailbox_holder(std::move(mailbox_holder_in)),
      ycbcr_data(std::move(ycbcr_data_in)) {}

MailboxVideoFrameData::~MailboxVideoFrameData() = default;

bool MailboxVideoFrameData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PipelineStatistics::PipelineStatistics()
    : audio_bytes_decoded(),
      video_bytes_decoded(),
      video_frames_decoded(),
      video_frames_dropped(),
      audio_memory_usage(),
      video_memory_usage() {}

PipelineStatistics::PipelineStatistics(
    uint64_t audio_bytes_decoded_in,
    uint64_t video_bytes_decoded_in,
    uint32_t video_frames_decoded_in,
    uint32_t video_frames_dropped_in,
    int64_t audio_memory_usage_in,
    int64_t video_memory_usage_in)
    : audio_bytes_decoded(std::move(audio_bytes_decoded_in)),
      video_bytes_decoded(std::move(video_bytes_decoded_in)),
      video_frames_decoded(std::move(video_frames_decoded_in)),
      video_frames_dropped(std::move(video_frames_dropped_in)),
      audio_memory_usage(std::move(audio_memory_usage_in)),
      video_memory_usage(std::move(video_memory_usage_in)) {}

PipelineStatistics::~PipelineStatistics() = default;
size_t PipelineStatistics::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->audio_bytes_decoded);
  seed = mojo::internal::WTFHash(seed, this->video_bytes_decoded);
  seed = mojo::internal::WTFHash(seed, this->video_frames_decoded);
  seed = mojo::internal::WTFHash(seed, this->video_frames_dropped);
  seed = mojo::internal::WTFHash(seed, this->audio_memory_usage);
  seed = mojo::internal::WTFHash(seed, this->video_memory_usage);
  return seed;
}

bool PipelineStatistics::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PredictionFeatures::PredictionFeatures()
    : profile(),
      video_size(),
      frames_per_sec(0),
      key_system(),
      use_hw_secure_codecs(false) {}

PredictionFeatures::PredictionFeatures(
    VideoCodecProfile profile_in,
    const ::blink::WebSize& video_size_in,
    double frames_per_sec_in,
    const WTF::String& key_system_in,
    bool use_hw_secure_codecs_in)
    : profile(std::move(profile_in)),
      video_size(std::move(video_size_in)),
      frames_per_sec(std::move(frames_per_sec_in)),
      key_system(std::move(key_system_in)),
      use_hw_secure_codecs(std::move(use_hw_secure_codecs_in)) {}

PredictionFeatures::~PredictionFeatures() = default;

bool PredictionFeatures::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PredictionTargets::PredictionTargets()
    : frames_decoded(0U),
      frames_dropped(0U),
      frames_power_efficient(0U) {}

PredictionTargets::PredictionTargets(
    uint32_t frames_decoded_in,
    uint32_t frames_dropped_in,
    uint32_t frames_power_efficient_in)
    : frames_decoded(std::move(frames_decoded_in)),
      frames_dropped(std::move(frames_dropped_in)),
      frames_power_efficient(std::move(frames_power_efficient_in)) {}

PredictionTargets::~PredictionTargets() = default;
size_t PredictionTargets::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->frames_decoded);
  seed = mojo::internal::WTFHash(seed, this->frames_dropped);
  seed = mojo::internal::WTFHash(seed, this->frames_power_efficient);
  return seed;
}

bool PredictionTargets::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PipelineDecoderInfo::PipelineDecoderInfo()
    : decoder_name(),
      is_platform_decoder(false),
      has_decrypting_demuxer_stream(false) {}

PipelineDecoderInfo::PipelineDecoderInfo(
    const WTF::String& decoder_name_in,
    bool is_platform_decoder_in,
    bool has_decrypting_demuxer_stream_in)
    : decoder_name(std::move(decoder_name_in)),
      is_platform_decoder(std::move(is_platform_decoder_in)),
      has_decrypting_demuxer_stream(std::move(has_decrypting_demuxer_stream_in)) {}

PipelineDecoderInfo::~PipelineDecoderInfo() = default;
size_t PipelineDecoderInfo::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->decoder_name);
  seed = mojo::internal::WTFHash(seed, this->is_platform_decoder);
  seed = mojo::internal::WTFHash(seed, this->has_decrypting_demuxer_stream);
  return seed;
}

bool PipelineDecoderInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
VideoFrameData::VideoFrameData() : tag_(Tag::EOS_DATA) {
  data_.eos_data = new EosVideoFrameDataPtr;
}

VideoFrameData::~VideoFrameData() {
  DestroyActive();
}


void VideoFrameData::set_eos_data(
    EosVideoFrameDataPtr eos_data) {
  if (tag_ == Tag::EOS_DATA) {
    *(data_.eos_data) = std::move(eos_data);
  } else {
    DestroyActive();
    tag_ = Tag::EOS_DATA;
    data_.eos_data = new EosVideoFrameDataPtr(
        std::move(eos_data));
  }
}
void VideoFrameData::set_shared_buffer_data(
    SharedBufferVideoFrameDataPtr shared_buffer_data) {
  if (tag_ == Tag::SHARED_BUFFER_DATA) {
    *(data_.shared_buffer_data) = std::move(shared_buffer_data);
  } else {
    DestroyActive();
    tag_ = Tag::SHARED_BUFFER_DATA;
    data_.shared_buffer_data = new SharedBufferVideoFrameDataPtr(
        std::move(shared_buffer_data));
  }
}
void VideoFrameData::set_dmabuf_data(
    DmabufVideoFrameDataPtr dmabuf_data) {
  if (tag_ == Tag::DMABUF_DATA) {
    *(data_.dmabuf_data) = std::move(dmabuf_data);
  } else {
    DestroyActive();
    tag_ = Tag::DMABUF_DATA;
    data_.dmabuf_data = new DmabufVideoFrameDataPtr(
        std::move(dmabuf_data));
  }
}
void VideoFrameData::set_gpu_memory_buffer_data(
    GpuMemoryBufferVideoFrameDataPtr gpu_memory_buffer_data) {
  if (tag_ == Tag::GPU_MEMORY_BUFFER_DATA) {
    *(data_.gpu_memory_buffer_data) = std::move(gpu_memory_buffer_data);
  } else {
    DestroyActive();
    tag_ = Tag::GPU_MEMORY_BUFFER_DATA;
    data_.gpu_memory_buffer_data = new GpuMemoryBufferVideoFrameDataPtr(
        std::move(gpu_memory_buffer_data));
  }
}
void VideoFrameData::set_mailbox_data(
    MailboxVideoFrameDataPtr mailbox_data) {
  if (tag_ == Tag::MAILBOX_DATA) {
    *(data_.mailbox_data) = std::move(mailbox_data);
  } else {
    DestroyActive();
    tag_ = Tag::MAILBOX_DATA;
    data_.mailbox_data = new MailboxVideoFrameDataPtr(
        std::move(mailbox_data));
  }
}

void VideoFrameData::DestroyActive() {
  switch (tag_) {

    case Tag::EOS_DATA:

      delete data_.eos_data;
      break;
    case Tag::SHARED_BUFFER_DATA:

      delete data_.shared_buffer_data;
      break;
    case Tag::DMABUF_DATA:

      delete data_.dmabuf_data;
      break;
    case Tag::GPU_MEMORY_BUFFER_DATA:

      delete data_.gpu_memory_buffer_data;
      break;
    case Tag::MAILBOX_DATA:

      delete data_.mailbox_data;
      break;
  }
}

bool VideoFrameData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
}  // namespace blink
}  // namespace mojom
}  // namespace media

namespace mojo {


// static
bool StructTraits<::media::mojom::blink::VideoTransformation::DataView, ::media::mojom::blink::VideoTransformationPtr>::Read(
    ::media::mojom::blink::VideoTransformation::DataView input,
    ::media::mojom::blink::VideoTransformationPtr* output) {
  bool success = true;
  ::media::mojom::blink::VideoTransformationPtr result(::media::mojom::blink::VideoTransformation::New());
  
      if (success && !input.ReadRotation(&result->rotation))
        success = false;
      if (success)
        result->mirrored = input.mirrored();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::EncryptionPattern::DataView, ::media::mojom::blink::EncryptionPatternPtr>::Read(
    ::media::mojom::blink::EncryptionPattern::DataView input,
    ::media::mojom::blink::EncryptionPatternPtr* output) {
  bool success = true;
  ::media::mojom::blink::EncryptionPatternPtr result(::media::mojom::blink::EncryptionPattern::New());
  
      if (success)
        result->crypt_byte_block = input.crypt_byte_block();
      if (success)
        result->skip_byte_block = input.skip_byte_block();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::VideoColorSpace::DataView, ::media::mojom::blink::VideoColorSpacePtr>::Read(
    ::media::mojom::blink::VideoColorSpace::DataView input,
    ::media::mojom::blink::VideoColorSpacePtr* output) {
  bool success = true;
  ::media::mojom::blink::VideoColorSpacePtr result(::media::mojom::blink::VideoColorSpace::New());
  
      if (success && !input.ReadPrimaries(&result->primaries))
        success = false;
      if (success && !input.ReadTransfer(&result->transfer))
        success = false;
      if (success && !input.ReadMatrix(&result->matrix))
        success = false;
      if (success && !input.ReadRange(&result->range))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::MasteringMetadata::DataView, ::media::mojom::blink::MasteringMetadataPtr>::Read(
    ::media::mojom::blink::MasteringMetadata::DataView input,
    ::media::mojom::blink::MasteringMetadataPtr* output) {
  bool success = true;
  ::media::mojom::blink::MasteringMetadataPtr result(::media::mojom::blink::MasteringMetadata::New());
  
      if (success && !input.ReadPrimaryR(&result->primary_r))
        success = false;
      if (success && !input.ReadPrimaryG(&result->primary_g))
        success = false;
      if (success && !input.ReadPrimaryB(&result->primary_b))
        success = false;
      if (success && !input.ReadWhitePoint(&result->white_point))
        success = false;
      if (success)
        result->luminance_max = input.luminance_max();
      if (success)
        result->luminance_min = input.luminance_min();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::HDRMetadata::DataView, ::media::mojom::blink::HDRMetadataPtr>::Read(
    ::media::mojom::blink::HDRMetadata::DataView input,
    ::media::mojom::blink::HDRMetadataPtr* output) {
  bool success = true;
  ::media::mojom::blink::HDRMetadataPtr result(::media::mojom::blink::HDRMetadata::New());
  
      if (success && !input.ReadMasteringMetadata(&result->mastering_metadata))
        success = false;
      if (success)
        result->max_content_light_level = input.max_content_light_level();
      if (success)
        result->max_frame_average_light_level = input.max_frame_average_light_level();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::AudioDecoderConfig::DataView, ::media::mojom::blink::AudioDecoderConfigPtr>::Read(
    ::media::mojom::blink::AudioDecoderConfig::DataView input,
    ::media::mojom::blink::AudioDecoderConfigPtr* output) {
  bool success = true;
  ::media::mojom::blink::AudioDecoderConfigPtr result(::media::mojom::blink::AudioDecoderConfig::New());
  
      if (success && !input.ReadCodec(&result->codec))
        success = false;
      if (success && !input.ReadProfile(&result->profile))
        success = false;
      if (success && !input.ReadSampleFormat(&result->sample_format))
        success = false;
      if (success && !input.ReadChannelLayout(&result->channel_layout))
        success = false;
      if (success)
        result->samples_per_second = input.samples_per_second();
      if (success && !input.ReadExtraData(&result->extra_data))
        success = false;
      if (success && !input.ReadSeekPreroll(&result->seek_preroll))
        success = false;
      if (success)
        result->codec_delay = input.codec_delay();
      if (success && !input.ReadEncryptionScheme(&result->encryption_scheme))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::VideoDecoderConfig::DataView, ::media::mojom::blink::VideoDecoderConfigPtr>::Read(
    ::media::mojom::blink::VideoDecoderConfig::DataView input,
    ::media::mojom::blink::VideoDecoderConfigPtr* output) {
  bool success = true;
  ::media::mojom::blink::VideoDecoderConfigPtr result(::media::mojom::blink::VideoDecoderConfig::New());
  
      if (success && !input.ReadCodec(&result->codec))
        success = false;
      if (success && !input.ReadProfile(&result->profile))
        success = false;
      if (success)
        result->level = input.level();
      if (success)
        result->has_alpha = input.has_alpha();
      if (success && !input.ReadTransformation(&result->transformation))
        success = false;
      if (success && !input.ReadCodedSize(&result->coded_size))
        success = false;
      if (success && !input.ReadVisibleRect(&result->visible_rect))
        success = false;
      if (success && !input.ReadNaturalSize(&result->natural_size))
        success = false;
      if (success && !input.ReadExtraData(&result->extra_data))
        success = false;
      if (success && !input.ReadEncryptionScheme(&result->encryption_scheme))
        success = false;
      if (success && !input.ReadColorSpaceInfo(&result->color_space_info))
        success = false;
      if (success && !input.ReadHdrMetadata(&result->hdr_metadata))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::DecryptConfig::DataView, ::media::mojom::blink::DecryptConfigPtr>::Read(
    ::media::mojom::blink::DecryptConfig::DataView input,
    ::media::mojom::blink::DecryptConfigPtr* output) {
  bool success = true;
  ::media::mojom::blink::DecryptConfigPtr result(::media::mojom::blink::DecryptConfig::New());
  
      if (success && !input.ReadEncryptionScheme(&result->encryption_scheme))
        success = false;
      if (success && !input.ReadKeyId(&result->key_id))
        success = false;
      if (success && !input.ReadIv(&result->iv))
        success = false;
      if (success && !input.ReadSubsamples(&result->subsamples))
        success = false;
      if (success && !input.ReadEncryptionPattern(&result->encryption_pattern))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::DecoderBuffer::DataView, ::media::mojom::blink::DecoderBufferPtr>::Read(
    ::media::mojom::blink::DecoderBuffer::DataView input,
    ::media::mojom::blink::DecoderBufferPtr* output) {
  bool success = true;
  ::media::mojom::blink::DecoderBufferPtr result(::media::mojom::blink::DecoderBuffer::New());
  
      if (success && !input.ReadTimestamp(&result->timestamp))
        success = false;
      if (success && !input.ReadDuration(&result->duration))
        success = false;
      if (success)
        result->is_end_of_stream = input.is_end_of_stream();
      if (success)
        result->data_size = input.data_size();
      if (success)
        result->is_key_frame = input.is_key_frame();
      if (success && !input.ReadSideData(&result->side_data))
        success = false;
      if (success && !input.ReadDecryptConfig(&result->decrypt_config))
        success = false;
      if (success && !input.ReadFrontDiscard(&result->front_discard))
        success = false;
      if (success && !input.ReadBackDiscard(&result->back_discard))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::AudioBuffer::DataView, ::media::mojom::blink::AudioBufferPtr>::Read(
    ::media::mojom::blink::AudioBuffer::DataView input,
    ::media::mojom::blink::AudioBufferPtr* output) {
  bool success = true;
  ::media::mojom::blink::AudioBufferPtr result(::media::mojom::blink::AudioBuffer::New());
  
      if (success && !input.ReadSampleFormat(&result->sample_format))
        success = false;
      if (success && !input.ReadChannelLayout(&result->channel_layout))
        success = false;
      if (success)
        result->channel_count = input.channel_count();
      if (success)
        result->sample_rate = input.sample_rate();
      if (success)
        result->frame_count = input.frame_count();
      if (success)
        result->end_of_stream = input.end_of_stream();
      if (success && !input.ReadTimestamp(&result->timestamp))
        success = false;
      if (success && !input.ReadData(&result->data))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::VideoFrame::DataView, ::media::mojom::blink::VideoFramePtr>::Read(
    ::media::mojom::blink::VideoFrame::DataView input,
    ::media::mojom::blink::VideoFramePtr* output) {
  bool success = true;
  ::media::mojom::blink::VideoFramePtr result(::media::mojom::blink::VideoFrame::New());
  
      if (success && !input.ReadFormat(&result->format))
        success = false;
      if (success && !input.ReadCodedSize(&result->coded_size))
        success = false;
      if (success && !input.ReadVisibleRect(&result->visible_rect))
        success = false;
      if (success && !input.ReadNaturalSize(&result->natural_size))
        success = false;
      if (success && !input.ReadTimestamp(&result->timestamp))
        success = false;
      if (success && !input.ReadData(&result->data))
        success = false;
      if (success && !input.ReadMetadata(&result->metadata))
        success = false;
      if (success && !input.ReadColorSpace(&result->color_space))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::EosVideoFrameData::DataView, ::media::mojom::blink::EosVideoFrameDataPtr>::Read(
    ::media::mojom::blink::EosVideoFrameData::DataView input,
    ::media::mojom::blink::EosVideoFrameDataPtr* output) {
  bool success = true;
  ::media::mojom::blink::EosVideoFrameDataPtr result(::media::mojom::blink::EosVideoFrameData::New());
  
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::SharedBufferVideoFrameData::DataView, ::media::mojom::blink::SharedBufferVideoFrameDataPtr>::Read(
    ::media::mojom::blink::SharedBufferVideoFrameData::DataView input,
    ::media::mojom::blink::SharedBufferVideoFrameDataPtr* output) {
  bool success = true;
  ::media::mojom::blink::SharedBufferVideoFrameDataPtr result(::media::mojom::blink::SharedBufferVideoFrameData::New());
  
      if (success)
        result->frame_data = input.TakeFrameData();
      if (success)
        result->frame_data_size = input.frame_data_size();
      if (success)
        result->y_stride = input.y_stride();
      if (success)
        result->u_stride = input.u_stride();
      if (success)
        result->v_stride = input.v_stride();
      if (success)
        result->y_offset = input.y_offset();
      if (success)
        result->u_offset = input.u_offset();
      if (success)
        result->v_offset = input.v_offset();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::DmabufVideoFrameData::DataView, ::media::mojom::blink::DmabufVideoFrameDataPtr>::Read(
    ::media::mojom::blink::DmabufVideoFrameData::DataView input,
    ::media::mojom::blink::DmabufVideoFrameDataPtr* output) {
  bool success = true;
  ::media::mojom::blink::DmabufVideoFrameDataPtr result(::media::mojom::blink::DmabufVideoFrameData::New());
  
      if (success && !input.ReadDmabufFds(&result->dmabuf_fds))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::GpuMemoryBufferVideoFrameData::DataView, ::media::mojom::blink::GpuMemoryBufferVideoFrameDataPtr>::Read(
    ::media::mojom::blink::GpuMemoryBufferVideoFrameData::DataView input,
    ::media::mojom::blink::GpuMemoryBufferVideoFrameDataPtr* output) {
  bool success = true;
  ::media::mojom::blink::GpuMemoryBufferVideoFrameDataPtr result(::media::mojom::blink::GpuMemoryBufferVideoFrameData::New());
  
      if (success && !input.ReadGpuMemoryBufferHandle(&result->gpu_memory_buffer_handle))
        success = false;
      if (success && !input.ReadMailboxHolder(&result->mailbox_holder))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::MailboxVideoFrameData::DataView, ::media::mojom::blink::MailboxVideoFrameDataPtr>::Read(
    ::media::mojom::blink::MailboxVideoFrameData::DataView input,
    ::media::mojom::blink::MailboxVideoFrameDataPtr* output) {
  bool success = true;
  ::media::mojom::blink::MailboxVideoFrameDataPtr result(::media::mojom::blink::MailboxVideoFrameData::New());
  
      if (success && !input.ReadMailboxHolder(&result->mailbox_holder))
        success = false;
      if (success && !input.ReadYcbcrData(&result->ycbcr_data))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::PipelineStatistics::DataView, ::media::mojom::blink::PipelineStatisticsPtr>::Read(
    ::media::mojom::blink::PipelineStatistics::DataView input,
    ::media::mojom::blink::PipelineStatisticsPtr* output) {
  bool success = true;
  ::media::mojom::blink::PipelineStatisticsPtr result(::media::mojom::blink::PipelineStatistics::New());
  
      if (success)
        result->audio_bytes_decoded = input.audio_bytes_decoded();
      if (success)
        result->video_bytes_decoded = input.video_bytes_decoded();
      if (success)
        result->video_frames_decoded = input.video_frames_decoded();
      if (success)
        result->video_frames_dropped = input.video_frames_dropped();
      if (success)
        result->audio_memory_usage = input.audio_memory_usage();
      if (success)
        result->video_memory_usage = input.video_memory_usage();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::PredictionFeatures::DataView, ::media::mojom::blink::PredictionFeaturesPtr>::Read(
    ::media::mojom::blink::PredictionFeatures::DataView input,
    ::media::mojom::blink::PredictionFeaturesPtr* output) {
  bool success = true;
  ::media::mojom::blink::PredictionFeaturesPtr result(::media::mojom::blink::PredictionFeatures::New());
  
      if (success && !input.ReadProfile(&result->profile))
        success = false;
      if (success && !input.ReadVideoSize(&result->video_size))
        success = false;
      if (success)
        result->frames_per_sec = input.frames_per_sec();
      if (success && !input.ReadKeySystem(&result->key_system))
        success = false;
      if (success)
        result->use_hw_secure_codecs = input.use_hw_secure_codecs();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::PredictionTargets::DataView, ::media::mojom::blink::PredictionTargetsPtr>::Read(
    ::media::mojom::blink::PredictionTargets::DataView input,
    ::media::mojom::blink::PredictionTargetsPtr* output) {
  bool success = true;
  ::media::mojom::blink::PredictionTargetsPtr result(::media::mojom::blink::PredictionTargets::New());
  
      if (success)
        result->frames_decoded = input.frames_decoded();
      if (success)
        result->frames_dropped = input.frames_dropped();
      if (success)
        result->frames_power_efficient = input.frames_power_efficient();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::media::mojom::blink::PipelineDecoderInfo::DataView, ::media::mojom::blink::PipelineDecoderInfoPtr>::Read(
    ::media::mojom::blink::PipelineDecoderInfo::DataView input,
    ::media::mojom::blink::PipelineDecoderInfoPtr* output) {
  bool success = true;
  ::media::mojom::blink::PipelineDecoderInfoPtr result(::media::mojom::blink::PipelineDecoderInfo::New());
  
      if (success && !input.ReadDecoderName(&result->decoder_name))
        success = false;
      if (success)
        result->is_platform_decoder = input.is_platform_decoder();
      if (success)
        result->has_decrypting_demuxer_stream = input.has_decrypting_demuxer_stream();
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::media::mojom::blink::VideoFrameData::DataView, ::media::mojom::blink::VideoFrameDataPtr>::Read(
    ::media::mojom::blink::VideoFrameData::DataView input,
    ::media::mojom::blink::VideoFrameDataPtr* output) {
  using UnionType = ::media::mojom::blink::VideoFrameData;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::EOS_DATA: {
      ::media::mojom::blink::EosVideoFrameDataPtr result_eos_data;
      if (!input.ReadEosData(&result_eos_data))
        return false;

      *output = UnionType::NewEosData(
          std::move(result_eos_data));
      break;
    }
    case Tag::SHARED_BUFFER_DATA: {
      ::media::mojom::blink::SharedBufferVideoFrameDataPtr result_shared_buffer_data;
      if (!input.ReadSharedBufferData(&result_shared_buffer_data))
        return false;

      *output = UnionType::NewSharedBufferData(
          std::move(result_shared_buffer_data));
      break;
    }
    case Tag::DMABUF_DATA: {
      ::media::mojom::blink::DmabufVideoFrameDataPtr result_dmabuf_data;
      if (!input.ReadDmabufData(&result_dmabuf_data))
        return false;

      *output = UnionType::NewDmabufData(
          std::move(result_dmabuf_data));
      break;
    }
    case Tag::GPU_MEMORY_BUFFER_DATA: {
      ::media::mojom::blink::GpuMemoryBufferVideoFrameDataPtr result_gpu_memory_buffer_data;
      if (!input.ReadGpuMemoryBufferData(&result_gpu_memory_buffer_data))
        return false;

      *output = UnionType::NewGpuMemoryBufferData(
          std::move(result_gpu_memory_buffer_data));
      break;
    }
    case Tag::MAILBOX_DATA: {
      ::media::mojom::blink::MailboxVideoFrameDataPtr result_mailbox_data;
      if (!input.ReadMailboxData(&result_mailbox_data))
        return false;

      *output = UnionType::NewMailboxData(
          std::move(result_mailbox_data));
      break;
    }
    default:
      return false;
  }
  return true;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif