// services/identity/public/mojom/google_service_auth_error.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_IDENTITY_PUBLIC_MOJOM_GOOGLE_SERVICE_AUTH_ERROR_MOJOM_H_
#define SERVICES_IDENTITY_PUBLIC_MOJOM_GOOGLE_SERVICE_AUTH_ERROR_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/identity/public/mojom/google_service_auth_error.mojom-shared.h"
#include "services/identity/public/mojom/google_service_auth_error.mojom-forward.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>




#include "google_apis/gaia/google_service_auth_error.h"




namespace identity {
namespace mojom {





class  GoogleServiceAuthError {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GoogleServiceAuthError, T>::value>;
  using DataView = GoogleServiceAuthErrorDataView;
  using Data_ = internal::GoogleServiceAuthError_Data;

  template <typename... Args>
  static GoogleServiceAuthErrorPtr New(Args&&... args) {
    return GoogleServiceAuthErrorPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GoogleServiceAuthErrorPtr From(const U& u) {
    return mojo::TypeConverter<GoogleServiceAuthErrorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GoogleServiceAuthError>::Convert(*this);
  }


  GoogleServiceAuthError();

  GoogleServiceAuthError(
      int32_t state,
      int32_t network_error,
      const std::string& error_message);

  ~GoogleServiceAuthError();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GoogleServiceAuthErrorPtr>
  GoogleServiceAuthErrorPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GoogleServiceAuthError::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GoogleServiceAuthError::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GoogleServiceAuthError::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GoogleServiceAuthError_UnserializedMessageContext<
            UserType, GoogleServiceAuthError::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<GoogleServiceAuthError::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return GoogleServiceAuthError::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GoogleServiceAuthError_UnserializedMessageContext<
            UserType, GoogleServiceAuthError::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GoogleServiceAuthError::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  int32_t state;
  
  int32_t network_error;
  
  std::string error_message;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GoogleServiceAuthError::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GoogleServiceAuthError::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GoogleServiceAuthError::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GoogleServiceAuthError::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
GoogleServiceAuthErrorPtr GoogleServiceAuthError::Clone() const {
  return New(
      mojo::Clone(state),
      mojo::Clone(network_error),
      mojo::Clone(error_message)
  );
}

template <typename T, GoogleServiceAuthError::EnableIfSame<T>*>
bool GoogleServiceAuthError::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->state, other_struct.state))
    return false;
  if (!mojo::Equals(this->network_error, other_struct.network_error))
    return false;
  if (!mojo::Equals(this->error_message, other_struct.error_message))
    return false;
  return true;
}

template <typename T, GoogleServiceAuthError::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.state < rhs.state)
    return true;
  if (rhs.state < lhs.state)
    return false;
  if (lhs.network_error < rhs.network_error)
    return true;
  if (rhs.network_error < lhs.network_error)
    return false;
  if (lhs.error_message < rhs.error_message)
    return true;
  if (rhs.error_message < lhs.error_message)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace identity

namespace mojo {


template <>
struct  StructTraits<::identity::mojom::GoogleServiceAuthError::DataView,
                                         ::identity::mojom::GoogleServiceAuthErrorPtr> {
  static bool IsNull(const ::identity::mojom::GoogleServiceAuthErrorPtr& input) { return !input; }
  static void SetToNull(::identity::mojom::GoogleServiceAuthErrorPtr* output) { output->reset(); }

  static decltype(::identity::mojom::GoogleServiceAuthError::state) state(
      const ::identity::mojom::GoogleServiceAuthErrorPtr& input) {
    return input->state;
  }

  static decltype(::identity::mojom::GoogleServiceAuthError::network_error) network_error(
      const ::identity::mojom::GoogleServiceAuthErrorPtr& input) {
    return input->network_error;
  }

  static const decltype(::identity::mojom::GoogleServiceAuthError::error_message)& error_message(
      const ::identity::mojom::GoogleServiceAuthErrorPtr& input) {
    return input->error_message;
  }

  static bool Read(::identity::mojom::GoogleServiceAuthError::DataView input, ::identity::mojom::GoogleServiceAuthErrorPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_IDENTITY_PUBLIC_MOJOM_GOOGLE_SERVICE_AUTH_ERROR_MOJOM_H_