// services/network/public/mojom/network_isolation_key.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_ISOLATION_KEY_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_ISOLATION_KEY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/network/public/mojom/network_isolation_key.mojom-shared.h"
#include "services/network/public/mojom/network_isolation_key.mojom-forward.h"
#include "url/mojom/origin.mojom.h"
#include <string>
#include <vector>




#include "net/base/network_isolation_key.h"




namespace network {
namespace mojom {








class  NetworkIsolationKey {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<NetworkIsolationKey, T>::value>;
  using DataView = NetworkIsolationKeyDataView;
  using Data_ = internal::NetworkIsolationKey_Data;

  template <typename... Args>
  static NetworkIsolationKeyPtr New(Args&&... args) {
    return NetworkIsolationKeyPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static NetworkIsolationKeyPtr From(const U& u) {
    return mojo::TypeConverter<NetworkIsolationKeyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NetworkIsolationKey>::Convert(*this);
  }


  NetworkIsolationKey();

  NetworkIsolationKey(
      const base::Optional<::url::Origin>& top_frame_origin,
      const base::Optional<::url::Origin>& frame_origin);

  ~NetworkIsolationKey();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NetworkIsolationKeyPtr>
  NetworkIsolationKeyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        NetworkIsolationKey::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        NetworkIsolationKey::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::NetworkIsolationKey_UnserializedMessageContext<
            UserType, NetworkIsolationKey::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<NetworkIsolationKey::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return NetworkIsolationKey::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::NetworkIsolationKey_UnserializedMessageContext<
            UserType, NetworkIsolationKey::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<NetworkIsolationKey::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  base::Optional<::url::Origin> top_frame_origin;
  
  base::Optional<::url::Origin> frame_origin;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
NetworkIsolationKeyPtr NetworkIsolationKey::Clone() const {
  return New(
      mojo::Clone(top_frame_origin),
      mojo::Clone(frame_origin)
  );
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>*>
bool NetworkIsolationKey::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->top_frame_origin, other_struct.top_frame_origin))
    return false;
  if (!mojo::Equals(this->frame_origin, other_struct.frame_origin))
    return false;
  return true;
}

template <typename T, NetworkIsolationKey::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.top_frame_origin < rhs.top_frame_origin)
    return true;
  if (rhs.top_frame_origin < lhs.top_frame_origin)
    return false;
  if (lhs.frame_origin < rhs.frame_origin)
    return true;
  if (rhs.frame_origin < lhs.frame_origin)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct  StructTraits<::network::mojom::NetworkIsolationKey::DataView,
                                         ::network::mojom::NetworkIsolationKeyPtr> {
  static bool IsNull(const ::network::mojom::NetworkIsolationKeyPtr& input) { return !input; }
  static void SetToNull(::network::mojom::NetworkIsolationKeyPtr* output) { output->reset(); }

  static const decltype(::network::mojom::NetworkIsolationKey::top_frame_origin)& top_frame_origin(
      const ::network::mojom::NetworkIsolationKeyPtr& input) {
    return input->top_frame_origin;
  }

  static const decltype(::network::mojom::NetworkIsolationKey::frame_origin)& frame_origin(
      const ::network::mojom::NetworkIsolationKeyPtr& input) {
    return input->frame_origin;
  }

  static bool Read(::network::mojom::NetworkIsolationKey::DataView input, ::network::mojom::NetworkIsolationKeyPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_ISOLATION_KEY_MOJOM_H_