// services/preferences/public/mojom/preferences.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "services/preferences/public/mojom/preferences.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"

#include "services/preferences/public/mojom/preferences.mojom-params-data.h"
namespace prefs {
namespace mojom {

std::ostream& operator<<(std::ostream& os, TrackedPreferenceMetadata_EnforcementLevel value) {
  switch(value) {
    case TrackedPreferenceMetadata_EnforcementLevel::NO_ENFORCEMENT:
      return os << "TrackedPreferenceMetadata_EnforcementLevel::NO_ENFORCEMENT";
    case TrackedPreferenceMetadata_EnforcementLevel::ENFORCE_ON_LOAD:
      return os << "TrackedPreferenceMetadata_EnforcementLevel::ENFORCE_ON_LOAD";
    default:
      return os << "Unknown TrackedPreferenceMetadata_EnforcementLevel value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, TrackedPreferenceMetadata_PrefTrackingStrategy value) {
  switch(value) {
    case TrackedPreferenceMetadata_PrefTrackingStrategy::ATOMIC:
      return os << "TrackedPreferenceMetadata_PrefTrackingStrategy::ATOMIC";
    case TrackedPreferenceMetadata_PrefTrackingStrategy::SPLIT:
      return os << "TrackedPreferenceMetadata_PrefTrackingStrategy::SPLIT";
    default:
      return os << "Unknown TrackedPreferenceMetadata_PrefTrackingStrategy value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, TrackedPreferenceMetadata_ValueType value) {
  switch(value) {
    case TrackedPreferenceMetadata_ValueType::IMPERSONAL:
      return os << "TrackedPreferenceMetadata_ValueType::IMPERSONAL";
    case TrackedPreferenceMetadata_ValueType::PERSONAL:
      return os << "TrackedPreferenceMetadata_ValueType::PERSONAL";
    default:
      return os << "Unknown TrackedPreferenceMetadata_ValueType value: " << static_cast<int32_t>(value);
  }
}

namespace internal {


// static
bool TrackedPersistentPrefStoreConfiguration_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const TrackedPersistentPrefStoreConfiguration_Data* object = static_cast<const TrackedPersistentPrefStoreConfiguration_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 88 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->unprotected_pref_filename, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->unprotected_pref_filename, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->protected_pref_filename, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->protected_pref_filename, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->tracking_configuration, 3, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams tracking_configuration_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->tracking_configuration, validation_context,
                                         &tracking_configuration_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->seed, 5, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams seed_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->seed, validation_context,
                                         &seed_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->legacy_device_id, 6, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams legacy_device_id_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->legacy_device_id, validation_context,
                                         &legacy_device_id_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->registry_seed, 7, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams registry_seed_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->registry_seed, validation_context,
                                         &registry_seed_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->registry_path, 8, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->registry_path, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterface(object->validation_delegate,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterface(object->reset_on_load_observer,
                                                 validation_context)) {
    return false;
  }

  return true;
}

TrackedPersistentPrefStoreConfiguration_Data::TrackedPersistentPrefStoreConfiguration_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool TrackedPreferenceMetadata_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const TrackedPreferenceMetadata_Data* object = static_cast<const TrackedPreferenceMetadata_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 40 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->name, 2, validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams name_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateContainer(object->name, validation_context,
                                         &name_validate_params)) {
    return false;
  }


  if (!::prefs::mojom::internal::TrackedPreferenceMetadata_EnforcementLevel_Data
        ::Validate(object->enforcement_level, validation_context))
    return false;


  if (!::prefs::mojom::internal::TrackedPreferenceMetadata_PrefTrackingStrategy_Data
        ::Validate(object->strategy, validation_context))
    return false;


  if (!::prefs::mojom::internal::TrackedPreferenceMetadata_ValueType_Data
        ::Validate(object->value_type, validation_context))
    return false;

  return true;
}

TrackedPreferenceMetadata_Data::TrackedPreferenceMetadata_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ResetOnLoadObserver_OnResetOnLoad_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const ResetOnLoadObserver_OnResetOnLoad_Params_Data* object = static_cast<const ResetOnLoadObserver_OnResetOnLoad_Params_Data*>(data);

  static constexpr struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[base::size(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = base::size(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[base::size(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

ResetOnLoadObserver_OnResetOnLoad_Params_Data::ResetOnLoadObserver_OnResetOnLoad_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace prefs

#if defined(_MSC_VER)
#pragma warning(pop)
#endif