// third_party/blink/public/mojom/feature_policy/feature_policy.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_FEATURE_POLICY_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_FEATURE_POLICY_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/feature_policy/feature_policy.mojom-shared-internal.h"
#include "url/mojom/origin.mojom-shared.h"
#include "third_party/blink/public/mojom/feature_policy/feature_policy_feature.mojom-shared.h"
#include "third_party/blink/public/mojom/feature_policy/policy_value.mojom-shared.h"



#include "base/component_export.h"




namespace blink {
namespace mojom {
class ParsedFeaturePolicyDeclarationDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::ParsedFeaturePolicyDeclarationDataView> {
  using Data = ::blink::mojom::internal::ParsedFeaturePolicyDeclaration_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


enum class WebSandboxFlags : int32_t {
  
  kNone = 0,
  
  kNavigation = 1,
  
  kPlugins = 2,
  
  kOrigin = 4,
  
  kForms = 8,
  
  kScripts = 16,
  
  kTopNavigation = 32,
  
  kPopups = 64,
  
  kAutomaticFeatures = 128,
  
  kPointerLock = 256,
  
  kDocumentDomain = 512,
  
  kOrientationLock = 1024,
  
  kPropagatesToAuxiliaryBrowsingContexts = 2048,
  
  kModals = 4096,
  
  kPresentationController = 8192,
  
  kTopNavigationByUserActivation = 16384,
  
  kDownloads = 32768,
  
  kStorageAccessByUserActivation = 65536,
  kMinValue = 0,
  kMaxValue = 65536,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, WebSandboxFlags value);
inline bool IsKnownEnumValue(WebSandboxFlags value) {
  return internal::WebSandboxFlags_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class FeaturePolicyDisposition : int32_t {
  
  kEnforce,
  
  kReport,
  kMinValue = 0,
  kMaxValue = 1,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, FeaturePolicyDisposition value);
inline bool IsKnownEnumValue(FeaturePolicyDisposition value) {
  return internal::FeaturePolicyDisposition_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
class ParsedFeaturePolicyDeclarationDataView {
 public:
  ParsedFeaturePolicyDeclarationDataView() {}

  ParsedFeaturePolicyDeclarationDataView(
      internal::ParsedFeaturePolicyDeclaration_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFeature(UserType* output) const {
    auto data_value = data_->feature;
    return mojo::internal::Deserialize<::blink::mojom::FeaturePolicyFeature>(
        data_value, output);
  }

  ::blink::mojom::FeaturePolicyFeature feature() const {
    return static_cast<::blink::mojom::FeaturePolicyFeature>(data_->feature);
  }
  inline void GetValuesDataView(
      mojo::MapDataView<::url::mojom::OriginDataView, ::blink::mojom::PolicyValueDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValues(UserType* output) {
    auto* pointer = data_->values.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<::url::mojom::OriginDataView, ::blink::mojom::PolicyValueDataView>>(
        pointer, output, context_);
  }
  inline void GetFallbackValueDataView(
      ::blink::mojom::PolicyValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFallbackValue(UserType* output) {
    auto* pointer = data_->fallback_value.Get();
    return mojo::internal::Deserialize<::blink::mojom::PolicyValueDataView>(
        pointer, output, context_);
  }
  inline void GetOpaqueValueDataView(
      ::blink::mojom::PolicyValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOpaqueValue(UserType* output) {
    auto* pointer = data_->opaque_value.Get();
    return mojo::internal::Deserialize<::blink::mojom::PolicyValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::ParsedFeaturePolicyDeclaration_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::WebSandboxFlags>
    : public mojo::internal::EnumHashImpl<::blink::mojom::WebSandboxFlags> {};

template <>
struct hash<::blink::mojom::FeaturePolicyDisposition>
    : public mojo::internal::EnumHashImpl<::blink::mojom::FeaturePolicyDisposition> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::blink::mojom::WebSandboxFlags, ::blink::mojom::WebSandboxFlags> {
  static ::blink::mojom::WebSandboxFlags ToMojom(::blink::mojom::WebSandboxFlags input) { return input; }
  static bool FromMojom(::blink::mojom::WebSandboxFlags input, ::blink::mojom::WebSandboxFlags* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::WebSandboxFlags, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::WebSandboxFlags, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::WebSandboxFlags>(input), output);
  }
};

}  // namespace internal


template <>
struct EnumTraits<::blink::mojom::FeaturePolicyDisposition, ::blink::mojom::FeaturePolicyDisposition> {
  static ::blink::mojom::FeaturePolicyDisposition ToMojom(::blink::mojom::FeaturePolicyDisposition input) { return input; }
  static bool FromMojom(::blink::mojom::FeaturePolicyDisposition input, ::blink::mojom::FeaturePolicyDisposition* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::FeaturePolicyDisposition, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::FeaturePolicyDisposition, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::FeaturePolicyDisposition>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ParsedFeaturePolicyDeclarationDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ParsedFeaturePolicyDeclarationDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::ParsedFeaturePolicyDeclaration_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    mojo::internal::Serialize<::blink::mojom::FeaturePolicyFeature>(
        Traits::feature(input), &(*output)->feature);
    decltype(Traits::values(input)) in_values = Traits::values(input);
    typename decltype((*output)->values)::BaseType::BufferWriter
        values_writer;
    const mojo::internal::ContainerValidateParams values_validate_params(
        new mojo::internal::ContainerValidateParams(0, false, nullptr), new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::MapDataView<::url::mojom::OriginDataView, ::blink::mojom::PolicyValueDataView>>(
        in_values, buffer, &values_writer, &values_validate_params,
        context);
    (*output)->values.Set(
        values_writer.is_null() ? nullptr : values_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->values.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null values in ParsedFeaturePolicyDeclaration struct");
    decltype(Traits::fallback_value(input)) in_fallback_value = Traits::fallback_value(input);
    typename decltype((*output)->fallback_value)::BaseType::BufferWriter
        fallback_value_writer;
    mojo::internal::Serialize<::blink::mojom::PolicyValueDataView>(
        in_fallback_value, buffer, &fallback_value_writer, context);
    (*output)->fallback_value.Set(
        fallback_value_writer.is_null() ? nullptr : fallback_value_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->fallback_value.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null fallback_value in ParsedFeaturePolicyDeclaration struct");
    decltype(Traits::opaque_value(input)) in_opaque_value = Traits::opaque_value(input);
    typename decltype((*output)->opaque_value)::BaseType::BufferWriter
        opaque_value_writer;
    mojo::internal::Serialize<::blink::mojom::PolicyValueDataView>(
        in_opaque_value, buffer, &opaque_value_writer, context);
    (*output)->opaque_value.Set(
        opaque_value_writer.is_null() ? nullptr : opaque_value_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->opaque_value.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null opaque_value in ParsedFeaturePolicyDeclaration struct");
  }

  static bool Deserialize(::blink::mojom::internal::ParsedFeaturePolicyDeclaration_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ParsedFeaturePolicyDeclarationDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void ParsedFeaturePolicyDeclarationDataView::GetValuesDataView(
    mojo::MapDataView<::url::mojom::OriginDataView, ::blink::mojom::PolicyValueDataView>* output) {
  auto pointer = data_->values.Get();
  *output = mojo::MapDataView<::url::mojom::OriginDataView, ::blink::mojom::PolicyValueDataView>(pointer, context_);
}
inline void ParsedFeaturePolicyDeclarationDataView::GetFallbackValueDataView(
    ::blink::mojom::PolicyValueDataView* output) {
  auto pointer = data_->fallback_value.Get();
  *output = ::blink::mojom::PolicyValueDataView(pointer, context_);
}
inline void ParsedFeaturePolicyDeclarationDataView::GetOpaqueValueDataView(
    ::blink::mojom::PolicyValueDataView* output) {
  auto pointer = data_->opaque_value.Get();
  *output = ::blink::mojom::PolicyValueDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FEATURE_POLICY_FEATURE_POLICY_MOJOM_SHARED_H_