// third_party/blink/public/mojom/frame/frame.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_TEST_UTILS_H_

#include "third_party/blink/public/mojom/frame/frame.mojom.h"
#include "third_party/blink/public/common/common_export.h"


namespace blink {
namespace mojom {


class BLINK_COMMON_EXPORT LocalFrameHostInterceptorForTesting : public LocalFrameHost {
  virtual LocalFrameHost* GetForwardingInterface() = 0;
  void EnterFullscreen(::blink::mojom::FullscreenOptionsPtr options) override;
  void ExitFullscreen() override;
  void FullscreenStateChanged(bool is_fullscreen) override;
  void RegisterProtocolHandler(const std::string& scheme, const ::GURL& url, const ::base::string16& title, bool user_gesture) override;
  void UnregisterProtocolHandler(const std::string& scheme, const ::GURL& url, bool user_gesture) override;
  void DidDisplayInsecureContent() override;
  void DidContainInsecureFormAction() override;
  void DocumentAvailableInMainFrame(bool uses_temporary_zoom_level) override;
  void SetNeedsOcclusionTracking(bool needs_tracking) override;
  void LifecycleStateChanged(::blink::mojom::FrameLifecycleState state) override;
  void EvictFromBackForwardCache() override;
  void VisibilityChanged(::blink::mojom::FrameVisibility visibility) override;
  void DidChangeThemeColor(const base::Optional<::SkColor>& theme_color) override;
  void DidFocusFrame() override;
  void EnforceInsecureRequestPolicy(uint8_t policy_bitmap) override;
  void EnforceInsecureNavigationsSet(const std::vector<uint32_t>& set) override;
  void DidChangeActiveSchedulerTrackedFeatures(uint64_t features_mask) override;
  void SuddenTerminationDisablerChanged(bool present, ::blink::mojom::SuddenTerminationDisablerType disabler_type) override;
  void HadStickyUserActivationBeforeNavigationChanged(bool has_gesture) override;
  void ScrollRectToVisibleInParentFrame(const ::gfx::Rect& rect_to_scroll, ::blink::mojom::ScrollIntoViewParamsPtr params) override;
  void BubbleLogicalScrollInParentFrame(::blink::mojom::ScrollDirection direction, ::ui::input_types::ScrollGranularity granularity) override;
  void DidAccessInitialDocument() override;
  void DidBlockNavigation(const ::GURL& blocked_url, const ::GURL& initiator_url, ::blink::mojom::NavigationBlockedReason reason) override;
  void DidChangeLoadProgress(double load_progress) override;
  void DispatchLoad() override;
  void GoToEntryAtOffset(int32_t offset, bool has_user_gesture) override;
  void RenderFallbackContentInParentProcess() override;
  void HandleAccessibilityFindInPageResult(FindInPageResultAXParamsPtr params) override;
  void HandleAccessibilityFindInPageTermination() override;
  void DocumentOnLoadCompleted() override;
  void ForwardResourceTimingToParent(::blink::mojom::ResourceTimingInfoPtr timing) override;
  void DidFinishDocumentLoad() override;
  void RunModalAlertDialog(const ::base::string16& alert_message, RunModalAlertDialogCallback callback) override;
  void RunModalConfirmDialog(const ::base::string16& alert_message, RunModalConfirmDialogCallback callback) override;
  void RunModalPromptDialog(const ::base::string16& alert_message, const ::base::string16& default_value, RunModalPromptDialogCallback callback) override;
  void RunBeforeUnloadConfirm(bool is_reload, RunBeforeUnloadConfirmCallback callback) override;
};
class BLINK_COMMON_EXPORT LocalFrameHostAsyncWaiter {
 public:
  explicit LocalFrameHostAsyncWaiter(LocalFrameHost* proxy);
  ~LocalFrameHostAsyncWaiter();
  void RunModalAlertDialog(
      const ::base::string16& alert_message);
  void RunModalConfirmDialog(
      const ::base::string16& alert_message, bool* out_success);
  void RunModalPromptDialog(
      const ::base::string16& alert_message, const ::base::string16& default_value, bool* out_success, ::base::string16* out_result);
  void RunBeforeUnloadConfirm(
      bool is_reload, bool* out_success);

 private:
  LocalFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalFrameHostAsyncWaiter);
};


class BLINK_COMMON_EXPORT LocalFrameInterceptorForTesting : public LocalFrame {
  virtual LocalFrame* GetForwardingInterface() = 0;
  void GetTextSurroundingSelection(uint32_t max_length, GetTextSurroundingSelectionCallback callback) override;
  void SendInterventionReport(const std::string& id, const std::string& message) override;
  void NotifyUserActivation() override;
  void AddMessageToConsole(::blink::mojom::ConsoleMessageLevel level, const std::string& message, bool discard_duplicates) override;
  void CheckCompleted() override;
  void Collapse(bool collapsed) override;
  void EnableViewSourceMode() override;
  void Focus() override;
  void ClearFocusedElement() override;
  void CopyImageAt(const ::gfx::Point& window_point) override;
  void SaveImageAt(const ::gfx::Point& window_point) override;
  void ReportBlinkFeatureUsage(const std::vector<::blink::mojom::WebFeature>& features) override;
  void RenderFallbackContent() override;
  void BeforeUnload(bool is_reload, BeforeUnloadCallback callback) override;
  void MediaPlayerActionAt(const ::gfx::Point& location, ::blink::mojom::MediaPlayerActionPtr action) override;
  void AdvanceFocusInForm(::blink::mojom::FocusType focus_type) override;
};
class BLINK_COMMON_EXPORT LocalFrameAsyncWaiter {
 public:
  explicit LocalFrameAsyncWaiter(LocalFrame* proxy);
  ~LocalFrameAsyncWaiter();
  void GetTextSurroundingSelection(
      uint32_t max_length, ::base::string16* out_content, uint32_t* out_start_offset, uint32_t* out_end_offset);
  void BeforeUnload(
      bool is_reload, bool* out_proceed, ::base::TimeTicks* out_before_unload_start_time, ::base::TimeTicks* out_before_unload_end_time);

 private:
  LocalFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalFrameAsyncWaiter);
};


class BLINK_COMMON_EXPORT RemoteFrameHostInterceptorForTesting : public RemoteFrameHost {
  virtual RemoteFrameHost* GetForwardingInterface() = 0;
  void SetInheritedEffectiveTouchAction(::cc::TouchAction touch_action) override;
  void VisibilityChanged(::blink::mojom::FrameVisibility visibility) override;
  void DidFocusFrame() override;
  void CheckCompleted() override;
};
class BLINK_COMMON_EXPORT RemoteFrameHostAsyncWaiter {
 public:
  explicit RemoteFrameHostAsyncWaiter(RemoteFrameHost* proxy);
  ~RemoteFrameHostAsyncWaiter();

 private:
  RemoteFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteFrameHostAsyncWaiter);
};


class BLINK_COMMON_EXPORT RemoteFrameInterceptorForTesting : public RemoteFrame {
  virtual RemoteFrame* GetForwardingInterface() = 0;
  void WillEnterFullscreen() override;
  void AddReplicatedContentSecurityPolicies(std::vector<::network::mojom::ContentSecurityPolicyHeaderPtr> headers) override;
  void ResetReplicatedContentSecurityPolicy() override;
  void EnforceInsecureNavigationsSet(const std::vector<uint32_t>& set) override;
  void SetReplicatedOrigin(const ::url::Origin& origin, bool is_potentially_trustworthy_unique_origin) override;
  void SetReplicatedAdFrameType(::blink::mojom::AdFrameType ad_frame_type) override;
  void DispatchLoadEventForFrameOwner() override;
  void SetNeedsOcclusionTracking(bool needs_tracking) override;
  void Collapse(bool collapsed) override;
  void Focus() override;
  void SetHadStickyUserActivationBeforeNavigation(bool has_gesture) override;
  void BubbleLogicalScroll(::blink::mojom::ScrollDirection direction, ::ui::input_types::ScrollGranularity granularity) override;
  void UpdateUserActivationState(::blink::mojom::UserActivationUpdateType state_update_type) override;
  void SetEmbeddingToken(const ::base::UnguessableToken& embedding_token) override;
  void SetPageFocus(bool is_focused) override;
  void RenderFallbackContent() override;
  void AddResourceTimingFromChild(::blink::mojom::ResourceTimingInfoPtr timing) override;
  void ScrollRectToVisible(const ::gfx::Rect& rect, ::blink::mojom::ScrollIntoViewParamsPtr params) override;
  void DidStartLoading() override;
  void DidStopLoading() override;
  void IntrinsicSizingInfoOfChildChanged(::blink::mojom::IntrinsicSizingInfoPtr sizing_info) override;
};
class BLINK_COMMON_EXPORT RemoteFrameAsyncWaiter {
 public:
  explicit RemoteFrameAsyncWaiter(RemoteFrame* proxy);
  ~RemoteFrameAsyncWaiter();

 private:
  RemoteFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteFrameAsyncWaiter);
};




}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_TEST_UTILS_H_