// Copyright (c) 2020 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "chrome/common/extensions/api/generated_schemas.h"

namespace {
const char kAccessibilityFeatures[] = "{\"namespace\":\"accessibilityFeatures\",\"properties\":{\"spokenFeedback\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"spokenFeedback\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"largeCursor\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"largeCursor\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"stickyKeys\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"stickyKeys\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"highContrast\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"highContrast\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"screenMagnifier\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"screenMagnifier\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"autoclick\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"autoclick\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"virtualKeyboard\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"virtualKeyboard\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"caretHighlight\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"caretHighlight\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"cursorHighlight\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"cursorHighlight\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"focusHighlight\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"focusHighlight\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"selectToSpeak\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"selectToSpeak\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"switchAccess\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"switchAccess\",{\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},\"animationPolicy\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"animationPolicy\",{\"type\":\"string\",\"enum\":[{\"name\":\"allowed\"},{\"name\":\"once\"},{\"name\":\"none\"}]}]}}}";
const char kAccessibilityPrivate[] = "{\"namespace\":\"accessibilityPrivate\",\"types\":[{\"id\":\"accessibilityPrivate.AlertInfo\",\"type\":\"object\",\"properties\":{\"message\":{\"type\":\"string\"}}},{\"id\":\"accessibilityPrivate.ScreenRect\",\"type\":\"object\",\"properties\":{\"left\":{\"type\":\"integer\"},\"top\":{\"type\":\"integer\"},\"width\":{\"type\":\"integer\"},\"height\":{\"type\":\"integer\"}}},{\"id\":\"accessibilityPrivate.Gesture\",\"type\":\"string\",\"enum\":[\"click\",\"swipeLeft1\",\"swipeUp1\",\"swipeRight1\",\"swipeDown1\",\"swipeLeft2\",\"swipeUp2\",\"swipeRight2\",\"swipeDown2\",\"swipeLeft3\",\"swipeUp3\",\"swipeRight3\",\"swipeDown3\",\"swipeLeft4\",\"swipeUp4\",\"swipeRight4\",\"swipeDown4\",\"tap2\",\"tap3\",\"tap4\"]},{\"id\":\"accessibilityPrivate.SwitchAccessCommand\",\"type\":\"string\",\"enum\":[\"select\",\"next\",\"previous\"]},{\"id\":\"accessibilityPrivate.SyntheticKeyboardEventType\",\"type\":\"string\",\"enum\":[\"keyup\",\"keydown\"]},{\"id\":\"accessibilityPrivate.SyntheticKeyboardModifiers\",\"type\":\"object\",\"properties\":{\"ctrl\":{\"type\":\"boolean\",\"optional\":true},\"alt\":{\"type\":\"boolean\",\"optional\":true},\"search\":{\"type\":\"boolean\",\"optional\":true},\"shift\":{\"type\":\"boolean\",\"optional\":true}}},{\"id\":\"accessibilityPrivate.SyntheticKeyboardEvent\",\"type\":\"object\",\"properties\":{\"type\":{\"$ref\":\"accessibilityPrivate.SyntheticKeyboardEventType\"},\"keyCode\":{\"type\":\"integer\"},\"modifiers\":{\"$ref\":\"accessibilityPrivate.SyntheticKeyboardModifiers\",\"optional\":true}}},{\"id\":\"accessibilityPrivate.SyntheticMouseEventType\",\"type\":\"string\",\"enum\":[\"press\",\"release\",\"drag\",\"move\",\"enter\",\"exit\"]},{\"id\":\"accessibilityPrivate.SyntheticMouseEvent\",\"type\":\"object\",\"properties\":{\"type\":{\"$ref\":\"accessibilityPrivate.SyntheticMouseEventType\"},\"x\":{\"type\":\"integer\"},\"y\":{\"type\":\"integer\"}}},{\"id\":\"accessibilityPrivate.SelectToSpeakState\",\"type\":\"string\",\"enum\":[\"selecting\",\"speaking\",\"inactive\"]},{\"id\":\"accessibilityPrivate.FocusType\",\"type\":\"string\",\"enum\":[\"glow\",\"solid\",\"dashed\"]},{\"id\":\"accessibilityPrivate.FocusRingInfo\",\"type\":\"object\",\"properties\":{\"rects\":{\"type\":\"array\",\"items\":{\"$ref\":\"accessibilityPrivate.ScreenRect\"}},\"type\":{\"$ref\":\"accessibilityPrivate.FocusType\"},\"color\":{\"type\":\"string\"},\"secondaryColor\":{\"type\":\"string\",\"optional\":true},\"id\":{\"type\":\"string\",\"optional\":true}}}],\"functions\":[{\"name\":\"getDisplayNameForLocale\",\"type\":\"function\",\"parameters\":[{\"name\":\"localeCodeToTranslate\",\"type\":\"string\"},{\"name\":\"displayLocaleCode\",\"type\":\"string\"}],\"returns\":{\"type\":\"string\"},\"platforms\":[\"chromeos\"]},{\"name\":\"getBatteryDescription\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"batteryDescription\",\"type\":\"string\"}]}],\"platforms\":[\"chromeos\"]},{\"name\":\"setNativeAccessibilityEnabled\",\"type\":\"function\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}]},{\"name\":\"setFocusRings\",\"type\":\"function\",\"parameters\":[{\"name\":\"focusRings\",\"type\":\"array\",\"items\":{\"$ref\":\"accessibilityPrivate.FocusRingInfo\"}}]},{\"name\":\"setHighlights\",\"type\":\"function\",\"parameters\":[{\"name\":\"rects\",\"type\":\"array\",\"items\":{\"$ref\":\"accessibilityPrivate.ScreenRect\"}},{\"name\":\"color\",\"type\":\"string\"}]},{\"name\":\"setKeyboardListener\",\"type\":\"function\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"},{\"type\":\"boolean\",\"name\":\"capture\"}]},{\"name\":\"darkenScreen\",\"type\":\"function\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}]},{\"name\":\"setSwitchAccessMenuState\",\"type\":\"function\",\"parameters\":[{\"name\":\"show\",\"type\":\"boolean\"},{\"name\":\"element_bounds\",\"$ref\":\"accessibilityPrivate.ScreenRect\"},{\"name\":\"item_count\",\"type\":\"integer\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"forwardKeyEventsToSwitchAccess\",\"type\":\"function\",\"parameters\":[{\"name\":\"shouldForward\",\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"setNativeChromeVoxArcSupportForCurrentApp\",\"type\":\"function\",\"parameters\":[{\"name\":\"enabled\",\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"sendSyntheticKeyEvent\",\"type\":\"function\",\"parameters\":[{\"name\":\"keyEvent\",\"$ref\":\"accessibilityPrivate.SyntheticKeyboardEvent\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"enableChromeVoxMouseEvents\",\"type\":\"function\",\"parameters\":[{\"name\":\"enabled\",\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"sendSyntheticMouseEvent\",\"type\":\"function\",\"parameters\":[{\"name\":\"mouseEvent\",\"$ref\":\"accessibilityPrivate.SyntheticMouseEvent\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"onSelectToSpeakStateChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"state\",\"$ref\":\"accessibilityPrivate.SelectToSpeakState\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"onScrollableBoundsForPointFound\",\"type\":\"function\",\"parameters\":[{\"name\":\"rect\",\"$ref\":\"accessibilityPrivate.ScreenRect\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"toggleDictation\",\"type\":\"function\",\"parameters\":[],\"platforms\":[\"chromeos\"]},{\"name\":\"setVirtualKeyboardVisible\",\"type\":\"function\",\"parameters\":[{\"name\":\"isVisible\",\"type\":\"boolean\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"openSettingsSubpage\",\"type\":\"function\",\"parameters\":[{\"name\":\"subpage\",\"type\":\"string\"}],\"platforms\":[\"chromeos\"]}],\"events\":[{\"name\":\"onIntroduceChromeVox\",\"type\":\"function\"},{\"name\":\"onAccessibilityGesture\",\"type\":\"function\",\"parameters\":[{\"name\":\"gesture\",\"$ref\":\"accessibilityPrivate.Gesture\"}]},{\"name\":\"onTwoFingerTouchStart\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"onTwoFingerTouchStop\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"onSelectToSpeakStateChangeRequested\",\"type\":\"function\",\"parameters\":[],\"platforms\":[\"chromeos\"]},{\"name\":\"onSwitchAccessCommand\",\"type\":\"function\",\"parameters\":[{\"name\":\"command\",\"$ref\":\"accessibilityPrivate.SwitchAccessCommand\"}],\"platforms\":[\"chromeos\"]},{\"name\":\"onAnnounceForAccessibility\",\"type\":\"function\",\"parameters\":[{\"name\":\"announceText\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}],\"platforms\":[\"chromeos\"]},{\"name\":\"findScrollableBoundsForPoint\",\"type\":\"function\",\"parameters\":[{\"name\":\"x\",\"type\":\"number\"},{\"name\":\"y\",\"type\":\"number\"}],\"platforms\":[\"chromeos\"]}]}";
const char kActivityLogPrivate[] = "{\"namespace\":\"activityLogPrivate\",\"types\":[{\"id\":\"activityLogPrivate.ExtensionActivityType\",\"type\":\"string\",\"enum\":[\"api_call\",\"api_event\",\"content_script\",\"dom_access\",\"dom_event\",\"web_request\"]},{\"id\":\"activityLogPrivate.ExtensionActivityFilter\",\"type\":\"string\",\"enum\":[\"api_call\",\"api_event\",\"content_script\",\"dom_access\",\"dom_event\",\"web_request\",\"any\"]},{\"id\":\"activityLogPrivate.ExtensionActivityDomVerb\",\"type\":\"string\",\"enum\":[\"getter\",\"setter\",\"method\",\"inserted\",\"xhr\",\"webrequest\",\"modified\"]},{\"id\":\"activityLogPrivate.ExtensionActivity\",\"type\":\"object\",\"properties\":{\"activityId\":{\"type\":\"string\",\"optional\":true},\"extensionId\":{\"type\":\"string\",\"optional\":true},\"activityType\":{\"$ref\":\"activityLogPrivate.ExtensionActivityType\"},\"time\":{\"type\":\"number\",\"optional\":true},\"apiCall\":{\"type\":\"string\",\"optional\":true},\"args\":{\"type\":\"string\",\"optional\":true},\"count\":{\"type\":\"number\",\"optional\":true},\"pageUrl\":{\"type\":\"string\",\"optional\":true},\"pageTitle\":{\"type\":\"string\",\"optional\":true},\"argUrl\":{\"type\":\"string\",\"optional\":true},\"other\":{\"type\":\"object\",\"optional\":true,\"properties\":{\"prerender\":{\"type\":\"boolean\",\"optional\":true},\"domVerb\":{\"$ref\":\"activityLogPrivate.ExtensionActivityDomVerb\",\"optional\":true},\"webRequest\":{\"type\":\"string\",\"optional\":true},\"extra\":{\"type\":\"string\",\"optional\":true}}}}},{\"id\":\"activityLogPrivate.Filter\",\"type\":\"object\",\"properties\":{\"extensionId\":{\"type\":\"string\",\"optional\":true},\"activityType\":{\"$ref\":\"activityLogPrivate.ExtensionActivityFilter\"},\"apiCall\":{\"type\":\"string\",\"optional\":true},\"pageUrl\":{\"type\":\"string\",\"optional\":true},\"argUrl\":{\"type\":\"string\",\"optional\":true},\"daysAgo\":{\"type\":\"integer\",\"optional\":true}}},{\"id\":\"activityLogPrivate.ActivityResultSet\",\"type\":\"object\",\"properties\":{\"activities\":{\"type\":\"array\",\"items\":{\"$ref\":\"activityLogPrivate.ExtensionActivity\"}}}}],\"functions\":[{\"name\":\"getExtensionActivities\",\"type\":\"function\",\"parameters\":[{\"name\":\"filter\",\"$ref\":\"activityLogPrivate.Filter\"},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"activityLogPrivate.ActivityResultSet\"}]}]},{\"name\":\"deleteActivities\",\"type\":\"function\",\"parameters\":[{\"name\":\"activityIds\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"deleteActivitiesByExtension\",\"type\":\"function\",\"parameters\":[{\"name\":\"extensionId\",\"type\":\"string\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"deleteDatabase\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"deleteUrls\",\"type\":\"function\",\"parameters\":[{\"name\":\"urls\",\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true}]}],\"events\":[{\"name\":\"onExtensionActivity\",\"type\":\"function\",\"parameters\":[{\"name\":\"activity\",\"$ref\":\"activityLogPrivate.ExtensionActivity\"}]}]}";
const char kCastStreamingReceiverSession[] = "{\"functions\":[{\"parameters\":[{\"$ref\":\"cast.streaming.receiverSession.RtpReceiverParams\",\"name\":\"audioParams\"},{\"$ref\":\"cast.streaming.receiverSession.RtpReceiverParams\",\"name\":\"videoParams\"},{\"$ref\":\"cast.streaming.receiverSession.IPEndPoint\",\"name\":\"localEndpoint\"},{\"type\":\"integer\",\"name\":\"maxWidth\"},{\"type\":\"integer\",\"name\":\"maxHeight\"},{\"type\":\"number\",\"name\":\"maxFrameRate\"},{\"type\":\"string\",\"name\":\"mediaStreamURL\"},{\"type\":\"function\",\"name\":\"error_callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"error\"}]},{\"additionalProperties\":{\"type\":\"any\"},\"optional\":true,\"type\":\"object\",\"name\":\"transport_options\"}],\"name\":\"createAndBind\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"cast.streaming.receiverSession\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"cast.streaming.receiverSession.IPEndPoint\",\"properties\":{\"address\":{\"name\":\"address\",\"type\":\"string\"},\"port\":{\"name\":\"port\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"cast.streaming.receiverSession.RtpReceiverParams\",\"properties\":{\"maxLatency\":{\"name\":\"maxLatency\",\"type\":\"integer\"},\"codecName\":{\"name\":\"codecName\",\"type\":\"string\"},\"senderSsrc\":{\"name\":\"senderSsrc\",\"type\":\"integer\"},\"receiverSsrc\":{\"name\":\"receiverSsrc\",\"type\":\"integer\"},\"rtpTimebase\":{\"optional\":true,\"name\":\"rtpTimebase\",\"type\":\"integer\"},\"aesKey\":{\"optional\":true,\"name\":\"aesKey\",\"type\":\"string\"},\"aesIvMask\":{\"optional\":true,\"name\":\"aesIvMask\",\"type\":\"string\"}}}]}";
const char kCastStreamingRtpStream[] = "{\"functions\":[{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"}],\"name\":\"destroy\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"}],\"returns\":{\"items\":{\"$ref\":\"cast.streaming.rtpStream.RtpParams\"},\"type\":\"array\",\"name\":\"getSupportedParams\"},\"name\":\"getSupportedParams\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"},{\"$ref\":\"cast.streaming.rtpStream.RtpParams\",\"name\":\"params\"}],\"name\":\"start\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"}],\"name\":\"stop\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"},{\"type\":\"boolean\",\"name\":\"enable\"}],\"name\":\"toggleLogging\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"},{\"optional\":true,\"type\":\"string\",\"name\":\"extraData\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"binary\",\"name\":\"rawEvents\",\"isInstanceOf\":\"ArrayBuffer\"}]}],\"name\":\"getRawEvents\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"stats\"}]}],\"name\":\"getStats\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"}],\"name\":\"onStarted\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"}],\"name\":\"onStopped\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"streamId\"},{\"type\":\"string\",\"name\":\"errorString\"}],\"name\":\"onError\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"cast.streaming.rtpStream\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"cast.streaming.rtpStream.CodecSpecificParams\",\"properties\":{\"key\":{\"name\":\"key\",\"type\":\"string\"},\"value\":{\"name\":\"value\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"cast.streaming.rtpStream.RtpPayloadParams\",\"properties\":{\"payloadType\":{\"name\":\"payloadType\",\"type\":\"integer\"},\"maxLatency\":{\"name\":\"maxLatency\",\"type\":\"integer\"},\"minLatency\":{\"optional\":true,\"name\":\"minLatency\",\"type\":\"integer\"},\"animatedLatency\":{\"optional\":true,\"name\":\"animatedLatency\",\"type\":\"integer\"},\"codecName\":{\"name\":\"codecName\",\"type\":\"string\"},\"ssrc\":{\"name\":\"ssrc\",\"type\":\"integer\"},\"feedbackSsrc\":{\"name\":\"feedbackSsrc\",\"type\":\"integer\"},\"clockRate\":{\"optional\":true,\"name\":\"clockRate\",\"type\":\"integer\"},\"minBitrate\":{\"optional\":true,\"name\":\"minBitrate\",\"type\":\"integer\"},\"maxBitrate\":{\"optional\":true,\"name\":\"maxBitrate\",\"type\":\"integer\"},\"channels\":{\"optional\":true,\"name\":\"channels\",\"type\":\"integer\"},\"maxFrameRate\":{\"optional\":true,\"name\":\"maxFrameRate\",\"type\":\"number\"},\"aesKey\":{\"optional\":true,\"name\":\"aesKey\",\"type\":\"string\"},\"aesIvMask\":{\"optional\":true,\"name\":\"aesIvMask\",\"type\":\"string\"},\"codecSpecificParams\":{\"name\":\"codecSpecificParams\",\"type\":\"array\",\"items\":{\"$ref\":\"cast.streaming.rtpStream.CodecSpecificParams\"}}}},{\"type\":\"object\",\"id\":\"cast.streaming.rtpStream.RtpParams\",\"properties\":{\"payload\":{\"name\":\"payload\",\"$ref\":\"cast.streaming.rtpStream.RtpPayloadParams\"},\"rtcpFeatures\":{\"name\":\"rtcpFeatures\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}}}]}";
const char kCastStreamingSession[] = "{\"functions\":[{\"allowAmbiguousOptionalArguments\":true,\"parameters\":[{\"name\":\"audioTrack\",\"optional\":true,\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"isInstanceOf\":\"MediaStreamTrack\"},{\"name\":\"videoTrack\",\"optional\":true,\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"isInstanceOf\":\"MediaStreamTrack\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"integer\",\"name\":\"audioStreamId\"},{\"type\":\"integer\",\"name\":\"videoStreamId\"},{\"type\":\"integer\",\"name\":\"udpTransportId\"}]}],\"name\":\"create\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"cast.streaming.session\",\"properties\":{},\"types\":[]}";
const char kCastStreamingUdpTransport[] = "{\"functions\":[{\"parameters\":[{\"type\":\"integer\",\"name\":\"transportId\"}],\"name\":\"destroy\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"transportId\"},{\"$ref\":\"cast.streaming.udpTransport.IPEndPoint\",\"name\":\"destination\"}],\"name\":\"setDestination\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"transportId\"},{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"options\"}],\"name\":\"setOptions\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"cast.streaming.udpTransport\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"cast.streaming.udpTransport.IPEndPoint\",\"properties\":{\"address\":{\"name\":\"address\",\"type\":\"string\"},\"port\":{\"name\":\"port\",\"type\":\"integer\"}}}]}";
const char kAutofillPrivate[] = "{\"functions\":[{\"parameters\":[{\"$ref\":\"autofillPrivate.AddressEntry\",\"name\":\"address\"}],\"name\":\"saveAddress\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"autofillPrivate.CountryEntry\"},\"type\":\"array\",\"name\":\"countries\"}]}],\"name\":\"getCountryList\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"countryCode\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"components\",\"$ref\":\"autofillPrivate.AddressComponents\"}]}],\"name\":\"getAddressComponents\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"autofillPrivate.AddressEntry\"},\"type\":\"array\",\"name\":\"entries\"}]}],\"name\":\"getAddressList\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autofillPrivate.CreditCardEntry\",\"name\":\"card\"}],\"name\":\"saveCreditCard\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"guid\"}],\"name\":\"removeEntry\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autofillPrivate.ValidatePhoneParams\",\"name\":\"params\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"type\":\"string\"},\"type\":\"array\",\"name\":\"validatedPhoneNumbers\"}]}],\"name\":\"validatePhoneNumbers\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"autofillPrivate.CreditCardEntry\"},\"type\":\"array\",\"name\":\"entries\"}]}],\"name\":\"getCreditCardList\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"guid\"}],\"name\":\"maskCreditCard\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"migrateCreditCards\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"logServerCardLinkClicked\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}],\"name\":\"setCreditCardFIDOAuthEnabledState\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"items\":{\"$ref\":\"autofillPrivate.AddressEntry\"},\"type\":\"array\",\"name\":\"addressEntries\"},{\"items\":{\"$ref\":\"autofillPrivate.CreditCardEntry\"},\"type\":\"array\",\"name\":\"creditCardEntries\"}],\"name\":\"onPersonalDataChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"autofillPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"FULL_NAME\"},{\"name\":\"COMPANY_NAME\"},{\"name\":\"ADDRESS_LINES\"},{\"name\":\"ADDRESS_LEVEL_1\"},{\"name\":\"ADDRESS_LEVEL_2\"},{\"name\":\"ADDRESS_LEVEL_3\"},{\"name\":\"POSTAL_CODE\"},{\"name\":\"SORTING_CODE\"},{\"name\":\"COUNTRY_CODE\"}],\"type\":\"string\",\"id\":\"autofillPrivate.AddressField\"},{\"type\":\"object\",\"id\":\"autofillPrivate.AutofillMetadata\",\"properties\":{\"summaryLabel\":{\"name\":\"summaryLabel\",\"type\":\"string\"},\"summarySublabel\":{\"optional\":true,\"name\":\"summarySublabel\",\"type\":\"string\"},\"isLocal\":{\"optional\":true,\"name\":\"isLocal\",\"type\":\"boolean\"},\"isCached\":{\"optional\":true,\"name\":\"isCached\",\"type\":\"boolean\"},\"isMigratable\":{\"optional\":true,\"name\":\"isMigratable\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autofillPrivate.AddressEntry\",\"properties\":{\"guid\":{\"optional\":true,\"name\":\"guid\",\"type\":\"string\"},\"fullNames\":{\"optional\":true,\"name\":\"fullNames\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"companyName\":{\"optional\":true,\"name\":\"companyName\",\"type\":\"string\"},\"addressLines\":{\"optional\":true,\"name\":\"addressLines\",\"type\":\"string\"},\"addressLevel1\":{\"optional\":true,\"name\":\"addressLevel1\",\"type\":\"string\"},\"addressLevel2\":{\"optional\":true,\"name\":\"addressLevel2\",\"type\":\"string\"},\"addressLevel3\":{\"optional\":true,\"name\":\"addressLevel3\",\"type\":\"string\"},\"postalCode\":{\"optional\":true,\"name\":\"postalCode\",\"type\":\"string\"},\"sortingCode\":{\"optional\":true,\"name\":\"sortingCode\",\"type\":\"string\"},\"countryCode\":{\"optional\":true,\"name\":\"countryCode\",\"type\":\"string\"},\"phoneNumbers\":{\"optional\":true,\"name\":\"phoneNumbers\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"emailAddresses\":{\"optional\":true,\"name\":\"emailAddresses\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"languageCode\":{\"optional\":true,\"name\":\"languageCode\",\"type\":\"string\"},\"metadata\":{\"optional\":true,\"name\":\"metadata\",\"$ref\":\"autofillPrivate.AutofillMetadata\"}}},{\"type\":\"object\",\"id\":\"autofillPrivate.CountryEntry\",\"properties\":{\"name\":{\"optional\":true,\"name\":\"name\",\"type\":\"string\"},\"countryCode\":{\"optional\":true,\"name\":\"countryCode\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"autofillPrivate.AddressComponent\",\"properties\":{\"field\":{\"name\":\"field\",\"$ref\":\"autofillPrivate.AddressField\"},\"fieldName\":{\"name\":\"fieldName\",\"type\":\"string\"},\"isLongField\":{\"name\":\"isLongField\",\"type\":\"boolean\"},\"placeholder\":{\"optional\":true,\"name\":\"placeholder\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"autofillPrivate.AddressComponentRow\",\"properties\":{\"row\":{\"name\":\"row\",\"type\":\"array\",\"items\":{\"$ref\":\"autofillPrivate.AddressComponent\"}}}},{\"type\":\"object\",\"id\":\"autofillPrivate.AddressComponents\",\"properties\":{\"components\":{\"name\":\"components\",\"type\":\"array\",\"items\":{\"$ref\":\"autofillPrivate.AddressComponentRow\"}},\"languageCode\":{\"name\":\"languageCode\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"autofillPrivate.CreditCardEntry\",\"properties\":{\"guid\":{\"optional\":true,\"name\":\"guid\",\"type\":\"string\"},\"name\":{\"optional\":true,\"name\":\"name\",\"type\":\"string\"},\"cardNumber\":{\"optional\":true,\"name\":\"cardNumber\",\"type\":\"string\"},\"expirationMonth\":{\"optional\":true,\"name\":\"expirationMonth\",\"type\":\"string\"},\"expirationYear\":{\"optional\":true,\"name\":\"expirationYear\",\"type\":\"string\"},\"metadata\":{\"optional\":true,\"name\":\"metadata\",\"$ref\":\"autofillPrivate.AutofillMetadata\"}}},{\"type\":\"object\",\"id\":\"autofillPrivate.ValidatePhoneParams\",\"properties\":{\"phoneNumbers\":{\"name\":\"phoneNumbers\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"indexOfNewNumber\":{\"name\":\"indexOfNewNumber\",\"type\":\"integer\"},\"countryCode\":{\"name\":\"countryCode\",\"type\":\"string\"}}}]}";
const char kAutotestPrivate[] = "{\"functions\":[{\"parameters\":[],\"name\":\"initializeEvents\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"logout\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"restart\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"force\"}],\"name\":\"shutdown\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"status\",\"$ref\":\"autotestPrivate.LoginStatusDict\"}]}],\"name\":\"loginStatus\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"lockScreen\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"autotestPrivate.ExtensionsInfoArray\"}]}],\"name\":\"getExtensionsInfo\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"any\",\"name\":\"all_policies\"}]}],\"name\":\"getAllEnterprisePolicies\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"refreshEnterprisePolicies\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"simulateAsanMemoryBug\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"value\"}],\"name\":\"setTouchpadSensitivity\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}],\"name\":\"setTapToClick\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}],\"name\":\"setThreeFingerClick\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}],\"name\":\"setTapDragging\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}],\"name\":\"setNaturalScroll\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"value\"}],\"name\":\"setMouseSensitivity\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"right\"}],\"name\":\"setPrimaryButtonRight\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}],\"name\":\"setMouseReverseScroll\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"autotestPrivate.Notification\"},\"type\":\"array\",\"name\":\"notifications\"}]}],\"name\":\"getVisibleNotifications\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"number\",\"name\":\"startTime\"}]}],\"name\":\"getArcStartTime\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"autotestPrivate.ArcState\"}]}],\"name\":\"getArcState\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"autotestPrivate.PlayStoreState\"}]}],\"name\":\"getPlayStoreState\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"autotestPrivate.Printer\"},\"type\":\"array\",\"name\":\"printers\"}]}],\"name\":\"getPrinterList\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"appId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"appShown\"}]}],\"name\":\"isAppShown\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"arcProvisioned\"}]}],\"name\":\"isArcProvisioned\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"appId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"package\",\"$ref\":\"autotestPrivate.ArcAppDict\"}]}],\"name\":\"getArcApp\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"packageName\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"package\",\"$ref\":\"autotestPrivate.ArcPackageDict\"}]}],\"name\":\"getArcPackage\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"appId\"},{\"type\":\"string\",\"name\":\"intent\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"appLaunched\"}]}],\"name\":\"launchArcApp\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"appId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"launchApp\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"appId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"closeApp\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"printer\",\"$ref\":\"autotestPrivate.Printer\"}],\"name\":\"updatePrinter\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"printerId\"}],\"name\":\"removePrinter\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setPlayStoreEnabled\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"name\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"histogram\",\"$ref\":\"autotestPrivate.Histogram\"}]}],\"name\":\"getHistogram\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"data\"}]}],\"name\":\"getClipboardTextData\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"data\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setClipboardTextData\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"runCrostiniInstaller\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"runCrostiniUninstaller\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setCrostiniEnabled\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"path\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"exportCrostini\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"path\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"importCrostini\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"imageUrl\"},{\"type\":\"string\",\"name\":\"imageHash\"},{\"type\":\"string\",\"name\":\"licenseKey\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"installPluginVM\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"name\"},{\"type\":\"string\",\"name\":\"path\"}],\"name\":\"registerComponent\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"base64Png\"}]}],\"name\":\"takeScreenshot\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"display_id\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"base64Png\"}]}],\"name\":\"takeScreenshotForDisplay\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"bootstrapMachineLearningService\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"},{\"type\":\"integer\",\"name\":\"timeout_ms\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setAssistantEnabled\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"enableAssistantAndWaitForReady\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"query\"},{\"type\":\"integer\",\"name\":\"timeout_ms\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"status\",\"$ref\":\"autotestPrivate.AssistantQueryStatus\"}]}],\"name\":\"sendAssistantTextQuery\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"timeout_s\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"status\",\"$ref\":\"autotestPrivate.AssistantQueryStatus\"}]}],\"name\":\"waitForAssistantQueryStatus\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"refreshed\"}]}],\"name\":\"isArcPackageListInitialRefreshed\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"pref_name\"},{\"type\":\"any\",\"name\":\"value\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setWhitelistedPref\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"appId\"},{\"type\":\"boolean\",\"name\":\"scaled\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setCrostiniAppScaled\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"number\",\"name\":\"scaleFactor\"}]}],\"name\":\"getPrimaryDisplayScaleFactor\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}]}],\"name\":\"isTabletModeEnabled\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}]}],\"name\":\"setTabletModeEnabled\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callb" "ack\",\"parameters\":[{\"items\":{\"$ref\":\"autotestPrivate.App\"},\"type\":\"array\",\"name\":\"apps\"}]}],\"name\":\"getAllInstalledApps\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"autotestPrivate.ShelfItem\"},\"type\":\"array\",\"name\":\"items\"}]}],\"name\":\"getShelfItems\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"displayId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"behavior\"}]}],\"name\":\"getShelfAutoHideBehavior\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"displayId\"},{\"type\":\"string\",\"name\":\"behavior\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setShelfAutoHideBehavior\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"displayId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"alignment\",\"$ref\":\"autotestPrivate.ShelfAlignmentType\"}]}],\"name\":\"getShelfAlignment\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"displayId\"},{\"$ref\":\"autotestPrivate.ShelfAlignmentType\",\"name\":\"alignment\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setShelfAlignment\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"start\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"finished\"}]}],\"name\":\"setOverviewModeState\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"showVirtualKeyboardIfEnabled\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"arcAppTracingStart\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"autotestPrivate.ArcAppTracingInfo\"}]}],\"name\":\"arcAppTracingStopAndAnalyze\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"swapWindowsInSplitView\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"packageName\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setArcAppWindowFocus\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"displayId\"},{\"$ref\":\"autotestPrivate.RotationType\",\"name\":\"rotation\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"success\"}]}],\"name\":\"waitForDisplayRotation\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"autotestPrivate.AppWindowInfo\"},\"type\":\"array\",\"name\":\"window_list\"}]}],\"name\":\"getAppWindowList\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"id\"},{\"$ref\":\"autotestPrivate.WindowStateChangeDict\",\"name\":\"change\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"currentType\",\"$ref\":\"autotestPrivate.WindowStateType\"}]}],\"name\":\"setAppWindowState\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"closeAppWindow\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"timeout_ms\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"appId\"}]}],\"name\":\"installPWAForCurrentURL\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autotestPrivate.Accelerator\",\"name\":\"accelerator\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"success\"}]}],\"name\":\"activateAccelerator\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autotestPrivate.LauncherStateType\",\"name\":\"launcherState\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"waitForLauncherState\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"success\"}]}],\"name\":\"createNewDesk\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"index\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"success\"}]}],\"name\":\"activateDeskAtIndex\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"success\"}]}],\"name\":\"removeActiveDesk\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autotestPrivate.MouseButton\",\"name\":\"button\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"mouseClick\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autotestPrivate.MouseButton\",\"name\":\"button\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"mousePress\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autotestPrivate.MouseButton\",\"name\":\"button\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"mouseRelease\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autotestPrivate.Location\",\"name\":\"location\"},{\"type\":\"number\",\"name\":\"duration_in_ms\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"mouseMove\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setMetricsEnabled\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"autotestPrivate.TraceConfig\",\"name\":\"config\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"startTracing\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"completeCallback\",\"parameters\":[{\"type\":\"string\",\"name\":\"data\"}]}],\"name\":\"stopTracing\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setArcTouchMode\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[],\"name\":\"onClipboardDataChanged\",\"type\":\"function\"}],\"platforms\":[\"chromeos\"],\"internal\":false,\"namespace\":\"autotestPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"Bottom\"},{\"name\":\"Left\"},{\"name\":\"Right\"}],\"type\":\"string\",\"id\":\"autotestPrivate.ShelfAlignmentType\"},{\"enum\":[{\"name\":\"App\"},{\"name\":\"PinnedApp\"},{\"name\":\"BrowserShortcut\"},{\"name\":\"Dialog\"}],\"type\":\"string\",\"id\":\"autotestPrivate.ShelfItemType\"},{\"enum\":[{\"name\":\"Closed\"},{\"name\":\"Running\"},{\"name\":\"Attention\"}],\"type\":\"string\",\"id\":\"autotestPrivate.ShelfItemStatus\"},{\"enum\":[{\"name\":\"Arc\"},{\"name\":\"BuiltIn\"},{\"name\":\"Crostini\"},{\"name\":\"Extension\"},{\"name\":\"Web\"},{\"name\":\"MacNative\"}],\"type\":\"string\",\"id\":\"autotestPrivate.AppType\"},{\"enum\":[{\"name\":\"Ready\"},{\"name\":\"DisabledByBlacklist\"},{\"name\":\"DisabledByPolicy\"},{\"name\":\"DisabledByUser\"},{\"name\":\"Terminated\"},{\"name\":\"UninstalledByUser\"}],\"type\":\"string\",\"id\":\"autotestPrivate.AppReadiness\"},{\"enum\":[{\"name\":\"Normal\"},{\"name\":\"Minimized\"},{\"name\":\"Maximized\"},{\"name\":\"Fullscreen\"},{\"name\":\"LeftSnapped\"},{\"name\":\"RightSnapped\"},{\"name\":\"PIP\"}],\"type\":\"string\",\"id\":\"autotestPrivate.WindowStateType\"},{\"enum\":[{\"name\":\"WMEventNormal\"},{\"name\":\"WMEventMaximize\"},{\"name\":\"WMEventMinimize\"},{\"name\":\"WMEventFullscreen\"},{\"name\":\"WMEventSnapLeft\"},{\"name\":\"WMEventSnapRight\"}],\"type\":\"string\",\"id\":\"autotestPrivate.WMEventType\"},{\"enum\":[{\"name\":\"Rotate0\"},{\"name\":\"Rotate90\"},{\"name\":\"Rotate180\"},{\"name\":\"Rotate270\"}],\"type\":\"string\",\"id\":\"autotestPrivate.RotationType\"},{\"enum\":[{\"name\":\"Closed\"},{\"name\":\"Peeking\"},{\"name\":\"Half\"},{\"name\":\"FullscreenAllApps\"},{\"name\":\"FullscreenSearch\"}],\"type\":\"string\",\"id\":\"autotestPrivate.LauncherStateType\"},{\"enum\":[{\"name\":\"Left\"},{\"name\":\"Middle\"},{\"name\":\"Right\"}],\"type\":\"string\",\"id\":\"autotestPrivate.MouseButton\"},{\"type\":\"object\",\"id\":\"autotestPrivate.WindowStateChangeDict\",\"properties\":{\"eventType\":{\"name\":\"eventType\",\"$ref\":\"autotestPrivate.WMEventType\"},\"failIfNoChange\":{\"optional\":true,\"name\":\"failIfNoChange\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.LoginStatusDict\",\"properties\":{\"isLoggedIn\":{\"name\":\"isLoggedIn\",\"type\":\"boolean\"},\"isOwner\":{\"name\":\"isOwner\",\"type\":\"boolean\"},\"isScreenLocked\":{\"name\":\"isScreenLocked\",\"type\":\"boolean\"},\"isReadyForPassword\":{\"name\":\"isReadyForPassword\",\"type\":\"boolean\"},\"isRegularUser\":{\"name\":\"isRegularUser\",\"type\":\"boolean\"},\"isGuest\":{\"name\":\"isGuest\",\"type\":\"boolean\"},\"isKiosk\":{\"name\":\"isKiosk\",\"type\":\"boolean\"},\"email\":{\"name\":\"email\",\"type\":\"string\"},\"displayEmail\":{\"name\":\"displayEmail\",\"type\":\"string\"},\"userImage\":{\"name\":\"userImage\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.ExtensionInfoDict\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"string\"},\"version\":{\"name\":\"version\",\"type\":\"string\"},\"name\":{\"name\":\"name\",\"type\":\"string\"},\"publicKey\":{\"name\":\"publicKey\",\"type\":\"string\"},\"descript" "ion\":{\"name\":\"description\",\"type\":\"string\"},\"backgroundUrl\":{\"name\":\"backgroundUrl\",\"type\":\"string\"},\"optionsUrl\":{\"name\":\"optionsUrl\",\"type\":\"string\"},\"hostPermissions\":{\"name\":\"hostPermissions\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"effectiveHostPermissions\":{\"name\":\"effectiveHostPermissions\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"apiPermissions\":{\"name\":\"apiPermissions\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"isComponent\":{\"name\":\"isComponent\",\"type\":\"boolean\"},\"isInternal\":{\"name\":\"isInternal\",\"type\":\"boolean\"},\"isUserInstalled\":{\"name\":\"isUserInstalled\",\"type\":\"boolean\"},\"isEnabled\":{\"name\":\"isEnabled\",\"type\":\"boolean\"},\"allowedInIncognito\":{\"name\":\"allowedInIncognito\",\"type\":\"boolean\"},\"hasPageAction\":{\"name\":\"hasPageAction\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.ExtensionsInfoArray\",\"properties\":{\"extensions\":{\"name\":\"extensions\",\"type\":\"array\",\"items\":{\"$ref\":\"autotestPrivate.ExtensionInfoDict\"}}}},{\"type\":\"object\",\"id\":\"autotestPrivate.Notification\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"string\"},\"type\":{\"name\":\"type\",\"type\":\"string\"},\"title\":{\"name\":\"title\",\"type\":\"string\"},\"message\":{\"name\":\"message\",\"type\":\"string\"},\"priority\":{\"name\":\"priority\",\"type\":\"integer\"},\"progress\":{\"name\":\"progress\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.Printer\",\"properties\":{\"printerName\":{\"name\":\"printerName\",\"type\":\"string\"},\"printerId\":{\"optional\":true,\"name\":\"printerId\",\"type\":\"string\"},\"printerType\":{\"optional\":true,\"name\":\"printerType\",\"type\":\"string\"},\"printerDesc\":{\"optional\":true,\"name\":\"printerDesc\",\"type\":\"string\"},\"printerMakeAndModel\":{\"optional\":true,\"name\":\"printerMakeAndModel\",\"type\":\"string\"},\"printerUri\":{\"optional\":true,\"name\":\"printerUri\",\"type\":\"string\"},\"printerPpd\":{\"optional\":true,\"name\":\"printerPpd\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.ArcState\",\"properties\":{\"provisioned\":{\"name\":\"provisioned\",\"type\":\"boolean\"},\"tosNeeded\":{\"name\":\"tosNeeded\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.PlayStoreState\",\"properties\":{\"allowed\":{\"name\":\"allowed\",\"type\":\"boolean\"},\"enabled\":{\"optional\":true,\"name\":\"enabled\",\"type\":\"boolean\"},\"managed\":{\"optional\":true,\"name\":\"managed\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.HistogramBucket\",\"properties\":{\"min\":{\"name\":\"min\",\"type\":\"integer\"},\"max\":{\"name\":\"max\",\"type\":\"integer\"},\"count\":{\"name\":\"count\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.Histogram\",\"properties\":{\"sum\":{\"name\":\"sum\",\"type\":\"number\"},\"buckets\":{\"name\":\"buckets\",\"type\":\"array\",\"items\":{\"$ref\":\"autotestPrivate.HistogramBucket\"}}}},{\"type\":\"object\",\"id\":\"autotestPrivate.AssistantQueryResponse\",\"properties\":{\"text\":{\"optional\":true,\"name\":\"text\",\"type\":\"string\"},\"htmlResponse\":{\"optional\":true,\"name\":\"htmlResponse\",\"type\":\"string\"},\"htmlFallback\":{\"optional\":true,\"name\":\"htmlFallback\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.AssistantQueryStatus\",\"properties\":{\"isMicOpen\":{\"name\":\"isMicOpen\",\"type\":\"boolean\"},\"queryText\":{\"name\":\"queryText\",\"type\":\"string\"},\"queryResponse\":{\"name\":\"queryResponse\",\"$ref\":\"autotestPrivate.AssistantQueryResponse\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.ArcAppDict\",\"properties\":{\"name\":{\"name\":\"name\",\"type\":\"string\"},\"packageName\":{\"name\":\"packageName\",\"type\":\"string\"},\"activity\":{\"name\":\"activity\",\"type\":\"string\"},\"intentUri\":{\"name\":\"intentUri\",\"type\":\"string\"},\"iconResourceId\":{\"name\":\"iconResourceId\",\"type\":\"string\"},\"lastLaunchTime\":{\"name\":\"lastLaunchTime\",\"type\":\"number\"},\"installTime\":{\"name\":\"installTime\",\"type\":\"number\"},\"sticky\":{\"name\":\"sticky\",\"type\":\"boolean\"},\"notificationsEnabled\":{\"name\":\"notificationsEnabled\",\"type\":\"boolean\"},\"ready\":{\"name\":\"ready\",\"type\":\"boolean\"},\"suspended\":{\"name\":\"suspended\",\"type\":\"boolean\"},\"showInLauncher\":{\"name\":\"showInLauncher\",\"type\":\"boolean\"},\"shortcut\":{\"name\":\"shortcut\",\"type\":\"boolean\"},\"launchable\":{\"name\":\"launchable\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.ArcPackageDict\",\"properties\":{\"packageName\":{\"name\":\"packageName\",\"type\":\"string\"},\"packageVersion\":{\"name\":\"packageVersion\",\"type\":\"integer\"},\"lastBackupAndroidId\":{\"name\":\"lastBackupAndroidId\",\"type\":\"string\"},\"lastBackupTime\":{\"name\":\"lastBackupTime\",\"type\":\"number\"},\"shouldSync\":{\"name\":\"shouldSync\",\"type\":\"boolean\"},\"system\":{\"name\":\"system\",\"type\":\"boolean\"},\"vpnProvider\":{\"name\":\"vpnProvider\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.Location\",\"properties\":{\"x\":{\"name\":\"x\",\"type\":\"number\"},\"y\":{\"name\":\"y\",\"type\":\"number\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.Bounds\",\"properties\":{\"left\":{\"name\":\"left\",\"type\":\"number\"},\"top\":{\"name\":\"top\",\"type\":\"number\"},\"width\":{\"name\":\"width\",\"type\":\"number\"},\"height\":{\"name\":\"height\",\"type\":\"number\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.ArcAppTracingInfo\",\"properties\":{\"success\":{\"name\":\"success\",\"type\":\"boolean\"},\"fps\":{\"name\":\"fps\",\"type\":\"number\"},\"commitDeviation\":{\"name\":\"commitDeviation\",\"type\":\"number\"},\"renderQuality\":{\"name\":\"renderQuality\",\"type\":\"number\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.App\",\"properties\":{\"appId\":{\"name\":\"appId\",\"type\":\"string\"},\"name\":{\"name\":\"name\",\"type\":\"string\"},\"shortName\":{\"name\":\"shortName\",\"type\":\"string\"},\"type\":{\"optional\":true,\"name\":\"type\",\"$ref\":\"autotestPrivate.AppType\"},\"readiness\":{\"optional\":true,\"name\":\"readiness\",\"$ref\":\"autotestPrivate.AppReadiness\"},\"additionalSearchTerms\":{\"name\":\"additionalSearchTerms\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"showInLauncher\":{\"optional\":true,\"name\":\"showInLauncher\",\"type\":\"boolean\"},\"showInSearch\":{\"optional\":true,\"name\":\"showInSearch\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.ShelfItem\",\"properties\":{\"appId\":{\"name\":\"appId\",\"type\":\"string\"},\"launchId\":{\"name\":\"launchId\",\"type\":\"string\"},\"title\":{\"name\":\"title\",\"type\":\"string\"},\"type\":{\"optional\":true,\"name\":\"type\",\"$ref\":\"autotestPrivate.ShelfItemType\"},\"status\":{\"name\":\"status\",\"$ref\":\"autotestPrivate.ShelfItemStatus\"},\"showsTooltip\":{\"name\":\"showsTooltip\",\"type\":\"boolean\"},\"pinnedByPolicy\":{\"name\":\"pinnedByPolicy\",\"type\":\"boolean\"},\"hasNotification\":{\"name\":\"hasNotification\",\"type\":\"boolean\"}}},{\"enum\":[{\"name\":\"Browser\"},{\"name\":\"ChromeApp\"},{\"name\":\"ArcApp\"},{\"name\":\"CrostiniApp\"},{\"name\":\"SystemApp\"},{\"name\":\"ExtensionApp\"}],\"type\":\"string\",\"id\":\"autotestPrivate.AppWindowType\"},{\"enum\":[{\"name\":\"Normal\"},{\"name\":\"Immersive\"}],\"type\":\"string\",\"id\":\"autotestPrivate.FrameMode\"},{\"type\":\"object\",\"id\":\"autotestPrivate.OverviewInfo\",\"properties\":{\"bounds\":{\"name\":\"bounds\",\"$ref\":\"autotestPrivate.Bounds\"},\"isDragged\":{\"name\":\"isDragged\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.AppWindowInfo\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"name\":{\"name\":\"name\",\"type\":\"string\"},\"windowType\":{\"name\":\"windowType\",\"$ref\":\"autotestPrivate.AppWindowType\"},\"stateType\":{\"name\":\"stateType\",\"$ref\":\"autotestPrivate.WindowStateType\"},\"boundsInRoot\":{\"name\":\"boundsInRoot\",\"$ref\":\"autotestPrivate.Bounds\"},\"displayId\":{\"name\":\"displayId\",\"type\":\"string\"},\"isVisible\":{\"name\":\"isVisible\",\"type\":\"boolean\"},\"canFocus\":{\"name\":\"canFocus\",\"type\":\"boolean\"},\"title\":{\"name\":\"title\",\"type\":\"string\"},\"isAnimating\":{\"name\":\"isAnimating\",\"type\":\"boolean\"},\"targetBounds\":{\"name\":\"targetBounds\",\"$ref\":\"autotestPrivate.Bounds\"},\"targetVisibility\":{\"name\":\"targetVisibility\",\"type\":\"boolean\"},\"isActive\":{\"name\":\"isActive\",\"type\":\"boolean\"},\"hasFocus\":{\"name\":\"hasFocus\",\"type\":\"boolean\"},\"onActiveDesk\":{\"name\":\"onActiveDesk\",\"type\":\"boolean\"},\"hasCapture\":{\"name\":\"hasCapture\",\"type\":\"boolean\"},\"canResize\":{\"name\":\"canResize\",\"type\":\"boolean\"},\"frameMode\":{\"name\":\"frameMode\",\"$ref\":\"autotestPrivate.FrameMode\"},\"isFrameVisible\":{\"name\":\"isFrameVisible\",\"type\":\"boolean\"},\"captionHeight\":{\"name\":\"captionHeight\",\"type\":\"integer\"},\"captionButtonEnabledStatus\":{\"name\":\"captionButtonEnabledStatus\",\"type\":\"integer\"},\"captionButtonVisibleStatus\":{\"name\":\"captionButtonVisibleStatus\",\"type\":\"integer\"},\"arcPackageName\":{\"optional\":true,\"name\":\"arcPackageName\",\"type\":\"string\"},\"overviewInfo\":{\"optional\":true,\"name\":\"overviewInfo\",\"$ref\":\"autotestPrivate.OverviewInfo\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.Accelerator\",\"pro" "perties\":{\"keyCode\":{\"name\":\"keyCode\",\"type\":\"string\"},\"shift\":{\"name\":\"shift\",\"type\":\"boolean\"},\"control\":{\"name\":\"control\",\"type\":\"boolean\"},\"alt\":{\"name\":\"alt\",\"type\":\"boolean\"},\"search\":{\"name\":\"search\",\"type\":\"boolean\"},\"pressed\":{\"name\":\"pressed\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"autotestPrivate.TraceConfig\",\"properties\":{\"record_mode\":{\"optional\":true,\"name\":\"record_mode\",\"type\":\"string\"},\"trace_buffer_size_in_events\":{\"optional\":true,\"name\":\"trace_buffer_size_in_events\",\"type\":\"integer\"},\"trace_buffer_size_in_kb\":{\"optional\":true,\"name\":\"trace_buffer_size_in_kb\",\"type\":\"integer\"},\"enable_systrace\":{\"optional\":true,\"name\":\"enable_systrace\",\"type\":\"boolean\"},\"enable_argument_filter\":{\"optional\":true,\"name\":\"enable_argument_filter\",\"type\":\"boolean\"},\"included_categories\":{\"optional\":true,\"name\":\"included_categories\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"excluded_categories\":{\"optional\":true,\"name\":\"excluded_categories\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"included_process_ids\":{\"optional\":true,\"name\":\"included_process_ids\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"enable_systrace_events\":{\"optional\":true,\"name\":\"enable_systrace_events\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}}}]}";
const char kBookmarkManagerPrivate[] = "{\"namespace\":\"bookmarkManagerPrivate\",\"types\":[{\"id\":\"bookmarkManagerPrivate.BookmarkNodeDataElement\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\",\"optional\":true},\"parentId\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\"},\"url\":{\"type\":\"string\",\"optional\":true},\"children\":{\"type\":\"array\",\"items\":{\"$ref\":\"bookmarkManagerPrivate.BookmarkNodeDataElement\"}}}},{\"id\":\"bookmarkManagerPrivate.BookmarkNodeData\",\"type\":\"object\",\"properties\":{\"sameProfile\":{\"type\":\"boolean\"},\"elements\":{\"type\":\"array\",\"items\":{\"$ref\":\"bookmarkManagerPrivate.BookmarkNodeDataElement\"}}}}],\"functions\":[{\"name\":\"copy\",\"type\":\"function\",\"parameters\":[{\"name\":\"idList\",\"type\":\"array\",\"items\":{\"type\":\"string\"},\"minItems\":1},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"cut\",\"type\":\"function\",\"parameters\":[{\"name\":\"idList\",\"type\":\"array\",\"items\":{\"type\":\"string\"},\"minItems\":1},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"paste\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"parentId\"},{\"name\":\"selectedIdList\",\"optional\":true,\"type\":\"array\",\"items\":{\"type\":\"string\"},\"minItems\":0},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"canPaste\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"parentId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"boolean\"}]}]},{\"name\":\"sortChildren\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"parentId\"}]},{\"name\":\"startDrag\",\"type\":\"function\",\"parameters\":[{\"name\":\"idList\",\"type\":\"array\",\"items\":{\"type\":\"string\"},\"minItems\":1},{\"name\":\"dragNodeIndex\",\"type\":\"integer\",\"minimum\":0},{\"name\":\"isFromTouch\",\"type\":\"boolean\"},{\"name\":\"x\",\"type\":\"integer\",\"minimum\":0},{\"name\":\"y\",\"type\":\"integer\",\"minimum\":0}]},{\"name\":\"drop\",\"type\":\"function\",\"parameters\":[{\"name\":\"parentId\",\"type\":\"string\"},{\"name\":\"index\",\"type\":\"integer\",\"minimum\":0,\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getSubtree\",\"type\":\"function\",\"parameters\":[{\"name\":\"id\",\"type\":\"string\"},{\"name\":\"foldersOnly\",\"type\":\"boolean\"},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}]}]},{\"name\":\"removeTrees\",\"type\":\"function\",\"parameters\":[{\"name\":\"idList\",\"type\":\"array\",\"items\":{\"type\":\"string\"},\"minItems\":1},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"undo\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"redo\",\"type\":\"function\",\"parameters\":[]}],\"events\":[{\"name\":\"onDragEnter\",\"type\":\"function\",\"parameters\":[{\"name\":\"bookmarkNodeData\",\"$ref\":\"bookmarkManagerPrivate.BookmarkNodeData\"}]},{\"name\":\"onDragLeave\",\"type\":\"function\",\"parameters\":[{\"name\":\"bookmarkNodeData\",\"$ref\":\"bookmarkManagerPrivate.BookmarkNodeData\"}]},{\"name\":\"onDrop\",\"type\":\"function\",\"parameters\":[{\"name\":\"bookmarkNodeData\",\"$ref\":\"bookmarkManagerPrivate.BookmarkNodeData\"}]}]}";
const char kBookmarks[] = "{\"namespace\":\"bookmarks\",\"properties\":{\"MAX_WRITE_OPERATIONS_PER_HOUR\":{\"value\":1000000,\"deprecated\":\"Bookmark write operations are no longer limited by Chrome.\",\"type\":\"integer\"},\"MAX_SUSTAINED_WRITE_OPERATIONS_PER_MINUTE\":{\"value\":1000000,\"deprecated\":\"Bookmark write operations are no longer limited by Chrome.\",\"type\":\"integer\"}},\"types\":[{\"id\":\"bookmarks.BookmarkTreeNodeUnmodifiable\",\"type\":\"string\",\"enum\":[\"managed\"]},{\"id\":\"bookmarks.BookmarkTreeNode\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\",\"minimum\":0},\"parentId\":{\"type\":\"string\",\"minimum\":0,\"optional\":true},\"index\":{\"type\":\"integer\",\"optional\":true},\"url\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\"},\"dateAdded\":{\"type\":\"number\",\"optional\":true},\"dateGroupModified\":{\"type\":\"number\",\"optional\":true},\"unmodifiable\":{\"$ref\":\"bookmarks.BookmarkTreeNodeUnmodifiable\",\"optional\":true},\"children\":{\"type\":\"array\",\"optional\":true,\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}}},{\"id\":\"bookmarks.CreateDetails\",\"inline_doc\":true,\"type\":\"object\",\"properties\":{\"parentId\":{\"type\":\"string\",\"serialized_type\":\"int64\",\"optional\":true},\"index\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"url\":{\"type\":\"string\",\"optional\":true}}}],\"functions\":[{\"name\":\"get\",\"type\":\"function\",\"parameters\":[{\"name\":\"idOrIdList\",\"choices\":[{\"type\":\"string\",\"serialized_type\":\"int64\"},{\"type\":\"array\",\"items\":{\"type\":\"string\",\"serialized_type\":\"int64\"},\"minItems\":1}]},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}]}]},{\"name\":\"getChildren\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"serialized_type\":\"int64\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}]}]},{\"name\":\"getRecent\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"minimum\":1,\"name\":\"numberOfItems\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}]}]},{\"name\":\"getTree\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}]}]},{\"name\":\"getSubTree\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"serialized_type\":\"int64\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}]}]},{\"name\":\"search\",\"type\":\"function\",\"parameters\":[{\"name\":\"query\",\"choices\":[{\"type\":\"string\"},{\"type\":\"object\",\"properties\":{\"query\":{\"type\":\"string\",\"optional\":true},\"url\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true}}}]},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}]}]},{\"name\":\"create\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"bookmarks.CreateDetails\",\"name\":\"bookmark\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"result\",\"$ref\":\"bookmarks.BookmarkTreeNode\"}]}]},{\"name\":\"move\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"serialized_type\":\"int64\",\"name\":\"id\"},{\"type\":\"object\",\"name\":\"destination\",\"properties\":{\"parentId\":{\"type\":\"string\",\"optional\":true},\"index\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"result\",\"$ref\":\"bookmarks.BookmarkTreeNode\"}]}]},{\"name\":\"update\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"serialized_type\":\"int64\",\"name\":\"id\"},{\"type\":\"object\",\"name\":\"changes\",\"properties\":{\"title\":{\"type\":\"string\",\"optional\":true},\"url\":{\"type\":\"string\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"result\",\"$ref\":\"bookmarks.BookmarkTreeNode\"}]}]},{\"name\":\"remove\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"serialized_type\":\"int64\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeTree\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"serialized_type\":\"int64\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"import\",\"type\":\"function\",\"nodoc\":\"true\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"export\",\"type\":\"function\",\"nodoc\":\"true\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]}],\"events\":[{\"name\":\"onCreated\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"$ref\":\"bookmarks.BookmarkTreeNode\",\"name\":\"bookmark\"}]},{\"name\":\"onRemoved\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"type\":\"object\",\"name\":\"removeInfo\",\"properties\":{\"parentId\":{\"type\":\"string\"},\"index\":{\"type\":\"integer\"},\"node\":{\"$ref\":\"bookmarks.BookmarkTreeNode\"}}}]},{\"name\":\"onChanged\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"type\":\"object\",\"name\":\"changeInfo\",\"properties\":{\"title\":{\"type\":\"string\"},\"url\":{\"type\":\"string\",\"optional\":true}}}]},{\"name\":\"onMoved\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"type\":\"object\",\"name\":\"moveInfo\",\"properties\":{\"parentId\":{\"type\":\"string\"},\"index\":{\"type\":\"integer\"},\"oldParentId\":{\"type\":\"string\"},\"oldIndex\":{\"type\":\"integer\"}}}]},{\"name\":\"onChildrenReordered\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"type\":\"object\",\"name\":\"reorderInfo\",\"properties\":{\"childIds\":{\"type\":\"array\",\"items\":{\"type\":\"string\"}}}}]},{\"name\":\"onImportBegan\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"onImportEnded\",\"type\":\"function\",\"parameters\":[]}]}";
const char kBrailleDisplayPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"brailleDisplayPrivate.DisplayState\"}]}],\"name\":\"getDisplayState\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"binary\",\"name\":\"cells\",\"isInstanceOf\":\"ArrayBuffer\"},{\"type\":\"integer\",\"name\":\"columns\"},{\"type\":\"integer\",\"name\":\"rows\"}],\"name\":\"writeDots\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"address\"}],\"name\":\"updateBluetoothBrailleDisplayAddress\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"name\":\"state\",\"$ref\":\"brailleDisplayPrivate.DisplayState\"}],\"name\":\"onDisplayStateChanged\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"event\",\"$ref\":\"brailleDisplayPrivate.KeyEvent\"}],\"name\":\"onKeyEvent\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"brailleDisplayPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"line_up\"},{\"name\":\"line_down\"},{\"name\":\"pan_left\"},{\"name\":\"pan_right\"},{\"name\":\"top\"},{\"name\":\"bottom\"},{\"name\":\"routing\"},{\"name\":\"secondary_routing\"},{\"name\":\"dots\"},{\"name\":\"chord\"},{\"name\":\"standard_key\"}],\"type\":\"string\",\"id\":\"brailleDisplayPrivate.KeyCommand\"},{\"type\":\"object\",\"id\":\"brailleDisplayPrivate.KeyEvent\",\"properties\":{\"command\":{\"name\":\"command\",\"$ref\":\"brailleDisplayPrivate.KeyCommand\"},\"displayPosition\":{\"optional\":true,\"name\":\"displayPosition\",\"type\":\"integer\"},\"brailleDots\":{\"optional\":true,\"name\":\"brailleDots\",\"type\":\"integer\"},\"standardKeyCode\":{\"optional\":true,\"name\":\"standardKeyCode\",\"type\":\"string\"},\"standardKeyChar\":{\"optional\":true,\"name\":\"standardKeyChar\",\"type\":\"string\"},\"spaceKey\":{\"optional\":true,\"name\":\"spaceKey\",\"type\":\"boolean\"},\"altKey\":{\"optional\":true,\"name\":\"altKey\",\"type\":\"boolean\"},\"shiftKey\":{\"optional\":true,\"name\":\"shiftKey\",\"type\":\"boolean\"},\"ctrlKey\":{\"optional\":true,\"name\":\"ctrlKey\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"brailleDisplayPrivate.DisplayState\",\"properties\":{\"available\":{\"name\":\"available\",\"type\":\"boolean\"},\"textRowCount\":{\"optional\":true,\"name\":\"textRowCount\",\"type\":\"integer\"},\"textColumnCount\":{\"optional\":true,\"name\":\"textColumnCount\",\"type\":\"integer\"}}}]}";
const char kChromeWebViewInternal[] = "{\"namespace\":\"chromeWebViewInternal\",\"dependencies\":[\"contextMenusInternal\",\"contextMenus\"],\"types\":[{\"id\":\"chromeWebViewInternal.ContextMenuItem\",\"type\":\"object\",\"properties\":{\"label\":{\"type\":\"string\",\"optional\":true},\"commandId\":{\"type\":\"integer\"}}}],\"functions\":[{\"name\":\"contextMenusCreate\",\"type\":\"function\",\"returns\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}]},\"parameters\":[{\"type\":\"integer\",\"name\":\"instanceId\"},{\"type\":\"object\",\"name\":\"createProperties\",\"properties\":{\"type\":{\"$ref\":\"contextMenus.ItemType\",\"optional\":true},\"id\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"checked\":{\"type\":\"boolean\",\"optional\":true},\"contexts\":{\"type\":\"array\",\"items\":{\"$ref\":\"contextMenus.ContextType\"},\"minItems\":1,\"optional\":true},\"visible\":{\"type\":\"boolean\",\"optional\":true},\"onclick\":{\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"info\",\"$ref\":\"contextMenusInternal.OnClickData\"}]},\"parentId\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"optional\":true},\"documentUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"targetUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"enabled\":{\"type\":\"boolean\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"contextMenusUpdate\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"instanceId\"},{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"name\":\"id\"},{\"type\":\"object\",\"name\":\"updateProperties\",\"properties\":{\"type\":{\"$ref\":\"contextMenus.ItemType\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"checked\":{\"type\":\"boolean\",\"optional\":true},\"contexts\":{\"type\":\"array\",\"items\":{\"$ref\":\"contextMenus.ContextType\"},\"minItems\":1,\"optional\":true},\"visible\":{\"type\":\"boolean\",\"optional\":true},\"onclick\":{\"type\":\"function\",\"optional\":true},\"parentId\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"optional\":true},\"documentUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"targetUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"enabled\":{\"type\":\"boolean\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"contextMenusRemove\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"instanceId\"},{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"name\":\"menuItemId\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"contextMenusRemoveAll\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"instanceId\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"showContextMenu\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"instanceId\"},{\"type\":\"integer\",\"name\":\"requestId\"},{\"type\":\"array\",\"name\":\"itemsToShow\",\"items\":{\"$ref\":\"chromeWebViewInternal.ContextMenuItem\"},\"optional\":true}]}],\"events\":[{\"name\":\"onClicked\",\"type\":\"function\",\"$ref\":\"contextMenusInternal.onClicked\"},{\"name\":\"onShow\",\"type\":\"function\",\"parameters\":[{\"name\":\"event\",\"type\":\"object\",\"properties\":{\"preventDefault\":{\"type\":\"function\",\"parameters\":[]}}}]}]}";
const char kCommandLinePrivate[] = "{\"namespace\":\"commandLinePrivate\",\"functions\":[{\"name\":\"hasSwitch\",\"type\":\"function\",\"parameters\":[{\"name\":\"name\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"type\":\"boolean\"}]}]}]}";
const char kContentSettings[] = "{\"namespace\":\"contentSettings\",\"types\":[{\"id\":\"contentSettings.ResourceIdentifier\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\"},\"description\":{\"type\":\"string\",\"optional\":true}}},{\"id\":\"contentSettings.Scope\",\"type\":\"string\",\"enum\":[\"regular\",\"incognito_session_only\"]},{\"id\":\"contentSettings.ContentSetting\",\"js_module\":\"ContentSetting\",\"type\":\"object\",\"functions\":[{\"name\":\"clear\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"scope\":{\"$ref\":\"contentSettings.Scope\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"get\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"primaryUrl\":{\"type\":\"string\"},\"secondaryUrl\":{\"type\":\"string\",\"optional\":true},\"resourceIdentifier\":{\"$ref\":\"contentSettings.ResourceIdentifier\",\"optional\":true},\"incognito\":{\"type\":\"boolean\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"setting\":{\"type\":\"any\"}}}]}]},{\"name\":\"set\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"primaryPattern\":{\"type\":\"string\"},\"secondaryPattern\":{\"type\":\"string\",\"optional\":true},\"resourceIdentifier\":{\"$ref\":\"contentSettings.ResourceIdentifier\",\"optional\":true},\"setting\":{\"type\":\"any\"},\"scope\":{\"$ref\":\"contentSettings.Scope\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getResourceIdentifiers\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"resourceIdentifiers\",\"type\":\"array\",\"optional\":true,\"items\":{\"$ref\":\"contentSettings.ResourceIdentifier\"}}]}]}]},{\"id\":\"contentSettings.CookiesContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"session_only\"]},{\"id\":\"contentSettings.ImagesContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\"]},{\"id\":\"contentSettings.JavascriptContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\"]},{\"id\":\"contentSettings.LocationContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"ask\"]},{\"id\":\"contentSettings.PluginsContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"detect_important_content\"]},{\"id\":\"contentSettings.PopupsContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\"]},{\"id\":\"contentSettings.NotificationsContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"ask\"]},{\"id\":\"contentSettings.FullscreenContentSetting\",\"type\":\"string\",\"enum\":[\"allow\"]},{\"id\":\"contentSettings.MouselockContentSetting\",\"type\":\"string\",\"enum\":[\"allow\"]},{\"id\":\"contentSettings.MicrophoneContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"ask\"]},{\"id\":\"contentSettings.CameraContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"ask\"]},{\"id\":\"contentSettings.PpapiBrokerContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"ask\"]},{\"id\":\"contentSettings.MultipleAutomaticDownloadsContentSetting\",\"type\":\"string\",\"enum\":[\"allow\",\"block\",\"ask\"]}],\"properties\":{\"cookies\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"cookies\",{\"$ref\":\"contentSettings.CookiesContentSetting\"}]},\"images\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"images\",{\"$ref\":\"contentSettings.ImagesContentSetting\"}]},\"javascript\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"javascript\",{\"$ref\":\"contentSettings.JavascriptContentSetting\"}]},\"location\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"geolocation\",{\"$ref\":\"contentSettings.LocationContentSetting\"}]},\"plugins\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"plugins\",{\"$ref\":\"contentSettings.PluginsContentSetting\"}]},\"popups\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"popups\",{\"$ref\":\"contentSettings.PopupsContentSetting\"}]},\"notifications\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"notifications\",{\"$ref\":\"contentSettings.NotificationsContentSetting\"}]},\"fullscreen\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"fullscreen\",{\"$ref\":\"contentSettings.FullscreenContentSetting\"}]},\"mouselock\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"mouselock\",{\"$ref\":\"contentSettings.MouselockContentSetting\"}]},\"microphone\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"media-stream-mic\",{\"$ref\":\"contentSettings.MicrophoneContentSetting\"}]},\"camera\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"media-stream-camera\",{\"$ref\":\"contentSettings.CameraContentSetting\"}]},\"unsandboxedPlugins\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"ppapi-broker\",{\"$ref\":\"contentSettings.PpapiBrokerContentSetting\"}]},\"automaticDownloads\":{\"$ref\":\"contentSettings.ContentSetting\",\"value\":[\"automatic-downloads\",{\"$ref\":\"contentSettings.MultipleAutomaticDownloadsContentSetting\"}]}}}";
const char kContextMenusInternal[] = "{\"namespace\":\"contextMenusInternal\",\"types\":[{\"id\":\"contextMenusInternal.OnClickData\",\"type\":\"object\",\"properties\":{\"menuItemId\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}]},\"parentMenuItemId\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"optional\":true},\"mediaType\":{\"type\":\"string\",\"optional\":true},\"linkUrl\":{\"type\":\"string\",\"optional\":true},\"srcUrl\":{\"type\":\"string\",\"optional\":true},\"pageUrl\":{\"type\":\"string\",\"optional\":true},\"frameUrl\":{\"type\":\"string\",\"optional\":true},\"frameId\":{\"type\":\"integer\",\"optional\":true},\"selectionText\":{\"type\":\"string\",\"optional\":true},\"editable\":{\"type\":\"boolean\"},\"wasChecked\":{\"type\":\"boolean\",\"optional\":true},\"checked\":{\"type\":\"boolean\",\"optional\":true}}}],\"events\":[{\"name\":\"onClicked\",\"type\":\"function\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"contextMenusInternal.OnClickData\"},{\"name\":\"tab\",\"$ref\":\"tabs.Tab\",\"optional\":true}]}]}";
const char kContextMenus[] = "{\"namespace\":\"contextMenus\",\"properties\":{\"ACTION_MENU_TOP_LEVEL_LIMIT\":{\"value\":6,\"type\":\"integer\"}},\"types\":[{\"id\":\"contextMenus.ContextType\",\"type\":\"string\",\"enum\":[\"all\",\"page\",\"frame\",\"selection\",\"link\",\"editable\",\"image\",\"video\",\"audio\",\"launcher\",\"browser_action\",\"page_action\"]},{\"id\":\"contextMenus.ItemType\",\"type\":\"string\",\"enum\":[\"normal\",\"checkbox\",\"radio\",\"separator\"]}],\"functions\":[{\"name\":\"create\",\"type\":\"function\",\"returns\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}]},\"parameters\":[{\"type\":\"object\",\"name\":\"createProperties\",\"properties\":{\"type\":{\"$ref\":\"contextMenus.ItemType\",\"optional\":true},\"id\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"checked\":{\"type\":\"boolean\",\"optional\":true},\"contexts\":{\"type\":\"array\",\"items\":{\"$ref\":\"contextMenus.ContextType\"},\"minItems\":1,\"optional\":true},\"visible\":{\"type\":\"boolean\",\"optional\":true},\"onclick\":{\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"info\",\"$ref\":\"contextMenusInternal.OnClickData\"},{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]},\"parentId\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"optional\":true},\"documentUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"targetUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"enabled\":{\"type\":\"boolean\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"update\",\"type\":\"function\",\"parameters\":[{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"name\":\"id\"},{\"type\":\"object\",\"name\":\"updateProperties\",\"preserveNull\":true,\"properties\":{\"type\":{\"$ref\":\"contextMenus.ItemType\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"checked\":{\"type\":\"boolean\",\"optional\":true},\"contexts\":{\"type\":\"array\",\"items\":{\"$ref\":\"contextMenus.ContextType\"},\"minItems\":1,\"optional\":true},\"visible\":{\"type\":\"boolean\",\"optional\":true},\"onclick\":{\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"info\",\"$ref\":\"contextMenusInternal.OnClickData\"},{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]},\"parentId\":{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"optional\":true},\"documentUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"targetUrlPatterns\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"enabled\":{\"type\":\"boolean\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"remove\",\"type\":\"function\",\"parameters\":[{\"choices\":[{\"type\":\"integer\"},{\"type\":\"string\"}],\"name\":\"menuItemId\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeAll\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]}],\"events\":[{\"name\":\"onClicked\",\"type\":\"function\",\"$ref\":\"contextMenusInternal.onClicked\"}]}";
const char kCookies[] = "{\"namespace\":\"cookies\",\"types\":[{\"id\":\"cookies.SameSiteStatus\",\"type\":\"string\",\"enum\":[\"no_restriction\",\"lax\",\"strict\",\"unspecified\"]},{\"id\":\"cookies.Cookie\",\"type\":\"object\",\"properties\":{\"name\":{\"type\":\"string\"},\"value\":{\"type\":\"string\"},\"domain\":{\"type\":\"string\"},\"hostOnly\":{\"type\":\"boolean\"},\"path\":{\"type\":\"string\"},\"secure\":{\"type\":\"boolean\"},\"httpOnly\":{\"type\":\"boolean\"},\"sameSite\":{\"$ref\":\"cookies.SameSiteStatus\"},\"session\":{\"type\":\"boolean\"},\"expirationDate\":{\"type\":\"number\",\"optional\":true},\"storeId\":{\"type\":\"string\"}}},{\"id\":\"cookies.CookieStore\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\"},\"tabIds\":{\"type\":\"array\",\"items\":{\"type\":\"integer\"}}}},{\"id\":\"cookies.OnChangedCause\",\"type\":\"string\",\"enum\":[\"evicted\",\"expired\",\"explicit\",\"expired_overwrite\",\"overwrite\"]}],\"functions\":[{\"name\":\"get\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"url\":{\"type\":\"string\"},\"name\":{\"type\":\"string\"},\"storeId\":{\"type\":\"string\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"cookie\",\"$ref\":\"cookies.Cookie\",\"optional\":true}]}]},{\"name\":\"getAll\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"url\":{\"type\":\"string\",\"optional\":true},\"name\":{\"type\":\"string\",\"optional\":true},\"domain\":{\"type\":\"string\",\"optional\":true},\"path\":{\"type\":\"string\",\"optional\":true},\"secure\":{\"type\":\"boolean\",\"optional\":true},\"session\":{\"type\":\"boolean\",\"optional\":true},\"storeId\":{\"type\":\"string\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"cookies\",\"type\":\"array\",\"items\":{\"$ref\":\"cookies.Cookie\"}}]}]},{\"name\":\"set\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"url\":{\"type\":\"string\"},\"name\":{\"type\":\"string\",\"optional\":true},\"value\":{\"type\":\"string\",\"optional\":true},\"domain\":{\"type\":\"string\",\"optional\":true},\"path\":{\"type\":\"string\",\"optional\":true},\"secure\":{\"type\":\"boolean\",\"optional\":true},\"httpOnly\":{\"type\":\"boolean\",\"optional\":true},\"sameSite\":{\"$ref\":\"cookies.SameSiteStatus\",\"optional\":true},\"expirationDate\":{\"type\":\"number\",\"optional\":true},\"storeId\":{\"type\":\"string\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"min_version\":\"11.0.674.0\",\"parameters\":[{\"name\":\"cookie\",\"$ref\":\"cookies.Cookie\",\"optional\":true}]}]},{\"name\":\"remove\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"url\":{\"type\":\"string\"},\"name\":{\"type\":\"string\"},\"storeId\":{\"type\":\"string\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"min_version\":\"11.0.674.0\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"optional\":true,\"properties\":{\"url\":{\"type\":\"string\"},\"name\":{\"type\":\"string\"},\"storeId\":{\"type\":\"string\"}}}]}]},{\"name\":\"getAllCookieStores\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"cookieStores\",\"type\":\"array\",\"items\":{\"$ref\":\"cookies.CookieStore\"}}]}]}],\"events\":[{\"name\":\"onChanged\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"changeInfo\",\"properties\":{\"removed\":{\"type\":\"boolean\"},\"cookie\":{\"$ref\":\"cookies.Cookie\"},\"cause\":{\"min_version\":\"12.0.707.0\",\"$ref\":\"cookies.OnChangedCause\"}}}]}]}";
const char kCryptotokenPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"string\",\"name\":\"appIdUrl\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"result\"}]}],\"name\":\"canOriginAssertAppId\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"binary\",\"name\":\"appIdHash\",\"isInstanceOf\":\"ArrayBuffer\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"result\"}]}],\"name\":\"isAppIdHashInEnterpriseContext\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"options\",\"$ref\":\"cryptotokenPrivate.CanAppIdGetAttestationOptions\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"result\"}]}],\"name\":\"canAppIdGetAttestation\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"cryptotokenPrivate\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"cryptotokenPrivate.CanAppIdGetAttestationOptions\",\"properties\":{\"appId\":{\"name\":\"appId\",\"type\":\"string\"},\"origin\":{\"name\":\"origin\",\"type\":\"string\"},\"tabId\":{\"name\":\"tabId\",\"type\":\"integer\"}}}]}";
const char kDashboardPrivate[] = "{\"namespace\":\"dashboardPrivate\",\"types\":[{\"id\":\"dashboardPrivate.Result\",\"type\":\"string\",\"enum\":[{\"name\":\"\"},{\"name\":\"unknown_error\"},{\"name\":\"user_cancelled\"},{\"name\":\"invalid_id\"},{\"name\":\"manifest_error\"},{\"name\":\"icon_error\"},{\"name\":\"invalid_icon_url\"}]}],\"functions\":[{\"name\":\"showPermissionPromptForDelegatedInstall\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\",\"minLength\":32,\"maxLength\":32},\"manifest\":{\"type\":\"string\",\"minLength\":1},\"delegatedUser\":{\"type\":\"string\"},\"iconUrl\":{\"type\":\"string\",\"optional\":true,\"desciption\":\"A URL for the image to display in the confirmation dialog\"},\"localizedName\":{\"type\":\"string\",\"optional\":true}}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"result\",\"$ref\":\"dashboardPrivate.Result\"}]}]}]}";
const char kDataReductionProxy[] = "{\"namespace\":\"dataReductionProxy\",\"properties\":{\"spdyProxyEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"spdy_proxy.enabled\",{\"type\":\"boolean\"}]},\"dataReductionDailyContentLength\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"data_reduction.daily_original_length\",{\"type\":\"array\"}]},\"dataReductionDailyReceivedLength\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"data_reduction.daily_received_length\",{\"type\":\"array\"}]},\"dataUsageReportingEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"data_usage_reporting.enabled\",{\"type\":\"boolean\"}]}},\"functions\":[{\"name\":\"clearDataSavings\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getDataUsage\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"getDataUsageCallback\",\"optional\":true,\"parameters\":[{\"name\":\"data_usage\",\"type\":\"object\",\"properties\":{\"data_usage_buckets\":{\"type\":\"array\",\"items\":{\"type\":\"any\"}}}}]}]}]}";
const char kDebugger[] = "{\"namespace\":\"debugger\",\"types\":[{\"id\":\"debugger.Debuggee\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true},\"extensionId\":{\"type\":\"string\",\"optional\":true},\"targetId\":{\"type\":\"string\",\"optional\":true}}},{\"id\":\"debugger.TargetInfoType\",\"type\":\"string\",\"enum\":[\"page\",\"background_page\",\"worker\",\"other\"]},{\"id\":\"debugger.DetachReason\",\"type\":\"string\",\"enum\":[\"target_closed\",\"canceled_by_user\"]},{\"id\":\"debugger.TargetInfo\",\"type\":\"object\",\"properties\":{\"type\":{\"$ref\":\"debugger.TargetInfoType\"},\"id\":{\"type\":\"string\"},\"tabId\":{\"type\":\"integer\",\"optional\":true},\"extensionId\":{\"type\":\"string\",\"optional\":true},\"attached\":{\"type\":\"boolean\"},\"title\":{\"type\":\"string\"},\"url\":{\"type\":\"string\"},\"faviconUrl\":{\"type\":\"string\",\"optional\":true}}}],\"functions\":[{\"name\":\"attach\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"debugger.Debuggee\",\"name\":\"target\"},{\"type\":\"string\",\"name\":\"requiredVersion\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"detach\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"debugger.Debuggee\",\"name\":\"target\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"sendCommand\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"debugger.Debuggee\",\"name\":\"target\"},{\"type\":\"string\",\"name\":\"method\"},{\"type\":\"object\",\"name\":\"commandParams\",\"optional\":true,\"additionalProperties\":{\"type\":\"any\"}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"type\":\"object\",\"name\":\"result\",\"optional\":true,\"additionalProperties\":{\"type\":\"any\"}}]}]},{\"name\":\"getTargets\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"array\",\"name\":\"result\",\"items\":{\"$ref\":\"debugger.TargetInfo\"}}]}]}],\"events\":[{\"name\":\"onEvent\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"debugger.Debuggee\",\"name\":\"source\"},{\"type\":\"string\",\"name\":\"method\"},{\"type\":\"object\",\"name\":\"params\",\"optional\":true,\"additionalProperties\":{\"type\":\"any\"}}]},{\"name\":\"onDetach\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"debugger.Debuggee\",\"name\":\"source\"},{\"$ref\":\"debugger.DetachReason\",\"name\":\"reason\"}]}]}";
const char kDesktopCapture[] = "{\"namespace\":\"desktopCapture\",\"types\":[{\"id\":\"desktopCapture.DesktopCaptureSourceType\",\"type\":\"string\",\"enum\":[\"screen\",\"window\",\"tab\",\"audio\"]}],\"functions\":[{\"name\":\"chooseDesktopMedia\",\"type\":\"function\",\"parameters\":[{\"type\":\"array\",\"items\":{\"$ref\":\"desktopCapture.DesktopCaptureSourceType\"},\"name\":\"sources\"},{\"$ref\":\"tabs.Tab\",\"name\":\"targetTab\",\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"streamId\",\"type\":\"string\"},{\"name\":\"options\",\"type\":\"object\",\"properties\":{\"canRequestAudioTrack\":{\"type\":\"boolean\"}}}]}],\"returns\":{\"type\":\"integer\"}},{\"name\":\"cancelChooseDesktopMedia\",\"type\":\"function\",\"parameters\":[{\"name\":\"desktopMediaRequestId\",\"type\":\"integer\"}]}]}";
const char kDeveloperPrivate[] = "{\"functions\":[{\"parameters\":[{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"autoUpdate\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"developerPrivate.GetExtensionsInfoOptions\",\"optional\":true,\"name\":\"options\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"developerPrivate.ExtensionInfo\"},\"type\":\"array\",\"name\":\"result\"}]}],\"name\":\"getExtensionsInfo\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"developerPrivate.ExtensionInfo\"}]}],\"name\":\"getExtensionInfo\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"string\"}]}],\"name\":\"getExtensionSize\",\"type\":\"function\"},{\"deprecated\":\"Use getExtensionsInfo\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"includeDisabled\"},{\"type\":\"boolean\",\"name\":\"includeTerminated\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"developerPrivate.ItemInfo\"},\"type\":\"array\",\"name\":\"result\"}]}],\"name\":\"getItemsInfo\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"developerPrivate.ProfileInfo\"}]}],\"name\":\"getProfileConfiguration\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"developerPrivate.ProfileConfigurationUpdate\",\"name\":\"update\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"updateProfileConfiguration\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"showPermissionsDialog\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"$ref\":\"developerPrivate.ReloadOptions\",\"optional\":true,\"name\":\"options\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"optional\":true,\"name\":\"error\",\"$ref\":\"developerPrivate.LoadError\"}]}],\"name\":\"reload\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"developerPrivate.ExtensionConfigurationUpdate\",\"name\":\"update\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"updateExtensionConfiguration\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"developerPrivate.LoadUnpackedOptions\",\"optional\":true,\"name\":\"options\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"optional\":true,\"name\":\"error\",\"$ref\":\"developerPrivate.LoadError\"}]}],\"name\":\"loadUnpacked\",\"type\":\"function\"},{\"parameters\":[{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"installDroppedFile\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"notifyDragInstallInProgress\",\"type\":\"function\"},{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"directory\",\"isInstanceOf\":\"DirectoryEntry\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"string\"}]}],\"name\":\"loadDirectory\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"developerPrivate.SelectType\",\"name\":\"selectType\"},{\"$ref\":\"developerPrivate.FileType\",\"name\":\"fileType\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"string\"}]}],\"name\":\"choosePath\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"path\"},{\"optional\":true,\"type\":\"string\",\"name\":\"privateKeyPath\"},{\"optional\":true,\"type\":\"integer\",\"name\":\"flags\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"response\",\"$ref\":\"developerPrivate.PackDirectoryResponse\"}]}],\"name\":\"packDirectory\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"result\"}]}],\"name\":\"isProfileManaged\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"properties\",\"$ref\":\"developerPrivate.RequestFileSourceProperties\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"response\",\"$ref\":\"developerPrivate.RequestFileSourceResponse\"}]}],\"name\":\"requestFileSource\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"properties\",\"$ref\":\"developerPrivate.OpenDevToolsProperties\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"openDevTools\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"developerPrivate.DeleteExtensionErrorsProperties\",\"name\":\"properties\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"deleteExtensionErrors\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"repairExtension\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"showOptions\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"showPath\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"isSuspended\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setShortcutHandlingSuspended\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"developerPrivate.ExtensionCommandUpdate\",\"name\":\"update\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"updateExtensionCommand\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"type\":\"string\",\"name\":\"host\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"addHostPermission\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"type\":\"string\",\"name\":\"host\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"removeHostPermission\",\"type\":\"function\"},{\"deprecated\":\"Use management.setEnabled\",\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"type\":\"boolean\",\"name\":\"enabled\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"enable\",\"type\":\"function\"},{\"deprecated\":\"Use updateExtensionConfiguration\",\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"type\":\"boolean\",\"name\":\"allow\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"allowIncognito\",\"type\":\"function\"},{\"deprecated\":\"Use updateExtensionConfiguration\",\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\"},{\"type\":\"boolean\",\"name\":\"allow\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"allowFileAccess\",\"type\":\"function\"},{\"deprecated\":\"Use openDevTools\",\"parameters\":[{\"name\":\"options\",\"$ref\":\"developerPrivate.InspectOptions\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"inspect\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"name\":\"response\",\"$ref\":\"developerPrivate.EventData\"}],\"name\":\"onItemStateChanged\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"info\",\"$ref\":\"developerPrivate.ProfileInfo\"}],\"name\":\"onProfileStateChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"developerPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"hosted_app\"},{\"name\":\"packaged_app\"},{\"name\":\"legacy_packaged_app\"},{\"name\":\"extension\"},{\"name\":\"theme\"}],\"type\":\"string\",\"id\":\"developerPrivate.ItemType\"},{\"type\":\"object\",\"id\":\"developerPrivate.ItemInspectView\",\"properties\":{\"path\":{\"name\":\"path\",\"type\":\"string\"},\"render_process_id\":{\"name\":\"render_process_id\",\"type\":\"integer\"},\"render_view_id\":{\"name\":\"render_view_id\",\"type\":\"integer\"},\"incognito\":{\"name\":\"incognito\",\"type\":\"boolean\"},\"generatedBackgroundPage\":{\"name\":\"generatedBackgroundPage\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.InspectOptions\",\"properties\":{\"extension_id\":{\"name\":\"extension_id\",\"type\":\"string\"},\"render_process_id\":{\"name\":\"render_process_id\",\"choices\":[{\"type\":\"string\"},{\"type\":\"integer\"}]},\"render_view_id\":{\"name\":\"render_view_id\",\"choices\":[{\"type\":\"string\"},{\"type\":\"integer\"}]},\"incognito\":{\"name\":\"incognito\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.InstallWarning\",\"properties\":{\"message\":{\"name\":\"message\",\"type\":\"string\"}}},{\"enum\":[{\"name\":\"HOSTED_APP\"},{\"name\":\"PLATFORM_APP\"},{\"name\":\"LEGACY_PACKAGED_APP\"},{\"name\":\"EXTENSION\"},{\"name\":\"THEME\"},{\"name\":\"SHARED_MODULE\"}],\"type\":\"string" "\",\"id\":\"developerPrivate.ExtensionType\"},{\"enum\":[{\"name\":\"FROM_STORE\"},{\"name\":\"UNPACKED\"},{\"name\":\"THIRD_PARTY\"},{\"name\":\"UNKNOWN\"}],\"type\":\"string\",\"id\":\"developerPrivate.Location\"},{\"enum\":[{\"name\":\"APP_WINDOW\"},{\"name\":\"BACKGROUND_CONTENTS\"},{\"name\":\"COMPONENT\"},{\"name\":\"EXTENSION_BACKGROUND_PAGE\"},{\"name\":\"EXTENSION_DIALOG\"},{\"name\":\"EXTENSION_GUEST\"},{\"name\":\"EXTENSION_POPUP\"},{\"name\":\"TAB_CONTENTS\"}],\"type\":\"string\",\"id\":\"developerPrivate.ViewType\"},{\"enum\":[{\"name\":\"MANIFEST\"},{\"name\":\"RUNTIME\"}],\"type\":\"string\",\"id\":\"developerPrivate.ErrorType\"},{\"enum\":[{\"name\":\"LOG\"},{\"name\":\"WARN\"},{\"name\":\"ERROR\"}],\"type\":\"string\",\"id\":\"developerPrivate.ErrorLevel\"},{\"enum\":[{\"name\":\"ENABLED\"},{\"name\":\"DISABLED\"},{\"name\":\"TERMINATED\"},{\"name\":\"BLACKLISTED\"}],\"type\":\"string\",\"id\":\"developerPrivate.ExtensionState\"},{\"enum\":[{\"name\":\"GLOBAL\"},{\"name\":\"CHROME\"}],\"type\":\"string\",\"id\":\"developerPrivate.CommandScope\"},{\"type\":\"object\",\"id\":\"developerPrivate.AccessModifier\",\"properties\":{\"isEnabled\":{\"name\":\"isEnabled\",\"type\":\"boolean\"},\"isActive\":{\"name\":\"isActive\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.StackFrame\",\"properties\":{\"lineNumber\":{\"name\":\"lineNumber\",\"type\":\"integer\"},\"columnNumber\":{\"name\":\"columnNumber\",\"type\":\"integer\"},\"url\":{\"name\":\"url\",\"type\":\"string\"},\"functionName\":{\"name\":\"functionName\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ManifestError\",\"properties\":{\"type\":{\"name\":\"type\",\"$ref\":\"developerPrivate.ErrorType\"},\"extensionId\":{\"name\":\"extensionId\",\"type\":\"string\"},\"fromIncognito\":{\"name\":\"fromIncognito\",\"type\":\"boolean\"},\"source\":{\"name\":\"source\",\"type\":\"string\"},\"message\":{\"name\":\"message\",\"type\":\"string\"},\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"manifestKey\":{\"name\":\"manifestKey\",\"type\":\"string\"},\"manifestSpecific\":{\"optional\":true,\"name\":\"manifestSpecific\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.RuntimeError\",\"properties\":{\"type\":{\"name\":\"type\",\"$ref\":\"developerPrivate.ErrorType\"},\"extensionId\":{\"name\":\"extensionId\",\"type\":\"string\"},\"fromIncognito\":{\"name\":\"fromIncognito\",\"type\":\"boolean\"},\"source\":{\"name\":\"source\",\"type\":\"string\"},\"message\":{\"name\":\"message\",\"type\":\"string\"},\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"severity\":{\"name\":\"severity\",\"$ref\":\"developerPrivate.ErrorLevel\"},\"contextUrl\":{\"name\":\"contextUrl\",\"type\":\"string\"},\"occurrences\":{\"name\":\"occurrences\",\"type\":\"integer\"},\"renderViewId\":{\"name\":\"renderViewId\",\"type\":\"integer\"},\"renderProcessId\":{\"name\":\"renderProcessId\",\"type\":\"integer\"},\"canInspect\":{\"name\":\"canInspect\",\"type\":\"boolean\"},\"stackTrace\":{\"name\":\"stackTrace\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.StackFrame\"}}}},{\"type\":\"object\",\"id\":\"developerPrivate.DisableReasons\",\"properties\":{\"suspiciousInstall\":{\"name\":\"suspiciousInstall\",\"type\":\"boolean\"},\"corruptInstall\":{\"name\":\"corruptInstall\",\"type\":\"boolean\"},\"updateRequired\":{\"name\":\"updateRequired\",\"type\":\"boolean\"},\"blockedByPolicy\":{\"name\":\"blockedByPolicy\",\"type\":\"boolean\"},\"custodianApprovalRequired\":{\"name\":\"custodianApprovalRequired\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.OptionsPage\",\"properties\":{\"openInTab\":{\"name\":\"openInTab\",\"type\":\"boolean\"},\"url\":{\"name\":\"url\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.HomePage\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"specified\":{\"name\":\"specified\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ExtensionView\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"renderProcessId\":{\"name\":\"renderProcessId\",\"type\":\"integer\"},\"renderViewId\":{\"name\":\"renderViewId\",\"type\":\"integer\"},\"incognito\":{\"name\":\"incognito\",\"type\":\"boolean\"},\"isIframe\":{\"name\":\"isIframe\",\"type\":\"boolean\"},\"type\":{\"name\":\"type\",\"$ref\":\"developerPrivate.ViewType\"}}},{\"enum\":[{\"name\":\"POLICY\"},{\"name\":\"SUPERVISED_USER_CUSTODIAN\"}],\"type\":\"string\",\"id\":\"developerPrivate.ControllerType\"},{\"enum\":[{\"name\":\"ON_CLICK\"},{\"name\":\"ON_SPECIFIC_SITES\"},{\"name\":\"ON_ALL_SITES\"}],\"type\":\"string\",\"id\":\"developerPrivate.HostAccess\"},{\"type\":\"object\",\"id\":\"developerPrivate.ControlledInfo\",\"properties\":{\"type\":{\"name\":\"type\",\"$ref\":\"developerPrivate.ControllerType\"},\"text\":{\"name\":\"text\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.Command\",\"properties\":{\"description\":{\"name\":\"description\",\"type\":\"string\"},\"keybinding\":{\"name\":\"keybinding\",\"type\":\"string\"},\"name\":{\"name\":\"name\",\"type\":\"string\"},\"isActive\":{\"name\":\"isActive\",\"type\":\"boolean\"},\"scope\":{\"name\":\"scope\",\"$ref\":\"developerPrivate.CommandScope\"},\"isExtensionAction\":{\"name\":\"isExtensionAction\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.DependentExtension\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"string\"},\"name\":{\"name\":\"name\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.Permission\",\"properties\":{\"message\":{\"name\":\"message\",\"type\":\"string\"},\"submessages\":{\"name\":\"submessages\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}}},{\"type\":\"object\",\"id\":\"developerPrivate.SiteControl\",\"properties\":{\"host\":{\"name\":\"host\",\"type\":\"string\"},\"granted\":{\"name\":\"granted\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.RuntimeHostPermissions\",\"properties\":{\"hasAllHosts\":{\"name\":\"hasAllHosts\",\"type\":\"boolean\"},\"hostAccess\":{\"name\":\"hostAccess\",\"$ref\":\"developerPrivate.HostAccess\"},\"hosts\":{\"name\":\"hosts\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.SiteControl\"}}}},{\"type\":\"object\",\"id\":\"developerPrivate.Permissions\",\"properties\":{\"simplePermissions\":{\"name\":\"simplePermissions\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.Permission\"}},\"runtimeHostPermissions\":{\"optional\":true,\"name\":\"runtimeHostPermissions\",\"$ref\":\"developerPrivate.RuntimeHostPermissions\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ExtensionInfo\",\"properties\":{\"blacklistText\":{\"optional\":true,\"name\":\"blacklistText\",\"type\":\"string\"},\"commands\":{\"name\":\"commands\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.Command\"}},\"controlledInfo\":{\"optional\":true,\"name\":\"controlledInfo\",\"$ref\":\"developerPrivate.ControlledInfo\"},\"dependentExtensions\":{\"name\":\"dependentExtensions\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.DependentExtension\"}},\"description\":{\"name\":\"description\",\"type\":\"string\"},\"disableReasons\":{\"name\":\"disableReasons\",\"$ref\":\"developerPrivate.DisableReasons\"},\"errorCollection\":{\"name\":\"errorCollection\",\"$ref\":\"developerPrivate.AccessModifier\"},\"fileAccess\":{\"name\":\"fileAccess\",\"$ref\":\"developerPrivate.AccessModifier\"},\"homePage\":{\"name\":\"homePage\",\"$ref\":\"developerPrivate.HomePage\"},\"iconUrl\":{\"name\":\"iconUrl\",\"type\":\"string\"},\"id\":{\"name\":\"id\",\"type\":\"string\"},\"incognitoAccess\":{\"name\":\"incognitoAccess\",\"$ref\":\"developerPrivate.AccessModifier\"},\"installWarnings\":{\"name\":\"installWarnings\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"launchUrl\":{\"optional\":true,\"name\":\"launchUrl\",\"type\":\"string\"},\"location\":{\"name\":\"location\",\"$ref\":\"developerPrivate.Location\"},\"locationText\":{\"optional\":true,\"name\":\"locationText\",\"type\":\"string\"},\"manifestErrors\":{\"name\":\"manifestErrors\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.ManifestError\"}},\"manifestHomePageUrl\":{\"name\":\"manifestHomePageUrl\",\"type\":\"string\"},\"mustRemainInstalled\":{\"name\":\"mustRemainInstalled\",\"type\":\"boolean\"},\"name\":{\"name\":\"name\",\"type\":\"string\"},\"offlineEnabled\":{\"name\":\"offlineEnabled\",\"type\":\"boolean\"},\"optionsPage\":{\"optional\":true,\"name\":\"optionsPage\",\"$ref\":\"developerPrivate.OptionsPage\"},\"path\":{\"optional\":true,\"name\":\"path\",\"type\":\"string\"},\"permissions\":{\"name\":\"permissions\",\"$ref\":\"developerPrivate.Permissions\"},\"prettifiedPath\":{\"optional\":true,\"name\":\"prettifiedPath\",\"type\":\"string\"},\"runtimeErrors\":{\"name\":\"runtimeErrors\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.RuntimeError\"}},\"runtimeWarnings\":{\"name\":\"runtimeWarnings\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"state\":{\"name\":\"state\",\"$ref\":\"developerPrivate.ExtensionState\"},\"type\":{\"name\":\"type\",\"$ref\":\"developerPrivate.ExtensionType\"},\"updateUrl\":{\"name\":\"updateUrl\",\"type\":\"string\"},\"userMayModify\":{\"name\":\"userMayModify\",\"type\":\"boolean\"},\"version\":{\"name\":\"version\",\"type\":\"string\"},\"views\":{\"name\":\"views\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.ExtensionView\"}},\"webStoreUrl\":{\"name\":\"webStoreUrl\",\"type\":\"string" "\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ProfileInfo\",\"properties\":{\"canLoadUnpacked\":{\"name\":\"canLoadUnpacked\",\"type\":\"boolean\"},\"inDeveloperMode\":{\"name\":\"inDeveloperMode\",\"type\":\"boolean\"},\"isDeveloperModeControlledByPolicy\":{\"name\":\"isDeveloperModeControlledByPolicy\",\"type\":\"boolean\"},\"isIncognitoAvailable\":{\"name\":\"isIncognitoAvailable\",\"type\":\"boolean\"},\"isSupervised\":{\"name\":\"isSupervised\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ItemInfo\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"string\"},\"name\":{\"name\":\"name\",\"type\":\"string\"},\"version\":{\"name\":\"version\",\"type\":\"string\"},\"description\":{\"name\":\"description\",\"type\":\"string\"},\"may_disable\":{\"name\":\"may_disable\",\"type\":\"boolean\"},\"enabled\":{\"name\":\"enabled\",\"type\":\"boolean\"},\"isApp\":{\"name\":\"isApp\",\"type\":\"boolean\"},\"type\":{\"name\":\"type\",\"$ref\":\"developerPrivate.ItemType\"},\"allow_activity\":{\"name\":\"allow_activity\",\"type\":\"boolean\"},\"allow_file_access\":{\"name\":\"allow_file_access\",\"type\":\"boolean\"},\"wants_file_access\":{\"name\":\"wants_file_access\",\"type\":\"boolean\"},\"incognito_enabled\":{\"name\":\"incognito_enabled\",\"type\":\"boolean\"},\"is_unpacked\":{\"name\":\"is_unpacked\",\"type\":\"boolean\"},\"allow_reload\":{\"name\":\"allow_reload\",\"type\":\"boolean\"},\"terminated\":{\"name\":\"terminated\",\"type\":\"boolean\"},\"allow_incognito\":{\"name\":\"allow_incognito\",\"type\":\"boolean\"},\"icon_url\":{\"name\":\"icon_url\",\"type\":\"string\"},\"path\":{\"optional\":true,\"name\":\"path\",\"type\":\"string\"},\"options_url\":{\"optional\":true,\"name\":\"options_url\",\"type\":\"string\"},\"app_launch_url\":{\"optional\":true,\"name\":\"app_launch_url\",\"type\":\"string\"},\"homepage_url\":{\"optional\":true,\"name\":\"homepage_url\",\"type\":\"string\"},\"update_url\":{\"optional\":true,\"name\":\"update_url\",\"type\":\"string\"},\"install_warnings\":{\"name\":\"install_warnings\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.InstallWarning\"}},\"manifest_errors\":{\"name\":\"manifest_errors\",\"type\":\"array\",\"items\":{\"type\":\"any\"}},\"runtime_errors\":{\"name\":\"runtime_errors\",\"type\":\"array\",\"items\":{\"type\":\"any\"}},\"offline_enabled\":{\"name\":\"offline_enabled\",\"type\":\"boolean\"},\"views\":{\"name\":\"views\",\"type\":\"array\",\"items\":{\"$ref\":\"developerPrivate.ItemInspectView\"}}}},{\"type\":\"object\",\"id\":\"developerPrivate.GetExtensionsInfoOptions\",\"properties\":{\"includeDisabled\":{\"optional\":true,\"name\":\"includeDisabled\",\"type\":\"boolean\"},\"includeTerminated\":{\"optional\":true,\"name\":\"includeTerminated\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ExtensionConfigurationUpdate\",\"properties\":{\"extensionId\":{\"name\":\"extensionId\",\"type\":\"string\"},\"fileAccess\":{\"optional\":true,\"name\":\"fileAccess\",\"type\":\"boolean\"},\"incognitoAccess\":{\"optional\":true,\"name\":\"incognitoAccess\",\"type\":\"boolean\"},\"errorCollection\":{\"optional\":true,\"name\":\"errorCollection\",\"type\":\"boolean\"},\"hostAccess\":{\"optional\":true,\"name\":\"hostAccess\",\"$ref\":\"developerPrivate.HostAccess\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ProfileConfigurationUpdate\",\"properties\":{\"inDeveloperMode\":{\"optional\":true,\"name\":\"inDeveloperMode\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ExtensionCommandUpdate\",\"properties\":{\"extensionId\":{\"name\":\"extensionId\",\"type\":\"string\"},\"commandName\":{\"name\":\"commandName\",\"type\":\"string\"},\"scope\":{\"optional\":true,\"name\":\"scope\",\"$ref\":\"developerPrivate.CommandScope\"},\"keybinding\":{\"optional\":true,\"name\":\"keybinding\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ReloadOptions\",\"properties\":{\"failQuietly\":{\"optional\":true,\"name\":\"failQuietly\",\"type\":\"boolean\"},\"populateErrorForUnpacked\":{\"optional\":true,\"name\":\"populateErrorForUnpacked\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.LoadUnpackedOptions\",\"properties\":{\"failQuietly\":{\"optional\":true,\"name\":\"failQuietly\",\"type\":\"boolean\"},\"populateError\":{\"optional\":true,\"name\":\"populateError\",\"type\":\"boolean\"},\"retryGuid\":{\"optional\":true,\"name\":\"retryGuid\",\"type\":\"string\"},\"useDraggedPath\":{\"optional\":true,\"name\":\"useDraggedPath\",\"type\":\"boolean\"}}},{\"enum\":[{\"name\":\"SUCCESS\"},{\"name\":\"ERROR\"},{\"name\":\"WARNING\"}],\"type\":\"string\",\"id\":\"developerPrivate.PackStatus\"},{\"enum\":[{\"name\":\"LOAD\"},{\"name\":\"PEM\"}],\"type\":\"string\",\"id\":\"developerPrivate.FileType\"},{\"enum\":[{\"name\":\"FILE\"},{\"name\":\"FOLDER\"}],\"type\":\"string\",\"id\":\"developerPrivate.SelectType\"},{\"enum\":[{\"name\":\"INSTALLED\"},{\"name\":\"UNINSTALLED\"},{\"name\":\"LOADED\"},{\"name\":\"UNLOADED\"},{\"name\":\"VIEW_REGISTERED\"},{\"name\":\"VIEW_UNREGISTERED\"},{\"name\":\"ERROR_ADDED\"},{\"name\":\"ERRORS_REMOVED\"},{\"name\":\"PREFS_CHANGED\"},{\"name\":\"WARNINGS_CHANGED\"},{\"name\":\"COMMAND_ADDED\"},{\"name\":\"COMMAND_REMOVED\"},{\"name\":\"PERMISSIONS_CHANGED\"}],\"type\":\"string\",\"id\":\"developerPrivate.EventType\"},{\"type\":\"object\",\"id\":\"developerPrivate.PackDirectoryResponse\",\"properties\":{\"message\":{\"name\":\"message\",\"type\":\"string\"},\"item_path\":{\"name\":\"item_path\",\"type\":\"string\"},\"pem_path\":{\"name\":\"pem_path\",\"type\":\"string\"},\"override_flags\":{\"name\":\"override_flags\",\"type\":\"integer\"},\"status\":{\"name\":\"status\",\"$ref\":\"developerPrivate.PackStatus\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ProjectInfo\",\"properties\":{\"name\":{\"name\":\"name\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.EventData\",\"properties\":{\"event_type\":{\"name\":\"event_type\",\"$ref\":\"developerPrivate.EventType\"},\"item_id\":{\"name\":\"item_id\",\"type\":\"string\"},\"extensionInfo\":{\"optional\":true,\"name\":\"extensionInfo\",\"$ref\":\"developerPrivate.ExtensionInfo\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.ErrorFileSource\",\"properties\":{\"beforeHighlight\":{\"name\":\"beforeHighlight\",\"type\":\"string\"},\"highlight\":{\"name\":\"highlight\",\"type\":\"string\"},\"afterHighlight\":{\"name\":\"afterHighlight\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.LoadError\",\"properties\":{\"error\":{\"name\":\"error\",\"type\":\"string\"},\"path\":{\"name\":\"path\",\"type\":\"string\"},\"source\":{\"optional\":true,\"name\":\"source\",\"$ref\":\"developerPrivate.ErrorFileSource\"},\"retryGuid\":{\"name\":\"retryGuid\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.RequestFileSourceProperties\",\"properties\":{\"extensionId\":{\"name\":\"extensionId\",\"type\":\"string\"},\"pathSuffix\":{\"name\":\"pathSuffix\",\"type\":\"string\"},\"message\":{\"name\":\"message\",\"type\":\"string\"},\"manifestKey\":{\"optional\":true,\"name\":\"manifestKey\",\"type\":\"string\"},\"manifestSpecific\":{\"optional\":true,\"name\":\"manifestSpecific\",\"type\":\"string\"},\"lineNumber\":{\"optional\":true,\"name\":\"lineNumber\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.RequestFileSourceResponse\",\"properties\":{\"highlight\":{\"name\":\"highlight\",\"type\":\"string\"},\"beforeHighlight\":{\"name\":\"beforeHighlight\",\"type\":\"string\"},\"afterHighlight\":{\"name\":\"afterHighlight\",\"type\":\"string\"},\"title\":{\"name\":\"title\",\"type\":\"string\"},\"message\":{\"name\":\"message\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.OpenDevToolsProperties\",\"properties\":{\"extensionId\":{\"optional\":true,\"name\":\"extensionId\",\"type\":\"string\"},\"renderViewId\":{\"name\":\"renderViewId\",\"type\":\"integer\"},\"renderProcessId\":{\"name\":\"renderProcessId\",\"type\":\"integer\"},\"incognito\":{\"optional\":true,\"name\":\"incognito\",\"type\":\"boolean\"},\"url\":{\"optional\":true,\"name\":\"url\",\"type\":\"string\"},\"lineNumber\":{\"optional\":true,\"name\":\"lineNumber\",\"type\":\"integer\"},\"columnNumber\":{\"optional\":true,\"name\":\"columnNumber\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"developerPrivate.DeleteExtensionErrorsProperties\",\"properties\":{\"extensionId\":{\"name\":\"extensionId\",\"type\":\"string\"},\"errorIds\":{\"optional\":true,\"name\":\"errorIds\",\"type\":\"array\",\"items\":{\"type\":\"integer\"}},\"type\":{\"optional\":true,\"name\":\"type\",\"$ref\":\"developerPrivate.ErrorType\"}}}]}";
const char kDownloads[] = "{\"functions\":[{\"parameters\":[{\"$ref\":\"downloads.DownloadOptions\",\"name\":\"options\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"}]}],\"name\":\"download\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"query\",\"$ref\":\"downloads.DownloadQuery\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"downloads.DownloadItem\"},\"type\":\"array\",\"name\":\"results\"}]}],\"name\":\"search\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"pause\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"resume\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"cancel\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"},{\"optional\":true,\"name\":\"options\",\"$ref\":\"downloads.GetFileIconOptions\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"optional\":true,\"type\":\"string\",\"name\":\"iconURL\"}]}],\"name\":\"getFileIcon\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"}],\"name\":\"open\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"}],\"name\":\"show\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"showDefaultFolder\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"query\",\"$ref\":\"downloads.DownloadQuery\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"type\":\"integer\"},\"type\":\"array\",\"name\":\"erasedIds\"}]}],\"name\":\"erase\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"removeFile\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"acceptDanger\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"boolean\",\"name\":\"enabled\"}],\"name\":\"setShelfEnabled\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"name\":\"downloadItem\",\"$ref\":\"downloads.DownloadItem\"}],\"name\":\"onCreated\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"}],\"name\":\"onErased\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"downloadDelta\",\"$ref\":\"downloads.DownloadDelta\"}],\"name\":\"onChanged\",\"type\":\"function\"},{\"options\":{\"maxListeners\":1},\"parameters\":[{\"name\":\"downloadItem\",\"$ref\":\"downloads.DownloadItem\"},{\"type\":\"function\",\"name\":\"suggest\",\"parameters\":[{\"optional\":true,\"name\":\"suggestion\",\"$ref\":\"downloads.FilenameSuggestion\"}]}],\"name\":\"onDeterminingFilename\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"downloads\",\"properties\":{},\"types\":[{\"inline_doc\":true,\"type\":\"object\",\"id\":\"downloads.HeaderNameValuePair\",\"properties\":{\"name\":{\"name\":\"name\",\"type\":\"string\"},\"value\":{\"name\":\"value\",\"type\":\"string\"}}},{\"enum\":[{\"name\":\"uniquify\"},{\"name\":\"overwrite\"},{\"name\":\"prompt\"}],\"type\":\"string\",\"id\":\"downloads.FilenameConflictAction\"},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"downloads.FilenameSuggestion\",\"properties\":{\"filename\":{\"name\":\"filename\",\"type\":\"string\"},\"conflictAction\":{\"optional\":true,\"name\":\"conflictAction\",\"$ref\":\"downloads.FilenameConflictAction\"}}},{\"inline_doc\":\"True\",\"enum\":[{\"name\":\"GET\"},{\"name\":\"POST\"}],\"type\":\"string\",\"id\":\"downloads.HttpMethod\"},{\"enum\":[{\"name\":\"FILE_FAILED\"},{\"name\":\"FILE_ACCESS_DENIED\"},{\"name\":\"FILE_NO_SPACE\"},{\"name\":\"FILE_NAME_TOO_LONG\"},{\"name\":\"FILE_TOO_LARGE\"},{\"name\":\"FILE_VIRUS_INFECTED\"},{\"name\":\"FILE_TRANSIENT_ERROR\"},{\"name\":\"FILE_BLOCKED\"},{\"name\":\"FILE_SECURITY_CHECK_FAILED\"},{\"name\":\"FILE_TOO_SHORT\"},{\"name\":\"FILE_HASH_MISMATCH\"},{\"name\":\"FILE_SAME_AS_SOURCE\"},{\"name\":\"NETWORK_FAILED\"},{\"name\":\"NETWORK_TIMEOUT\"},{\"name\":\"NETWORK_DISCONNECTED\"},{\"name\":\"NETWORK_SERVER_DOWN\"},{\"name\":\"NETWORK_INVALID_REQUEST\"},{\"name\":\"SERVER_FAILED\"},{\"name\":\"SERVER_NO_RANGE\"},{\"name\":\"SERVER_BAD_CONTENT\"},{\"name\":\"SERVER_UNAUTHORIZED\"},{\"name\":\"SERVER_CERT_PROBLEM\"},{\"name\":\"SERVER_FORBIDDEN\"},{\"name\":\"SERVER_UNREACHABLE\"},{\"name\":\"SERVER_CONTENT_LENGTH_MISMATCH\"},{\"name\":\"SERVER_CROSS_ORIGIN_REDIRECT\"},{\"name\":\"USER_CANCELED\"},{\"name\":\"USER_SHUTDOWN\"},{\"name\":\"CRASH\"}],\"type\":\"string\",\"id\":\"downloads.InterruptReason\"},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"downloads.DownloadOptions\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"filename\":{\"optional\":true,\"name\":\"filename\",\"type\":\"string\"},\"conflictAction\":{\"optional\":true,\"name\":\"conflictAction\",\"$ref\":\"downloads.FilenameConflictAction\"},\"saveAs\":{\"optional\":true,\"name\":\"saveAs\",\"type\":\"boolean\"},\"method\":{\"optional\":true,\"name\":\"method\",\"$ref\":\"downloads.HttpMethod\"},\"headers\":{\"optional\":true,\"name\":\"headers\",\"type\":\"array\",\"items\":{\"$ref\":\"downloads.HeaderNameValuePair\"}},\"body\":{\"optional\":true,\"name\":\"body\",\"type\":\"string\"}}},{\"enum\":[{\"name\":\"file\"},{\"name\":\"url\"},{\"name\":\"content\"},{\"name\":\"uncommon\"},{\"name\":\"host\"},{\"name\":\"unwanted\"},{\"name\":\"safe\"},{\"name\":\"accepted\"}],\"type\":\"string\",\"id\":\"downloads.DangerType\"},{\"enum\":[{\"name\":\"in_progress\"},{\"name\":\"interrupted\"},{\"name\":\"complete\"}],\"type\":\"string\",\"id\":\"downloads.State\"},{\"type\":\"object\",\"id\":\"downloads.DownloadItem\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"url\":{\"name\":\"url\",\"type\":\"string\"},\"finalUrl\":{\"name\":\"finalUrl\",\"type\":\"string\"},\"referrer\":{\"name\":\"referrer\",\"type\":\"string\"},\"filename\":{\"name\":\"filename\",\"type\":\"string\"},\"incognito\":{\"name\":\"incognito\",\"type\":\"boolean\"},\"danger\":{\"name\":\"danger\",\"$ref\":\"downloads.DangerType\"},\"mime\":{\"name\":\"mime\",\"type\":\"string\"},\"startTime\":{\"name\":\"startTime\",\"type\":\"string\"},\"endTime\":{\"optional\":true,\"name\":\"endTime\",\"type\":\"string\"},\"estimatedEndTime\":{\"optional\":true,\"name\":\"estimatedEndTime\",\"type\":\"string\"},\"state\":{\"name\":\"state\",\"$ref\":\"downloads.State\"},\"paused\":{\"name\":\"paused\",\"type\":\"boolean\"},\"canResume\":{\"name\":\"canResume\",\"type\":\"boolean\"},\"error\":{\"optional\":true,\"name\":\"error\",\"$ref\":\"downloads.InterruptReason\"},\"bytesReceived\":{\"name\":\"bytesReceived\",\"type\":\"number\"},\"totalBytes\":{\"name\":\"totalBytes\",\"type\":\"number\"},\"fileSize\":{\"name\":\"fileSize\",\"type\":\"number\"},\"exists\":{\"name\":\"exists\",\"type\":\"boolean\"},\"byExtensionId\":{\"optional\":true,\"name\":\"byExtensionId\",\"type\":\"string\"},\"byExtensionName\":{\"optional\":true,\"name\":\"byExtensionName\",\"type\":\"string\"}}},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"downloads.DownloadQuery\",\"properties\":{\"query\":{\"optional\":true,\"name\":\"query\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"startedBefore\":{\"optional\":true,\"name\":\"startedBefore\",\"type\":\"string\"},\"startedAfter\":{\"optional\":true,\"name\":\"startedAfter\",\"type\":\"string\"},\"endedBefore\":{\"optional\":true,\"name\":\"endedBefore\",\"type\":\"string\"},\"endedAfter\":{\"optional\":true,\"name\":\"endedAfter\",\"type\":\"string\"},\"totalBytesGreater\":{\"optional\":true,\"name\":\"totalBytesGreater\",\"type\":\"number\"},\"totalBytesLess\":{\"optional\":true,\"name\":\"totalBytesLess\",\"type\":\"number\"},\"filenameRegex\":{\"optional\":true,\"name\":\"filenameRegex\",\"type\":\"string\"},\"urlRegex\":{\"optional\":true,\"name\":\"urlRegex\",\"type\":\"string\"},\"finalUrlRegex\":{\"optional\":true,\"name\":\"finalUrlRegex\",\"type\":\"string\"},\"limit\":{\"optional\":true,\"name\":\"limit\",\"type\":\"integer\"},\"orderBy\":{\"optional\":true,\"name\":\"orderBy\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"id\":{\"optional\":true,\"name\":\"id\",\"type\":\"integer\"},\"url\":{\"optional\":true,\"name\":\"url\",\"type\":\"string\"},\"finalUrl\":{\"optional\":true,\"name\":\"finalUrl\",\"type\":\"string\"},\"filename\":{\"optional\":true,\"name\":\"filename\",\"type\":\"string\"},\"danger\":{\"optional\":true,\"name\":\"danger\",\"$ref\":\"downloads.DangerType\"},\"mime\":{\"optional\":true,\"name\":\"mime\",\"type\":\"string\"},\"startTime\":{\"optional\":true,\"name\":\"startTime\",\"type\":\"string\"},\"endTime\":{\"optional\":true,\"name\":\"endTime\",\"type\":\"string\"},\"state\":{\"optional\":true,\"name\":\"state\",\"$ref\":\"downloads.State\"},\"paused\":{\"optional\":true,\"name\":\"paused\",\"type\":\"boolean\"},\"error\":{\"optional\":true,\"name\":\"error\",\"$ref\":\"downloads.InterruptReason\"},\"bytesReceived\":{\"optional\":true,\"name\":\"bytesReceived\",\"type\":\"number\"},\"totalBytes\":{\"optiona" "l\":true,\"name\":\"totalBytes\",\"type\":\"number\"},\"fileSize\":{\"optional\":true,\"name\":\"fileSize\",\"type\":\"number\"},\"exists\":{\"optional\":true,\"name\":\"exists\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"downloads.StringDelta\",\"properties\":{\"previous\":{\"optional\":true,\"name\":\"previous\",\"type\":\"string\"},\"current\":{\"optional\":true,\"name\":\"current\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"downloads.DoubleDelta\",\"properties\":{\"previous\":{\"optional\":true,\"name\":\"previous\",\"type\":\"number\"},\"current\":{\"optional\":true,\"name\":\"current\",\"type\":\"number\"}}},{\"type\":\"object\",\"id\":\"downloads.BooleanDelta\",\"properties\":{\"previous\":{\"optional\":true,\"name\":\"previous\",\"type\":\"boolean\"},\"current\":{\"optional\":true,\"name\":\"current\",\"type\":\"boolean\"}}},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"downloads.DownloadDelta\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"url\":{\"optional\":true,\"name\":\"url\",\"$ref\":\"downloads.StringDelta\"},\"finalUrl\":{\"optional\":true,\"name\":\"finalUrl\",\"$ref\":\"downloads.StringDelta\"},\"filename\":{\"optional\":true,\"name\":\"filename\",\"$ref\":\"downloads.StringDelta\"},\"danger\":{\"optional\":true,\"name\":\"danger\",\"$ref\":\"downloads.StringDelta\"},\"mime\":{\"optional\":true,\"name\":\"mime\",\"$ref\":\"downloads.StringDelta\"},\"startTime\":{\"optional\":true,\"name\":\"startTime\",\"$ref\":\"downloads.StringDelta\"},\"endTime\":{\"optional\":true,\"name\":\"endTime\",\"$ref\":\"downloads.StringDelta\"},\"state\":{\"optional\":true,\"name\":\"state\",\"$ref\":\"downloads.StringDelta\"},\"canResume\":{\"optional\":true,\"name\":\"canResume\",\"$ref\":\"downloads.BooleanDelta\"},\"paused\":{\"optional\":true,\"name\":\"paused\",\"$ref\":\"downloads.BooleanDelta\"},\"error\":{\"optional\":true,\"name\":\"error\",\"$ref\":\"downloads.StringDelta\"},\"totalBytes\":{\"optional\":true,\"name\":\"totalBytes\",\"$ref\":\"downloads.DoubleDelta\"},\"fileSize\":{\"optional\":true,\"name\":\"fileSize\",\"$ref\":\"downloads.DoubleDelta\"},\"exists\":{\"optional\":true,\"name\":\"exists\",\"$ref\":\"downloads.BooleanDelta\"}}},{\"inline_doc\":true,\"type\":\"object\",\"id\":\"downloads.GetFileIconOptions\",\"properties\":{\"size\":{\"optional\":true,\"name\":\"size\",\"type\":\"integer\",\"enum\":[16,32]}}}]}";
const char kDownloadsInternal[] = "{\"functions\":[{\"parameters\":[{\"type\":\"integer\",\"name\":\"downloadId\"},{\"type\":\"string\",\"name\":\"filename\"},{\"type\":\"string\",\"name\":\"conflict_action\"}],\"name\":\"determineFilename\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"downloadsInternal\",\"properties\":{},\"types\":[]}";
const char kEnterpriseHardwarePlatform[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"enterprise.hardwarePlatform.HardwarePlatformInfo\"}]}],\"name\":\"getHardwarePlatformInfo\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"enterprise.hardwarePlatform\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"enterprise.hardwarePlatform.HardwarePlatformInfo\",\"properties\":{\"model\":{\"name\":\"model\",\"type\":\"string\"},\"manufacturer\":{\"name\":\"manufacturer\",\"type\":\"string\"}}}]}";
const char kFontSettings[] = "{\"namespace\":\"fontSettings\",\"types\":[{\"id\":\"fontSettings.FontName\",\"type\":\"object\",\"properties\":{\"fontId\":{\"type\":\"string\"},\"displayName\":{\"type\":\"string\"}}},{\"id\":\"fontSettings.ScriptCode\",\"type\":\"string\",\"enum\":[\"Afak\",\"Arab\",\"Armi\",\"Armn\",\"Avst\",\"Bali\",\"Bamu\",\"Bass\",\"Batk\",\"Beng\",\"Blis\",\"Bopo\",\"Brah\",\"Brai\",\"Bugi\",\"Buhd\",\"Cakm\",\"Cans\",\"Cari\",\"Cham\",\"Cher\",\"Cirt\",\"Copt\",\"Cprt\",\"Cyrl\",\"Cyrs\",\"Deva\",\"Dsrt\",\"Dupl\",\"Egyd\",\"Egyh\",\"Egyp\",\"Elba\",\"Ethi\",\"Geor\",\"Geok\",\"Glag\",\"Goth\",\"Gran\",\"Grek\",\"Gujr\",\"Guru\",\"Hang\",\"Hani\",\"Hano\",\"Hans\",\"Hant\",\"Hebr\",\"Hluw\",\"Hmng\",\"Hung\",\"Inds\",\"Ital\",\"Java\",\"Jpan\",\"Jurc\",\"Kali\",\"Khar\",\"Khmr\",\"Khoj\",\"Knda\",\"Kpel\",\"Kthi\",\"Lana\",\"Laoo\",\"Latf\",\"Latg\",\"Latn\",\"Lepc\",\"Limb\",\"Lina\",\"Linb\",\"Lisu\",\"Loma\",\"Lyci\",\"Lydi\",\"Mand\",\"Mani\",\"Maya\",\"Mend\",\"Merc\",\"Mero\",\"Mlym\",\"Moon\",\"Mong\",\"Mroo\",\"Mtei\",\"Mymr\",\"Narb\",\"Nbat\",\"Nkgb\",\"Nkoo\",\"Nshu\",\"Ogam\",\"Olck\",\"Orkh\",\"Orya\",\"Osma\",\"Palm\",\"Perm\",\"Phag\",\"Phli\",\"Phlp\",\"Phlv\",\"Phnx\",\"Plrd\",\"Prti\",\"Rjng\",\"Roro\",\"Runr\",\"Samr\",\"Sara\",\"Sarb\",\"Saur\",\"Sgnw\",\"Shaw\",\"Shrd\",\"Sind\",\"Sinh\",\"Sora\",\"Sund\",\"Sylo\",\"Syrc\",\"Syre\",\"Syrj\",\"Syrn\",\"Tagb\",\"Takr\",\"Tale\",\"Talu\",\"Taml\",\"Tang\",\"Tavt\",\"Telu\",\"Teng\",\"Tfng\",\"Tglg\",\"Thaa\",\"Thai\",\"Tibt\",\"Tirh\",\"Ugar\",\"Vaii\",\"Visp\",\"Wara\",\"Wole\",\"Xpeo\",\"Xsux\",\"Yiii\",\"Zmth\",\"Zsym\",\"Zyyy\"]},{\"id\":\"fontSettings.GenericFamily\",\"type\":\"string\",\"enum\":[\"standard\",\"sansserif\",\"serif\",\"fixed\",\"cursive\",\"fantasy\"]},{\"id\":\"fontSettings.LevelOfControl\",\"type\":\"string\",\"enum\":[\"not_controllable\",\"controlled_by_other_extensions\",\"controllable_by_this_extension\",\"controlled_by_this_extension\"]}],\"functions\":[{\"name\":\"clearFont\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"script\":{\"$ref\":\"fontSettings.ScriptCode\",\"optional\":true},\"genericFamily\":{\"$ref\":\"fontSettings.GenericFamily\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getFont\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"script\":{\"$ref\":\"fontSettings.ScriptCode\",\"optional\":true},\"genericFamily\":{\"$ref\":\"fontSettings.GenericFamily\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"fontId\":{\"type\":\"string\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]}]},{\"name\":\"setFont\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"script\":{\"$ref\":\"fontSettings.ScriptCode\",\"optional\":true},\"genericFamily\":{\"$ref\":\"fontSettings.GenericFamily\"},\"fontId\":{\"type\":\"string\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getFontList\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"fontSettings.FontName\"}}]}]},{\"name\":\"clearDefaultFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"optional\":true,\"properties\":{}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getDefaultFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"optional\":true,\"properties\":{}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]}]},{\"name\":\"setDefaultFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"clearDefaultFixedFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"optional\":true,\"properties\":{}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getDefaultFixedFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"optional\":true,\"properties\":{}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]}]},{\"name\":\"setDefaultFixedFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"clearMinimumFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"optional\":true,\"properties\":{}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getMinimumFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"optional\":true,\"properties\":{}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]}]},{\"name\":\"setMinimumFontSize\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]}],\"events\":[{\"name\":\"onFontChanged\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"fontId\":{\"type\":\"string\"},\"script\":{\"$ref\":\"fontSettings.ScriptCode\",\"optional\":true},\"genericFamily\":{\"$ref\":\"fontSettings.GenericFamily\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]},{\"name\":\"onDefaultFontSizeChanged\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]},{\"name\":\"onDefaultFixedFontSizeChanged\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]},{\"name\":\"onMinimumFontSizeChanged\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"pixelSize\":{\"type\":\"integer\"},\"levelOfControl\":{\"$ref\":\"fontSettings.LevelOfControl\"}}}]}]}";
const char kGcm[] = "{\"namespace\":\"gcm\",\"properties\":{\"MAX_MESSAGE_SIZE\":{\"value\":4096,\"type\":\"integer\"}},\"functions\":[{\"name\":\"register\",\"type\":\"function\",\"parameters\":[{\"name\":\"senderIds\",\"type\":\"array\",\"items\":{\"type\":\"string\",\"minLength\":1},\"minItems\":1,\"maxItems\":100},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"registrationId\",\"type\":\"string\"}]}]},{\"name\":\"unregister\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[]}]},{\"name\":\"send\",\"type\":\"function\",\"parameters\":[{\"name\":\"message\",\"type\":\"object\",\"properties\":{\"destinationId\":{\"type\":\"string\",\"minLength\":1},\"messageId\":{\"type\":\"string\",\"minLength\":1},\"timeToLive\":{\"type\":\"integer\",\"minimum\":0,\"maximum\":86400,\"optional\":true},\"data\":{\"type\":\"object\",\"properties\":{},\"additionalProperties\":{\"type\":\"string\",\"minLength\":1}}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"messageId\",\"type\":\"string\"}]}]}],\"events\":[{\"name\":\"onMessage\",\"type\":\"function\",\"parameters\":[{\"name\":\"message\",\"type\":\"object\",\"properties\":{\"data\":{\"type\":\"object\",\"properties\":{},\"additionalProperties\":{\"type\":\"string\"}},\"from\":{\"type\":\"string\",\"optional\":true},\"collapseKey\":{\"type\":\"string\",\"optional\":true}}}]},{\"name\":\"onMessagesDeleted\",\"type\":\"function\"},{\"name\":\"onSendError\",\"type\":\"function\",\"parameters\":[{\"name\":\"error\",\"type\":\"object\",\"properties\":{\"errorMessage\":{\"type\":\"string\"},\"messageId\":{\"type\":\"string\",\"optional\":true},\"details\":{\"type\":\"object\",\"properties\":{},\"additionalProperties\":{\"type\":\"string\"}}}}]}]}";
const char kHistory[] = "{\"namespace\":\"history\",\"types\":[{\"id\":\"history.TransitionType\",\"type\":\"string\",\"enum\":[\"link\",\"typed\",\"auto_bookmark\",\"auto_subframe\",\"manual_subframe\",\"generated\",\"auto_toplevel\",\"form_submit\",\"reload\",\"keyword\",\"keyword_generated\"]},{\"id\":\"history.HistoryItem\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\",\"minimum\":0},\"url\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"lastVisitTime\":{\"type\":\"number\",\"optional\":true},\"visitCount\":{\"type\":\"integer\",\"optional\":true},\"typedCount\":{\"type\":\"integer\",\"optional\":true}}},{\"id\":\"history.VisitItem\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\",\"minimum\":0},\"visitId\":{\"type\":\"string\"},\"visitTime\":{\"type\":\"number\",\"optional\":true},\"referringVisitId\":{\"type\":\"string\"},\"transition\":{\"$ref\":\"history.TransitionType\"}}}],\"functions\":[{\"name\":\"search\",\"type\":\"function\",\"parameters\":[{\"name\":\"query\",\"type\":\"object\",\"properties\":{\"text\":{\"type\":\"string\"},\"startTime\":{\"type\":\"number\",\"optional\":true},\"endTime\":{\"type\":\"number\",\"optional\":true},\"maxResults\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"history.HistoryItem\"}}]}]},{\"name\":\"getVisits\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"url\":{\"type\":\"string\"}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"results\",\"type\":\"array\",\"items\":{\"$ref\":\"history.VisitItem\"}}]}]},{\"name\":\"addUrl\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"url\":{\"type\":\"string\"}}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"deleteUrl\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"url\":{\"type\":\"string\"}}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"deleteRange\",\"type\":\"function\",\"parameters\":[{\"name\":\"range\",\"type\":\"object\",\"properties\":{\"startTime\":{\"type\":\"number\"},\"endTime\":{\"type\":\"number\"}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[]}]},{\"name\":\"deleteAll\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[]}]}],\"events\":[{\"name\":\"onVisited\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"history.HistoryItem\"}]},{\"name\":\"onVisitRemoved\",\"type\":\"function\",\"parameters\":[{\"name\":\"removed\",\"type\":\"object\",\"properties\":{\"allHistory\":{\"type\":\"boolean\"},\"urls\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true}}}]}]}";
const char kI18n[] = "{\"namespace\":\"i18n\",\"types\":[{\"id\":\"i18n.LanguageCode\",\"type\":\"string\"}],\"functions\":[{\"name\":\"getAcceptLanguages\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"languages\",\"type\":\"array\",\"items\":{\"$ref\":\"i18n.LanguageCode\"}}]}]},{\"name\":\"getMessage\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"messageName\"},{\"type\":\"any\",\"name\":\"substitutions\",\"optional\":true},{\"type\":\"object\",\"name\":\"options\",\"optional\":true,\"properties\":{\"escapeLt\":{\"type\":\"boolean\",\"optional\":true}}}],\"returns\":{\"type\":\"string\"}},{\"name\":\"getUILanguage\",\"type\":\"function\",\"parameters\":[],\"returns\":{\"type\":\"string\"}},{\"name\":\"detectLanguage\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"text\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"object\",\"name\":\"result\",\"properties\":{\"isReliable\":{\"type\":\"boolean\"},\"languages\":{\"type\":\"array\",\"items\":{\"type\":\"object\",\"properties\":{\"language\":{\"$ref\":\"i18n.LanguageCode\"},\"percentage\":{\"type\":\"integer\"}}}}}}]}]}],\"events\":[]}";
const char kIdentity[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"identity.AccountInfo\"},\"type\":\"array\",\"name\":\"accounts\"}]}],\"name\":\"getAccounts\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"identity.TokenDetails\",\"optional\":true,\"name\":\"details\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"optional\":true,\"type\":\"string\",\"name\":\"token\"}]}],\"name\":\"getAuthToken\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"userInfo\",\"$ref\":\"identity.ProfileUserInfo\"}]}],\"name\":\"getProfileUserInfo\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"identity.InvalidTokenDetails\",\"name\":\"details\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"removeCachedAuthToken\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"identity.WebAuthFlowDetails\",\"name\":\"details\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"optional\":true,\"type\":\"string\",\"name\":\"responseUrl\"}]}],\"name\":\"launchWebAuthFlow\",\"type\":\"function\"},{\"parameters\":[{\"optional\":true,\"type\":\"string\",\"name\":\"path\"}],\"returns\":{\"type\":\"string\",\"name\":\"getRedirectURL\"},\"name\":\"getRedirectURL\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"name\":\"account\",\"$ref\":\"identity.AccountInfo\"},{\"type\":\"boolean\",\"name\":\"signedIn\"}],\"name\":\"onSignInChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"identity\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"identity.AccountInfo\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"identity.ProfileUserInfo\",\"properties\":{\"email\":{\"name\":\"email\",\"type\":\"string\"},\"id\":{\"name\":\"id\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"identity.TokenDetails\",\"properties\":{\"interactive\":{\"optional\":true,\"name\":\"interactive\",\"type\":\"boolean\"},\"account\":{\"optional\":true,\"name\":\"account\",\"$ref\":\"identity.AccountInfo\"},\"scopes\":{\"optional\":true,\"name\":\"scopes\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}}},{\"type\":\"object\",\"id\":\"identity.InvalidTokenDetails\",\"properties\":{\"token\":{\"name\":\"token\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"identity.WebAuthFlowDetails\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"interactive\":{\"optional\":true,\"name\":\"interactive\",\"type\":\"boolean\"}}}]}";
const char kIdentityPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"string\",\"name\":\"result\"},{\"type\":\"string\",\"name\":\"window_id\"}],\"name\":\"setConsentResult\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"type\":\"string\",\"name\":\"key\"},{\"type\":\"string\",\"name\":\"url\"},{\"type\":\"string\",\"name\":\"mode\"}],\"name\":\"onWebFlowRequest\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"identityPrivate\",\"properties\":{},\"types\":[]}";
const char kImageWriterPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"string\",\"name\":\"storageUnitId\"},{\"type\":\"string\",\"name\":\"imageUrl\"},{\"$ref\":\"imageWriterPrivate.UrlWriteOptions\",\"optional\":true,\"name\":\"options\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"writeFromUrl\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"storageUnitId\"},{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"fileEntry\",\"isInstanceOf\":\"FileEntry\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"writeFromFile\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"returns\":{\"type\":\"boolean\",\"name\":\"cancelWrite\"},\"name\":\"cancelWrite\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"storageUnitId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"destroyPartitions\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"imageWriterPrivate.RemovableStorageDevice\"},\"type\":\"array\",\"name\":\"devices\"}]}],\"name\":\"listRemovableStorageDevices\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"name\":\"info\",\"$ref\":\"imageWriterPrivate.ProgressInfo\"}],\"name\":\"onWriteProgress\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"onWriteComplete\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"info\",\"$ref\":\"imageWriterPrivate.ProgressInfo\"},{\"type\":\"string\",\"name\":\"error\"}],\"name\":\"onWriteError\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"device\",\"$ref\":\"imageWriterPrivate.RemovableStorageDevice\"}],\"name\":\"onDeviceInserted\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"device\",\"$ref\":\"imageWriterPrivate.RemovableStorageDevice\"}],\"name\":\"onDeviceRemoved\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"imageWriterPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"confirmation\"},{\"name\":\"download\"},{\"name\":\"verifyDownload\"},{\"name\":\"unzip\"},{\"name\":\"write\"},{\"name\":\"verifyWrite\"},{\"name\":\"unknown\"}],\"type\":\"string\",\"id\":\"imageWriterPrivate.Stage\"},{\"type\":\"object\",\"id\":\"imageWriterPrivate.UrlWriteOptions\",\"properties\":{\"imageHash\":{\"optional\":true,\"name\":\"imageHash\",\"type\":\"string\"},\"saveAsDownload\":{\"optional\":true,\"name\":\"saveAsDownload\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"imageWriterPrivate.ProgressInfo\",\"properties\":{\"stage\":{\"name\":\"stage\",\"$ref\":\"imageWriterPrivate.Stage\"},\"percentComplete\":{\"name\":\"percentComplete\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"imageWriterPrivate.RemovableStorageDevice\",\"properties\":{\"storageUnitId\":{\"name\":\"storageUnitId\",\"type\":\"string\"},\"capacity\":{\"name\":\"capacity\",\"type\":\"number\"},\"vendor\":{\"name\":\"vendor\",\"type\":\"string\"},\"model\":{\"name\":\"model\",\"type\":\"string\"},\"removable\":{\"name\":\"removable\",\"type\":\"boolean\"}}}]}";
const char kInstanceID[] = "{\"namespace\":\"instanceID\",\"functions\":[{\"name\":\"getID\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"instanceID\",\"type\":\"string\"}]}]},{\"name\":\"getCreationTime\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"creationTime\",\"type\":\"number\"}]}]},{\"name\":\"getToken\",\"type\":\"function\",\"parameters\":[{\"name\":\"getTokenParams\",\"type\":\"object\",\"properties\":{\"authorizedEntity\":{\"type\":\"string\",\"minLength\":1},\"scope\":{\"type\":\"string\",\"minLength\":1},\"options\":{\"type\":\"object\",\"properties\":{},\"additionalProperties\":{\"type\":\"string\",\"minLength\":1},\"optional\":true}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"token\",\"type\":\"string\"}]}]},{\"name\":\"deleteToken\",\"type\":\"function\",\"parameters\":[{\"name\":\"deleteTokenParams\",\"type\":\"object\",\"properties\":{\"authorizedEntity\":{\"type\":\"string\",\"minLength\":1},\"scope\":{\"type\":\"string\",\"minLength\":1}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[]}]},{\"name\":\"deleteID\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[]}]}],\"events\":[{\"name\":\"onTokenRefresh\",\"type\":\"function\"}]}";
const char kLanguageSettingsPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"languageSettingsPrivate.Language\"},\"type\":\"array\",\"name\":\"languages\"}]}],\"name\":\"getLanguageList\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"languageCode\"}],\"name\":\"enableLanguage\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"languageCode\"}],\"name\":\"disableLanguage\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"languageCode\"},{\"type\":\"boolean\",\"name\":\"enable\"}],\"name\":\"setEnableTranslationForLanguage\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"languageCode\"},{\"name\":\"moveType\",\"$ref\":\"languageSettingsPrivate.MoveType\"}],\"name\":\"moveLanguage\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"languageSettingsPrivate.SpellcheckDictionaryStatus\"},\"type\":\"array\",\"name\":\"status\"}]}],\"name\":\"getSpellcheckDictionaryStatuses\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"type\":\"string\"},\"type\":\"array\",\"name\":\"words\"}]}],\"name\":\"getSpellcheckWords\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"word\"}],\"name\":\"addSpellcheckWord\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"word\"}],\"name\":\"removeSpellcheckWord\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"languageCode\"}]}],\"name\":\"getTranslateTargetLanguage\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"lists\",\"$ref\":\"languageSettingsPrivate.InputMethodLists\"}]}],\"name\":\"getInputMethodLists\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"inputMethodId\"}],\"name\":\"addInputMethod\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"inputMethodId\"}],\"name\":\"removeInputMethod\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"languageCode\"}],\"name\":\"retryDownloadDictionary\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"items\":{\"$ref\":\"languageSettingsPrivate.SpellcheckDictionaryStatus\"},\"type\":\"array\",\"name\":\"statuses\"}],\"name\":\"onSpellcheckDictionariesChanged\",\"type\":\"function\"},{\"parameters\":[{\"items\":{\"type\":\"string\"},\"type\":\"array\",\"name\":\"wordsAdded\"},{\"items\":{\"type\":\"string\"},\"type\":\"array\",\"name\":\"wordsRemoved\"}],\"name\":\"onCustomDictionaryChanged\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"inputMethodId\"}],\"name\":\"onInputMethodAdded\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"inputMethodId\"}],\"name\":\"onInputMethodRemoved\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"languageSettingsPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"TOP\"},{\"name\":\"UP\"},{\"name\":\"DOWN\"},{\"name\":\"UNKNOWN\"}],\"type\":\"string\",\"id\":\"languageSettingsPrivate.MoveType\"},{\"type\":\"object\",\"id\":\"languageSettingsPrivate.Language\",\"properties\":{\"code\":{\"name\":\"code\",\"type\":\"string\"},\"displayName\":{\"name\":\"displayName\",\"type\":\"string\"},\"nativeDisplayName\":{\"name\":\"nativeDisplayName\",\"type\":\"string\"},\"supportsUI\":{\"optional\":true,\"name\":\"supportsUI\",\"type\":\"boolean\"},\"supportsSpellcheck\":{\"optional\":true,\"name\":\"supportsSpellcheck\",\"type\":\"boolean\"},\"supportsTranslate\":{\"optional\":true,\"name\":\"supportsTranslate\",\"type\":\"boolean\"},\"isProhibitedLanguage\":{\"optional\":true,\"name\":\"isProhibitedLanguage\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"languageSettingsPrivate.SpellcheckDictionaryStatus\",\"properties\":{\"languageCode\":{\"name\":\"languageCode\",\"type\":\"string\"},\"isReady\":{\"name\":\"isReady\",\"type\":\"boolean\"},\"isDownloading\":{\"optional\":true,\"name\":\"isDownloading\",\"type\":\"boolean\"},\"downloadFailed\":{\"optional\":true,\"name\":\"downloadFailed\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"languageSettingsPrivate.InputMethod\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"string\"},\"displayName\":{\"name\":\"displayName\",\"type\":\"string\"},\"languageCodes\":{\"name\":\"languageCodes\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"enabled\":{\"optional\":true,\"name\":\"enabled\",\"type\":\"boolean\"},\"hasOptionsPage\":{\"optional\":true,\"name\":\"hasOptionsPage\",\"type\":\"boolean\"},\"isProhibitedByPolicy\":{\"optional\":true,\"name\":\"isProhibitedByPolicy\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"languageSettingsPrivate.InputMethodLists\",\"properties\":{\"componentExtensionImes\":{\"name\":\"componentExtensionImes\",\"type\":\"array\",\"items\":{\"$ref\":\"languageSettingsPrivate.InputMethod\"}},\"thirdPartyExtensionImes\":{\"name\":\"thirdPartyExtensionImes\",\"type\":\"array\",\"items\":{\"$ref\":\"languageSettingsPrivate.InputMethod\"}}}}]}";
const char kManifestTypes[] = "{\"namespace\":\"manifestTypes\",\"types\":[{\"id\":\"manifestTypes.ChromeSettingsOverrides\",\"type\":\"object\",\"properties\":{\"homepage\":{\"optional\":true,\"type\":\"string\"},\"search_provider\":{\"type\":\"object\",\"optional\":true,\"properties\":{\"name\":{\"type\":\"string\",\"optional\":true},\"keyword\":{\"type\":\"string\",\"optional\":true},\"favicon_url\":{\"type\":\"string\",\"optional\":true},\"search_url\":{\"type\":\"string\"},\"encoding\":{\"type\":\"string\",\"optional\":true},\"suggest_url\":{\"type\":\"string\",\"optional\":true},\"image_url\":{\"type\":\"string\",\"optional\":true},\"search_url_post_params\":{\"type\":\"string\",\"optional\":true},\"suggest_url_post_params\":{\"type\":\"string\",\"optional\":true},\"image_url_post_params\":{\"type\":\"string\",\"optional\":true},\"alternate_urls\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"prepopulated_id\":{\"type\":\"integer\",\"optional\":true},\"is_default\":{\"type\":\"boolean\"}}},\"startup_pages\":{\"optional\":true,\"type\":\"array\",\"items\":{\"type\":\"string\"}}}},{\"id\":\"manifestTypes.ChromeUIOverrides\",\"type\":\"object\",\"properties\":{\"bookmarks_ui\":{\"type\":\"object\",\"optional\":true,\"properties\":{\"remove_button\":{\"type\":\"boolean\",\"optional\":true},\"remove_bookmark_shortcut\":{\"type\":\"boolean\",\"optional\":true},\"remove_bookmark_open_pages_shortcut\":{\"type\":\"boolean\",\"optional\":true}}}}},{\"id\":\"manifestTypes.FileSystemProviderSource\",\"type\":\"string\",\"enum\":[\"file\",\"device\",\"network\"]},{\"id\":\"manifestTypes.FileSystemProviderCapabilities\",\"optional\":true,\"type\":\"object\",\"properties\":{\"configurable\":{\"type\":\"boolean\",\"optional\":true},\"multiple_mounts\":{\"type\":\"boolean\",\"optional\":true},\"watchable\":{\"type\":\"boolean\",\"optional\":true},\"source\":{\"$ref\":\"manifestTypes.FileSystemProviderSource\"}}}]}";
const char kNotifications[] = "{\"functions\":[{\"parameters\":[{\"optional\":true,\"type\":\"string\",\"name\":\"notificationId\"},{\"$ref\":\"notifications.NotificationOptions\",\"name\":\"options\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"notificationId\"}]}],\"name\":\"create\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"notificationId\"},{\"$ref\":\"notifications.NotificationOptions\",\"name\":\"options\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"wasUpdated\"}]}],\"name\":\"update\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"notificationId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"wasCleared\"}]}],\"name\":\"clear\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"notifications\"}]}],\"name\":\"getAll\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"level\",\"$ref\":\"notifications.PermissionLevel\"}]}],\"name\":\"getPermissionLevel\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"type\":\"string\",\"name\":\"notificationId\"},{\"type\":\"boolean\",\"name\":\"byUser\"}],\"name\":\"onClosed\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"notificationId\"}],\"name\":\"onClicked\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"notificationId\"},{\"type\":\"integer\",\"name\":\"buttonIndex\"}],\"name\":\"onButtonClicked\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"level\",\"$ref\":\"notifications.PermissionLevel\"}],\"name\":\"onPermissionLevelChanged\",\"type\":\"function\"},{\"deprecated\":\"Custom notification settings button is no longer supported.\",\"parameters\":[],\"name\":\"onShowSettings\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"notifications\",\"properties\":{},\"types\":[{\"noinline_doc\":\"True\",\"enum\":[{\"name\":\"basic\"},{\"name\":\"image\"},{\"name\":\"list\"},{\"name\":\"progress\"}],\"type\":\"string\",\"id\":\"notifications.TemplateType\"},{\"enum\":[{\"name\":\"granted\"},{\"name\":\"denied\"}],\"type\":\"string\",\"id\":\"notifications.PermissionLevel\"},{\"type\":\"object\",\"id\":\"notifications.NotificationItem\",\"properties\":{\"title\":{\"name\":\"title\",\"type\":\"string\"},\"message\":{\"name\":\"message\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"notifications.NotificationBitmap\",\"properties\":{\"width\":{\"name\":\"width\",\"type\":\"integer\"},\"height\":{\"name\":\"height\",\"type\":\"integer\"},\"data\":{\"optional\":true,\"name\":\"data\",\"type\":\"binary\",\"isInstanceOf\":\"ArrayBuffer\"}}},{\"type\":\"object\",\"id\":\"notifications.NotificationButton\",\"properties\":{\"title\":{\"name\":\"title\",\"type\":\"string\"},\"iconUrl\":{\"deprecated\":\"Button icons not visible for Mac OS X users.\",\"optional\":true,\"name\":\"iconUrl\",\"type\":\"string\"},\"iconBitmap\":{\"optional\":true,\"name\":\"iconBitmap\",\"$ref\":\"notifications.NotificationBitmap\"}}},{\"type\":\"object\",\"id\":\"notifications.NotificationOptions\",\"properties\":{\"type\":{\"optional\":true,\"name\":\"type\",\"$ref\":\"notifications.TemplateType\"},\"iconUrl\":{\"optional\":true,\"name\":\"iconUrl\",\"type\":\"string\"},\"iconBitmap\":{\"optional\":true,\"name\":\"iconBitmap\",\"$ref\":\"notifications.NotificationBitmap\"},\"appIconMaskUrl\":{\"deprecated\":\"The app icon mask is not visible for Mac OS X users.\",\"optional\":true,\"name\":\"appIconMaskUrl\",\"type\":\"string\"},\"appIconMaskBitmap\":{\"optional\":true,\"name\":\"appIconMaskBitmap\",\"$ref\":\"notifications.NotificationBitmap\"},\"title\":{\"optional\":true,\"name\":\"title\",\"type\":\"string\"},\"message\":{\"optional\":true,\"name\":\"message\",\"type\":\"string\"},\"contextMessage\":{\"optional\":true,\"name\":\"contextMessage\",\"type\":\"string\"},\"priority\":{\"optional\":true,\"name\":\"priority\",\"type\":\"integer\"},\"eventTime\":{\"optional\":true,\"name\":\"eventTime\",\"type\":\"number\"},\"buttons\":{\"optional\":true,\"name\":\"buttons\",\"type\":\"array\",\"items\":{\"$ref\":\"notifications.NotificationButton\"}},\"expandedMessage\":{\"optional\":true,\"name\":\"expandedMessage\",\"type\":\"string\"},\"imageUrl\":{\"deprecated\":\"The image is not visible for Mac OS X users.\",\"optional\":true,\"name\":\"imageUrl\",\"type\":\"string\"},\"imageBitmap\":{\"optional\":true,\"name\":\"imageBitmap\",\"$ref\":\"notifications.NotificationBitmap\"},\"items\":{\"optional\":true,\"name\":\"items\",\"type\":\"array\",\"items\":{\"$ref\":\"notifications.NotificationItem\"}},\"progress\":{\"optional\":true,\"name\":\"progress\",\"type\":\"integer\"},\"isClickable\":{\"deprecated\":\"This UI hint is ignored as of Chrome 67\",\"optional\":true,\"name\":\"isClickable\",\"type\":\"boolean\"},\"requireInteraction\":{\"optional\":true,\"name\":\"requireInteraction\",\"type\":\"boolean\"},\"silent\":{\"optional\":true,\"name\":\"silent\",\"type\":\"boolean\"}}}]}";
const char kOmnibox[] = "{\"namespace\":\"omnibox\",\"types\":[{\"id\":\"omnibox.DescriptionStyleType\",\"type\":\"string\",\"enum\":[\"url\",\"match\",\"dim\"]},{\"id\":\"omnibox.OnInputEnteredDisposition\",\"type\":\"string\",\"enum\":[\"currentTab\",\"newForegroundTab\",\"newBackgroundTab\"]},{\"id\":\"omnibox.SuggestResult\",\"type\":\"object\",\"properties\":{\"content\":{\"type\":\"string\",\"minLength\":1},\"description\":{\"type\":\"string\",\"minLength\":1},\"deletable\":{\"type\":\"boolean\",\"optional\":true},\"descriptionStyles\":{\"optional\":true,\"type\":\"array\",\"items\":{\"type\":\"object\",\"name\":\"matchClassification\",\"properties\":{\"offset\":{\"type\":\"integer\"},\"type\":{\"$ref\":\"omnibox.DescriptionStyleType\"},\"length\":{\"type\":\"integer\",\"optional\":true}}}},\"descriptionStylesRaw\":{\"optional\":true,\"type\":\"array\",\"items\":{\"type\":\"object\",\"name\":\"matchClassification\",\"properties\":{\"offset\":{\"type\":\"integer\"},\"type\":{\"type\":\"integer\"}}}}}},{\"id\":\"omnibox.DefaultSuggestResult\",\"inline_doc\":true,\"type\":\"object\",\"properties\":{\"description\":{\"type\":\"string\",\"minLength\":1},\"descriptionStyles\":{\"optional\":true,\"type\":\"array\",\"items\":{\"type\":\"object\",\"name\":\"matchClassification\",\"properties\":{\"offset\":{\"type\":\"integer\"},\"type\":{\"$ref\":\"omnibox.DescriptionStyleType\"},\"length\":{\"type\":\"integer\",\"optional\":true}}}},\"descriptionStylesRaw\":{\"optional\":true,\"type\":\"array\",\"items\":{\"type\":\"object\",\"name\":\"matchClassification\",\"properties\":{\"offset\":{\"type\":\"integer\"},\"type\":{\"type\":\"integer\"}}}}}}],\"functions\":[{\"name\":\"sendSuggestions\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"requestId\"},{\"name\":\"suggestResults\",\"type\":\"array\",\"items\":{\"$ref\":\"omnibox.SuggestResult\"}}]},{\"name\":\"setDefaultSuggestion\",\"type\":\"function\",\"parameters\":[{\"name\":\"suggestion\",\"$ref\":\"omnibox.DefaultSuggestResult\"}]}],\"events\":[{\"name\":\"onInputStarted\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"onInputChanged\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"text\"},{\"name\":\"suggest\",\"type\":\"function\",\"parameters\":[{\"name\":\"suggestResults\",\"type\":\"array\",\"items\":{\"$ref\":\"omnibox.SuggestResult\"}}]}]},{\"name\":\"onInputEntered\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"text\"},{\"name\":\"disposition\",\"$ref\":\"omnibox.OnInputEnteredDisposition\"}]},{\"name\":\"onInputCancelled\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"onDeleteSuggestion\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"text\"}]}]}";
const char kPageCapture[] = "{\"namespace\":\"pageCapture\",\"functions\":[{\"name\":\"saveAsMHTML\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"mhtmlData\",\"type\":\"binary\",\"optional\":true}]}]}]}";
const char kPasswordsPrivate[] = "{\"functions\":[{\"parameters\":[],\"name\":\"recordPasswordsPageAccessInSettings\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"id\"},{\"type\":\"string\",\"name\":\"new_username\"},{\"optional\":true,\"type\":\"string\",\"name\":\"new_password\"}],\"name\":\"changeSavedPassword\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"id\"}],\"name\":\"removeSavedPassword\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"id\"}],\"name\":\"removePasswordException\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"undoRemoveSavedPasswordOrException\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"optional\":true,\"type\":\"string\",\"name\":\"password\"}]}],\"name\":\"requestPlaintextPassword\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"passwordsPrivate.PasswordUiEntry\"},\"type\":\"array\",\"name\":\"entries\"}]}],\"name\":\"getSavedPasswordList\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"passwordsPrivate.ExceptionEntry\"},\"type\":\"array\",\"name\":\"exceptions\"}]}],\"name\":\"getPasswordExceptionList\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"importPasswords\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"exportPasswords\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"status\",\"$ref\":\"passwordsPrivate.ExportProgressStatus\"}]}],\"name\":\"requestExportProgressStatus\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"cancelExportPasswords\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"items\":{\"$ref\":\"passwordsPrivate.PasswordUiEntry\"},\"type\":\"array\",\"name\":\"entries\"}],\"name\":\"onSavedPasswordsListChanged\",\"type\":\"function\"},{\"parameters\":[{\"items\":{\"$ref\":\"passwordsPrivate.ExceptionEntry\"},\"type\":\"array\",\"name\":\"exceptions\"}],\"name\":\"onPasswordExceptionsListChanged\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"passwordsPrivate.PasswordExportProgress\",\"name\":\"status\"}],\"name\":\"onPasswordsFileExportProgress\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"passwordsPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"NOT_STARTED\"},{\"name\":\"IN_PROGRESS\"},{\"name\":\"SUCCEEDED\"},{\"name\":\"FAILED_CANCELLED\"},{\"name\":\"FAILED_WRITE_FAILED\"}],\"type\":\"string\",\"id\":\"passwordsPrivate.ExportProgressStatus\"},{\"type\":\"object\",\"id\":\"passwordsPrivate.UrlCollection\",\"properties\":{\"origin\":{\"name\":\"origin\",\"type\":\"string\"},\"shown\":{\"name\":\"shown\",\"type\":\"string\"},\"link\":{\"name\":\"link\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"passwordsPrivate.PasswordUiEntry\",\"properties\":{\"urls\":{\"name\":\"urls\",\"$ref\":\"passwordsPrivate.UrlCollection\"},\"username\":{\"name\":\"username\",\"type\":\"string\"},\"numCharactersInPassword\":{\"name\":\"numCharactersInPassword\",\"type\":\"integer\"},\"federationText\":{\"optional\":true,\"name\":\"federationText\",\"type\":\"string\"},\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"fromAccountStore\":{\"name\":\"fromAccountStore\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"passwordsPrivate.ExceptionEntry\",\"properties\":{\"urls\":{\"name\":\"urls\",\"$ref\":\"passwordsPrivate.UrlCollection\"},\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"fromAccountStore\":{\"name\":\"fromAccountStore\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"passwordsPrivate.PasswordExportProgress\",\"properties\":{\"status\":{\"name\":\"status\",\"$ref\":\"passwordsPrivate.ExportProgressStatus\"},\"folderName\":{\"optional\":true,\"name\":\"folderName\",\"type\":\"string\"}}}]}";
const char kPermissions[] = "{\"namespace\":\"permissions\",\"types\":[{\"id\":\"permissions.Permissions\",\"type\":\"object\",\"properties\":{\"permissions\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"origins\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true}}}],\"events\":[{\"name\":\"onAdded\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"permissions.Permissions\",\"name\":\"permissions\"}]},{\"name\":\"onRemoved\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"permissions.Permissions\",\"name\":\"permissions\"}]}],\"functions\":[{\"name\":\"getAll\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"permissions\",\"$ref\":\"permissions.Permissions\"}]}]},{\"name\":\"contains\",\"type\":\"function\",\"parameters\":[{\"name\":\"permissions\",\"$ref\":\"permissions.Permissions\"},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"type\":\"boolean\"}]}]},{\"name\":\"request\",\"type\":\"function\",\"parameters\":[{\"name\":\"permissions\",\"$ref\":\"permissions.Permissions\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"granted\",\"type\":\"boolean\"}]}]},{\"name\":\"remove\",\"type\":\"function\",\"parameters\":[{\"name\":\"permissions\",\"$ref\":\"permissions.Permissions\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"removed\",\"type\":\"boolean\"}]}]}]}";
const char kResourcesPrivate[] = "{\"functions\":[{\"parameters\":[{\"$ref\":\"resourcesPrivate.Component\",\"name\":\"component\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"result\"}]}],\"name\":\"getStrings\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"resourcesPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"identity\"},{\"name\":\"pdf\"}],\"type\":\"string\",\"id\":\"resourcesPrivate.Component\"}]}";
const char kSafeBrowsingPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"safeBrowsingPrivate.ReferrerChainEntry\"},\"type\":\"array\",\"name\":\"entries\"}]}],\"name\":\"getReferrerChain\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"$ref\":\"safeBrowsingPrivate.PolicySpecifiedPasswordReuse\",\"name\":\"reuseDetails\"}],\"name\":\"onPolicySpecifiedPasswordReuseDetected\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"userName\"}],\"name\":\"onPolicySpecifiedPasswordChanged\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"dict\",\"$ref\":\"safeBrowsingPrivate.DangerousDownloadInfo\"}],\"name\":\"onDangerousDownloadOpened\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"dict\",\"$ref\":\"safeBrowsingPrivate.InterstitialInfo\"}],\"name\":\"onSecurityInterstitialShown\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"dict\",\"$ref\":\"safeBrowsingPrivate.InterstitialInfo\"}],\"name\":\"onSecurityInterstitialProceeded\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"safeBrowsingPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"EVENT_URL\"},{\"name\":\"LANDING_PAGE\"},{\"name\":\"LANDING_REFERRER\"},{\"name\":\"CLIENT_REDIRECT\"},{\"name\":\"RECENT_NAVIGATION\"},{\"name\":\"REFERRER\"}],\"type\":\"string\",\"id\":\"safeBrowsingPrivate.URLType\"},{\"enum\":[{\"name\":\"BROWSER_INITIATED\"},{\"name\":\"RENDERER_INITIATED_WITHOUT_USER_GESTURE\"},{\"name\":\"RENDERER_INITIATED_WITH_USER_GESTURE\"}],\"type\":\"string\",\"id\":\"safeBrowsingPrivate.NavigationInitiation\"},{\"type\":\"object\",\"id\":\"safeBrowsingPrivate.PolicySpecifiedPasswordReuse\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"userName\":{\"name\":\"userName\",\"type\":\"string\"},\"isPhishingUrl\":{\"name\":\"isPhishingUrl\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"safeBrowsingPrivate.DangerousDownloadInfo\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"fileName\":{\"name\":\"fileName\",\"type\":\"string\"},\"downloadDigestSha256\":{\"name\":\"downloadDigestSha256\",\"type\":\"string\"},\"userName\":{\"name\":\"userName\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"safeBrowsingPrivate.InterstitialInfo\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"reason\":{\"name\":\"reason\",\"type\":\"string\"},\"netErrorCode\":{\"optional\":true,\"name\":\"netErrorCode\",\"type\":\"string\"},\"userName\":{\"name\":\"userName\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"safeBrowsingPrivate.ServerRedirect\",\"properties\":{\"url\":{\"optional\":true,\"name\":\"url\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"safeBrowsingPrivate.ReferrerChainEntry\",\"properties\":{\"url\":{\"name\":\"url\",\"type\":\"string\"},\"mainFrameUrl\":{\"optional\":true,\"name\":\"mainFrameUrl\",\"type\":\"string\"},\"urlType\":{\"name\":\"urlType\",\"$ref\":\"safeBrowsingPrivate.URLType\"},\"ipAddresses\":{\"optional\":true,\"name\":\"ipAddresses\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},\"referrerUrl\":{\"optional\":true,\"name\":\"referrerUrl\",\"type\":\"string\"},\"referrerMainFrameUrl\":{\"optional\":true,\"name\":\"referrerMainFrameUrl\",\"type\":\"string\"},\"isRetargeting\":{\"optional\":true,\"name\":\"isRetargeting\",\"type\":\"boolean\"},\"navigationTimeMs\":{\"optional\":true,\"name\":\"navigationTimeMs\",\"type\":\"number\"},\"serverRedirectChain\":{\"optional\":true,\"name\":\"serverRedirectChain\",\"type\":\"array\",\"items\":{\"$ref\":\"safeBrowsingPrivate.ServerRedirect\"}},\"navigationInitiation\":{\"optional\":true,\"name\":\"navigationInitiation\",\"$ref\":\"safeBrowsingPrivate.NavigationInitiation\"},\"maybeLaunchedByExternalApp\":{\"optional\":true,\"name\":\"maybeLaunchedByExternalApp\",\"type\":\"boolean\"}}}]}";
const char kSessions[] = "{\"namespace\":\"sessions\",\"types\":[{\"id\":\"sessions.Filter\",\"type\":\"object\",\"properties\":{\"maxResults\":{\"type\":\"integer\",\"minimum\":0,\"maximum\":25,\"optional\":true}}},{\"id\":\"sessions.Session\",\"type\":\"object\",\"properties\":{\"lastModified\":{\"type\":\"integer\"},\"tab\":{\"$ref\":\"tabs.Tab\",\"optional\":true},\"window\":{\"$ref\":\"windows.Window\",\"optional\":true}}},{\"id\":\"sessions.Device\",\"type\":\"object\",\"properties\":{\"info\":{\"type\":\"string\"},\"deviceName\":{\"type\":\"string\"},\"sessions\":{\"type\":\"array\",\"items\":{\"$ref\":\"sessions.Session\"}}}}],\"functions\":[{\"name\":\"getRecentlyClosed\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"sessions.Filter\",\"name\":\"filter\",\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"sessions\",\"type\":\"array\",\"items\":{\"$ref\":\"sessions.Session\"}}]}]},{\"name\":\"getDevices\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"sessions.Filter\",\"name\":\"filter\",\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"devices\",\"type\":\"array\",\"items\":{\"$ref\":\"sessions.Device\"}}]}]},{\"name\":\"restore\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"sessionId\",\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"$ref\":\"sessions.Session\",\"name\":\"restoredSession\"}]}]}],\"events\":[{\"name\":\"onChanged\",\"type\":\"function\"}],\"properties\":{\"MAX_SESSION_RESULTS\":{\"value\":25,\"type\":\"integer\"}}}";
const char kSettingsPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"string\",\"name\":\"name\"},{\"type\":\"any\",\"name\":\"value\"},{\"optional\":true,\"type\":\"string\",\"name\":\"pageId\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"success\"}]}],\"name\":\"setPref\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"settingsPrivate.PrefObject\"},\"type\":\"array\",\"name\":\"prefs\"}]}],\"name\":\"getAllPrefs\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"name\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"pref\",\"$ref\":\"settingsPrivate.PrefObject\"}]}],\"name\":\"getPref\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"number\",\"name\":\"zoom\"}]}],\"name\":\"getDefaultZoom\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"number\",\"name\":\"zoom\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"success\"}]}],\"name\":\"setDefaultZoom\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"items\":{\"$ref\":\"settingsPrivate.PrefObject\"},\"type\":\"array\",\"name\":\"prefs\"}],\"name\":\"onPrefsChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"settingsPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"BOOLEAN\"},{\"name\":\"NUMBER\"},{\"name\":\"STRING\"},{\"name\":\"URL\"},{\"name\":\"LIST\"},{\"name\":\"DICTIONARY\"}],\"type\":\"string\",\"id\":\"settingsPrivate.PrefType\"},{\"enum\":[{\"name\":\"DEVICE_POLICY\"},{\"name\":\"USER_POLICY\"},{\"name\":\"OWNER\"},{\"name\":\"PRIMARY_USER\"},{\"name\":\"EXTENSION\"},{\"name\":\"PARENT\"},{\"name\":\"CHILD_RESTRICTION\"}],\"type\":\"string\",\"id\":\"settingsPrivate.ControlledBy\"},{\"enum\":[{\"name\":\"ENFORCED\"},{\"name\":\"RECOMMENDED\"},{\"name\":\"PARENT_SUPERVISED\"}],\"type\":\"string\",\"id\":\"settingsPrivate.Enforcement\"},{\"type\":\"object\",\"id\":\"settingsPrivate.PrefObject\",\"properties\":{\"key\":{\"name\":\"key\",\"type\":\"string\"},\"type\":{\"name\":\"type\",\"$ref\":\"settingsPrivate.PrefType\"},\"value\":{\"name\":\"value\",\"type\":\"any\"},\"controlledBy\":{\"optional\":true,\"name\":\"controlledBy\",\"$ref\":\"settingsPrivate.ControlledBy\"},\"controlledByName\":{\"optional\":true,\"name\":\"controlledByName\",\"type\":\"string\"},\"enforcement\":{\"optional\":true,\"name\":\"enforcement\",\"$ref\":\"settingsPrivate.Enforcement\"},\"recommendedValue\":{\"optional\":true,\"name\":\"recommendedValue\",\"type\":\"any\"},\"extensionId\":{\"optional\":true,\"name\":\"extensionId\",\"type\":\"string\"},\"extensionCanBeDisabled\":{\"optional\":true,\"name\":\"extensionCanBeDisabled\",\"type\":\"boolean\"}}}]}";
const char kSignedInDevices[] = "{\"functions\":[{\"parameters\":[{\"optional\":true,\"type\":\"boolean\",\"name\":\"isLocal\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"signedInDevices.DeviceInfo\"},\"type\":\"array\",\"name\":\"devices\"}]}],\"name\":\"get\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"items\":{\"$ref\":\"signedInDevices.DeviceInfo\"},\"type\":\"array\",\"name\":\"devices\"}],\"name\":\"onDeviceInfoChange\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"signedInDevices\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"win\"},{\"name\":\"mac\"},{\"name\":\"linux\"},{\"name\":\"chrome_os\"},{\"name\":\"android\"},{\"name\":\"ios\"},{\"name\":\"unknown\"}],\"type\":\"string\",\"id\":\"signedInDevices.OS\"},{\"enum\":[{\"name\":\"desktop_or_laptop\"},{\"name\":\"phone\"},{\"name\":\"tablet\"},{\"name\":\"unknown\"}],\"type\":\"string\",\"id\":\"signedInDevices.DeviceType\"},{\"type\":\"object\",\"id\":\"signedInDevices.DeviceInfo\",\"properties\":{\"name\":{\"name\":\"name\",\"type\":\"string\"},\"id\":{\"name\":\"id\",\"type\":\"string\"},\"os\":{\"name\":\"os\",\"$ref\":\"signedInDevices.OS\"},\"type\":{\"name\":\"type\",\"$ref\":\"signedInDevices.DeviceType\"},\"chromeVersion\":{\"name\":\"chromeVersion\",\"type\":\"string\"}}}]}";
const char kSystemIndicator[] = "{\"functions\":[{\"parameters\":[{\"name\":\"details\",\"$ref\":\"systemIndicator.SetIconDetails\"},{\"optional\":true,\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setIcon\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"enable\",\"type\":\"function\"},{\"parameters\":[],\"name\":\"disable\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[],\"name\":\"onClicked\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"systemIndicator\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"systemIndicator.SetIconDetails\",\"properties\":{\"path\":{\"optional\":true,\"name\":\"path\",\"type\":\"any\"},\"imageData\":{\"optional\":true,\"name\":\"imageData\",\"type\":\"any\"}}}]}";
const char kSystemPrivate[] = "{\"namespace\":\"systemPrivate\",\"types\":[{\"id\":\"systemPrivate.UpdateStatusState\",\"type\":\"string\",\"enum\":[\"NotAvailable\",\"Updating\",\"NeedRestart\"]},{\"id\":\"systemPrivate.GetIncognitoModeAvailabilityValue\",\"type\":\"string\",\"enum\":[\"enabled\",\"disabled\",\"forced\"]},{\"id\":\"systemPrivate.UpdateStatus\",\"type\":\"object\",\"properties\":{\"state\":{\"$ref\":\"systemPrivate.UpdateStatusState\"},\"downloadProgress\":{\"type\":\"number\"}}}],\"functions\":[{\"name\":\"getIncognitoModeAvailability\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"value\",\"$ref\":\"systemPrivate.GetIncognitoModeAvailabilityValue\"}]}]},{\"name\":\"getUpdateStatus\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"$ref\":\"systemPrivate.UpdateStatus\",\"name\":\"status\"}]}]},{\"name\":\"getApiKey\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"key\",\"type\":\"string\"}]}]}]}";
const char kTabCapture[] = "{\"functions\":[{\"parameters\":[{\"$ref\":\"tabCapture.CaptureOptions\",\"name\":\"options\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"stream\",\"isInstanceOf\":\"LocalMediaStream\"}]}],\"name\":\"capture\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"tabCapture.CaptureInfo\"},\"type\":\"array\",\"name\":\"result\"}]}],\"name\":\"getCapturedTabs\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"startUrl\"},{\"$ref\":\"tabCapture.CaptureOptions\",\"name\":\"options\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"stream\",\"isInstanceOf\":\"LocalMediaStream\"}]}],\"name\":\"captureOffscreenTab\",\"type\":\"function\"},{\"parameters\":[{\"optional\":true,\"name\":\"options\",\"$ref\":\"tabCapture.GetMediaStreamOptions\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"streamId\"}]}],\"name\":\"getMediaStreamId\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"$ref\":\"tabCapture.CaptureInfo\",\"name\":\"info\"}],\"name\":\"onStatusChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"tabCapture\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"pending\"},{\"name\":\"active\"},{\"name\":\"stopped\"},{\"name\":\"error\"}],\"type\":\"string\",\"id\":\"tabCapture.TabCaptureState\"},{\"type\":\"object\",\"id\":\"tabCapture.CaptureInfo\",\"properties\":{\"tabId\":{\"name\":\"tabId\",\"type\":\"integer\"},\"status\":{\"name\":\"status\",\"$ref\":\"tabCapture.TabCaptureState\"},\"fullscreen\":{\"name\":\"fullscreen\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"tabCapture.MediaStreamConstraint\",\"properties\":{\"mandatory\":{\"name\":\"mandatory\",\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}},\"optional\":{\"optional\":true,\"name\":\"optional\",\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}}},{\"type\":\"object\",\"id\":\"tabCapture.CaptureOptions\",\"properties\":{\"audio\":{\"optional\":true,\"name\":\"audio\",\"type\":\"boolean\"},\"video\":{\"optional\":true,\"name\":\"video\",\"type\":\"boolean\"},\"audioConstraints\":{\"optional\":true,\"name\":\"audioConstraints\",\"$ref\":\"tabCapture.MediaStreamConstraint\"},\"videoConstraints\":{\"optional\":true,\"name\":\"videoConstraints\",\"$ref\":\"tabCapture.MediaStreamConstraint\"},\"presentationId\":{\"optional\":true,\"name\":\"presentationId\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"tabCapture.GetMediaStreamOptions\",\"properties\":{\"consumerTabId\":{\"optional\":true,\"name\":\"consumerTabId\",\"type\":\"integer\"},\"targetTabId\":{\"optional\":true,\"name\":\"targetTabId\",\"type\":\"integer\"}}}]}";
const char kTabs[] = "{\"namespace\":\"tabs\",\"types\":[{\"id\":\"tabs.MutedInfoReason\",\"type\":\"string\",\"enum\":[{\"name\":\"user\"},{\"name\":\"capture\"},{\"name\":\"extension\"}]},{\"id\":\"tabs.MutedInfo\",\"type\":\"object\",\"properties\":{\"muted\":{\"type\":\"boolean\"},\"reason\":{\"$ref\":\"tabs.MutedInfoReason\",\"optional\":true},\"extensionId\":{\"type\":\"string\",\"optional\":true}}},{\"id\":\"tabs.Tab\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"integer\",\"minimum\":-1,\"optional\":true},\"index\":{\"type\":\"integer\",\"minimum\":-1},\"windowId\":{\"type\":\"integer\",\"minimum\":0},\"openerTabId\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"selected\":{\"type\":\"boolean\",\"deprecated\":\"Please use $(ref:tabs.Tab.highlighted).\"},\"highlighted\":{\"type\":\"boolean\"},\"active\":{\"type\":\"boolean\"},\"pinned\":{\"type\":\"boolean\"},\"audible\":{\"type\":\"boolean\",\"optional\":true},\"discarded\":{\"type\":\"boolean\"},\"autoDiscardable\":{\"type\":\"boolean\"},\"mutedInfo\":{\"$ref\":\"tabs.MutedInfo\",\"optional\":true},\"url\":{\"type\":\"string\",\"optional\":true},\"pendingUrl\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"favIconUrl\":{\"type\":\"string\",\"optional\":true},\"status\":{\"type\":\"string\",\"optional\":true},\"incognito\":{\"type\":\"boolean\"},\"width\":{\"type\":\"integer\",\"optional\":true},\"height\":{\"type\":\"integer\",\"optional\":true},\"sessionId\":{\"type\":\"string\",\"optional\":true}}},{\"id\":\"tabs.ZoomSettingsMode\",\"type\":\"string\",\"enum\":[{\"name\":\"automatic\"},{\"name\":\"manual\"},{\"name\":\"disabled\"}]},{\"id\":\"tabs.ZoomSettingsScope\",\"type\":\"string\",\"enum\":[{\"name\":\"per-origin\"},{\"name\":\"per-tab\"}]},{\"id\":\"tabs.ZoomSettings\",\"type\":\"object\",\"properties\":{\"mode\":{\"$ref\":\"tabs.ZoomSettingsMode\",\"optional\":true},\"scope\":{\"$ref\":\"tabs.ZoomSettingsScope\",\"optional\":true},\"defaultZoomFactor\":{\"type\":\"number\",\"optional\":true}}},{\"id\":\"tabs.TabStatus\",\"type\":\"string\",\"enum\":[\"loading\",\"complete\"]},{\"id\":\"tabs.WindowType\",\"type\":\"string\",\"enum\":[\"normal\",\"popup\",\"panel\",\"app\",\"devtools\"]}],\"properties\":{\"TAB_ID_NONE\":{\"value\":-1,\"type\":\"integer\"}},\"functions\":[{\"name\":\"get\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]}]},{\"name\":\"getCurrent\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\",\"optional\":true}]}]},{\"name\":\"connect\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"connectInfo\",\"properties\":{\"name\":{\"type\":\"string\",\"optional\":true},\"frameId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}},\"optional\":true}],\"returns\":{\"$ref\":\"runtime.Port\"}},{\"name\":\"sendRequest\",\"deprecated\":\"Please use $(ref:runtime.sendMessage).\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"any\",\"name\":\"request\"},{\"type\":\"function\",\"name\":\"responseCallback\",\"optional\":true,\"parameters\":[{\"name\":\"response\",\"type\":\"any\"}]}]},{\"name\":\"sendMessage\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"any\",\"name\":\"message\"},{\"type\":\"object\",\"name\":\"options\",\"properties\":{\"frameId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}},\"optional\":true},{\"type\":\"function\",\"name\":\"responseCallback\",\"optional\":true,\"parameters\":[{\"name\":\"response\",\"type\":\"any\"}]}]},{\"name\":\"getSelected\",\"deprecated\":\"Please use $(ref:tabs.query) <code>{active: true}</code>.\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":-2,\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]}]},{\"name\":\"getAllInWindow\",\"type\":\"function\",\"deprecated\":\"Please use $(ref:tabs.query) <code>{windowId: windowId}</code>.\",\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":-2,\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"tabs\",\"type\":\"array\",\"items\":{\"$ref\":\"tabs.Tab\"}}]}]},{\"name\":\"create\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"createProperties\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":-2,\"optional\":true},\"index\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"url\":{\"type\":\"string\",\"optional\":true},\"active\":{\"type\":\"boolean\",\"optional\":true},\"selected\":{\"deprecated\":\"Please use <em>active</em>.\",\"type\":\"boolean\",\"optional\":true},\"pinned\":{\"type\":\"boolean\",\"optional\":true},\"openerTabId\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]}]},{\"name\":\"duplicate\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"tab\",\"optional\":true,\"$ref\":\"tabs.Tab\"}]}]},{\"name\":\"query\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"queryInfo\",\"properties\":{\"active\":{\"type\":\"boolean\",\"optional\":true},\"pinned\":{\"type\":\"boolean\",\"optional\":true},\"audible\":{\"type\":\"boolean\",\"optional\":true},\"muted\":{\"type\":\"boolean\",\"optional\":true},\"highlighted\":{\"type\":\"boolean\",\"optional\":true},\"discarded\":{\"type\":\"boolean\",\"optional\":true},\"autoDiscardable\":{\"type\":\"boolean\",\"optional\":true},\"currentWindow\":{\"type\":\"boolean\",\"optional\":true},\"lastFocusedWindow\":{\"type\":\"boolean\",\"optional\":true},\"status\":{\"$ref\":\"tabs.TabStatus\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true},\"url\":{\"choices\":[{\"type\":\"string\"},{\"type\":\"array\",\"items\":{\"type\":\"string\"}}],\"optional\":true},\"windowId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":-2},\"windowType\":{\"$ref\":\"tabs.WindowType\",\"optional\":true},\"index\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"array\",\"items\":{\"$ref\":\"tabs.Tab\"}}]}]},{\"name\":\"highlight\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"highlightInfo\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":-2},\"tabs\":{\"choices\":[{\"type\":\"array\",\"items\":{\"type\":\"integer\",\"minimum\":0}},{\"type\":\"integer\"}]}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"window\",\"$ref\":\"windows.Window\"}]}]},{\"name\":\"update\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0,\"optional\":true},{\"type\":\"object\",\"name\":\"updateProperties\",\"properties\":{\"url\":{\"type\":\"string\",\"optional\":true},\"active\":{\"type\":\"boolean\",\"optional\":true},\"highlighted\":{\"type\":\"boolean\",\"optional\":true},\"selected\":{\"deprecated\":\"Please use <em>highlighted</em>.\",\"type\":\"boolean\",\"optional\":true},\"pinned\":{\"type\":\"boolean\",\"optional\":true},\"muted\":{\"type\":\"boolean\",\"optional\":true},\"openerTabId\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"autoDiscardable\":{\"type\":\"boolean\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\",\"optional\":true}]}]},{\"name\":\"move\",\"type\":\"function\",\"parameters\":[{\"name\":\"tabIds\",\"choices\":[{\"type\":\"integer\",\"minimum\":0},{\"type\":\"array\",\"items\":{\"type\":\"integer\",\"minimum\":0}}]},{\"type\":\"object\",\"name\":\"moveProperties\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":-2,\"optional\":true},\"index\":{\"type\":\"integer\",\"minimum\":-1}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"tabs\",\"choices\":[{\"$ref\":\"tabs.Tab\"},{\"type\":\"array\",\"items\":{\"$ref\":\"tabs.Tab\"}}]}]}]},{\"name\":\"reload\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0,\"optional\":true},{\"type\":\"object\",\"name\":\"reloadProperties\",\"optional\":true,\"properties\":{\"bypassCache\":{\"type\":\"boolean\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"remove\",\"type\":\"function\",\"parameters\":[{\"name\":\"tabIds\",\"choices\":[{\"type\":\"integer\",\"minimum\":0},{\"type\":\"array\",\"items\":{\"type\":\"integer\",\"minimum\":0}}]},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"detectLanguage\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0,\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"language\"}]}]},{\"name\":\"captureVisibleTab\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":-2,\"optional\":true},{\"$ref\":\"extensionTypes.ImageDetail" "s\",\"name\":\"options\",\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"dataUrl\"}]}]},{\"name\":\"executeScript\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0,\"optional\":true},{\"$ref\":\"extensionTypes.InjectDetails\",\"name\":\"details\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"result\",\"optional\":true,\"type\":\"array\",\"items\":{\"type\":\"any\",\"minimum\":0}}]}]},{\"name\":\"insertCSS\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0,\"optional\":true},{\"$ref\":\"extensionTypes.InjectDetails\",\"name\":\"details\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"setZoom\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0,\"optional\":true},{\"type\":\"number\",\"name\":\"zoomFactor\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getZoom\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0,\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"number\",\"name\":\"zoomFactor\"}]}]},{\"name\":\"setZoomSettings\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"optional\":true,\"minimum\":0},{\"$ref\":\"tabs.ZoomSettings\",\"name\":\"zoomSettings\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getZoomSettings\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"optional\":true,\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"$ref\":\"tabs.ZoomSettings\",\"name\":\"zoomSettings\"}]}]},{\"name\":\"discard\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"optional\":true,\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\",\"optional\":true}]}]},{\"name\":\"goForward\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"optional\":true,\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"goBack\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"optional\":true,\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]}],\"events\":[{\"name\":\"onCreated\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"tabs.Tab\",\"name\":\"tab\"}]},{\"name\":\"onUpdated\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"changeInfo\",\"properties\":{\"status\":{\"type\":\"string\",\"optional\":true},\"url\":{\"type\":\"string\",\"optional\":true},\"pinned\":{\"type\":\"boolean\",\"optional\":true},\"audible\":{\"type\":\"boolean\",\"optional\":true},\"discarded\":{\"type\":\"boolean\",\"optional\":true},\"autoDiscardable\":{\"type\":\"boolean\",\"optional\":true},\"mutedInfo\":{\"$ref\":\"tabs.MutedInfo\",\"optional\":true},\"favIconUrl\":{\"type\":\"string\",\"optional\":true},\"title\":{\"type\":\"string\",\"optional\":true}}},{\"$ref\":\"tabs.Tab\",\"name\":\"tab\"}]},{\"name\":\"onMoved\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"moveInfo\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":0},\"fromIndex\":{\"type\":\"integer\",\"minimum\":0},\"toIndex\":{\"type\":\"integer\",\"minimum\":0}}}]},{\"name\":\"onSelectionChanged\",\"deprecated\":\"Please use $(ref:tabs.onActivated).\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"selectInfo\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":0}}}]},{\"name\":\"onActiveChanged\",\"deprecated\":\"Please use $(ref:tabs.onActivated).\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"selectInfo\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":0}}}]},{\"name\":\"onActivated\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"activeInfo\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0},\"windowId\":{\"type\":\"integer\",\"minimum\":0}}}]},{\"name\":\"onHighlightChanged\",\"deprecated\":\"Please use $(ref:tabs.onHighlighted).\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"selectInfo\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":0},\"tabIds\":{\"type\":\"array\",\"name\":\"tabIds\",\"items\":{\"type\":\"integer\",\"minimum\":0}}}}]},{\"name\":\"onHighlighted\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"highlightInfo\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":0},\"tabIds\":{\"type\":\"array\",\"name\":\"tabIds\",\"items\":{\"type\":\"integer\",\"minimum\":0}}}}]},{\"name\":\"onDetached\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"detachInfo\",\"properties\":{\"oldWindowId\":{\"type\":\"integer\",\"minimum\":0},\"oldPosition\":{\"type\":\"integer\",\"minimum\":0}}}]},{\"name\":\"onAttached\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"attachInfo\",\"properties\":{\"newWindowId\":{\"type\":\"integer\",\"minimum\":0},\"newPosition\":{\"type\":\"integer\",\"minimum\":0}}}]},{\"name\":\"onRemoved\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"object\",\"name\":\"removeInfo\",\"properties\":{\"windowId\":{\"type\":\"integer\",\"minimum\":0},\"isWindowClosing\":{\"type\":\"boolean\"}}}]},{\"name\":\"onReplaced\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"addedTabId\",\"minimum\":0},{\"type\":\"integer\",\"name\":\"removedTabId\",\"minimum\":0}]},{\"name\":\"onZoomChange\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"ZoomChangeInfo\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0},\"oldZoomFactor\":{\"type\":\"number\"},\"newZoomFactor\":{\"type\":\"number\"},\"zoomSettings\":{\"$ref\":\"tabs.ZoomSettings\"}}}]}]}";
const char kTypes[] = "{\"namespace\":\"types\",\"types\":[{\"id\":\"types.ChromeSettingScope\",\"type\":\"string\",\"enum\":[\"regular\",\"regular_only\",\"incognito_persistent\",\"incognito_session_only\"]},{\"id\":\"types.LevelOfControl\",\"type\":\"string\",\"enum\":[\"not_controllable\",\"controlled_by_other_extensions\",\"controllable_by_this_extension\",\"controlled_by_this_extension\"]},{\"id\":\"types.ChromeSetting\",\"type\":\"object\",\"js_module\":\"ChromeSetting\",\"customBindings\":\"types.ChromeSetting\",\"functions\":[{\"name\":\"get\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"incognito\":{\"type\":\"boolean\",\"optional\":true}}},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"value\":{\"type\":\"any\"},\"levelOfControl\":{\"$ref\":\"types.LevelOfControl\"},\"incognitoSpecific\":{\"type\":\"boolean\",\"optional\":true}}}]}]},{\"name\":\"set\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"value\":{\"type\":\"any\"},\"scope\":{\"$ref\":\"types.ChromeSettingScope\",\"optional\":true}}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"clear\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"scope\":{\"$ref\":\"types.ChromeSettingScope\",\"optional\":true}}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]}],\"events\":[{\"name\":\"onChange\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"value\":{\"type\":\"any\"},\"levelOfControl\":{\"$ref\":\"types.LevelOfControl\"},\"incognitoSpecific\":{\"type\":\"boolean\",\"optional\":true}}}]}]}]}";
const char kWebNavigation[] = "{\"namespace\":\"webNavigation\",\"types\":[{\"id\":\"webNavigation.TransitionType\",\"type\":\"string\",\"enum\":[\"link\",\"typed\",\"auto_bookmark\",\"auto_subframe\",\"manual_subframe\",\"generated\",\"start_page\",\"form_submit\",\"reload\",\"keyword\",\"keyword_generated\"]},{\"id\":\"webNavigation.TransitionQualifier\",\"type\":\"string\",\"enum\":[\"client_redirect\",\"server_redirect\",\"forward_back\",\"from_address_bar\"]}],\"functions\":[{\"name\":\"getFrame\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0},\"processId\":{\"type\":\"integer\",\"optional\":true,\"deprecated\":\"Frames are now uniquely identified by their tab ID and frame ID; the process ID is no longer needed and therefore ignored.\"},\"frameId\":{\"type\":\"integer\",\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"optional\":true,\"properties\":{\"errorOccurred\":{\"type\":\"boolean\"},\"url\":{\"type\":\"string\"},\"parentFrameId\":{\"type\":\"integer\"}}}]}]},{\"name\":\"getAllFrames\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"details\",\"type\":\"array\",\"optional\":true,\"items\":{\"type\":\"object\",\"properties\":{\"errorOccurred\":{\"type\":\"boolean\"},\"processId\":{\"type\":\"integer\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"}}}}]}]}],\"events\":[{\"name\":\"onBeforeNavigate\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"processId\":{\"type\":\"integer\",\"deprecated\":\"The processId is no longer set for this event, since the process which will render the resulting document is not known until onCommit.\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onCommitted\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"processId\":{\"type\":\"integer\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"transitionType\":{\"$ref\":\"webNavigation.TransitionType\"},\"transitionQualifiers\":{\"type\":\"array\",\"items\":{\"$ref\":\"webNavigation.TransitionQualifier\"}},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onDOMContentLoaded\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"processId\":{\"type\":\"integer\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onCompleted\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"processId\":{\"type\":\"integer\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onErrorOccurred\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"processId\":{\"type\":\"integer\",\"deprecated\":\"The processId is no longer set for this event.\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"error\":{\"type\":\"string\"},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onCreatedNavigationTarget\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"sourceTabId\":{\"type\":\"integer\"},\"sourceProcessId\":{\"type\":\"integer\"},\"sourceFrameId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"tabId\":{\"type\":\"integer\"},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onReferenceFragmentUpdated\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"processId\":{\"type\":\"integer\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"transitionType\":{\"$ref\":\"webNavigation.TransitionType\"},\"transitionQualifiers\":{\"type\":\"array\",\"items\":{\"$ref\":\"webNavigation.TransitionQualifier\"}},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onTabReplaced\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"replacedTabId\":{\"type\":\"integer\"},\"tabId\":{\"type\":\"integer\"},\"timeStamp\":{\"type\":\"number\"}}}]},{\"name\":\"onHistoryStateUpdated\",\"type\":\"function\",\"filters\":[{\"name\":\"url\",\"type\":\"array\",\"items\":{\"$ref\":\"events.UrlFilter\"}}],\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"tabId\":{\"type\":\"integer\"},\"url\":{\"type\":\"string\"},\"processId\":{\"type\":\"integer\"},\"frameId\":{\"type\":\"integer\"},\"parentFrameId\":{\"type\":\"integer\"},\"transitionType\":{\"$ref\":\"webNavigation.TransitionType\"},\"transitionQualifiers\":{\"type\":\"array\",\"items\":{\"$ref\":\"webNavigation.TransitionQualifier\"}},\"timeStamp\":{\"type\":\"number\"}}}]}]}";
const char kWebrtcAudioPrivate[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"items\":{\"$ref\":\"webrtcAudioPrivate.SinkInfo\"},\"type\":\"array\",\"name\":\"sinkInfo\"}]}],\"name\":\"getSinks\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"string\",\"name\":\"sourceIdInOrigin\"},{\"type\":\"function\",\"name\":\"cb\",\"parameters\":[{\"type\":\"string\",\"name\":\"sinkId\"}]}],\"name\":\"getAssociatedSink\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[],\"name\":\"onSinksChanged\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"webrtcAudioPrivate\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"webrtcAudioPrivate.SinkInfo\",\"properties\":{\"sinkId\":{\"name\":\"sinkId\",\"type\":\"string\"},\"sinkLabel\":{\"name\":\"sinkLabel\",\"type\":\"string\"},\"sampleRate\":{\"name\":\"sampleRate\",\"type\":\"integer\"},\"isReady\":{\"name\":\"isReady\",\"type\":\"boolean\"},\"isDefault\":{\"name\":\"isDefault\",\"type\":\"boolean\"}}}]}";
const char kWebrtcDesktopCapturePrivate[] = "{\"functions\":[{\"parameters\":[{\"items\":{\"$ref\":\"webrtcDesktopCapturePrivate.DesktopCaptureSourceType\"},\"type\":\"array\",\"name\":\"sources\"},{\"name\":\"request\",\"$ref\":\"webrtcDesktopCapturePrivate.RequestInfo\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"streamId\"}]}],\"returns\":{\"type\":\"integer\",\"name\":\"chooseDesktopMedia\"},\"name\":\"chooseDesktopMedia\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"desktopMediaRequestId\"}],\"name\":\"cancelChooseDesktopMedia\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"webrtcDesktopCapturePrivate\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"webrtcDesktopCapturePrivate.RequestInfo\",\"properties\":{\"guestProcessId\":{\"name\":\"guestProcessId\",\"type\":\"integer\"},\"guestRenderFrameId\":{\"name\":\"guestRenderFrameId\",\"type\":\"integer\"}}},{\"enum\":[{\"name\":\"screen\"},{\"name\":\"window\"},{\"name\":\"tab\"}],\"type\":\"string\",\"id\":\"webrtcDesktopCapturePrivate.DesktopCaptureSourceType\"}]}";
const char kWebrtcLoggingPrivate[] = "{\"functions\":[{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"items\":{\"$ref\":\"webrtcLoggingPrivate.MetaDataEntry\"},\"type\":\"array\",\"name\":\"metaData\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"setMetaData\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"start\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"boolean\",\"name\":\"shouldUpload\"}],\"name\":\"setUploadOnRenderClose\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"stop\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"string\",\"name\":\"logId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"store\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"string\",\"name\":\"logId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"webrtcLoggingPrivate.UploadResult\"}]}],\"name\":\"uploadStored\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"webrtcLoggingPrivate.UploadResult\"}]}],\"name\":\"upload\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"discard\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"boolean\",\"name\":\"incoming\"},{\"type\":\"boolean\",\"name\":\"outgoing\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"startRtpDump\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"boolean\",\"name\":\"incoming\"},{\"type\":\"boolean\",\"name\":\"outgoing\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"stopRtpDump\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"integer\",\"name\":\"seconds\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"webrtcLoggingPrivate.RecordingInfo\"}]}],\"name\":\"startAudioDebugRecordings\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"info\",\"$ref\":\"webrtcLoggingPrivate.RecordingInfo\"}]}],\"name\":\"stopAudioDebugRecordings\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"request\",\"$ref\":\"webrtcLoggingPrivate.RequestInfo\"},{\"type\":\"string\",\"name\":\"securityOrigin\"},{\"type\":\"string\",\"name\":\"sessionId\"},{\"type\":\"integer\",\"name\":\"maxLogSizeBytes\"},{\"type\":\"integer\",\"name\":\"outputPeriodMs\"},{\"type\":\"integer\",\"name\":\"webAppId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"webrtcLoggingPrivate.StartEventLoggingResult\"}]}],\"name\":\"startEventLogging\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"entry\",\"isInstanceOf\":\"DirectoryEntry\"}]}],\"name\":\"getLogsDirectory\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"webrtcLoggingPrivate\",\"properties\":{},\"types\":[{\"type\":\"object\",\"id\":\"webrtcLoggingPrivate.MetaDataEntry\",\"properties\":{\"key\":{\"name\":\"key\",\"type\":\"string\"},\"value\":{\"name\":\"value\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"webrtcLoggingPrivate.UploadResult\",\"properties\":{\"reportId\":{\"name\":\"reportId\",\"type\":\"string\"}}},{\"type\":\"object\",\"id\":\"webrtcLoggingPrivate.RequestInfo\",\"properties\":{\"tabId\":{\"optional\":true,\"name\":\"tabId\",\"type\":\"integer\"},\"guestProcessId\":{\"optional\":true,\"name\":\"guestProcessId\",\"type\":\"integer\"},\"targetWebview\":{\"optional\":true,\"name\":\"targetWebview\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"webrtcLoggingPrivate.RecordingInfo\",\"properties\":{\"prefixPath\":{\"name\":\"prefixPath\",\"type\":\"string\"},\"didStop\":{\"name\":\"didStop\",\"type\":\"boolean\"},\"didManualStop\":{\"name\":\"didManualStop\",\"type\":\"boolean\"}}},{\"type\":\"object\",\"id\":\"webrtcLoggingPrivate.StartEventLoggingResult\",\"properties\":{\"logId\":{\"name\":\"logId\",\"type\":\"string\"}}}]}";
const char kWebstorePrivate[] = "{\"namespace\":\"webstorePrivate\",\"types\":[{\"id\":\"webstorePrivate.Result\",\"type\":\"string\",\"enum\":[{\"name\":\"\"},{\"name\":\"success\"},{\"name\":\"user_gesture_required\"},{\"name\":\"unknown_error\"},{\"name\":\"feature_disabled\"},{\"name\":\"unsupported_extension_type\"},{\"name\":\"missing_dependencies\"},{\"name\":\"install_error\"},{\"name\":\"user_cancelled\"},{\"name\":\"invalid_id\"},{\"name\":\"blacklisted\"},{\"name\":\"blocked_by_policy\"},{\"name\":\"install_in_progress\"},{\"name\":\"launch_in_progress\"},{\"name\":\"manifest_error\"},{\"name\":\"icon_error\"},{\"name\":\"invalid_icon_url\"},{\"name\":\"already_installed\"},{\"name\":\"blocked_for_child_account\"}]},{\"id\":\"webstorePrivate.WebGlStatus\",\"type\":\"string\",\"enum\":[\"webgl_allowed\",\"webgl_blocked\"]},{\"id\":\"webstorePrivate.ExtensionInstallStatus\",\"type\":\"string\",\"enum\":[{\"name\":\"can_request\"},{\"name\":\"request_pending\"},{\"name\":\"blocked_by_policy\"},{\"name\":\"installable\"},{\"name\":\"enabled\"},{\"name\":\"disabled\"},{\"name\":\"terminated\"},{\"name\":\"blacklisted\"},{\"name\":\"custodian_approval_required\"}]}],\"functions\":[{\"name\":\"install\",\"parameters\":[{\"name\":\"expected_id\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"beginInstallWithManifest3\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\",\"minLength\":32,\"maxLength\":32},\"manifest\":{\"type\":\"string\",\"minLength\":1},\"iconUrl\":{\"type\":\"string\",\"optional\":true,\"desciption\":\"A URL for the image to display in the confirmation dialog\"},\"localizedName\":{\"type\":\"string\",\"optional\":true},\"locale\":{\"type\":\"string\",\"optional\":true},\"appInstallBubble\":{\"type\":\"boolean\",\"optional\":true},\"enableLauncher\":{\"type\":\"boolean\",\"optional\":true},\"authuser\":{\"type\":\"string\",\"optional\":true}},\"additionalProperties\":{\"type\":\"any\"}},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"result\",\"$ref\":\"webstorePrivate.Result\"}]}]},{\"name\":\"completeInstall\",\"parameters\":[{\"name\":\"expected_id\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"enableAppLauncher\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getBrowserLogin\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"info\",\"type\":\"object\",\"properties\":{\"login\":{\"type\":\"string\"}}}]}]},{\"name\":\"getStoreLogin\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"login\",\"type\":\"string\"}]}]},{\"name\":\"setStoreLogin\",\"parameters\":[{\"name\":\"login\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getWebGLStatus\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"webgl_status\",\"$ref\":\"webstorePrivate.WebGlStatus\"}]}]},{\"name\":\"getIsLauncherEnabled\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"is_enabled\",\"type\":\"boolean\"}]}]},{\"name\":\"isInIncognitoMode\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"is_incognito\",\"type\":\"boolean\"}]}]},{\"name\":\"getEphemeralAppsEnabled\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"is_enabled\",\"type\":\"boolean\"}]}]},{\"name\":\"launchEphemeralApp\",\"parameters\":[{\"name\":\"id\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"result\",\"$ref\":\"webstorePrivate.Result\"}]}]},{\"name\":\"isPendingCustodianApproval\",\"parameters\":[{\"name\":\"id\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"is_pending_approval\",\"type\":\"boolean\"}]}]},{\"name\":\"getReferrerChain\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"referrerChain\",\"type\":\"string\"}]}]},{\"name\":\"getExtensionStatus\",\"parameters\":[{\"name\":\"id\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"status\",\"$ref\":\"webstorePrivate.ExtensionInstallStatus\"}]}]},{\"name\":\"requestExtension\",\"parameters\":[{\"name\":\"id\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"status\",\"$ref\":\"webstorePrivate.ExtensionInstallStatus\"}]}]}]}";
const char kWindows[] = "{\"namespace\":\"windows\",\"types\":[{\"id\":\"windows.WindowType\",\"type\":\"string\",\"enum\":[{\"name\":\"normal\"},{\"name\":\"popup\"},{\"name\":\"panel\"},{\"name\":\"app\"},{\"name\":\"devtools\"}]},{\"id\":\"windows.WindowState\",\"type\":\"string\",\"enum\":[{\"name\":\"normal\"},{\"name\":\"minimized\"},{\"name\":\"maximized\"},{\"name\":\"fullscreen\"},{\"name\":\"locked-fullscreen\"}]},{\"id\":\"windows.Window\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0},\"focused\":{\"type\":\"boolean\"},\"top\":{\"type\":\"integer\",\"optional\":true},\"left\":{\"type\":\"integer\",\"optional\":true},\"width\":{\"type\":\"integer\",\"optional\":true},\"height\":{\"type\":\"integer\",\"optional\":true},\"tabs\":{\"type\":\"array\",\"items\":{\"$ref\":\"tabs.Tab\"},\"optional\":true},\"incognito\":{\"type\":\"boolean\"},\"type\":{\"$ref\":\"windows.WindowType\",\"optional\":true},\"state\":{\"$ref\":\"windows.WindowState\",\"optional\":true},\"alwaysOnTop\":{\"type\":\"boolean\"},\"sessionId\":{\"type\":\"string\",\"optional\":true}}},{\"id\":\"windows.CreateType\",\"type\":\"string\",\"enum\":[\"normal\",\"popup\",\"panel\"]}],\"properties\":{\"WINDOW_ID_NONE\":{\"value\":-1,\"type\":\"integer\"},\"WINDOW_ID_CURRENT\":{\"value\":-2,\"type\":\"integer\"}},\"functions\":[{\"name\":\"get\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":-2},{\"type\":\"object\",\"name\":\"getInfo\",\"optional\":true,\"properties\":{\"populate\":{\"type\":\"boolean\",\"optional\":true},\"windowTypes\":{\"type\":\"array\",\"items\":{\"$ref\":\"windows.WindowType\"},\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"window\",\"$ref\":\"windows.Window\"}]}]},{\"name\":\"getCurrent\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"getInfo\",\"optional\":true,\"properties\":{\"populate\":{\"type\":\"boolean\",\"optional\":true},\"windowTypes\":{\"type\":\"array\",\"items\":{\"$ref\":\"windows.WindowType\"},\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"window\",\"$ref\":\"windows.Window\"}]}]},{\"name\":\"getLastFocused\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"getInfo\",\"optional\":true,\"properties\":{\"populate\":{\"type\":\"boolean\",\"optional\":true},\"windowTypes\":{\"type\":\"array\",\"items\":{\"$ref\":\"windows.WindowType\"},\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"window\",\"$ref\":\"windows.Window\"}]}]},{\"name\":\"getAll\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"getInfo\",\"optional\":true,\"properties\":{\"populate\":{\"type\":\"boolean\",\"optional\":true},\"windowTypes\":{\"type\":\"array\",\"items\":{\"$ref\":\"windows.WindowType\"},\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"windows\",\"type\":\"array\",\"items\":{\"$ref\":\"windows.Window\"}}]}]},{\"name\":\"create\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"createData\",\"properties\":{\"url\":{\"optional\":true,\"choices\":[{\"type\":\"string\"},{\"type\":\"array\",\"items\":{\"type\":\"string\"}}]},\"tabId\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"left\":{\"type\":\"integer\",\"optional\":true},\"top\":{\"type\":\"integer\",\"optional\":true},\"width\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"height\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"focused\":{\"type\":\"boolean\",\"optional\":true},\"incognito\":{\"type\":\"boolean\",\"optional\":true},\"type\":{\"$ref\":\"windows.CreateType\",\"optional\":true},\"state\":{\"$ref\":\"windows.WindowState\",\"optional\":true},\"setSelfAsOpener\":{\"type\":\"boolean\",\"optional\":true}},\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"window\",\"$ref\":\"windows.Window\",\"optional\":true}]}]},{\"name\":\"update\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":-2},{\"type\":\"object\",\"name\":\"updateInfo\",\"properties\":{\"left\":{\"type\":\"integer\",\"optional\":true},\"top\":{\"type\":\"integer\",\"optional\":true},\"width\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"height\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true},\"focused\":{\"type\":\"boolean\",\"optional\":true},\"drawAttention\":{\"type\":\"boolean\",\"optional\":true},\"state\":{\"$ref\":\"windows.WindowState\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"window\",\"$ref\":\"windows.Window\"}]}]},{\"name\":\"remove\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]}],\"events\":[{\"name\":\"onCreated\",\"type\":\"function\",\"filters\":[{\"name\":\"windowTypes\",\"type\":\"array\",\"items\":{\"$ref\":\"windows.WindowType\"}}],\"parameters\":[{\"$ref\":\"windows.Window\",\"name\":\"window\"}]},{\"name\":\"onRemoved\",\"type\":\"function\",\"filters\":[{\"name\":\"windowTypes\",\"type\":\"array\",\"items\":{\"$ref\":\"windows.WindowType\"}}],\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":0}]},{\"name\":\"onFocusChanged\",\"type\":\"function\",\"filters\":[{\"name\":\"windowTypes\",\"type\":\"array\",\"items\":{\"$ref\":\"windows.WindowType\"}}],\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"minimum\":-1}]}]}";
const char kProcesses[] = "{\"functions\":[{\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"integer\",\"name\":\"processId\"}]}],\"name\":\"getProcessIdForTab\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"processId\"},{\"name\":\"callback\",\"parameters\":[{\"type\":\"boolean\",\"name\":\"didTerminate\"}],\"type\":\"function\",\"optional\":true}],\"name\":\"terminate\",\"type\":\"function\"},{\"parameters\":[{\"choices\":[{\"type\":\"integer\"},{\"type\":\"array\",\"items\":{\"type\":\"integer\"}}],\"name\":\"processIds\"},{\"type\":\"boolean\",\"name\":\"includeMemory\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"processes\"}]}],\"name\":\"getProcessInfo\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"processes\"}],\"name\":\"onUpdated\",\"type\":\"function\"},{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"processes\"}],\"name\":\"onUpdatedWithMemory\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"processes.Process\",\"name\":\"process\"}],\"name\":\"onCreated\",\"type\":\"function\"},{\"parameters\":[{\"$ref\":\"processes.Process\",\"name\":\"process\"}],\"name\":\"onUnresponsive\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"processId\"},{\"type\":\"integer\",\"name\":\"exitType\"},{\"type\":\"integer\",\"name\":\"exitCode\"}],\"name\":\"onExited\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"processes\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"browser\"},{\"name\":\"renderer\"},{\"name\":\"extension\"},{\"name\":\"notification\"},{\"name\":\"plugin\"},{\"name\":\"worker\"},{\"name\":\"nacl\"},{\"name\":\"service_worker\"},{\"name\":\"utility\"},{\"name\":\"gpu\"},{\"name\":\"other\"}],\"type\":\"string\",\"id\":\"processes.ProcessType\"},{\"type\":\"object\",\"id\":\"processes.TaskInfo\",\"properties\":{\"title\":{\"name\":\"title\",\"type\":\"string\"},\"tabId\":{\"optional\":true,\"name\":\"tabId\",\"type\":\"integer\"}}},{\"type\":\"object\",\"id\":\"processes.Cache\",\"properties\":{\"size\":{\"name\":\"size\",\"type\":\"number\"},\"liveSize\":{\"name\":\"liveSize\",\"type\":\"number\"}}},{\"type\":\"object\",\"id\":\"processes.Process\",\"properties\":{\"id\":{\"name\":\"id\",\"type\":\"integer\"},\"osProcessId\":{\"name\":\"osProcessId\",\"type\":\"integer\"},\"type\":{\"name\":\"type\",\"$ref\":\"processes.ProcessType\"},\"profile\":{\"name\":\"profile\",\"type\":\"string\"},\"naclDebugPort\":{\"name\":\"naclDebugPort\",\"type\":\"integer\"},\"tasks\":{\"name\":\"tasks\",\"type\":\"array\",\"items\":{\"$ref\":\"processes.TaskInfo\"}},\"cpu\":{\"optional\":true,\"name\":\"cpu\",\"type\":\"number\"},\"network\":{\"optional\":true,\"name\":\"network\",\"type\":\"number\"},\"privateMemory\":{\"optional\":true,\"name\":\"privateMemory\",\"type\":\"number\"},\"jsMemoryAllocated\":{\"optional\":true,\"name\":\"jsMemoryAllocated\",\"type\":\"number\"},\"jsMemoryUsed\":{\"optional\":true,\"name\":\"jsMemoryUsed\",\"type\":\"number\"},\"sqliteMemory\":{\"optional\":true,\"name\":\"sqliteMemory\",\"type\":\"number\"},\"imageCache\":{\"optional\":true,\"name\":\"imageCache\",\"$ref\":\"processes.Cache\"},\"scriptCache\":{\"optional\":true,\"name\":\"scriptCache\",\"$ref\":\"processes.Cache\"},\"cssCache\":{\"optional\":true,\"name\":\"cssCache\",\"$ref\":\"processes.Cache\"}}}]}";
const char kInputIme[] = "{\"namespace\":\"input.ime\",\"types\":[{\"id\":\"input.ime.KeyboardEventType\",\"type\":\"string\",\"enum\":[\"keyup\",\"keydown\"]},{\"id\":\"input.ime.KeyboardEvent\",\"type\":\"object\",\"properties\":{\"type\":{\"$ref\":\"input.ime.KeyboardEventType\"},\"requestId\":{\"type\":\"string\",\"optional\":true},\"extensionId\":{\"type\":\"string\",\"optional\":true},\"key\":{\"type\":\"string\"},\"code\":{\"type\":\"string\"},\"keyCode\":{\"type\":\"integer\",\"optional\":true},\"altKey\":{\"type\":\"boolean\",\"optional\":true},\"altgrKey\":{\"type\":\"boolean\",\"optional\":true},\"ctrlKey\":{\"type\":\"boolean\",\"optional\":true},\"shiftKey\":{\"type\":\"boolean\",\"optional\":true},\"capsLock\":{\"type\":\"boolean\",\"optional\":true}}},{\"id\":\"input.ime.InputContextType\",\"type\":\"string\",\"enum\":[\"text\",\"search\",\"tel\",\"url\",\"email\",\"number\",\"password\"]},{\"id\":\"input.ime.AutoCapitalizeType\",\"type\":\"string\",\"enum\":[\"characters\",\"words\",\"sentences\"]},{\"id\":\"input.ime.InputContext\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"type\":{\"$ref\":\"input.ime.InputContextType\"},\"autoCorrect\":{\"type\":\"boolean\"},\"autoComplete\":{\"type\":\"boolean\"},\"autoCapitalize\":{\"$ref\":\"input.ime.AutoCapitalizeType\"},\"spellCheck\":{\"type\":\"boolean\"},\"shouldDoLearning\":{\"type\":\"boolean\"}}},{\"id\":\"input.ime.MenuItemStyle\",\"type\":\"string\",\"enum\":[\"check\",\"radio\",\"separator\"]},{\"id\":\"input.ime.MenuItem\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\"},\"label\":{\"type\":\"string\",\"optional\":true},\"style\":{\"$ref\":\"input.ime.MenuItemStyle\",\"optional\":true},\"visible\":{\"type\":\"boolean\",\"optional\":true},\"checked\":{\"type\":\"boolean\",\"optional\":true},\"enabled\":{\"type\":\"boolean\",\"optional\":true}}},{\"id\":\"input.ime.UnderlineStyle\",\"type\":\"string\",\"enum\":[\"underline\",\"doubleUnderline\",\"noUnderline\"]},{\"id\":\"input.ime.WindowPosition\",\"type\":\"string\",\"enum\":[\"cursor\",\"composition\"]},{\"id\":\"input.ime.ScreenType\",\"type\":\"string\",\"enum\":[\"normal\",\"login\",\"lock\",\"secondary-login\"]},{\"id\":\"input.ime.MouseButton\",\"type\":\"string\",\"enum\":[\"left\",\"middle\",\"right\"]},{\"id\":\"input.ime.WindowType\",\"type\":\"string\",\"platforms\":[\"win\",\"linux\"],\"enum\":[\"normal\",\"followCursor\"]},{\"id\":\"input.ime.Bounds\",\"type\":\"object\",\"platforms\":[\"win\",\"linux\"],\"properties\":{\"left\":{\"type\":\"integer\"},\"top\":{\"type\":\"integer\"},\"width\":{\"type\":\"integer\"},\"height\":{\"type\":\"integer\"}}},{\"id\":\"input.ime.CreateWindowOptions\",\"type\":\"object\",\"platforms\":[\"win\",\"linux\"],\"properties\":{\"windowType\":{\"$ref\":\"input.ime.WindowType\"},\"url\":{\"type\":\"string\",\"optional\":true},\"bounds\":{\"$ref\":\"input.ime.Bounds\",\"optional\":true}}}],\"functions\":[{\"name\":\"setComposition\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"text\":{\"type\":\"string\"},\"selectionStart\":{\"optional\":true,\"type\":\"integer\"},\"selectionEnd\":{\"optional\":true,\"type\":\"integer\"},\"cursor\":{\"type\":\"integer\"},\"segments\":{\"type\":\"array\",\"optional\":true,\"items\":{\"type\":\"object\",\"properties\":{\"start\":{\"type\":\"integer\"},\"end\":{\"type\":\"integer\"},\"style\":{\"$ref\":\"input.ime.UnderlineStyle\"}}}}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"clearComposition\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"commitText\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"text\":{\"type\":\"string\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"sendKeyEvents\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"keyData\":{\"type\":\"array\",\"items\":{\"$ref\":\"input.ime.KeyboardEvent\"}}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"hideInputView\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[]},{\"name\":\"setCandidateWindowProperties\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"engineID\":{\"type\":\"string\"},\"properties\":{\"type\":\"object\",\"properties\":{\"visible\":{\"type\":\"boolean\",\"optional\":true},\"cursorVisible\":{\"type\":\"boolean\",\"optional\":true},\"vertical\":{\"type\":\"boolean\",\"optional\":true},\"pageSize\":{\"type\":\"integer\",\"optional\":true},\"auxiliaryText\":{\"type\":\"string\",\"optional\":true},\"auxiliaryTextVisible\":{\"type\":\"boolean\",\"optional\":true},\"windowPosition\":{\"$ref\":\"input.ime.WindowPosition\",\"optional\":true}}}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"setCandidates\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"candidates\":{\"type\":\"array\",\"items\":{\"type\":\"object\",\"properties\":{\"candidate\":{\"type\":\"string\"},\"id\":{\"type\":\"integer\"},\"parentId\":{\"type\":\"integer\",\"optional\":true},\"label\":{\"type\":\"string\",\"optional\":true},\"annotation\":{\"type\":\"string\",\"optional\":true},\"usage\":{\"type\":\"object\",\"optional\":true,\"properties\":{\"title\":{\"type\":\"string\"},\"body\":{\"type\":\"string\"}}}}}}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"setCursorPosition\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"candidateID\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"setMenuItems\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"engineID\":{\"type\":\"string\"},\"items\":{\"type\":\"array\",\"items\":{\"$ref\":\"input.ime.MenuItem\"}}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"updateMenuItems\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"engineID\":{\"type\":\"string\"},\"items\":{\"type\":\"array\",\"items\":{\"$ref\":\"input.ime.MenuItem\"}}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"deleteSurroundingText\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"engineID\":{\"type\":\"string\"},\"contextID\":{\"type\":\"integer\"},\"offset\":{\"type\":\"integer\"},\"length\":{\"type\":\"integer\",\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"keyEventHandled\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"type\":\"string\",\"name\":\"requestId\"},{\"type\":\"boolean\",\"name\":\"response\"}]},{\"name\":\"createWindow\",\"type\":\"function\",\"platforms\":[\"win\",\"linux\"],\"parameters\":[{\"$ref\":\"input.ime.CreateWindowOptions\",\"name\":\"options\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"windowObject\",\"type\":\"object\",\"isInstanceOf\":\"Window\"}]}]},{\"name\":\"showWindow\",\"type\":\"function\",\"platforms\":[\"win\",\"linux\"],\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"hideWindow\",\"type\":\"function\",\"platforms\":[\"win\",\"linux\"],\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"activate\",\"type\":\"function\",\"platforms\":[\"win\",\"linux\"],\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"deactivate\",\"type\":\"function\",\"platforms\":[\"win\",\"linux\"],\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]}],\"events\":[{\"name\":\"onActivate\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"type\":\"string\",\"name\":\"engineID\"},{\"name\":\"screen\",\"$ref\":\"input.ime.ScreenType\"}]},{\"name\":\"onDeactivated\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"type\":\"string\",\"name\":\"engineID\"}]},{\"name\":\"onFocus\",\"type\":\"function\",\"platforms\":[\"chromeos\"" ",\"win\",\"linux\"],\"parameters\":[{\"$ref\":\"input.ime.InputContext\",\"name\":\"context\"}]},{\"name\":\"onBlur\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"type\":\"integer\",\"name\":\"contextID\"}]},{\"name\":\"onInputContextUpdate\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"$ref\":\"input.ime.InputContext\",\"name\":\"context\"}]},{\"name\":\"onKeyEvent\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"options\":{\"supportsFilters\":false,\"supportsListeners\":true,\"supportsRules\":false,\"maxListeners\":1},\"parameters\":[{\"type\":\"string\",\"name\":\"engineID\"},{\"$ref\":\"input.ime.KeyboardEvent\",\"name\":\"keyData\"},{\"type\":\"string\",\"name\":\"requestId\"}],\"returns\":{\"type\":\"boolean\",\"optional\":true}},{\"name\":\"onCandidateClicked\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"type\":\"string\",\"name\":\"engineID\"},{\"type\":\"integer\",\"name\":\"candidateID\"},{\"name\":\"button\",\"$ref\":\"input.ime.MouseButton\"}]},{\"name\":\"onMenuItemActivated\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"type\":\"string\",\"name\":\"engineID\"},{\"type\":\"string\",\"name\":\"name\"}]},{\"name\":\"onSurroundingTextChanged\",\"type\":\"function\",\"platforms\":[\"chromeos\"],\"parameters\":[{\"type\":\"string\",\"name\":\"engineID\"},{\"type\":\"object\",\"name\":\"surroundingInfo\",\"properties\":{\"text\":{\"type\":\"string\"},\"focus\":{\"type\":\"integer\"},\"anchor\":{\"type\":\"integer\"},\"offset\":{\"type\":\"integer\"}}}]},{\"name\":\"onReset\",\"type\":\"function\",\"platforms\":[\"chromeos\",\"win\",\"linux\"],\"parameters\":[{\"type\":\"string\",\"name\":\"engineID\"}]},{\"name\":\"onCompositionBoundsChanged\",\"type\":\"function\",\"platforms\":[\"win\",\"linux\"],\"parameters\":[{\"type\":\"array\",\"name\":\"boundsList\",\"items\":{\"$ref\":\"input.ime.Bounds\"}}]}]}";
const char kEnterpriseReportingPrivate[] = "{\"functions\":[{\"parameters\":[{\"additionalProperties\":{\"type\":\"any\"},\"type\":\"object\",\"name\":\"report\"},{\"name\":\"callback\",\"parameters\":[],\"type\":\"function\",\"optional\":true}],\"name\":\"uploadChromeDesktopReport\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"callback\",\"parameters\":[{\"type\":\"string\",\"name\":\"id\"}],\"type\":\"function\",\"optional\":true}],\"name\":\"getDeviceId\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"binary\",\"name\":\"secret\",\"isInstanceOf\":\"ArrayBuffer\"}]}],\"name\":\"getPersistentSecret\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"binary\",\"name\":\"data\",\"isInstanceOf\":\"ArrayBuffer\"}]}],\"name\":\"getDeviceData\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"string\",\"name\":\"id\"},{\"optional\":true,\"type\":\"binary\",\"name\":\"data\",\"isInstanceOf\":\"ArrayBuffer\"},{\"name\":\"callback\",\"parameters\":[],\"type\":\"function\",\"optional\":true}],\"name\":\"setDeviceData\",\"type\":\"function\"},{\"parameters\":[{\"name\":\"callback\",\"parameters\":[{\"name\":\"deviceInfo\",\"$ref\":\"enterprise.reportingPrivate.DeviceInfo\"}],\"type\":\"function\",\"optional\":true}],\"name\":\"getDeviceInfo\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"enterprise.reportingPrivate\",\"properties\":{},\"types\":[{\"enum\":[{\"name\":\"UNKNOWN\"},{\"name\":\"DISABLED\"},{\"name\":\"ENABLED\"}],\"type\":\"string\",\"id\":\"enterprise.reportingPrivate.SettingValue\"},{\"type\":\"object\",\"id\":\"enterprise.reportingPrivate.DeviceInfo\",\"properties\":{\"osName\":{\"name\":\"osName\",\"type\":\"string\"},\"osVersion\":{\"name\":\"osVersion\",\"type\":\"string\"},\"deviceHostName\":{\"name\":\"deviceHostName\",\"type\":\"string\"},\"deviceModel\":{\"name\":\"deviceModel\",\"type\":\"string\"},\"serialNumber\":{\"name\":\"serialNumber\",\"type\":\"string\"},\"screenLockSecured\":{\"name\":\"screenLockSecured\",\"$ref\":\"enterprise.reportingPrivate.SettingValue\"},\"diskEncrypted\":{\"name\":\"diskEncrypted\",\"$ref\":\"enterprise.reportingPrivate.SettingValue\"}}}]}";
const char kCloudPrintPrivate[] = "{\"namespace\":\"cloudPrintPrivate\",\"types\":[{\"id\":\"cloudPrintPrivate.PrinterSettings\",\"type\":\"object\",\"properties\":{\"name\":{\"type\":\"string\"},\"connect\":{\"type\":\"boolean\"}}},{\"id\":\"cloudPrintPrivate.UserSettings\",\"type\":\"object\",\"properties\":{\"printers\":{\"type\":\"array\",\"items\":{\"$ref\":\"cloudPrintPrivate.PrinterSettings\"}},\"connectNewPrinters\":{\"type\":\"boolean\"}}}],\"functions\":[{\"name\":\"setupConnector\",\"type\":\"function\",\"parameters\":[{\"name\":\"userEmail\",\"type\":\"string\"},{\"name\":\"robotEmail\",\"type\":\"string\"},{\"name\":\"credentials\",\"type\":\"string\"},{\"name\":\"userSettings\",\"$ref\":\"cloudPrintPrivate.UserSettings\"}]},{\"name\":\"getHostName\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"getPrinters\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}]}]},{\"name\":\"getClientId\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]}]}";
const char kMdns[] = "{\"functions\":[{\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[]}],\"name\":\"forceDiscovery\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[{\"options\":{\"supportsFilters\":true,\"maxListeners\":10},\"parameters\":[{\"items\":{\"$ref\":\"mdns.MDnsService\"},\"type\":\"array\",\"name\":\"services\"}],\"name\":\"onServiceList\",\"type\":\"function\"}],\"platforms\":null,\"internal\":false,\"namespace\":\"mdns\",\"properties\":{\"MAX_SERVICE_INSTANCES_PER_EVENT\":{\"type\":\"integer\",\"value\":2048}},\"types\":[{\"type\":\"object\",\"id\":\"mdns.MDnsService\",\"properties\":{\"serviceName\":{\"name\":\"serviceName\",\"type\":\"string\"},\"serviceHostPort\":{\"name\":\"serviceHostPort\",\"type\":\"string\"},\"ipAddress\":{\"name\":\"ipAddress\",\"type\":\"string\"},\"serviceData\":{\"name\":\"serviceData\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}}}]}";
const char kAction[] = "{\"namespace\":\"action\",\"functions\":[{\"name\":\"setTitle\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"title\":{\"type\":\"string\"},\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getTitle\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"setIcon\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"imageData\":{\"choices\":[{\"$ref\":\"browserAction.ImageDataType\"},{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}],\"optional\":true},\"path\":{\"choices\":[{\"type\":\"string\"},{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}],\"optional\":true},\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"setPopup\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0},\"popup\":{\"type\":\"string\"}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getPopup\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"setBadgeText\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"text\":{\"type\":\"string\"},\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getBadgeText\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"setBadgeBackgroundColor\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"color\":{\"choices\":[{\"type\":\"string\"},{\"$ref\":\"browserAction.ColorArray\"}]},\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getBadgeBackgroundColor\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"browserAction.ColorArray\"}]}]},{\"name\":\"enable\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"optional\":true,\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"disable\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"optional\":true,\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]}],\"events\":[{\"name\":\"onClicked\",\"type\":\"function\",\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]}]}";
const char kBrowserAction[] = "{\"namespace\":\"browserAction\",\"types\":[{\"id\":\"browserAction.ColorArray\",\"type\":\"array\",\"items\":{\"type\":\"integer\",\"minimum\":0,\"maximum\":255},\"minItems\":4,\"maxItems\":4},{\"id\":\"browserAction.ImageDataType\",\"type\":\"object\",\"isInstanceOf\":\"ImageData\",\"additionalProperties\":{\"type\":\"any\"}}],\"functions\":[{\"name\":\"setTitle\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"title\":{\"type\":\"string\"},\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getTitle\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"setIcon\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"imageData\":{\"choices\":[{\"$ref\":\"browserAction.ImageDataType\"},{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}],\"optional\":true},\"path\":{\"choices\":[{\"type\":\"string\"},{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}],\"optional\":true},\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"setPopup\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true,\"minimum\":0},\"popup\":{\"type\":\"string\"}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getPopup\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"setBadgeText\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"text\":{\"type\":\"string\"},\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getBadgeText\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"setBadgeBackgroundColor\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"color\":{\"choices\":[{\"type\":\"string\"},{\"$ref\":\"browserAction.ColorArray\"}]},\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getBadgeBackgroundColor\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"$ref\":\"browserAction.ColorArray\"}]}]},{\"name\":\"enable\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"optional\":true,\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"disable\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"optional\":true,\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"openPopup\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"popupView\",\"type\":\"object\",\"optional\":true,\"additionalProperties\":{\"type\":\"any\"}}]}]}],\"events\":[{\"name\":\"onClicked\",\"type\":\"function\",\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]}]}";
const char kBrowsingData[] = "{\"namespace\":\"browsingData\",\"types\":[{\"id\":\"browsingData.RemovalOptions\",\"type\":\"object\",\"properties\":{\"since\":{\"type\":\"number\",\"optional\":true},\"originTypes\":{\"type\":\"object\",\"optional\":true,\"properties\":{\"unprotectedWeb\":{\"type\":\"boolean\",\"optional\":true},\"protectedWeb\":{\"type\":\"boolean\",\"optional\":true},\"extension\":{\"type\":\"boolean\",\"optional\":true}}},\"origins\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"excludeOrigins\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true}}},{\"id\":\"browsingData.DataTypeSet\",\"type\":\"object\",\"properties\":{\"appcache\":{\"type\":\"boolean\",\"optional\":true},\"cache\":{\"type\":\"boolean\",\"optional\":true},\"cacheStorage\":{\"type\":\"boolean\",\"optional\":true},\"cookies\":{\"type\":\"boolean\",\"optional\":true},\"downloads\":{\"type\":\"boolean\",\"optional\":true},\"fileSystems\":{\"type\":\"boolean\",\"optional\":true},\"formData\":{\"type\":\"boolean\",\"optional\":true},\"history\":{\"type\":\"boolean\",\"optional\":true},\"indexedDB\":{\"type\":\"boolean\",\"optional\":true},\"localStorage\":{\"type\":\"boolean\",\"optional\":true},\"serverBoundCertificates\":{\"type\":\"boolean\",\"optional\":true,\"deprecated\":\"Support for server-bound certificates has been removed. This data type will be ignored.\"},\"passwords\":{\"type\":\"boolean\",\"optional\":true},\"pluginData\":{\"type\":\"boolean\",\"optional\":true},\"serviceWorkers\":{\"type\":\"boolean\",\"optional\":true},\"webSQL\":{\"type\":\"boolean\",\"optional\":true}}}],\"functions\":[{\"name\":\"settings\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"parameters\":[{\"name\":\"result\",\"type\":\"object\",\"properties\":{\"options\":{\"$ref\":\"browsingData.RemovalOptions\"},\"dataToRemove\":{\"$ref\":\"browsingData.DataTypeSet\"},\"dataRemovalPermitted\":{\"$ref\":\"browsingData.DataTypeSet\"}}}]}]},{\"name\":\"remove\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"dataToRemove\",\"$ref\":\"browsingData.DataTypeSet\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeAppcache\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeCache\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeCacheStorage\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeCookies\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeDownloads\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeFileSystems\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeFormData\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeHistory\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeIndexedDB\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeLocalStorage\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removePluginData\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removePasswords\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeServiceWorkers\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"removeWebSQL\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"browsingData.RemovalOptions\",\"name\":\"options\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]}]}";
const char kExtension[] = "{\"namespace\":\"extension\",\"properties\":{\"lastError\":{\"type\":\"object\",\"optional\":true,\"deprecated\":\"Please use $(ref:runtime.lastError).\",\"properties\":{\"message\":{\"type\":\"string\"}}},\"inIncognitoContext\":{\"type\":\"boolean\",\"optional\":true}},\"types\":[{\"id\":\"extension.ViewType\",\"type\":\"string\",\"enum\":[\"tab\",\"popup\"]}],\"functions\":[{\"name\":\"sendRequest\",\"deprecated\":\"Please use $(ref:runtime.sendMessage).\",\"type\":\"function\",\"allowAmbiguousOptionalArguments\":true,\"parameters\":[{\"type\":\"string\",\"name\":\"extensionId\",\"optional\":true},{\"type\":\"any\",\"name\":\"request\"},{\"type\":\"function\",\"name\":\"responseCallback\",\"optional\":true,\"parameters\":[{\"name\":\"response\",\"type\":\"any\"}]}]},{\"name\":\"getURL\",\"deprecated\":\"Please use $(ref:runtime.getURL).\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"path\"}],\"returns\":{\"type\":\"string\"}},{\"name\":\"getViews\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"fetchProperties\",\"optional\":true,\"properties\":{\"type\":{\"$ref\":\"extension.ViewType\",\"optional\":true},\"windowId\":{\"type\":\"integer\",\"optional\":true},\"tabId\":{\"type\":\"integer\",\"optional\":true}}}],\"returns\":{\"type\":\"array\",\"items\":{\"name\":\"viewGlobals\",\"type\":\"object\",\"isInstanceOf\":\"Window\",\"additionalProperties\":{\"type\":\"any\"}}}},{\"name\":\"getBackgroundPage\",\"type\":\"function\",\"parameters\":[],\"returns\":{\"type\":\"object\",\"optional\":true,\"name\":\"backgroundPageGlobal\",\"isInstanceOf\":\"Window\",\"additionalProperties\":{\"type\":\"any\"}}},{\"name\":\"getExtensionTabs\",\"deprecated\":\"Please use $(ref:extension.getViews) <code>{type: \\\"tab\\\"}</code>.\",\"type\":\"function\",\"maximumManifestVersion\":1,\"parameters\":[{\"type\":\"integer\",\"name\":\"windowId\",\"optional\":true}],\"returns\":{\"type\":\"array\",\"items\":{\"type\":\"object\",\"name\":\"tabGlobals\",\"isInstanceOf\":\"Window\",\"additionalProperties\":{\"type\":\"any\"}}}},{\"name\":\"isAllowedIncognitoAccess\",\"type\":\"function\",\"min_version\":\"12.0.706.0\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"isAllowedAccess\",\"type\":\"boolean\"}]}]},{\"name\":\"isAllowedFileSchemeAccess\",\"type\":\"function\",\"min_version\":\"12.0.706.0\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"isAllowedAccess\",\"type\":\"boolean\"}]}]},{\"name\":\"setUpdateUrlData\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"data\",\"maxLength\":1024}]}],\"events\":[{\"name\":\"onRequest\",\"deprecated\":\"Please use $(ref:runtime.onMessage).\",\"type\":\"function\",\"options\":{\"unmanaged\":true},\"parameters\":[{\"name\":\"request\",\"type\":\"any\",\"optional\":true},{\"name\":\"sender\",\"$ref\":\"runtime.MessageSender\"},{\"name\":\"sendResponse\",\"type\":\"function\"}]},{\"name\":\"onRequestExternal\",\"deprecated\":\"Please use $(ref:runtime.onMessageExternal).\",\"type\":\"function\",\"parameters\":[{\"name\":\"request\",\"type\":\"any\",\"optional\":true},{\"name\":\"sender\",\"$ref\":\"runtime.MessageSender\"},{\"name\":\"sendResponse\",\"type\":\"function\"}]}]}";
const char kIdltest[] = "{\"functions\":[{\"parameters\":[{\"type\":\"binary\",\"name\":\"input\",\"isInstanceOf\":\"ArrayBuffer\"},{\"type\":\"function\",\"name\":\"cb\",\"parameters\":[{\"items\":{\"type\":\"integer\"},\"type\":\"array\",\"name\":\"array\"}]}],\"name\":\"sendArrayBuffer\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"binary\",\"name\":\"input\"},{\"type\":\"function\",\"name\":\"cb\",\"parameters\":[{\"items\":{\"type\":\"integer\"},\"type\":\"array\",\"name\":\"array\"}]}],\"name\":\"sendArrayBufferView\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"function\",\"name\":\"cb\",\"parameters\":[{\"type\":\"binary\",\"name\":\"buffer\",\"isInstanceOf\":\"ArrayBuffer\"}]}],\"name\":\"getArrayBuffer\",\"type\":\"function\"},{\"parameters\":[{\"type\":\"integer\",\"name\":\"switch\"}],\"name\":\"nocompileFunc\",\"type\":\"function\"}],\"documentation_options\":{},\"deprecated\":null,\"events\":[],\"platforms\":null,\"internal\":false,\"namespace\":\"idltest\",\"properties\":{},\"types\":[]}";
const char kPageAction[] = "{\"namespace\":\"pageAction\",\"types\":[{\"id\":\"pageAction.ImageDataType\",\"type\":\"object\",\"isInstanceOf\":\"ImageData\",\"additionalProperties\":{\"type\":\"any\"}}],\"functions\":[{\"name\":\"show\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"hide\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"tabId\",\"minimum\":0},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"setTitle\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0},\"title\":{\"type\":\"string\"}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getTitle\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]},{\"name\":\"setIcon\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0},\"imageData\":{\"choices\":[{\"$ref\":\"pageAction.ImageDataType\"},{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}],\"optional\":true},\"path\":{\"choices\":[{\"type\":\"string\"},{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}],\"optional\":true},\"iconIndex\":{\"type\":\"integer\",\"minimum\":0,\"optional\":true}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"setPopup\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\",\"minimum\":0},\"popup\":{\"type\":\"string\"}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[],\"optional\":true}]},{\"name\":\"getPopup\",\"type\":\"function\",\"parameters\":[{\"name\":\"details\",\"type\":\"object\",\"properties\":{\"tabId\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"result\",\"type\":\"string\"}]}]}],\"events\":[{\"name\":\"onClicked\",\"type\":\"function\",\"parameters\":[{\"name\":\"tab\",\"$ref\":\"tabs.Tab\"}]}]}";
const char kTopSites[] = "{\"namespace\":\"topSites\",\"types\":[{\"id\":\"topSites.MostVisitedURL\",\"type\":\"object\",\"properties\":{\"url\":{\"type\":\"string\"},\"title\":{\"type\":\"string\"}}}],\"functions\":[{\"name\":\"get\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"type\":\"array\",\"name\":\"data\",\"items\":{\"$ref\":\"topSites.MostVisitedURL\"}}]}]}]}";
const char kApp[] = "{\"namespace\":\"app\",\"types\":[{\"id\":\"app.Details\",\"type\":\"object\",\"properties\":{},\"additionalProperties\":{\"type\":\"any\"}},{\"id\":\"app.DOMWindow\",\"type\":\"object\",\"properties\":{},\"additionalProperties\":{\"type\":\"any\"}},{\"id\":\"app.InstallState\",\"type\":\"string\",\"enum\":[\"not_installed\",\"installed\",\"disabled\"]},{\"id\":\"app.RunningState\",\"type\":\"string\",\"enum\":[\"running\",\"cannot_run\",\"ready_to_run\"]}],\"functions\":[{\"name\":\"getIsInstalled\",\"type\":\"function\",\"parameters\":[],\"returns\":{\"name\":\"isInstalled\",\"type\":\"boolean\"}},{\"name\":\"installState\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"$ref\":\"app.InstallState\",\"name\":\"state\"}]}]},{\"name\":\"runningState\",\"type\":\"function\",\"parameters\":[],\"returns\":{\"$ref\":\"app.RunningState\"}},{\"name\":\"getDetails\",\"type\":\"function\",\"parameters\":[],\"returns\":{\"$ref\":\"app.Details\",\"optional\":true}}]}";
const char kCommands[] = "{\"namespace\":\"commands\",\"types\":[{\"id\":\"commands.Command\",\"type\":\"object\",\"properties\":{\"name\":{\"type\":\"string\",\"optional\":true},\"description\":{\"type\":\"string\",\"optional\":true},\"shortcut\":{\"type\":\"string\",\"optional\":true}}}],\"events\":[{\"name\":\"onCommand\",\"type\":\"function\",\"parameters\":[{\"name\":\"command\",\"type\":\"string\"}]}],\"functions\":[{\"name\":\"getAll\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"commands\",\"type\":\"array\",\"items\":{\"$ref\":\"commands.Command\"}}]}]}]}";
const char kDeclarativeContent[] = "{\"namespace\":\"declarativeContent\",\"types\":[{\"id\":\"declarativeContent.ImageDataType\",\"type\":\"binary\",\"isInstanceOf\":\"ImageData\",\"additionalProperties\":{\"type\":\"any\"},\"inline_doc\":true},{\"id\":\"declarativeContent.PageStateMatcherInstanceType\",\"type\":\"string\",\"enum\":[\"declarativeContent.PageStateMatcher\"]},{\"id\":\"declarativeContent.ShowPageActionInstanceType\",\"type\":\"string\",\"enum\":[\"declarativeContent.ShowPageAction\"]},{\"id\":\"declarativeContent.ShowActionInstanceType\",\"type\":\"string\",\"enum\":[\"declarativeContent.ShowAction\"]},{\"id\":\"declarativeContent.SetIconInstanceType\",\"type\":\"string\",\"enum\":[\"declarativeContent.SetIcon\"]},{\"id\":\"declarativeContent.RequestContentScriptInstanceType\",\"type\":\"string\",\"enum\":[\"declarativeContent.RequestContentScript\"]},{\"id\":\"declarativeContent.PageStateMatcher\",\"type\":\"object\",\"properties\":{\"pageUrl\":{\"$ref\":\"events.UrlFilter\",\"optional\":true},\"css\":{\"type\":\"array\",\"optional\":true,\"items\":{\"type\":\"string\"}},\"isBookmarked\":{\"type\":\"boolean\",\"optional\":true},\"instanceType\":{\"$ref\":\"declarativeContent.PageStateMatcherInstanceType\"}}},{\"id\":\"declarativeContent.ShowPageAction\",\"type\":\"object\",\"properties\":{\"instanceType\":{\"$ref\":\"declarativeContent.ShowPageActionInstanceType\"}}},{\"id\":\"declarativeContent.ShowAction\",\"type\":\"object\",\"properties\":{\"instanceType\":{\"$ref\":\"declarativeContent.ShowActionInstanceType\"}}},{\"id\":\"declarativeContent.SetIcon\",\"type\":\"object\",\"properties\":{\"instanceType\":{\"$ref\":\"declarativeContent.SetIconInstanceType\"},\"imageData\":{\"choices\":[{\"$ref\":\"declarativeContent.ImageDataType\"},{\"type\":\"object\",\"additionalProperties\":{\"type\":\"any\"}}],\"optional\":true}}},{\"id\":\"declarativeContent.RequestContentScript\",\"type\":\"object\",\"properties\":{\"css\":{\"type\":\"array\",\"optional\":true,\"items\":{\"type\":\"string\"}},\"js\":{\"type\":\"array\",\"optional\":true,\"items\":{\"type\":\"string\"}},\"allFrames\":{\"type\":\"boolean\",\"optional\":true},\"matchAboutBlank\":{\"type\":\"boolean\",\"optional\":true},\"instanceType\":{\"$ref\":\"declarativeContent.RequestContentScriptInstanceType\"}}}],\"functions\":[],\"events\":[{\"name\":\"onPageChanged\",\"options\":{\"supportsListeners\":false,\"supportsRules\":true,\"conditions\":[\"declarativeContent.PageStateMatcher\"],\"actions\":[\"declarativeContent.RequestContentScript\",\"declarativeContent.SetIcon\",\"declarativeContent.ShowPageAction\",\"declarativeContent.ShowAction\"]}}]}";
const char kPrivacy[] = "{\"namespace\":\"privacy\",\"types\":[{\"id\":\"privacy.IPHandlingPolicy\",\"type\":\"string\",\"enum\":[\"default\",\"default_public_and_private_interfaces\",\"default_public_interface_only\",\"disable_non_proxied_udp\"]}],\"properties\":{\"network\":{\"type\":\"object\",\"value\":{},\"properties\":{\"networkPredictionEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"networkPredictionEnabled\",{\"type\":\"boolean\"}]},\"webRTCMultipleRoutesEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"webRTCMultipleRoutesEnabled\",{\"type\":\"boolean\"}],\"deprecated\":\"Please use privacy.network.webRTCIPHandlingPolicy. This remains for backward compatibility in this release and will be removed in the future.\"},\"webRTCNonProxiedUdpEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"webRTCNonProxiedUdpEnabled\",{\"type\":\"boolean\"}],\"deprecated\":\"Please use privacy.network.webRTCIPHandlingPolicy. This remains for backward compatibility in this release and will be removed in the future.\"},\"webRTCIPHandlingPolicy\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"webRTCIPHandlingPolicy\",{\"$ref\":\"privacy.IPHandlingPolicy\"}]}}},\"services\":{\"type\":\"object\",\"value\":{},\"properties\":{\"alternateErrorPagesEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"alternateErrorPagesEnabled\",{\"type\":\"boolean\"}]},\"autofillEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"autofillEnabled\",{\"type\":\"boolean\"}],\"deprecated\":\"Please use privacy.services.autofillAddressEnabled and privacy.services.autofillCreditCardEnabled. This remains for backward compatibility in this release and will be removed in the future.\"},\"autofillAddressEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"autofillAddressEnabled\",{\"type\":\"boolean\"}]},\"autofillCreditCardEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"autofillCreditCardEnabled\",{\"type\":\"boolean\"}]},\"passwordSavingEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"passwordSavingEnabled\",{\"type\":\"boolean\"}]},\"safeBrowsingEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"safeBrowsingEnabled\",{\"type\":\"boolean\"}]},\"safeBrowsingExtendedReportingEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"safeBrowsingExtendedReportingEnabled\",{\"type\":\"boolean\"}]},\"searchSuggestEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"searchSuggestEnabled\",{\"type\":\"boolean\"}]},\"spellingServiceEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"spellingServiceEnabled\",{\"type\":\"boolean\"}]},\"translationServiceEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"translationServiceEnabled\",{\"type\":\"boolean\"}]}}},\"websites\":{\"type\":\"object\",\"value\":{},\"properties\":{\"thirdPartyCookiesAllowed\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"thirdPartyCookiesAllowed\",{\"type\":\"boolean\"}]},\"hyperlinkAuditingEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"hyperlinkAuditingEnabled\",{\"type\":\"boolean\"}]},\"referrersEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"referrersEnabled\",{\"type\":\"boolean\"}]},\"doNotTrackEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"doNotTrackEnabled\",{\"type\":\"boolean\"}]},\"protectedContentEnabled\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"protectedContentEnabled\",{\"type\":\"boolean\"}],\"platforms\":[\"win\",\"chromeos\"]}}}}}";
const char kProxy[] = "{\"namespace\":\"proxy\",\"types\":[{\"id\":\"proxy.Scheme\",\"type\":\"string\",\"enum\":[\"http\",\"https\",\"quic\",\"socks4\",\"socks5\"]},{\"id\":\"proxy.Mode\",\"type\":\"string\",\"enum\":[\"direct\",\"auto_detect\",\"pac_script\",\"fixed_servers\",\"system\"]},{\"id\":\"proxy.ProxyServer\",\"type\":\"object\",\"properties\":{\"scheme\":{\"$ref\":\"proxy.Scheme\",\"optional\":true},\"host\":{\"type\":\"string\"},\"port\":{\"type\":\"integer\",\"optional\":true}}},{\"id\":\"proxy.ProxyRules\",\"type\":\"object\",\"properties\":{\"singleProxy\":{\"$ref\":\"proxy.ProxyServer\",\"optional\":true},\"proxyForHttp\":{\"$ref\":\"proxy.ProxyServer\",\"optional\":true},\"proxyForHttps\":{\"$ref\":\"proxy.ProxyServer\",\"optional\":true},\"proxyForFtp\":{\"$ref\":\"proxy.ProxyServer\",\"optional\":true},\"fallbackProxy\":{\"$ref\":\"proxy.ProxyServer\",\"optional\":true},\"bypassList\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true}}},{\"id\":\"proxy.PacScript\",\"type\":\"object\",\"properties\":{\"url\":{\"type\":\"string\",\"optional\":true},\"data\":{\"type\":\"string\",\"optional\":true},\"mandatory\":{\"type\":\"boolean\",\"optional\":true}}},{\"id\":\"proxy.ProxyConfig\",\"type\":\"object\",\"properties\":{\"rules\":{\"$ref\":\"proxy.ProxyRules\",\"optional\":true},\"pacScript\":{\"$ref\":\"proxy.PacScript\",\"optional\":true},\"mode\":{\"$ref\":\"proxy.Mode\"}}}],\"properties\":{\"settings\":{\"$ref\":\"types.ChromeSetting\",\"value\":[\"proxy\",{\"$ref\":\"proxy.ProxyConfig\"}]}},\"events\":[{\"name\":\"onProxyError\",\"type\":\"function\",\"parameters\":[{\"type\":\"object\",\"name\":\"details\",\"properties\":{\"fatal\":{\"type\":\"boolean\"},\"error\":{\"type\":\"string\"},\"details\":{\"type\":\"string\"}}}]}]}";
const char kTts[] = "{\"namespace\":\"tts\",\"types\":[{\"id\":\"tts.EventType\",\"type\":\"string\",\"enum\":[\"start\",\"end\",\"word\",\"sentence\",\"marker\",\"interrupted\",\"cancelled\",\"error\",\"pause\",\"resume\"]},{\"id\":\"tts.VoiceGender\",\"type\":\"string\",\"deprecated\":\"Gender is deprecated and is ignored.\",\"enum\":[\"male\",\"female\"]},{\"id\":\"tts.TtsOptions\",\"type\":\"object\",\"properties\":{\"enqueue\":{\"type\":\"boolean\",\"optional\":true},\"voiceName\":{\"type\":\"string\",\"optional\":true},\"extensionId\":{\"type\":\"string\",\"optional\":true},\"lang\":{\"type\":\"string\",\"optional\":true},\"gender\":{\"$ref\":\"tts.VoiceGender\",\"optional\":true,\"deprecated\":\"Gender is deprecated and will be ignored.\"},\"rate\":{\"type\":\"number\",\"optional\":true,\"minimum\":0.1,\"maximum\":10},\"pitch\":{\"type\":\"number\",\"optional\":true,\"minimum\":0,\"maximum\":2},\"volume\":{\"type\":\"number\",\"optional\":true,\"minimum\":0,\"maximum\":1},\"requiredEventTypes\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"desiredEventTypes\":{\"type\":\"array\",\"items\":{\"type\":\"string\"},\"optional\":true},\"onEvent\":{\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"event\",\"$ref\":\"tts.TtsEvent\"}]}}},{\"id\":\"tts.TtsEvent\",\"type\":\"object\",\"properties\":{\"type\":{\"$ref\":\"tts.EventType\"},\"charIndex\":{\"type\":\"integer\",\"optional\":true},\"errorMessage\":{\"type\":\"string\",\"optional\":true},\"srcId\":{\"type\":\"number\",\"optional\":true},\"isFinalEvent\":{\"type\":\"boolean\",\"optional\":true},\"length\":{\"type\":\"integer\",\"optional\":true}}},{\"id\":\"tts.TtsVoice\",\"type\":\"object\",\"properties\":{\"voiceName\":{\"type\":\"string\",\"optional\":true},\"lang\":{\"type\":\"string\",\"optional\":true},\"gender\":{\"$ref\":\"tts.VoiceGender\",\"optional\":true,\"deprecated\":\"Gender is deprecated and will be ignored.\"},\"remote\":{\"type\":\"boolean\",\"optional\":true},\"extensionId\":{\"type\":\"string\",\"optional\":true},\"eventTypes\":{\"type\":\"array\",\"items\":{\"$ref\":\"tts.EventType\"},\"optional\":true}}}],\"functions\":[{\"name\":\"speak\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"utterance\"},{\"$ref\":\"tts.TtsOptions\",\"name\":\"options\",\"optional\":true},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"stop\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"pause\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"resume\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"isSpeaking\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"speaking\",\"type\":\"boolean\"}]}]},{\"name\":\"getVoices\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"type\":\"array\",\"name\":\"voices\",\"items\":{\"$ref\":\"tts.TtsVoice\"}}]}]}],\"events\":[{\"name\":\"onEvent\",\"type\":\"function\",\"parameters\":[{\"name\":\"event\",\"$ref\":\"tts.TtsEvent\"}]}]}";
const char kTtsEngine[] = "{\"namespace\":\"ttsEngine\",\"types\":[{\"id\":\"ttsEngine.VoiceGender\",\"type\":\"string\",\"deprecated\":\"Gender is deprecated and will be ignored.\",\"enum\":[\"male\",\"female\"]}],\"functions\":[{\"name\":\"updateVoices\",\"type\":\"function\",\"parameters\":[{\"type\":\"array\",\"name\":\"voices\",\"items\":{\"$ref\":\"tts.TtsVoice\"}}]},{\"name\":\"sendTtsEvent\",\"type\":\"function\",\"parameters\":[{\"type\":\"integer\",\"name\":\"requestId\"},{\"name\":\"event\",\"$ref\":\"tts.TtsEvent\"}]}],\"events\":[{\"name\":\"onSpeak\",\"type\":\"function\",\"parameters\":[{\"type\":\"string\",\"name\":\"utterance\"},{\"type\":\"object\",\"name\":\"options\",\"properties\":{\"voiceName\":{\"type\":\"string\",\"optional\":true},\"lang\":{\"type\":\"string\",\"optional\":true},\"gender\":{\"$ref\":\"ttsEngine.VoiceGender\",\"optional\":true,\"deprecated\":\"Gender is deprecated and will be ignored.\"},\"rate\":{\"type\":\"number\",\"optional\":true,\"minimum\":0.1,\"maximum\":10.0},\"pitch\":{\"type\":\"number\",\"optional\":true,\"minimum\":0,\"maximum\":2},\"volume\":{\"type\":\"number\",\"optional\":true,\"minimum\":0,\"maximum\":1}}},{\"name\":\"sendTtsEvent\",\"type\":\"function\",\"parameters\":[{\"name\":\"event\",\"$ref\":\"tts.TtsEvent\"}]}]},{\"name\":\"onStop\",\"type\":\"function\"},{\"name\":\"onPause\",\"type\":\"function\"},{\"name\":\"onResume\",\"type\":\"function\"}]}";
const char kInputMethodPrivate[] = "{\"namespace\":\"inputMethodPrivate\",\"types\":[{\"id\":\"inputMethodPrivate.MenuItemStyle\",\"type\":\"string\",\"enum\":[\"check\",\"radio\",\"separator\"]},{\"id\":\"inputMethodPrivate.MenuItem\",\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\"},\"label\":{\"type\":\"string\",\"optional\":true},\"style\":{\"$ref\":\"inputMethodPrivate.MenuItemStyle\",\"optional\":true},\"visible\":{\"type\":\"boolean\",\"optional\":true},\"checked\":{\"type\":\"boolean\",\"optional\":true},\"enabled\":{\"type\":\"boolean\",\"optional\":true}}},{\"id\":\"inputMethodPrivate.UnderlineStyle\",\"type\":\"string\",\"enum\":[\"underline\",\"doubleUnderline\",\"noUnderline\"]},{\"id\":\"inputMethodPrivate.FocusReason\",\"type\":\"string\",\"enum\":[\"mouse\",\"touch\",\"pen\",\"other\"]},{\"id\":\"inputMethodPrivate.InputContextType\",\"type\":\"string\",\"enum\":[\"text\",\"search\",\"tel\",\"url\",\"email\",\"number\",\"password\"]},{\"id\":\"inputMethodPrivate.AutoCapitalizeType\",\"type\":\"string\",\"enum\":[\"off\",\"characters\",\"words\",\"sentences\"]},{\"id\":\"inputMethodPrivate.InputContext\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"type\":{\"$ref\":\"inputMethodPrivate.InputContextType\"},\"autoCorrect\":{\"type\":\"boolean\"},\"autoComplete\":{\"type\":\"boolean\"},\"autoCapitalize\":{\"$ref\":\"inputMethodPrivate.AutoCapitalizeType\"},\"spellCheck\":{\"type\":\"boolean\"},\"shouldDoLearning\":{\"type\":\"boolean\"},\"focusReason\":{\"$ref\":\"inputMethodPrivate.FocusReason\"},\"hasBeenPassword\":{\"type\":\"boolean\"}}}],\"functions\":[{\"name\":\"getInputMethodConfig\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"config\",\"type\":\"object\",\"properties\":{\"isPhysicalKeyboardAutocorrectEnabled\":{\"type\":\"boolean\"},\"isImeMenuActivated\":{\"type\":\"boolean\"}}}]}]},{\"name\":\"getInputMethods\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"inputMethods\",\"type\":\"array\",\"items\":{\"type\":\"object\",\"properties\":{\"id\":{\"type\":\"string\"},\"name\":{\"type\":\"string\"},\"indicator\":{\"type\":\"string\"}}}}]}]},{\"name\":\"getCurrentInputMethod\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"inputMethodId\",\"type\":\"string\"}]}]},{\"name\":\"setCurrentInputMethod\",\"type\":\"function\",\"parameters\":[{\"name\":\"inputMethodId\",\"type\":\"string\",\"optional\":false},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"fetchAllDictionaryWords\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":false,\"parameters\":[{\"name\":\"words\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}]}]},{\"name\":\"addWordToDictionary\",\"type\":\"function\",\"parameters\":[{\"name\":\"word\",\"type\":\"string\",\"optional\":false},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"getEncryptSyncEnabled\",\"type\":\"function\",\"parameters\":[{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[{\"name\":\"enabled\",\"type\":\"boolean\",\"optional\":false}]}]},{\"name\":\"setXkbLayout\",\"type\":\"function\",\"parameters\":[{\"name\":\"xkb_name\",\"type\":\"string\"},{\"name\":\"callback\",\"type\":\"function\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"finishComposingText\",\"type\":\"function\",\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"setSelectionRange\",\"type\":\"function\",\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"selectionStart\":{\"optional\":true,\"type\":\"integer\"},\"selectionEnd\":{\"optional\":true,\"type\":\"integer\"}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"notifyImeMenuItemActivated\",\"type\":\"function\",\"parameters\":[{\"name\":\"engineID\",\"type\":\"string\"},{\"name\":\"name\",\"type\":\"string\"}]},{\"name\":\"showInputView\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"openOptionsPage\",\"type\":\"function\",\"parameters\":[{\"name\":\"inputMethodId\",\"type\":\"string\"}]},{\"name\":\"getCompositionBounds\",\"type\":\"function\",\"parameters\":[{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"boundsList\",\"type\":\"array\",\"items\":{\"type\":\"object\",\"properties\":{\"x\":{\"type\":\"integer\"},\"y\":{\"type\":\"integer\"},\"w\":{\"type\":\"integer\"},\"h\":{\"type\":\"integer\"}}}}]}]},{\"name\":\"getSurroundingText\",\"type\":\"function\",\"parameters\":[{\"name\":\"beforeLength\",\"type\":\"integer\"},{\"name\":\"afterLength\",\"type\":\"integer\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"surroundingInfo\",\"type\":\"object\",\"properties\":{\"before\":{\"type\":\"string\"},\"selected\":{\"type\":\"string\"},\"after\":{\"type\":\"string\"}}}]}]},{\"name\":\"getSetting\",\"type\":\"function\",\"parameters\":[{\"name\":\"engineID\",\"type\":\"string\"},{\"name\":\"key\",\"type\":\"string\"},{\"type\":\"function\",\"name\":\"callback\",\"parameters\":[{\"name\":\"setting\",\"type\":\"any\",\"optional\":true}]}]},{\"name\":\"setSetting\",\"type\":\"function\",\"parameters\":[{\"name\":\"engineID\",\"type\":\"string\"},{\"name\":\"key\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"any\"},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[]}]},{\"name\":\"setCompositionRange\",\"type\":\"function\",\"parameters\":[{\"name\":\"parameters\",\"type\":\"object\",\"properties\":{\"contextID\":{\"type\":\"integer\"},\"selectionBefore\":{\"type\":\"integer\"},\"selectionAfter\":{\"type\":\"integer\"},\"segments\":{\"type\":\"array\",\"optional\":true,\"items\":{\"type\":\"object\",\"properties\":{\"start\":{\"type\":\"integer\"},\"end\":{\"type\":\"integer\"},\"style\":{\"$ref\":\"inputMethodPrivate.UnderlineStyle\"}}}}}},{\"type\":\"function\",\"name\":\"callback\",\"optional\":true,\"parameters\":[{\"name\":\"success\",\"type\":\"boolean\"}]}]},{\"name\":\"reset\",\"type\":\"function\",\"parameters\":[]}],\"events\":[{\"name\":\"onChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"newInputMethodId\",\"type\":\"string\"}]},{\"name\":\"onCompositionBoundsChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"firstBounds\",\"type\":\"object\",\"properties\":{\"x\":{\"type\":\"integer\"},\"y\":{\"type\":\"integer\"},\"w\":{\"type\":\"integer\"},\"h\":{\"type\":\"integer\"}}},{\"name\":\"boundsList\",\"type\":\"array\",\"items\":{\"type\":\"object\",\"properties\":{\"x\":{\"type\":\"integer\"},\"y\":{\"type\":\"integer\"},\"w\":{\"type\":\"integer\"},\"h\":{\"type\":\"integer\"}}}}]},{\"name\":\"onDictionaryLoaded\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"onDictionaryChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"added\",\"type\":\"array\",\"items\":{\"type\":\"string\"}},{\"name\":\"removed\",\"type\":\"array\",\"items\":{\"type\":\"string\"}}]},{\"name\":\"onImeMenuActivationChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"activation\",\"type\":\"boolean\"}]},{\"name\":\"onImeMenuListChanged\",\"type\":\"function\",\"parameters\":[]},{\"name\":\"onImeMenuItemsChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"engineID\",\"type\":\"string\"},{\"name\":\"items\",\"type\":\"array\",\"items\":{\"$ref\":\"inputMethodPrivate.MenuItem\"}}]},{\"name\":\"onFocus\",\"type\":\"function\",\"parameters\":[{\"$ref\":\"inputMethodPrivate.InputContext\",\"name\":\"context\"}]},{\"name\":\"onSettingsChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"engineID\",\"type\":\"string\"},{\"name\":\"key\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"any\"}]},{\"name\":\"onScreenProjectionChanged\",\"type\":\"function\",\"parameters\":[{\"name\":\"isProjected\",\"type\":\"boolean\"}]}]}";
}  // namespace

namespace extensions {
namespace api {

// static
bool ChromeGeneratedSchemas::IsGenerated(base::StringPiece name) {
  return !Get(name).empty();
}

// static
base::StringPiece ChromeGeneratedSchemas::Get(base::StringPiece name) {
  static const struct {
    base::StringPiece name;
    base::StringPiece schema;
  } kSchemas[] = {
    {{"accessibilityFeatures", 21}, {kAccessibilityFeatures, sizeof(kAccessibilityFeatures) - 1}},
    {{"accessibilityPrivate", 20}, {kAccessibilityPrivate, sizeof(kAccessibilityPrivate) - 1}},
    {{"action", 6}, {kAction, sizeof(kAction) - 1}},
    {{"activityLogPrivate", 18}, {kActivityLogPrivate, sizeof(kActivityLogPrivate) - 1}},
    {{"app", 3}, {kApp, sizeof(kApp) - 1}},
    {{"autofillPrivate", 15}, {kAutofillPrivate, sizeof(kAutofillPrivate) - 1}},
    {{"autotestPrivate", 15}, {kAutotestPrivate, sizeof(kAutotestPrivate) - 1}},
    {{"bookmarkManagerPrivate", 22}, {kBookmarkManagerPrivate, sizeof(kBookmarkManagerPrivate) - 1}},
    {{"bookmarks", 9}, {kBookmarks, sizeof(kBookmarks) - 1}},
    {{"brailleDisplayPrivate", 21}, {kBrailleDisplayPrivate, sizeof(kBrailleDisplayPrivate) - 1}},
    {{"browserAction", 13}, {kBrowserAction, sizeof(kBrowserAction) - 1}},
    {{"browsingData", 12}, {kBrowsingData, sizeof(kBrowsingData) - 1}},
    {{"cast.streaming.receiverSession", 30}, {kCastStreamingReceiverSession, sizeof(kCastStreamingReceiverSession) - 1}},
    {{"cast.streaming.rtpStream", 24}, {kCastStreamingRtpStream, sizeof(kCastStreamingRtpStream) - 1}},
    {{"cast.streaming.session", 22}, {kCastStreamingSession, sizeof(kCastStreamingSession) - 1}},
    {{"cast.streaming.udpTransport", 27}, {kCastStreamingUdpTransport, sizeof(kCastStreamingUdpTransport) - 1}},
    {{"chromeWebViewInternal", 21}, {kChromeWebViewInternal, sizeof(kChromeWebViewInternal) - 1}},
    {{"cloudPrintPrivate", 17}, {kCloudPrintPrivate, sizeof(kCloudPrintPrivate) - 1}},
    {{"commandLinePrivate", 18}, {kCommandLinePrivate, sizeof(kCommandLinePrivate) - 1}},
    {{"commands", 8}, {kCommands, sizeof(kCommands) - 1}},
    {{"contentSettings", 15}, {kContentSettings, sizeof(kContentSettings) - 1}},
    {{"contextMenus", 12}, {kContextMenus, sizeof(kContextMenus) - 1}},
    {{"contextMenusInternal", 20}, {kContextMenusInternal, sizeof(kContextMenusInternal) - 1}},
    {{"cookies", 7}, {kCookies, sizeof(kCookies) - 1}},
    {{"cryptotokenPrivate", 18}, {kCryptotokenPrivate, sizeof(kCryptotokenPrivate) - 1}},
    {{"dashboardPrivate", 16}, {kDashboardPrivate, sizeof(kDashboardPrivate) - 1}},
    {{"dataReductionProxy", 18}, {kDataReductionProxy, sizeof(kDataReductionProxy) - 1}},
    {{"debugger", 8}, {kDebugger, sizeof(kDebugger) - 1}},
    {{"declarativeContent", 18}, {kDeclarativeContent, sizeof(kDeclarativeContent) - 1}},
    {{"desktopCapture", 14}, {kDesktopCapture, sizeof(kDesktopCapture) - 1}},
    {{"developerPrivate", 16}, {kDeveloperPrivate, sizeof(kDeveloperPrivate) - 1}},
    {{"downloads", 9}, {kDownloads, sizeof(kDownloads) - 1}},
    {{"downloadsInternal", 17}, {kDownloadsInternal, sizeof(kDownloadsInternal) - 1}},
    {{"enterprise.hardwarePlatform", 27}, {kEnterpriseHardwarePlatform, sizeof(kEnterpriseHardwarePlatform) - 1}},
    {{"enterprise.reportingPrivate", 27}, {kEnterpriseReportingPrivate, sizeof(kEnterpriseReportingPrivate) - 1}},
    {{"extension", 9}, {kExtension, sizeof(kExtension) - 1}},
    {{"fontSettings", 12}, {kFontSettings, sizeof(kFontSettings) - 1}},
    {{"gcm", 3}, {kGcm, sizeof(kGcm) - 1}},
    {{"history", 7}, {kHistory, sizeof(kHistory) - 1}},
    {{"i18n", 4}, {kI18n, sizeof(kI18n) - 1}},
    {{"identity", 8}, {kIdentity, sizeof(kIdentity) - 1}},
    {{"identityPrivate", 15}, {kIdentityPrivate, sizeof(kIdentityPrivate) - 1}},
    {{"idltest", 7}, {kIdltest, sizeof(kIdltest) - 1}},
    {{"imageWriterPrivate", 18}, {kImageWriterPrivate, sizeof(kImageWriterPrivate) - 1}},
    {{"input.ime", 9}, {kInputIme, sizeof(kInputIme) - 1}},
    {{"inputMethodPrivate", 18}, {kInputMethodPrivate, sizeof(kInputMethodPrivate) - 1}},
    {{"instanceID", 10}, {kInstanceID, sizeof(kInstanceID) - 1}},
    {{"languageSettingsPrivate", 23}, {kLanguageSettingsPrivate, sizeof(kLanguageSettingsPrivate) - 1}},
    {{"manifestTypes", 13}, {kManifestTypes, sizeof(kManifestTypes) - 1}},
    {{"mdns", 4}, {kMdns, sizeof(kMdns) - 1}},
    {{"notifications", 13}, {kNotifications, sizeof(kNotifications) - 1}},
    {{"omnibox", 7}, {kOmnibox, sizeof(kOmnibox) - 1}},
    {{"pageAction", 10}, {kPageAction, sizeof(kPageAction) - 1}},
    {{"pageCapture", 11}, {kPageCapture, sizeof(kPageCapture) - 1}},
    {{"passwordsPrivate", 16}, {kPasswordsPrivate, sizeof(kPasswordsPrivate) - 1}},
    {{"permissions", 11}, {kPermissions, sizeof(kPermissions) - 1}},
    {{"privacy", 7}, {kPrivacy, sizeof(kPrivacy) - 1}},
    {{"processes", 9}, {kProcesses, sizeof(kProcesses) - 1}},
    {{"proxy", 5}, {kProxy, sizeof(kProxy) - 1}},
    {{"resourcesPrivate", 16}, {kResourcesPrivate, sizeof(kResourcesPrivate) - 1}},
    {{"safeBrowsingPrivate", 19}, {kSafeBrowsingPrivate, sizeof(kSafeBrowsingPrivate) - 1}},
    {{"sessions", 8}, {kSessions, sizeof(kSessions) - 1}},
    {{"settingsPrivate", 15}, {kSettingsPrivate, sizeof(kSettingsPrivate) - 1}},
    {{"signedInDevices", 15}, {kSignedInDevices, sizeof(kSignedInDevices) - 1}},
    {{"systemIndicator", 15}, {kSystemIndicator, sizeof(kSystemIndicator) - 1}},
    {{"systemPrivate", 13}, {kSystemPrivate, sizeof(kSystemPrivate) - 1}},
    {{"tabCapture", 10}, {kTabCapture, sizeof(kTabCapture) - 1}},
    {{"tabs", 4}, {kTabs, sizeof(kTabs) - 1}},
    {{"topSites", 8}, {kTopSites, sizeof(kTopSites) - 1}},
    {{"tts", 3}, {kTts, sizeof(kTts) - 1}},
    {{"ttsEngine", 9}, {kTtsEngine, sizeof(kTtsEngine) - 1}},
    {{"types", 5}, {kTypes, sizeof(kTypes) - 1}},
    {{"webNavigation", 13}, {kWebNavigation, sizeof(kWebNavigation) - 1}},
    {{"webrtcAudioPrivate", 18}, {kWebrtcAudioPrivate, sizeof(kWebrtcAudioPrivate) - 1}},
    {{"webrtcDesktopCapturePrivate", 27}, {kWebrtcDesktopCapturePrivate, sizeof(kWebrtcDesktopCapturePrivate) - 1}},
    {{"webrtcLoggingPrivate", 20}, {kWebrtcLoggingPrivate, sizeof(kWebrtcLoggingPrivate) - 1}},
    {{"webstorePrivate", 15}, {kWebstorePrivate, sizeof(kWebstorePrivate) - 1}},
    {{"windows", 7}, {kWindows, sizeof(kWindows) - 1}},
  };
  for (const auto& schema : kSchemas) {
    if (schema.name == name)
      return schema.schema;
  }
  return base::StringPiece();
}

}  // namespace api
}  // namespace extensions
